/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997 
 * All rights reserved
 * 
 */

#ifndef _RELEASE_H_ 
#define _RELEASE_H_

/*
 * RELEASE_PRODUCT says which product this release is for
 */
#define RELEASE_PRODUCT 	2

/*
 * RELEASE_{MAJOR,MINOR,FIX,INTERNAL} form the four part release number
 * for the product (mp image or nic driver.)
 */
#define RELEASE_MAJOR		12
#define RELEASE_MINOR		4
#define RELEASE_FIX		13
#define RELEASE_INTERNAL	0

/*
 * RELEASE_MAINT_{MAJOR,MINOR,FIX,INTERNAL} form the four part release number
 * for the maintenance kernel in switch releases
 */
#define RELEASE_MAINT_MAJOR	12
#define RELEASE_MAINT_MINOR	4
#define RELEASE_MAINT_FIX	13
#define RELEASE_MAINT_INTERNAL	0

/*
 * RELEASE_BOOT_{MAJOR,MINOR,FIX,INTERNAL} form the four part release number
 * for the boot program in switch releases
 */
#define RELEASE_BOOT_MAJOR	12
#define RELEASE_BOOT_MINOR	4
#define RELEASE_BOOT_FIX	13
#define RELEASE_BOOT_INTERNAL	0

/*
 * RELEASE_BOOT_REV is the revision level of the eeprom data structure code.
 * This is used in the switch eeprom, switch firmware, and NIC eeprom.
 */
#define RELEASE_BOOT_REV	3

/*
 * The following should go away in favor of strings defined in 
 * common/oem.h.  It is a per-product string to be displayed
 * in association with the release number.
 * XXX I don't understand this comment.  The NIC uses this string and
 * doesn't use the oem.h file at all.
 */
#if defined(OEM_OP1)
#define RELEASE_PRODUCT_NAME	"SUNW,vge V1.1, Rev 12.4.13"
#else /* defined(OEM_OP1) */
/* default to Alteon */
#define RELEASE_PRODUCT_NAME	"Alteon Gigabit Ethernet V12.4.13"
#endif /* defined(OEM_OP1) */

/*
 * RELEASE_PRODUCT  Product		RELEASE_PRODUCT_NAME
 * ===============  ==================  =======================================
 *	0	    No product		""
 *	1	    SPARC/Solaris NIC	"Alteon Gigabit Ethernet VM.m.f"
 *      2           Tigon Switch        ""
 *    2	    No product		""
 */

#endif /* _RELEASE_H_ */

