/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: alt_data.c,v $
 * Revision 1.1.5.43  1999/02/03  01:05:13  fhwang
 * 	To move snap get & set entry up one.
 * 	[1999/02/03  01:01:53  fhwang]
 *
 * Revision 1.1.5.42  1999/01/30  02:32:10  fhwang
 * 	add entry for snap_get and snap_set
 * 	[1999/01/30  01:03:10  fhwang]
 * 
 * Revision 1.1.5.41  1998/11/16  23:34:59  ted
 * 	Add registry support for the READ_MAX_DMA value
 * 	[1998/11/16  23:34:37  ted]
 * 
 * Revision 1.1.5.40  1998/09/29  21:57:03  ted
 * 	Add non-shared rupt ndd parm and change limits on hybrid_len parm
 * 	[1998/09/29  21:37:19  ted]
 * 
 * Revision 1.1.5.39  1998/08/20  18:37:30  leonid
 * 	For performance reasons,
 * 	RECV_COAL_MAX is set to 2 and
 * 	RECV_COAL_TICKS is set to 1000
 * 	[1998/08/20  18:36:58  leonid]
 * 
 * Revision 1.1.5.38  1998/08/03  22:06:14  hayes
 * 	cleanup, add registry options
 * 	[1998/08/03  22:05:00  hayes]
 * 
 * Revision 1.1.5.37  1998/08/03  17:11:05  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:24  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:36  hayes]
 * 
 * 	host based send ring now works off RCB flag
 * 	[1998/07/29  18:31:07  hayes]
 * 
 * 	host based send ring works
 * 	[1998/07/28  03:57:31  hayes]
 * 
 * Revision 1.1.5.36  1998/07/14  02:32:23  ted
 * 	New registry init names, fix tracing
 * 	[1998/07/14  02:10:58  ted]
 * 
 * Revision 1.1.5.35  1998/07/10  16:57:53  hayes
 * 	default 450gx fix to on
 * 	[1998/07/10  16:56:46  hayes]
 * 
 * Revision 1.1.5.34  1998/07/08  22:26:12  hayes
 * 	add 450gx fix
 * 	[1998/07/08  22:24:34  hayes]
 * 
 * Revision 1.1.5.33  1998/06/19  17:11:25  hayes
 * 	reset Tracing...
 * 	[1998/06/19  17:08:17  hayes]
 * 
 * 	adjust default tuning parms for NDIS
 * 	[1998/06/19  17:07:38  hayes]
 * 
 * Revision 1.1.5.32  1998/06/18  16:06:52  hayes
 * 	Merged with changes from 1.1.5.31
 * 	[1998/06/18  16:06:41  hayes]
 * 
 * 	complete merge
 * 	[1998/06/18  15:50:34  hayes]
 * 
 * Revision 1.1.5.31  1998/06/18  15:50:50  hayes
 * 	complete merge
 * 	[1998/06/18  15:50:34  hayes]
 * 
 * Revision 1.1.5.30  1998/06/12  23:46:57  ted
 * 	Rework NT data structures and peripheral changes
 * 	[1998/06/12  23:41:34  ted]
 * 
 * 	snapshot of merge with new Registry handling
 * 	[1998/06/10  22:15:03  ted]
 * 
 * Revision 1.1.5.29  1998/06/08  23:55:15  ted
 * 	Remove debugging stuff
 * 	[1998/06/04  23:39:14  ted]
 * 
 * 	Snapshot NT generification phase 1
 * 	[1998/06/04  19:52:03  ted]
 * 
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:33:52  ted]
 * 
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:08:19  ted]
 * 
 * Revision 1.1.5.28  1998/04/02  06:03:01  ted
 * 	Merged with changes from 1.1.5.27
 * 	[1998/04/02  06:02:41  ted]
 * 
 * 	Add checksum debugging support
 * 	[1998/04/02  05:55:29  ted]
 * 
 * Revision 1.1.5.27  1998/04/01  21:25:41  ted
 * 	Solaris driver now handled changed tick default (1ms vs. 100 ms.)
 * 	[1998/04/01  21:25:12  ted]
 * 
 * Revision 1.1.5.26  1998/01/30  03:40:16  ted
 * 	new ndd parms to control flow control
 * 	[1998/01/30  03:36:09  ted]
 * 
 * Revision 1.1.5.25  1997/12/18  23:21:12  venkat
 * 	merged from ge_0_37_latest
 * 	[1997/12/18  23:13:16  venkat]
 * 
 * Revision 1.1.5.24  1997/12/03  01:22:45  ted
 * 	Bring forward ODI fixes from release 2
 * 	[1997/12/03  01:14:05  ted]
 * 
 * Revision 1.1.5.23  1997/11/21  04:48:20  hayes
 * 	release for NIC 3.1 pre-Beta
 * 	[1997/11/21  04:43:34  hayes]
 * 
 * Revision 1.1.5.22  1997/11/19  19:23:41  ted
 * 	Support Tigon and Tigon2 in the same driver
 * 	[1997/11/19  19:20:35  ted]
 * 
 * Revision 1.1.5.21  1997/11/14  19:16:51  hayes
 * 	first checkin after mongo merge...
 * 	[1997/11/14  19:12:49  hayes]
 * 
 * Revision 1.1.5.20  1997/10/21  00:12:48  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  22:59:44  ted]
 * 
 * Revision 1.1.21.2  1997/10/16  17:30:18  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:24:09  ted]
 * 
 * Revision 1.1.21.1  1997/09/28  22:03:53  ted
 * 	Turn tracing down to level 1
 * 	[1997/09/28  22:00:16  ted]
 * 
 * Revision 1.1.5.19  1997/09/16  21:46:48  ted
 * 	Change from MIB-II V1 (RFC 1213) to MIB-II V2 (RFC 1573)
 * 	[1997/09/16  21:42:34  ted]
 * 
 * Revision 1.1.5.18  1997/09/11  18:06:03  ted
 * 	Mixing vlans, jumbos, and redundancy works, plus small fixes from release 1.1 and better NIC tracing
 * 	[1997/09/11  18:00:26  ted]
 * 
 * Revision 1.1.5.17  1997/08/23  18:18:00  ted
 * 	Merged with changes from 1.1.5.16
 * 	[1997/08/23  18:17:40  ted]
 * 
 * 	Allocate nic structure memory separately from other memory
 * 	[1997/08/23  18:13:18  ted]
 * 
 * Revision 1.1.5.16  1997/08/23  17:40:17  skapur
 * 	Solaris jumbogram support
 * 	[1997/08/23  17:38:25  skapur]
 * 
 * Revision 1.1.5.15  1997/07/28  22:40:14  ted
 * 	Merge
 * 	[1997/07/28  22:36:40  ted]
 * 
 * 	Merge
 * 	[1997/07/28  21:49:48  ted]
 * 
 * 	Solaris dual homing support
 * 	[1997/07/28  21:39:14  ted]
 * 
 * Revision 1.1.5.14  1997/07/25  22:59:22  ted
 * 	Merge fixes from ge_0_22 and add link negotiation support
 * 	[1997/07/25  22:32:41  ted]
 * 
 * 	Architectural performance change
 * 	[1997/07/24  21:45:34  ted]
 * 
 * Revision 1.1.5.14  1997/07/25  22:59:22  ted
 * 	Merge fixes from ge_0_22 and add link negotiation support
 * 	[1997/07/25  22:32:41  ted]
 * 
 * 	Architectural performance change
 * 	[1997/07/24  21:45:34  ted]
 * 
 * Revision 1.1.5.13  1997/06/03  18:55:11  ted
 * 	Changes to support Sun naming of drivers (vge vs. alt)
 * 	[1997/06/03  18:54:01  ted]
 * 
 * Revision 1.1.5.12  1997/05/21  03:35:50  ted
 * 	Use pub_tg.h.
 * 	[1997/05/21  03:24:41  ted]
 * 
 * Revision 1.1.5.11  1997/05/03  05:00:19  ted
 * 	Fix up statistics
 * 	[1997/05/03  04:56:40  ted]
 * 
 * Revision 1.1.5.10  1997/04/04  06:22:18  akhan
 * 	NT merge
 * 	[1997/04/04  06:20:51  akhan]
 * 
 * Revision 1.1.5.9  1997/03/28  01:39:35  ted
 * 	Major merge of NDIS and ODI with mainstream Unix ports
 * 	[1997/03/28  01:31:44  ted]
 * 
 * Revision 1.1.5.8  1997/03/24  08:34:32  ted
 * 	Merged with changes from 1.1.5.7
 * 	[1997/03/24  08:33:39  ted]
 * 
 * 	New event ring handling, producer lives in host memory, misc. other more modest changes
 * 	[1997/03/24  08:28:17  ted]
 * 
 * Revision 1.1.5.7  1997/03/19  05:39:43  suresh
 * 	add AIX include files
 * 	[1997/03/19  05:39:29  suresh]
 * 
 * Revision 1.1.5.6  1997/03/17  08:47:51  skapur
 * 	Change tracing defaults
 * 	[1997/03/17  08:33:15  skapur]
 * 
 * Revision 1.1.5.5  1997/03/02  18:36:45  ted
 * 	redundancy support and a few bug fixes
 * 	[1997/03/02  18:25:34  ted]
 * 
 * Revision 1.1.5.4  1997/02/15  04:41:10  ted
 * 	ALT_LOCKS_SUPPORTED from #if defined to #if
 * 	[1997/02/15  02:46:02  ted]
 * 
 * Revision 1.1.5.3  1997/02/12  00:28:05  ted
 * 	Implement ndd support using code borrowed from Sun
 * 	[1997/02/12  00:27:34  ted]
 * 
 * Revision 1.1.5.2  1997/02/11  04:08:10  ted
 * 	Minor changes in the alt_param_tune array
 * 	[1997/02/11  04:02:12  ted]
 * 
 * 	Fix naming problem with krwlock_t altstruplock.
 * 	[1997/02/08  22:24:56  ted]
 * 
 * Revision 1.1.5.1  1997/02/07  21:57:56  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:47:35  ted]
 * 
 * Revision 1.1.2.1  1996/11/21  18:01:29  ted
 * 	Moved from ../unix/common and merged in WINNT changes
 * 	[1996/11/21  17:41:28  ted]
 * 
 * Revision 1.3.2.2  1996/11/20  20:04:39  ted
 * 	Redo include file structuring
 * 	[1996/11/20  19:54:33  ted]
 * 
 * Revision 1.3.2.1  1996/11/01  18:25:28  ted
 * 	change rr_ to tg_ and add proper copyright
 * 	[1996/10/30  22:58:24  ted]
 * 
 * $EndLog$
 */
/*
 * FILE alt_data.c
 *
 * COPYRIGHT (c) Essential Communication Corp. 1995
 * $Source: /projects/rcs/sw/ge/./nic/host/common/alt_data.c,v $
 * $Revision: 1.1.5.43 $ $Locker:  $
 * $Date: 1999/02/03 01:05:13 $ $Author: fhwang $ $State: Exp $
 */

#ifndef __lint
static char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/common/alt_data.c,v 1.1.5.43 1999/02/03 01:05:13 fhwang Exp $";
#endif /* __lint */

/*
 * This file contains driver data
 */

/* general include files */
#if !defined(WINNT)
#include <sys/types.h>		/* generic types */
#endif /* !defined(WINNT) */

/* System V include files */
#if defined(ALT_SYSV)
#include <sys/ethernet.h>	/* ether_addr */
#endif /* defined(ALT_SYSV) */

/* BSD include files */
#if defined(ALT_BSD)
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#endif /* defined(ALT_BSD) */

/* system specific include files */
#if defined(__sun)
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ddidmareq.h>	/* ddi dma structs */
#include <sys/time.h>		/* struct timespec */
#include <sys/ksynch.h>		/* kconfvar_t */
#include <sys/stream.h>		/* queue_t */
#endif /* defined(__sun) */

#if defined(WINNT)
#include <ndis.h>
#endif /* defined(WINNT) */

#if defined(__NETWARE_386__)
#include <odi.h>
#include <odi_nbi.h>
#include <odi_nesl.h>
#include <parser.h>
#include <cmsm.h>
#include <string.h>
#endif /* defined(__NETWARE_386__) */

/* alteon include files */
#include "alt.h"
#include "alttypes.h"
#include "altreg.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include "altioctl.h"
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */
#include "pub_tg.h"
#include "altos.h"
#include "althdr.h"
#include "altbpdu.h"
#include "altdrv.h"
#include "altftns.h"
#include "link.h"

/* include the firmware arrays */
#include "alt_fw.h"
#include "alt_fw2.h"

#if defined(ALT_BSD)
#if defined(__ntap)
/* no ddi_soft_state stuff, use an array */
int alt_unit = 0;
struct altinst alt_inst[NALT];
#else /* defined(__ntap) */  /* linked list because of dynamic drivers */
struct altinst *altInstP;
#endif /* __ntap */
#endif /* defined(ALT_BSD) */

#if defined(ALT_STREAM)
void *altStatep;		/* pointer to the Alteon state info */
/*
 * Linked list of active (inuse) driver Streams.
 */
struct altstr *altstrup = NULL;
krwlock_t altstruplock;
#endif /* defined(ALT_STREAM) */

/* Tracing variables */
int altTracing = 1;
int altTraceInited = FALSE;
int altTraceSnap = FALSE;
int altTraceWholePacket = FALSE;

#if ALT_LOCKS_SUPPORTED
bool altTraceMutexInited = FALSE;
LOCK_TYPE altTraceMu;
#endif /* ALT_LOCKS_SUPPORTED */

/* intialization arrays for the BPDU message starting point */
#if ALT_BIG_ENDIAN 
#if defined(U64)
struct bpduMsg initBPDU = { 
    0x42, 0x42, 3, 0, 0, 0, 0, 0, 0xffffffffffffffffULL, 0xffffffff, 
    0xffffffffffffffffULL, 0xffff, 0, 0xffff, 0, 0};
#else /* defined(U64) */
struct bpduMsg initBPDU = { 
    0x42, 0x42, 3, 0, 0, 0, 0, 0, {0xffffffffUL, 0xffffffffUL}, 0xffffffff, 
    {0xffffffffUL, 0xffffffffUL}, 0xffff, 0, 0xffff, 0, 0};
#endif /* defined(U64) */
#else /* ALT_BIG_ENDIAN */
struct bpduMsg initBPDU = { 
    0, 3, 0x42, 0x42, 0, 0, 0, 0, {0xffffffffUL, 0xffffffffUL}, 0xffffffffUL, 
    {0xffffffffUL, 0xffffffffUL}, 0xffff, 0, 0xffff, 0, 0};
#endif /* ALT_BIG_ENDIAN */

/*
 * Ethernet BPDU multicast address definition.
 * 
 * CAUTION, alignment may be a big deal don't accidentally put something
 * character oriented between the bpdumsg structure and this.
 * For whatever reason, on suns the ether_addr is defined as an array of
 * uchars, but the ether_cmp routine does things in halfword amounts.
 */
struct ether_addr etherBPDUaddr = {
    0x01, 0x80, 0xc2, 0, 0, 0
};

/* broadcast address for ether addr compare for Tigon 1 BD flags check */
struct ether_addr broadcastAddr = {
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};

U16 altVlanTagId = 0x8100;	/* global for easy access */

#if defined(__sun)
struct alt_param alt_param_arr[] = {
    /* min	    max		value		name   getfn  putfn altp */
{0, TG_TICKS_PER_SEC, TG_TICKS_PER_SEC/10, "stat_ticks", alt_param_get, 
 alt_param_set},
{0, SEND_RING_ENTRIES, 60, "send_max_coalesced_bds", alt_param_get,
     alt_param_set},
{0, TG_TICKS_PER_SEC, 0, "send_coal_ticks", alt_param_get, alt_param_set},
{0, RECV_RETURN_RING_ENTRIES, 6, "recv_max_coalesced_bds", alt_param_get,
     alt_param_set},
{0, TG_TICKS_PER_SEC, TG_TICKS_PER_SEC/10000, "recv_coal_ticks", 
     alt_param_get, alt_param_set},
{0, 0x3fffffff, 0, "nic_tracing", alt_param_get, alt_param_set},
{0, 1, 1, "link_negotiation", alt_param_get, alt_param_link_set},
{0, 1, 0, "dump_nic", alt_param_get, alt_param_set},
{0, 1, 0, "jumbo", alt_param_get, alt_param_jumbo_set},
{0, 1, 0, "vlan?", alt_param_get, alt_param_vlan_set},
{0, 0xffff, 0, "vlan_tag", 
     alt_param_vlan_tag_get, alt_param_vlan_tag_set},
{0, 0xffff, 0, "vlan_tag_id", alt_param_tag_id_get, alt_param_tag_id_set},
{0, 1, 0, "redund?", alt_param_get, alt_param_redund_set},
{0, NALT-1, 0, "redund", alt_param_get, alt_param_set},
{0, 1, 0, "fdr_filter", alt_param_get, alt_param_fdr_set},
{0, 1, 1, "rx_flow_control", alt_param_get, alt_param_rx_flow_set},
{0, 1, 0, "tx_flow_control", alt_param_get, alt_param_tx_flow_set},
{0, MAX_HYBRID_SIZE, HYBRID_LEN, "hybrid_len", alt_param_get, 
     alt_param_hybrid_len_set},
{0, 1, 1, "shared_rupt", alt_param_get, alt_param_share_rupt_set},
{0, 1, 0, "snap", alt_param_get, alt_param_snap_set},
/* start by not allowing any instances, altattach routine adjust the min
 * and max values to match loaded instances */
{0, (NALT * MAX_VLANS) - 1, 0, "instance", alt_param_get, alt_param_set},
};
#endif /* defined(__sun) */

#if defined(WINNT)
const NDIS_PHYSICAL_ADDRESS cmdRingPtr = {0, TG_COMMAND_RING};
const NDIS_PHYSICAL_ADDRESS sendRingPtr = {0, SEND_RING_PTR};
alt_nt_tune_parms_t ntp;
alt_nt_inst_parms_t inst_tp;

alt_reg_tab_t alt_glob_reg_tab[] = {
    {
	ALT_REG_KEY_GLOB_STAT_TICKS, 
	NdisParameterInteger, 
	&ntp.glob.stat_ticks,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	TG_TICKS_PER_SEC,
	TG_TICKS_PER_SEC/10
    },
    {
	ALT_REG_KEY_GLOB_SEND_COAL_TICKS, 
	NdisParameterInteger, 
	&ntp.glob.send_coal_ticks,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	TG_TICKS_PER_SEC,
	0
    },
    {
	ALT_REG_KEY_GLOB_RECV_COAL_TICKS, 
	NdisParameterInteger, 
	&ntp.glob.recv_coal_ticks,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	TG_TICKS_PER_SEC,
	TG_TICKS_PER_SEC/1000
    },
    {
	ALT_REG_KEY_GLOB_SEND_COAL_MAX, 
	NdisParameterInteger, 
	&ntp.glob.send_coal_max,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	SEND_RING_ENTRIES,
	1
    },
    {
	ALT_REG_KEY_GLOB_RECV_COAL_MAX, 
	NdisParameterInteger, 
	&ntp.glob.recv_coal_max,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	512,
	2
    },
    {
	ALT_REG_KEY_GLOB_PCI_MEM_INV, 
	NdisParameterInteger, 
	&ntp.glob.pci_mem_inv,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0,
    },
    {
	ALT_REG_KEY_GLOB_PCI_READ_MAX, 
	NdisParameterInteger, 
	&ntp.glob.pci_read_max,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1024,
	0
    },
    {
	ALT_REG_KEY_GLOB_PCI_WRITE_MAX, 
	NdisParameterInteger, 
	&ntp.glob.pci_write_max,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	0xffffffff,
	0xffffffff
    },
    {
	ALT_REG_KEY_GLOB_PCI_LATENCY_TIMER, 
	NdisParameterInteger, 
	&ntp.glob.pci_latency_timer,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	0x000000ff,
	0
    },
    {
	ALT_REG_KEY_GLOB_450GX_FIX, 
	NdisParameterInteger, 
	&ntp.glob.i450gx_fix,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
#if USE_CKSUM_OFFLOAD
	0,
#else /* USE_CKSUM_OFFLOAD */
	1
#endif /* USE_CKSUM_OFFLOAD */
    },
    {
        ALT_REG_KEY_GLOB_RUPT_TIMEOUT,
        NdisParameterInteger,
        &ntp.glob.ruptTimeout,
        NDIS_STATUS_FAILURE,    /* init to fail */
        0,
        1000000,
        10000
    },
    {
        ALT_REG_KEY_GLOB_HYBRID_LEN,
        NdisParameterInteger,
        &ntp.glob.hybridLen,
        NDIS_STATUS_FAILURE,    /* init to fail */
        0,
        MAX_HYBRID_SIZE,
        HYBRID_LEN
    },
    {
        ALT_REG_KEY_GLOB_SHARED_RUPT,
        NdisParameterInteger,
        &ntp.glob.sharedRupt,
        NDIS_STATUS_FAILURE,    /* init to fail */
        0,
        1,
        1
    },
    {
        ALT_REG_KEY_GLOB_REAP_AFTER_SEND,
        NdisParameterInteger,
        &ntp.glob.reapAfterSend,
        NDIS_STATUS_FAILURE,    /* init to fail */
        0,
        1,
        0
    },
    {
        ALT_REG_KEY_GLOB_MIN_DMA,
        NdisParameterInteger,
        &ntp.glob.minDma,
        NDIS_STATUS_FAILURE,    /* init to fail */
        0,
        0xff,
        0xff
    },
    {
        ALT_REG_KEY_GLOB_SEND_UPDATE_ONLY,
        NdisParameterInteger,
        &ntp.glob.sendUpdateOnly,
        NDIS_STATUS_FAILURE,    /* init to fail */
        0,
        1,
        0
    },
};

alt_reg_tab_t alt_inst_reg_tab[] = {
    {
	ALT_REG_KEY_INST_INSTANCE, 
	NdisParameterInteger, 
	&inst_tp.instance,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	NALT,
	0
    },
    {
	ALT_REG_KEY_INST_SLOT, 
	NdisParameterInteger, 
	&inst_tp.slot,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	255,
	0
    },
    {
	ALT_REG_KEY_INST_TX_FLOW_CONTROL,
	NdisParameterInteger, 
	&inst_tp.tx_flow_control,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0
    },
    {
	ALT_REG_KEY_INST_RX_FLOW_CONTROL,
	NdisParameterInteger, 
	&inst_tp.rx_flow_control,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	1
    },
    {
	ALT_REG_KEY_INST_LINK_NEGOTIATION,
	NdisParameterInteger, 
	&inst_tp.link_negotiation,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	1
    },
    {
	ALT_REG_KEY_INST_FDR_FILTER, 
	NdisParameterInteger, 
	&inst_tp.fdr_filter,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0
    },
    {
	ALT_REG_KEY_INST_RSL_ENABLE, 
	NdisParameterInteger, 
	&inst_tp.rsl_enable,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0
    },
    {
	ALT_REG_KEY_INST_RSL_PRIMARY_INST, 
	NdisParameterInteger, 
	&inst_tp.rsl_pri_inst,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	255,
	0
    },
    {
	ALT_REG_KEY_INST_RSL_SECONDARY_INST, 
	NdisParameterInteger, 
	&inst_tp.rsl_sec_inst,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	255,
	0
    },
    {
	ALT_REG_KEY_INST_JUMBO_FRAMES, 
	NdisParameterInteger, 
	&inst_tp.jumbo_frames,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0
    },
    {
	ALT_REG_KEY_INST_JUMBO_MTU, 
	NdisParameterInteger, 
	&inst_tp.jumbo_mtu,
	NDIS_STATUS_FAILURE,	/* init to fail */
	9018,
	9022,
	9018
    },
    {
	ALT_REG_KEY_INST_VLAN_ENABLE, 
	NdisParameterInteger, 
	&inst_tp.vlan_enable,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0
    },
    {
	ALT_REG_KEY_INST_VLAN_COUNT, 
	NdisParameterInteger, 
	&inst_tp.vlan_count,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	64,
	0
    },
    {
	ALT_REG_KEY_INST_REGISTRY_CONSISTENT, 
	NdisParameterInteger, 
	&inst_tp.registry_consistent,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0,
    },
    {
	ALT_REG_KEY_INST_NIC_TRACING, 
	NdisParameterInteger, 
	&inst_tp.nic_tracing,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	0xffffffff,
	0
    },
    {
	ALT_REG_KEY_INST_COMMAND, 
	NdisParameterInteger, 
	&inst_tp.command,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	0xffffffff,
	0
    },
    {
	ALT_REG_KEY_INST_HOST_TRACING, 
	NdisParameterInteger, 
	&inst_tp.host_tracing,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	4,
#if defined(DBG)
	1
#else /* defined(DBG) */
	1
#endif /* defined(DBG) */
    },
    {
	ALT_REG_KEY_INST_DEBUG_PCI, 
	NdisParameterInteger, 
	&inst_tp.debug_pci,
	NDIS_STATUS_FAILURE,	/* init to fail */
	0,
	1,
	0
    }
};
#endif /* defined(WINNT) */

#if ALT_TRACE
u_long alt_tbuf[(ALT_TRACE_SIZE+1)*ALT_TRACE_ELEM_SIZE];
u_long *alt_curtb = &alt_tbuf[(ALT_TRACE_SIZE-1)*ALT_TRACE_ELEM_SIZE];
u_long *alt_endtb = &alt_tbuf[ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE]; 
u_long alt_stbuf[(ALT_TRACE_SIZE+1)*ALT_TRACE_ELEM_SIZE];
u_long *alt_curstb = &alt_stbuf[(ALT_TRACE_SIZE-1)*ALT_TRACE_ELEM_SIZE];
u_long *alt_endstb = &alt_stbuf[ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE]; 
#if defined(ALT_STREAM) || defined(WINNT)
u_long alt_trtmp[(ALT_TRACE_SIZE+1)*ALT_TRACE_ELEM_SIZE];
#endif /* defined(ALT_STREAM) */
#endif /* ALT_TRACE */

#if SEND_CKSUM_DEBUG
int do_send_ip_cksum = 0;
int do_send_tcpudp_cksum = 0;
int do_send_pseudo_cksum = 0;

int send_bdflags;
#endif /* SEND_CKSUM_DEBUG */

#if RECV_CKSUM_DEBUG
int do_recv_ip_cksum = 0;
int do_recv_tcpudp_cksum = 0;
int do_recv_pseudo_cksum = 0;
#endif /* RECV_CKSUM_DEBUG */
