/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altbpdu.h,v $
 * Revision 1.1.2.4  1998/03/03  22:23:41  ted
 * 	Implement faster dual homing code
 * 	[1998/03/03  22:22:44  ted]
 *
 * Revision 1.1.2.3  1997/09/11  18:06:05  ted
 * 	Mixing vlans, jumbos, and redundancy works, plus small fixes from release 1.1 and better NIC tracing
 * 	[1997/09/11  18:00:31  ted]
 * 
 * Revision 1.1.2.2  1997/07/28  22:40:15  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:39:19  ted]
 * 
 * Revision 1.1.2.1  1997/03/02  18:36:46  ted
 * 	redundancy support and a few bug fixes
 * 	[1997/03/02  18:25:37  ted]
 * 
 * $EndLog$
 */

/*
 * FILE altbpdu.h
 *
 * $Source: /projects/rcs/sw/ge/./nic/host/common/altbpdu.h,v $
 * $Revision: 1.1.2.4 $ $Locker:  $
 * $Date: 1998/03/03 22:23:41 $ $Author: ted $ $State: Exp $
 */

#ifndef _ALTBPDU_H
#define _ALTBPDU_H

#if ALT_BIG_ENDIAN
struct bpduMsg {
    U8 dsap;
    U8 ssap;
    U8 control;
    U8 protoHigh;
    U8 protoLow;
    U8 version;
    U8 msgType;
    U8 flags;
    struct {
	U32 high;
	U32 low;
    } rootId;
    U32 pathCost;
    struct {
	U32 high;
	U32 low;
    } bridgeId;
    U16 portId;
    U16 msgAge;
    U16 maxAge;
    U16 helloTime;
    U16 forwardDelay;
};
#else /* ALT_BIG_ENDIAN */
struct bpduMsg {
    U8 dsap;
    U8 ssap;
    U8 control;
    U8 protoHigh;
    U8 protoLow;
    U8 version;
    U8 msgType;
    U8 flags;
    struct {
	U32 high;
	U32 low;
    } rootId;
    U32 pathCost;
    struct {
	U32 high;
	U32 low;
    } bridgeId;
    U16 portId;
    U16 msgAge;
    U16 maxAge;
    U16 helloTime;
    U16 forwardDelay;
};
#endif /* ALT_BIG_ENDIAN */

#define BETTER_ID(one, two)				\
((one).high) == (two).high ? 				\
((U32)ntohl((one).low) < (U32)ntohl((two).low)) :	\
    ((U32)ntohl((one).high) <  (U32)ntohl((two).high))

#define EQUAL_ID(one, two) \
 ((one).high == (two).high) && ((one).low == (two).low)
#endif /* _ALTBPDU_H */

