/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997, 1998 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altcfg.c $
 * Revision nic_api_12_4_latest_shuang/2 1999/10/25 22:24:09 shuang
 * 	fix typo in altDelMultiCast()
 * 
 * Revision copper_fhwang/4 1999/09/03 23:38:46 fhwang
 * 	add speed and duplex for NT driver
 * 
 * Revision copper_fhwang/2 1999/08/27 02:26:23 fhwang
 * 	add LNK_100MB, LNK_10MB, LNK_HALF_DUPLEX for tx1000
 * 
 * Revision 1.1.2.1  1998/11/04  19:37:34  ted
 * 	Split altdrv.c into altcfg.c, altcinit.c, and altintr.c
 * 	[1998/11/04  19:36:52  ted]
 *
 * $EndLog$
 */

#ifndef __lint
static char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/common/altcfg.c,v 1.1.2.1 1998/11/04 19:37:34 ted Exp $";
#endif /* __lint */

/* General include files */
#if !defined(ALT_SYSV) && !defined(WINNT)
#include <string.h>		/* get these from systm.h via conf.h below */
#endif /* !defined(ALT_SYSV) && !defined(WINNT) */ 

#if !defined(WINNT)
#include <sys/types.h>
#include <sys/errno.h>
#endif /* !defined(WINNT) */

/* System V include files */
#if defined(ALT_SYSV)
#include <sys/kmem.h>
#include <sys/ethernet.h>	/* ether_addr */
#include <sys/cmn_err.h>
#include <sys/conf.h>
#endif /* defined(ALT_SYSV) */

/* streams specific files */
#if defined(ALT_STREAM)
#include <sys/stream.h>		/* queue_t, before sunddi.h or warning */
#include <sys/dlpi.h>
#endif /* defined(ALT_STREAM) */

/* BSD include files */
#if defined(ALT_BSD)
#include <sys/socket.h>
#include <sys/mbuf.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#endif /* defined(ALT_BSD) */

/* system specific include files */
#if defined(__sun)
#include <sys/byteorder.h>	/* htonl... */
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ddi.h>		/* min */
#include <sys/ddidmareq.h>	/* ddi dma structs */
#include <sys/sunddi.h>		/* DDI_SUCCESS... */
#include <sys/ksynch.h>		/* kconfvar_t */
/* non-ddi defined function, not proto available in standard header files */
extern mblk_t *desballoc(unsigned char *, int, int, frtn_t *);
#endif /* defined(__sun) */

#if defined(WINNT)
#include <ndis.h>
#include "altntmsg.h"
#endif /* defined(WINNT) */	

#if defined(__NETWARE_386__)
#include <odi.h>
#include <odi_nbi.h>
#include <odi_nesl.h>
#include <parser.h>
#include <cmsm.h>
#include <splat.h>
#include <portable.h>
#endif /* defined(__NETWARE_386__) */

/* alteon include files */
#include "alt.h"
#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include "altioctl.h"
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */
#include "eeprom.h"
#include "pub_tg.h"
#include "altos.h"
#include "althdr.h"
#include "altreg.h"		/* must follow althdr.h */
#include "altftns.h"
#include "altbpdu.h"
#include "altdrv.h"
#include "link.h"

#if defined(WINNT)
#include "drvstat.h"
#endif /* defined(WINNT) */	

#if defined(__sun)
#include "sbus.h"
#endif /* defined(__sun) */

#if defined(__NETWARE_386__)
#include <ethertsm.h>
#endif /* defined(__NETWARE_386__) */

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altHostState(struct altinst *altp, bool up)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altHostState(altp, up)
struct altinst *altp;
bool up;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(hststate, 0x10021, up, altp, nic, altp->instance);

    if (up) {
	DO_TG_COMMAND(TG_CMD_HOST_STATE, 0, TG_CMD_CODE_STACK_UP);
	altp->flags |= ALT_HOST_UP;
    } else {
	DO_TG_COMMAND(TG_CMD_HOST_STATE, 0, TG_CMD_CODE_STACK_DOWN);
	altp->flags &= ~ALT_HOST_UP;
    }
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altAddMultiCast(struct altinst *altp, struct ether_addr *ethp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altAddMultiCast(altp, ethp)
struct altinst *altp;
struct ether_addr *ethp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;
    U32 macspot[2];		/* space for the padded MAC address */

    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	/* synchronize with active multicast command */
	if (nic->flags & ALT_MULTI_ACTIVE)
	    SNOOZE(200);	/* about an interrupt time */
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags |= ALT_MULTI_ACTIVE;
	ALT_ENABLE(spl, &nic->flagMu);

	/* stick the ether_addr into the shared mem and tell firmware */
	macspot[0] = 0;
	MEMCPY(((char *)macspot)+2, (MEMCPY_TYPE)ethp, 6);

	ALTTRACE(addmulti, 0x1001a, altp, macspot[0], macspot[1], ethp);
	
	ALT_SWAP_MEMCPY_TODEV((MEMCPY_TYPE)&nic->genComm->gen_com.
			      mcast_xfer_buf,
			      (MEMCPY_TYPE)macspot, 8);

	DO_TG_COMMAND(TG_CMD_ADD_MULTICAST_ADDR, 0, 0);
    } else {
	/* stick the ether_addr into the shared mem and tell firmware */
	macspot[0] = 0;
	MEMCPY(((char *)macspot)+2, (MEMCPY_TYPE)ethp, 6);

#if !ALT_BIG_ENDIAN
	/* swap it around for little endian hosts */
	macspot[0] = ntohl(macspot[0]);
	macspot[1] = ntohl(macspot[1]);
#endif /* !ALT_BIG_ENDIAN */

	ALTTRACE(addmulti, 0x1000c, altp, macspot[0], macspot[1], ethp);
	DO_TG_EXT_COMMAND2(TG_CMD_EXT_ADD_MULTICAST_ADDR, 0, 0, 
			   macspot[0], macspot[1]);
    }
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altDelMultiCast(struct altinst *altp, struct ether_addr *ethp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altDelMultiCast(altp, ethp)
struct altinst *altp;
struct ether_addr *ethp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;
    U32 macspot[2];		/* space for the padded MAC address */

    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	/* synchronize with active multicast command */
	if (nic->flags & ALT_MULTI_ACTIVE)
	    SNOOZE(200);	/* about an interrupt time */
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags |= ALT_MULTI_ACTIVE;
	ALT_ENABLE(spl, &nic->flagMu);

	/* stick the ether_addr into the shared mem and tell firmware */
	macspot[0] = 0;
	MEMCPY(((char *)macspot)+2, (MEMCPY_TYPE)ethp, 6);
	ALTTRACE(delmulti, 0x1001b, altp, macspot[0], macspot[1], ethp);
	ALT_SWAP_MEMCPY_TODEV((MEMCPY_TYPE)&nic->genComm->gen_com.
			      mcast_xfer_buf,
			      (MEMCPY_TYPE)macspot, 8);

	DO_TG_COMMAND(TG_CMD_DEL_MULTICAST_ADDR, 0, 0);
    } else {
	/* stick the ether_addr into the shared mem and tell firmware */
	macspot[0] = 0;
	MEMCPY(((char *)macspot)+2, (MEMCPY_TYPE)ethp, 6);

#if !ALT_BIG_ENDIAN
	/* swap it around for little endian hosts */
	macspot[0] = ntohl(macspot[0]);
	macspot[1] = ntohl(macspot[1]);
#endif /* !ALT_BIG_ENDIAN */

	ALTTRACE(delmulti, 0x1000d, altp, macspot[0], macspot[1], ethp);
	DO_TG_EXT_COMMAND2(TG_CMD_EXT_DEL_MULTICAST_ADDR, 0, 0, 
			   macspot[0], macspot[1]);
    }
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altSetMacaddr(struct tg_nic *nic, struct ether_addr *ethp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altSetMacaddr(nic, ethp)
struct tg_nic *nic;
struct ether_addr *ethp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct altinst *altp = nic->altp;
    struct tg_command command;
    U32 macspot[2];		/* space for the padded MAC address */

    /* stick the ether_addr into the shared mem and tell firmware */
    MEMCPY(((char *)macspot)+2, (MEMCPY_TYPE)ethp, 6);
    ALTTRACE(setmac, 0x1001c, altp, nic, macspot[0], macspot[1]);
    ALT_SWAP_MEMCPY_TODEV((MEMCPY_TYPE)&nic->genComm->gen_com.mac_addr, 
			  (MEMCPY_TYPE)macspot, 8);

    DO_TG_COMMAND(TG_CMD_SET_MAC_ADDR, 0, 0);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altSetPromiscuous(struct altinst *altp, bool on)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altSetPromiscuous(altp, on)
struct altinst *altp;
bool on;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(setprom, 0x10029, altp, nic, on, 0);
    if (on) {
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags |= ALT_PROM_MODE;
	ALT_ENABLE(spl, &nic->flagMu);
	DO_TG_COMMAND(TG_CMD_SET_PROMISC_MODE, 0, TG_CMD_CODE_PROMISC_ENABLE);
    } else {
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags &= ~ALT_PROM_MODE;
	ALT_ENABLE(spl, &nic->flagMu);
	DO_TG_COMMAND(TG_CMD_SET_PROMISC_MODE, 0, TG_CMD_CODE_PROMISC_DISABLE);
    }
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altSetMultiCastMode(struct altinst *altp, bool on)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altSetMultiCastMode(altp, on)
struct altinst *altp;
bool on;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(setmulti, 0x1003f, altp, nic, on, 0);
    if (on) {
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags |= ALT_MULTICAST_MODE;
	ALT_ENABLE(spl, &nic->flagMu);
	DO_TG_COMMAND(TG_CMD_SET_MULTICAST_MODE, 0, 
		      TG_CMD_CODE_MULTICAST_ENABLE);
    } else {
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags &= ~ALT_MULTICAST_MODE;
	ALT_ENABLE(spl, &nic->flagMu);
	DO_TG_COMMAND(TG_CMD_SET_MULTICAST_MODE, 0, 
		      TG_CMD_CODE_MULTICAST_DISABLE);
    }
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altUpdateGencomStats(struct altinst *altp)
#else   /* defined(__STDC__) || defined(ALT_PROTOS) */
altUpdateGencomStats(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;
 
    ALTTRACE(updtgenc, 0x1003a, altp, nic, 0, 0);
    DO_TG_COMMAND(TG_CMD_UPDATE_GENCOM_STATS, 0, 0); 
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altClearProfile(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altClearProfile(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(clrprof, 0x10027, altp, nic, 0, 0);
    DO_TG_COMMAND(TG_CMD_CLEAR_PROFILE, 0, 0);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altClearNicStats(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altClearNicStats(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(clrstats, 0x10028, altp, nic, 0, 0);
    DO_TG_COMMAND(TG_CMD_CLEAR_STATS, 0, 0);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altSetFdrMode(struct altinst *altp, bool on)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altSetFdrMode(altp, on)
struct altinst *altp;
bool on;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->nic;

    ALTTRACE(fdrfilt, 0x1003b, altp, nic, on, 0);
    if (on) {
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags |= ALT_DO_FDR_FILTERING;
	ALT_ENABLE(spl, &nic->flagMu);
	DO_TG_COMMAND(TG_CMD_FDR_FILTERING, 0, TG_CMD_CODE_FDR_FILT_ENABLE);
    } else {
	ALT_DISABLE(spl, &nic->flagMu);
	nic->flags &= ~ALT_DO_FDR_FILTERING;
	ALT_ENABLE(spl, &nic->flagMu);
	DO_TG_COMMAND(TG_CMD_FDR_FILTERING, 0, TG_CMD_CODE_FDR_FILT_DISABLE);
    }
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altRefreshNicStats(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altRefreshNicStats(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(newstats, 0x10050, altp, nic, 0, 0);
    DO_TG_COMMAND(TG_CMD_REFRESH_STATS, 0, 0);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altDoLinkNegotiation(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altDoLinkNegotiation(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_command command;
    struct tg_nic *nic = altp->nic;

    ALTTRACE(linkneg, 0x10051, altp, nic, 0, 0);
    DO_TG_COMMAND(TG_CMD_LINK_NEGOTIATION, 0, 0);
}

int
#if defined(__STDC__) || defined(ALT_PROTOS)
altAddRedund(struct altinst *ifconfigAltp, struct altinst *attachAltp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altAddRedund(ifconfigAltp, attachAltp)
struct altinst *ifconfigAltp;
struct altinst *attachAltp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    int rc = 0;
    int i;

    ALT_DISABLE(spl, &ifconfigAltp->nicMu);
    /* turn on jumbo, if enabled, first so we don't have to back out */
    if (ifconfigAltp->flags & ALT_JUMBO_ENABLED)
	if (rc = altInitJumbo(attachAltp))
	    return(rc);
    if (attachAltp->state == ALT_FW_RUNNING)
	FillJumboRecvRing(attachAltp);

    /* link it up */
    ifconfigAltp->attachNic = attachAltp->nic;
    ifconfigAltp->flags |= ALT_REDUNDANT | ALT_RED_IFCONFIG;
    attachAltp->flags |= ALT_REDUNDANT | ALT_RED_ATTACH;
    attachAltp->flags |= 
	ifconfigAltp->flags & (ALT_JUMBO_ENABLED | ALT_VLANS_ACTIVE);
    attachAltp->nic->altp = ifconfigAltp;
    attachAltp->ifconfigNic = ifconfigAltp->nic;
    attachAltp->attachNic = attachAltp->nic;
    ifconfigAltp->nic->curBPDU = initBPDU; /* struct copy */
    attachAltp->nic->curBPDU = initBPDU;  /* struct copy */

    ifconfigAltp->nic->flags |= ALT_RED_STANDBY;
    attachAltp->nic->flags |= ALT_RED_ACTIVE;
    ifconfigAltp->nic = ifconfigAltp->attachNic;

    /* all the VLAN stuff */
    for (i=0; i < MAX_VLANS; i++) {
#if defined(__sun)
	attachAltp->ipq[i] = ifconfigAltp->ipq[i]; /* set the ipqs up too */
#endif /* defined(__sun) */
	attachAltp->vlan_id[i] = ifconfigAltp->vlan_id[i];
	attachAltp->jumbo[i] = ifconfigAltp->jumbo[i];
    }
    for (i=0; i < MAX_VLAN_IDS; i++)
	attachAltp->vlan_translate[i] = ifconfigAltp->vlan_translate[i];

    ALT_ENABLE(spl, &ifconfigAltp->nicMu);

    /* copy the mac address from the ifconfig'd if to the attached */
    ether_copy(&ifconfigAltp->macAddr, &attachAltp->macAddr);
    altSetMacaddr(ifconfigAltp->attachNic, &attachAltp->macAddr);

    /* tell the card to start receiving packets */
    if (ifconfigAltp->flags & ALT_HOST_UP) {
	altHostState(attachAltp, TRUE);
	attachAltp->flags |= ALT_HOST_UP;
    }

    /* make the MAC accept BPDU packets, hidden from streams mcast table */
    altAddMultiCast(ifconfigAltp, &etherBPDUaddr);
    altAddMultiCast(attachAltp, &etherBPDUaddr);

    /* add in all the previously configured multicast addresses
     * from the initNic to the attached NIC */
#if !defined(WINNT)
    for (i = 0; i < ifconfigAltp->mccount; i++) {
	altAddMultiCast(attachAltp, &ifconfigAltp->mctab[i].addr);
    }
#endif /* !defined(WINNT) */

    /* if the ifconfiged interface was in promiscuous mode make the
     * other interface be too */
    if (ifconfigAltp->flags & ALT_PROMISC) {
	attachAltp->flags |= ALT_PROMISC;
	altSetPromiscuous(attachAltp, TRUE);
    }
    return(rc);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altRemRedund(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altRemRedund(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
#if 0				/* not supported now XXX */
    struct altinst *altp2;

    ALT_DISABLE(spl, &altp->nicMu);
    /* get back our original macAddr (from Serial EEPROM) */
    /* XXX issue when overridden */
    altGetMacAddr(altp, &altp->macAddr);
    altSetMacaddr(altp->attachNic, &altp->macAddr);
	
    /* unlink it */
    altp2 = altp->ifconfigNic->altp;
    altp2->attachNic = (struct tg_nic *)0;
    altp2->nic = altp2->initNic; /* put them back to orig state */
    altp->nic = altp->initNic;   /* put them back to orig state */
    altp2->flags &= ~(ALT_REDUNDANT | ALT_RED_IFCONFIG | ALT_RED_ATTACH);
    altp->flags &= ~(ALT_REDUNDANT |  ALT_RED_IFCONFIG | ALT_RED_ATTACH);
    altp->nic->flags &= ~(ALT_RED_ACTIVE | ALT_RED_STANDBY);
    altp2->nic->flags &= ~(ALT_RED_ACTIVE | ALT_RED_STANDBY);
    altp->nic->altp = altp;
    altp->ifconfigNic = altp->initNic;
    altp->attachNic = (struct tg_nic *)0;
    for (i=0; i < MAX_VLANS; i++)
	altp2->ipq[i] = (queue_t *)0; /* null it out */
    ALT_ENABLE(spl, &altp->nicMu);

    /* make the MAC stop accepting BPDU packets */
    altDelMultiCast(altp, &etherBPDUaddr);
    altDelMultiCast(altp2, &etherBPDUaddr);

    /* delete all other multicast addresses from the list */
    for (i = 0; i < altp->mccount; i++) {
	altDelMultiCast(altp2, &altp->mctab[i].addr);
    }

    /* if promiscuity was on, turn it off, so we're back to normal */
    if (altp2->flags & ALT_PROMISC) {
	altSetPromiscuous(altp, FALSE);
	altp2->flags &= ~ALT_PROMISC;
    }

    /* tell the card to stop receiving packets */
    altHostState(altp, FALSE);
    altp->flags &= ~ALT_HOST_UP;
#endif /* 0 */
}

#if defined(__sun)
void
altUpdateTuneParms(struct tg_nic *nic)
{
    U32 link_set;

    WRSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks, 
	    nic->tuneParms[STAT_TICKS].parm_val);
    WRSHMEM(nic->genComm->gen_com.tuneParms.send_max_coalesced_bds, 
	    nic->tuneParms[SEND_BDS].parm_val);
    WRSHMEM(nic->genComm->gen_com.tuneParms.send_coal_ticks, 
	    nic->tuneParms[SEND_TICKS].parm_val);
    WRSHMEM(nic->genComm->gen_com.tuneParms.recv_max_coalesced_bds,
	    nic->tuneParms[RECV_BDS].parm_val);
    WRSHMEM(nic->genComm->gen_com.tuneParms.recv_coal_ticks, 
	    nic->tuneParms[RECV_TICKS].parm_val);
    WRSHMEM(nic->genComm->gen_com.tuneParms.tracing,
	    nic->tuneParms[NIC_TRACE].parm_val);
    /*
     * nic->genComm->gen_com.tuneParms.link_negotiation must
     * be always set to the desired value, not an intermediate
     * value because back to back tuneParms updates may leave
     * the value in an incorrect state
     */
    link_set = LNK_ENABLE | LNK_FULL_DUPLEX | LNK_1000MB |
               LNK_100MB | LNK_10MB | LNK_HALF_DUPLEX;
    if (nic->tuneParms[LINK_NEGOTIATE].parm_val)
	link_set |= LNK_NEGOTIATE;
    if (nic->tuneParms[RX_FLOW_CTL].parm_val)
	link_set |= LNK_RX_FLOW_CTL_Y;
    if (nic->tuneParms[TX_FLOW_CTL].parm_val) {
	/* not legal on a Rev 4 Tigon */
	if ((INCFG32(nic->configHandle, nic->configBase, 
		     TG_MISC_HOST_CONTROL) & TG_MHC_TIGON_VERSION_MASK) ==
	    TG_MHC_LSI_GATE_VERS) {
	    NOTE3("%s%d: Can't set TX flow control on this hardware, ignored",
		  nic->name, nic->initAltp->instance);
	} else
	    link_set |= LNK_TX_FLOW_CTL_Y;
    }
    if (nic->nic_type == ALT_SBUS_NIC &&
	(nic->tigonRev == TG_MHC_LSI_STANDARD_CELL_VERS ||
	 nic->tigonRev == TG_MHC_LSI_STANDARD_CELL_VERS_B))
	link_set |= LNK_PREF;
    WRSHMEM(nic->genComm->gen_com.tuneParms.link_negotiation, link_set);

    if (nic->nic_type == ALT_SBUS_NIC &&
	(nic->tigonRev == TG_MHC_LSI_STANDARD_CELL_VERS ||
	 nic->tigonRev == TG_MHC_LSI_STANDARD_CELL_VERS_B)) {
	link_set = LNK_ENABLE | LNK_NEGOTIATE | LNK_FULL_DUPLEX | 
	    LNK_HALF_DUPLEX | LNK_100MB | LNK_10MB;
	WRSHMEM(nic->genComm->gen_com.tuneParms.fast_link_negotiation, 
		link_set);
    }
    nic->hybridLen = nic->tuneParms[HYBRID_LENGTH].parm_val;
}
void
altUpdateNddParms(struct tg_nic *nic)
{
    nic->tuneParms[STAT_TICKS].parm_val = 
	RDSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks);
    nic->tuneParms[SEND_BDS].parm_val = 
	RDSHMEM(nic->genComm->gen_com.tuneParms.send_max_coalesced_bds);
    nic->tuneParms[SEND_TICKS].parm_val =
	RDSHMEM(nic->genComm->gen_com.tuneParms.send_coal_ticks);
    nic->tuneParms[RECV_BDS].parm_val = 
	RDSHMEM(nic->genComm->gen_com.tuneParms.recv_max_coalesced_bds);
    nic->tuneParms[RECV_TICKS].parm_val =
	RDSHMEM(nic->genComm->gen_com.tuneParms.recv_coal_ticks);
    nic->tuneParms[NIC_TRACE].parm_val = 
	RDSHMEM(nic->genComm->gen_com.tuneParms.tracing);
    if (RDSHMEM(nic->genComm->gen_com.tuneParms.link_negotiation) & 
	LNK_NEGOTIATE)
	nic->tuneParms[LINK_NEGOTIATE].parm_val = 1;
    else
	nic->tuneParms[LINK_NEGOTIATE].parm_val = 0;
    if (RDSHMEM(nic->genComm->gen_com.tuneParms.link_negotiation) & 
	LNK_RX_FLOW_CTL_Y)
	nic->tuneParms[RX_FLOW_CTL].parm_val = 1;
    else
	nic->tuneParms[RX_FLOW_CTL].parm_val = 0;
    if (RDSHMEM(nic->genComm->gen_com.tuneParms.link_negotiation) & 
	LNK_TX_FLOW_CTL_Y)
	nic->tuneParms[TX_FLOW_CTL].parm_val = 1;
    else
	nic->tuneParms[TX_FLOW_CTL].parm_val = 0;
    nic->tuneParms[HYBRID_LENGTH].parm_val = nic->hybridLen;
}
#else /* defined(__sun) */
void
altUpdateTuneParms(struct tg_nic *nic)
{
    U32 link_set;

    /* special tuning stuff, modification via ioctl */
    WRSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks, nic->stat_ticks);
    WRSHMEM(nic->genComm->gen_com.tuneParms.send_coal_ticks, 
	    nic->send_bd_ticks);
    WRSHMEM(nic->genComm->gen_com.tuneParms.tracing, nic->nic_tracing);
    WRSHMEM(nic->genComm->gen_com.tuneParms.recv_coal_ticks,
	    nic->recv_bd_ticks);

    /*
     * nic->genComm->gen_com.tuneParms.link_negotiation must
     * be always set to the desired value, not an intermediate
     * value because back to back tuneParms updates may leave
     * the value in an incorrect state
     */
    link_set = LNK_ENABLE;
    if (nic->linkSpeed <= 10)
	link_set |= LNK_10MB;
    else if (nic->linkSpeed <= 100)
	link_set |= LNK_100MB;
    else if (nic->linkSpeed <= 1000)
	link_set |= LNK_1000MB;
    
    if (nic->fullDuplex)
	link_set |= LNK_FULL_DUPLEX;
    else
	link_set |= LNK_HALF_DUPLEX;
    
    if (nic->flags & ALT_DO_LINK_NEGOTIATION) {
	    link_set |= LNK_NEGOTIATE;
	    link_set |= LNK_10MB;
	    link_set |= LNK_100MB;
	    link_set |= LNK_1000MB;
	    link_set |= LNK_FULL_DUPLEX;
	    link_set |= LNK_HALF_DUPLEX;
    }
		
    if (nic->flags & ALT_RX_FLOW_CONTROL)
	link_set |= LNK_RX_FLOW_CTL_Y;
    if ((nic->flags & ALT_TX_FLOW_CONTROL) &&
	nic->tigonRev != TG_MHC_LSI_GATE_VERS)
	link_set |= LNK_TX_FLOW_CTL_Y;
    WRSHMEM(nic->genComm->gen_com.tuneParms.link_negotiation, link_set);
    WRSHMEM(nic->genComm->gen_com.tuneParms.send_max_coalesced_bds, 
	    nic->send_bd_coal);
    WRSHMEM(nic->genComm->gen_com.tuneParms.recv_max_coalesced_bds, 
	    nic->recv_bd_coal);
    MB();

    nic->hybridLen = HYBRID_LEN;
}
#endif /* defined(__sun) */
