/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997, 1998 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altcinit.c $
 * Revision api12_3_ted/2 1999/06/18 21:49:12 ted
 * 	Remove OP14's real name from source
 * 
 * Revision cur_hayes/2 1999/03/26 22:36:20 hayes
 * 	add support for OP14, SGI and NEC
 * 
 * Revision 1.1.2.11  1999/01/26  21:27:22  leonid
 * 	Three memory leaks have been fixed
 * 	[1999/01/26  21:27:06  leonid]
 *
 * Revision 1.1.2.10  1999/01/21  22:59:36  ted
 * 	Remove unnecessary case
 * 	[1999/01/21  22:59:28  ted]
 * 
 * Revision 1.1.2.9  1999/01/20  00:17:58  leonid
 * 	Support for RING_DISABLED flag is added
 * 	[1999/01/20  00:17:37  leonid]
 * 
 * Revision 1.1.2.8  1999/01/19  00:36:56  leonid
 * 	For ndis driver, remove locks from alt_FreeNICmem()
 * 	[1999/01/19  00:36:30  leonid]
 * 
 * Revision 1.1.2.7  1998/12/03  19:13:04  hayes
 * 	fix minDma, revisit 450GX fix for x86 solaris
 * 	[1998/12/03  19:12:51  hayes]
 * 
 * Revision 1.1.2.6  1998/11/30  18:48:54  hayes
 * 	mini rings work for solaris/12.3 testing
 * 	[1998/11/30  18:46:41  hayes]
 * 
 * Revision 1.1.2.5  1998/11/19  00:15:54  dfoy
 * 	Fixed swkey check for ODI.
 * 	[1998/11/18  23:57:04  dfoy]
 * 
 * Revision 1.1.2.4  1998/11/17  00:19:30  hayes
 * 	update cksum offload testing framework
 * 	[1998/11/17  00:17:28  hayes]
 * 
 * Revision 1.1.2.3  1998/11/16  23:35:01  ted
 * 	Make combo of checksum offload and 450GX fix disable 450GX fix, change buffer ratio for NT, add registry based read max DMA init
 * 	[1998/11/16  23:32:22  ted]
 * 
 * Revision 1.1.2.2  1998/11/09  19:33:41  ted
 * 	support jumbos on x86 Solaris (test extended recv BD)
 * 	[1998/11/09  19:33:15  ted]
 * 
 * Revision 1.1.2.1  1998/11/04  19:37:36  ted
 * 	Split altdrv.c into altcfg.c, altcinit.c, and altintr.c
 * 	[1998/11/04  19:36:54  ted]
 * 
 * $EndLog$
 */

#ifndef __lint
static char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/common/altcinit.c,v 1.1.2.11 1999/01/26 21:27:22 leonid Exp $";
#endif /* __lint */

/* General include files */
#if !defined(ALT_SYSV) && !defined(WINNT)
#include <string.h>		/* get these from systm.h via conf.h below */
#endif /* !defined(ALT_SYSV) && !defined(WINNT) */ 

#if !defined(WINNT)
#include <sys/types.h>
#include <sys/errno.h>
#endif /* !defined(WINNT) */

/* System V include files */
#if defined(ALT_SYSV)
#include <sys/kmem.h>
#include <sys/ethernet.h>	/* ether_addr */
#include <sys/cmn_err.h>
#include <sys/conf.h>
#endif /* defined(ALT_SYSV) */

/* streams specific files */
#if defined(ALT_STREAM)
#include <sys/stream.h>		/* queue_t, before sunddi.h or warning */
#include <sys/dlpi.h>
#endif /* defined(ALT_STREAM) */

/* BSD include files */
#if defined(ALT_BSD)
#include <sys/socket.h>
#include <sys/mbuf.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#endif /* defined(ALT_BSD) */

/* system specific include files */
#if defined(__sun)
#include <sys/byteorder.h>	/* htonl... */
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ddi.h>		/* min */
#include <sys/ddidmareq.h>	/* ddi dma structs */
#include <sys/sunddi.h>		/* DDI_SUCCESS... */
#include <sys/ksynch.h>		/* kconfvar_t */
/* non-ddi defined function, not proto available in standard header files */
extern mblk_t *desballoc(unsigned char *, int, int, frtn_t *);
#endif /* defined(__sun) */

#if defined(WINNT)
#include <ndis.h>
#include "altntmsg.h"
#endif /* defined(WINNT) */	

#if defined(__NETWARE_386__)
#include <odi.h>
#include <odi_nbi.h>
#include <odi_nesl.h>
#include <parser.h>
#include <cmsm.h>
#include <splat.h>
#include <portable.h>
#endif /* defined(__NETWARE_386__) */

/* alteon include files */
#include "alt.h"
#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include "altioctl.h"
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */
#include "eeprom.h"
#include "pub_tg.h"
#include "altos.h"
#include "althdr.h"
#include "altreg.h"		/* must follow althdr.h */
#include "altftns.h"
#include "altbpdu.h"
#include "altdrv.h"
#include "link.h"

#if defined(WINNT)
#include "drvstat.h"
#endif /* defined(WINNT) */	

#if defined(__sun)
#include "sbus.h"
#endif /* defined(__sun) */

#if defined(__NETWARE_386__)
#include <ethertsm.h>
#endif /* defined(__NETWARE_386__) */

/*
 * miscellaneous function forwards
 */
#if defined(__STDC__) || defined(ALT_PROTOS)
STATIC void FreePartialAfterAllocFail(struct altinst *, U32);
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
STATIC void FreePartialAfterAllocFail();
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */

/* the following are used by altInitCard and FreePartialAfterAllocFail to
 * keep track of where things were when they went bad
 */
#define GENINFO_ALLOCED        0x00001
#define STATS2_ALLOCED         0x00002
#define RING_PTRS_ALLOCED      0x00004
#define EVENT_ARR_ALLOCED      0x00008
#define RECV_STD_ALLOCED       0x00010
#define RECV_JUMBO_ALLOCED     0x00020
#define RECV_RETURN_ALLOCED    0x00040
#define LOCKS_ALLOCED          0x00080
#define SEND_STUFF_ALLOCED     0x00100
#define SEND_DATA_ALLOCED      0x00200
#define SEND_DATA_PREPPED      0x00400
#define RECV_STUFF_ALLOCED     0x00800
#define RECV_DATA_ALLOCED      0x01000
#define RECV_DATA_PREPPED      0x02000
#if HOST_SEND_RING
#define SEND_ALLOCED           0x04000
#endif /* HOST_SEND_RING */
#if USE_MINI_RING
#define RECV_MINI_ALLOCED      0x08000
#define RECV_MINI_DATA_ALLOCED 0x10000
#define MINI_DATA_PREPPED      0x20000
#endif /* USE_MINI_RING */

/* ----------------- Initilization Code ----------------- */

int
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_InitNICstruct(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
alt_InitNICstruct(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic;

    ALTTRACE(NICstruc, 0x1002a, altp, altp->instance, 0, 0);

    /* NOTE *altp has been cleared to zero when this is called */

    MEMZALLOC(altp->initNic, struct tg_nic *, 
	      sizeof(struct tg_nic), ALT_NOSLEEP);
    if (!altp->initNic) {
	ERROR3("%s%d: alt_InitNICstruct: failed to allocate tg_nic memory\n",
	       altp->nic->name, altp->instance);
	ALTTRACEE(notgnic, 0xf0000, 0, 0, 0, 0);
	return(ENOMEM);
    }

    altp->nic = altp->initNic;
    nic = altp->nic;
    /* point the nic's altp back at the initialized altp for now,
     * in redundant case this gets moved, maybe */
    nic->altp = altp;

    /* fill in the tg_nic structure */
    (void) strcpy(nic->eyeCatch, "tgNic");

    return(PASSED);
}

/*
 * alt_FreeNICstruct
 *	Frees NIC memory
 *	Returns error or 0 for no error.
 */
int
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_FreeNICstruct(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
alt_FreeNICstruct(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;

    ALTTRACE(NICfree, 0x10001, altp, altp->instance, 0, 0);

    MEMFREE((caddr_t)nic, sizeof(struct tg_nic), ALT_NOSLEEP);
    return(PASSED);
}

/*
 * alt_InitNICmem
 *	Initializes the NIC specific memory and locks
 *	Returns error or 0 for no error.
 */

int
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_InitNICmem(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
alt_InitNICmem(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    int rc = 0;
    struct tg_nic *nic = altp->initNic;
    int i; 
    struct alt_dma_info *infop;
    U32 allocMask = 0;
    int j;
    ALT_MSG_DATA_TYPE curPtr; 
#if ALT_RECV_EXT
    int k;
    caddr_t pagePtr;
#endif /* ALT_RECV_EXT */
#if USE_DMA_MEMALLOC
    DMA_ADDR_TYPE physPtr;
    DMA_ADDR_TYPE physPagePtr;
#endif /* USE_DMA_MEMALLOC */

    ALTTRACE(NICmem, 0x10000, altp, altp->instance, nic, 0);

#if defined(__sun)
    /* fill in DMA attribute structure */
    nic->dmaAttr.dma_attr_version = DMA_ATTR_V0;
    nic->dmaAttr.dma_attr_addr_lo = 0;
    nic->dmaAttr.dma_attr_addr_hi = 0xffffffff;
    nic->dmaAttr.dma_attr_count_max = 0x0001ffff;
    nic->dmaAttr.dma_attr_align = 64; /* good number */
    nic->dmaAttr.dma_attr_burstsizes = 0xffffffff; /* infinite */
    nic->dmaAttr.dma_attr_minxfer = 1;
    nic->dmaAttr.dma_attr_maxxfer = 0x0001ffff;
    nic->dmaAttr.dma_attr_seg = 0xffffffff;
    nic->dmaAttr.dma_attr_sgllen = 1; /* force contiguous allocations */
    nic->dmaAttr.dma_attr_granular = 1;
    nic->dmaAttr.dma_attr_flags = 0;

#if FAST_DMA
    /* fill in the bus DMA limits struct, fast DMA stuff */
    nic->dmaLims.dlim_addr_lo = 0;
    nic->dmaLims.dlim_addr_hi = 0xffffffff;
    nic->dmaLims.dlim_cntr_max = 0xffffffff;
    nic->dmaLims.dlim_minxfer = 1;
    nic->dmaLims.dlim_dmaspeed = 100*1024; /* in kb/s */
    if (nic->nic_type == ALT_SBUS_NIC) {
	/* dlim_burstsizes for 32 and 64 bit xfers */
	nic->dmaLims.dlim_burstsizes = 0x00700070;	
    } else {
	nic->dmaLims.dlim_burstsizes = 0xffffffff; /* infinite */
#if defined(__i386)
	nic->dmaLims.dlim_version = DMALIM_VER0;
	nic->dmaLims.dlim_adreg_max = 0xffffffff;
	nic->dmaLims.dlim_ctreg_max = 0xffff;
	nic->dmaLims.dlim_granular = 1;
	nic->dmaAttr.dma_attr_sgllen = 1; /* force contiguous allocations */
	nic->dmaLims.dlim_reqsize = 0xffffffff;
#endif /* defined(__i386) */
    }
#endif /* FAST_DMA */
#endif /* defined(__sun) */
    
    /* allocate the general info area */
    DMA_MEMALLOC(nic->genInfoAlloc, caddr_t,
		 sizeof(struct tg_gen_info) + CACHE_LINE_SIZE, 
		 ALT_DMA_CONSISTENT,
		 DDI_DMA_RDWR, &nic->genInfoDmaInfo);
    if (!nic->genInfoAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate genInfo memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(nogninfo, 0xf0001, 0, 0, 0, 0);
	return(ENOMEM);
    }
    nic->genInfo = ALIGN_ADDR(nic->genInfoAlloc, CACHE_LINE_SIZE, 
			      struct tg_gen_info *);
    SET_INFOP_ADDR(&nic->genInfoDmaInfo, nic->genInfo);
    ALIGN_DMA_ADDR(nic->genInfoDmaInfo.dataAddrDmaAddr, CACHE_LINE_SIZE);
    allocMask |= GENINFO_ALLOCED;

    /* allocate a stats area for refreshing */
    DMA_MEMALLOC(nic->genInfoStats2, struct tg_stats *,
		 sizeof(struct tg_stats), ALT_DMA_CONSISTENT, DDI_DMA_RDWR,
		 &nic->genInfoStats2DmaInfo);
    if (!nic->genInfoStats2) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate genInfoStats2 memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(nostats2, 0xf0015, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    SET_INFOP_ADDR(&nic->genInfoStats2DmaInfo, nic->genInfoStats2);
    allocMask |= STATS2_ALLOCED;

    /* allocate enough space for the event producer, the send consumer, and
     * the recv ring producer, all on their own CACHE_LINE */
    DMA_MEMALLOC(nic->ringPointersAlloc, caddr_t, CACHE_LINE_SIZE * 4,
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, &nic->ringPointersDmaInfo);
    if (!nic->ringPointersAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate event producer memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(noevtprd, 0xf0002, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    /* now set up the various pointers in the space allocated */
    nic->eventProdPtr = ALIGN_ADDR(nic->ringPointersAlloc,
				   CACHE_LINE_SIZE, U32 *);
    SET_INFOP_ADDR(&nic->ringPointersDmaInfo, nic->eventProdPtr);
    nic->sendConsPtr = ALIGN_ADDR((char *)nic->ringPointersAlloc + 
				  CACHE_LINE_SIZE,
				  CACHE_LINE_SIZE, U32 *);
    nic->recvReturnProdPtr = 
	ALIGN_ADDR((char *)nic->ringPointersAlloc + (2 *CACHE_LINE_SIZE),
		   CACHE_LINE_SIZE, U32 *);

    /* use this address later to calculate DMA addresses to put into genInfo */
    ALIGN_DMA_ADDR(nic->ringPointersDmaInfo.dataAddrDmaAddr,  CACHE_LINE_SIZE);
    allocMask |= RING_PTRS_ALLOCED;

    /* allocate the event ring */
    DMA_MEMALLOC(nic->eventArrAlloc, caddr_t,
		 sizeof(struct tg_event) * (EVENT_RING_ENTRIES + 1),
		 ALT_DMA_CONSISTENT, DDI_DMA_READ, 
		 &nic->eventArrDmaInfo);
    if (!nic->eventArrAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate eventArr memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(noevtArr, 0xf0005, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    nic->eventArr = ALIGN_ADDR(nic->eventArrAlloc, CACHE_LINE_SIZE, 
			       struct tg_event (*)[EVENT_RING_ENTRIES]);
    SET_INFOP_ADDR(&nic->eventArrDmaInfo, nic->eventArr);
    /* also fix up dma address */
    ALIGN_DMA_ADDR(nic->eventArrDmaInfo.dataAddrDmaAddr, CACHE_LINE_SIZE);
    allocMask |= EVENT_ARR_ALLOCED;

#if HOST_SEND_RING
    /* allocate the send ring(s) */
    DMA_MEMALLOC(nic->sendRingAlloc, caddr_t,
		 sizeof(struct recv_bd) * (SEND_RING_ENTRIES + 1), 
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->sendRingDmaInfo);
    if (!nic->sendRingAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate sendRing memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(nosendrg, 0xf0029, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    /* align on a cache-line boundary for possible write-invalidate op */
    nic->sendRing = 
	ALIGN_ADDR(nic->sendRingAlloc, CACHE_LINE_SIZE,
		   struct send_bd (*)[SEND_RING_ENTRIES]);
    SET_INFOP_ADDR(&nic->sendRingDmaInfo, nic->sendRing);

    /* also fix up dma address */
    ALIGN_DMA_ADDR(nic->sendRingDmaInfo.dataAddrDmaAddr, CACHE_LINE_SIZE);
    allocMask |= SEND_ALLOCED;
#endif /* HOST_SEND_RING */

    /* allocate the recv ring(s) */
    DMA_MEMALLOC(nic->recvStdRingAlloc, caddr_t,
		 sizeof(struct recv_bd) * (RECV_STANDARD_RING_ENTRIES + 1), 
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvStdRingDmaInfo);
    if (!nic->recvStdRingAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate recvStdRing memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(norcvstd, 0xf0006, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    /* align on a cache-line boundary for possible write-invalidate op */
    nic->recvStdRing = 
	ALIGN_ADDR(nic->recvStdRingAlloc, CACHE_LINE_SIZE,
		   struct recv_bd (*)[RECV_STANDARD_RING_ENTRIES]);
    SET_INFOP_ADDR(&nic->recvStdRingDmaInfo, nic->recvStdRing);

    /* also fix up dma address */
    ALIGN_DMA_ADDR(nic->recvStdRingDmaInfo.dataAddrDmaAddr, CACHE_LINE_SIZE);
    allocMask |= RECV_STD_ALLOCED;

    DMA_MEMALLOC(nic->recvJumboRingAlloc, caddr_t,
		 sizeof(struct JUMBO_RECV_BD) * (RECV_JUMBO_RING_ENTRIES + 1), 
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvJumboRingDmaInfo);
    if (!nic->recvJumboRingAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate recvJumboRing memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(norcvjmb, 0xf0007, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    /* align on a cache-line boundary for possible write-invalidate op */
    nic->recvJumboRing = 
	ALIGN_ADDR(nic->recvJumboRingAlloc, CACHE_LINE_SIZE,
		   struct JUMBO_RECV_BD (*)[RECV_JUMBO_RING_ENTRIES]);
    SET_INFOP_ADDR(&nic->recvJumboRingDmaInfo, nic->recvJumboRing);

    /* also fix up dma address */
    ALIGN_DMA_ADDR(nic->recvJumboRingDmaInfo.dataAddrDmaAddr, CACHE_LINE_SIZE);
    allocMask |= RECV_JUMBO_ALLOCED;

#if USE_MINI_RING
    DMA_MEMALLOC(nic->recvMiniRingAlloc, caddr_t,
		 sizeof(struct recv_bd) * (RECV_MINI_RING_ENTRIES + 1), 
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvMiniRingDmaInfo);
    if (!nic->recvMiniRingAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate recvMiniRing memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(norcvmin, 0xf001a, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    /* align on a cache-line boundary for possible write-invalidate op */
    nic->recvMiniRing = 
	ALIGN_ADDR(nic->recvMiniRingAlloc, CACHE_LINE_SIZE,
		   struct recv_bd (*)[RECV_MINI_RING_ENTRIES]);
    SET_INFOP_ADDR(&nic->recvMiniRingDmaInfo, nic->recvMiniRing);

    /* also fix up dma address */
    ALIGN_DMA_ADDR(nic->recvMiniRingDmaInfo.dataAddrDmaAddr, CACHE_LINE_SIZE);
    allocMask |= RECV_MINI_ALLOCED;
#endif /* USE_MINI_RING */

    DMA_MEMALLOC(nic->recvReturnRingAlloc, caddr_t, 
		 sizeof(struct recv_bd) * (RECV_RETURN_RING_ENTRIES + 1), 
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvReturnRingDmaInfo);
    if (!nic->recvReturnRingAlloc) {
	ERROR3("%s%d: alt_InitNICmem: failed to allocate recvReturnRing memory\n",
	       nic->name, altp->instance);
	ALTTRACEE(norcvret, 0xf0008, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    /* align on a cache-line boundary for possible write-invalidate op */
    nic->recvReturnRing = 
	ALIGN_ADDR(nic->recvReturnRingAlloc, CACHE_LINE_SIZE,
		   struct recv_bd (*)[RECV_RETURN_RING_ENTRIES]);
    SET_INFOP_ADDR(&nic->recvReturnRingDmaInfo, nic->recvReturnRing);

    /* also fix up dma address */
    ALIGN_DMA_ADDR(nic->recvReturnRingDmaInfo.dataAddrDmaAddr, 
		   CACHE_LINE_SIZE);
    allocMask |= RECV_RETURN_ALLOCED;

#if ALT_LOCKS_SUPPORTED
    LOCK_INIT(&altp->nicMu, "redundant nic mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    /* initialize the flags mutex */
    LOCK_INIT(&nic->flagMu, "nic flag mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    /* initialize the memory window mutex */
    LOCK_INIT(&nic->memWindowMu, "memory window mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    LOCK_INIT(&nic->cmdMutex, "command ring mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    LOCK_INIT(&nic->sendMutex, "send ring mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    LOCK_INIT(&nic->recvMutex, "general recv mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    LOCK_INIT(&nic->recvRingMutex, "recv ring mutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    LOCK_INIT(&nic->recvBufsMutex, "bufsInRecvRingmutex", MUTEX_DRIVER, 
	       (void *)nic->iblock_cookie);
    allocMask |= LOCKS_ALLOCED;
#endif /* ALT_LOCKS_SUPPORTED */


    /* allocate send buffers and associated structures */
    ALLOC_SEND_STUFF(rc, altp, nic);
    if (rc) {
	ERROR3("%s%d: Couldn't allocate send buffer structures\n", 
	       nic->name, altp->instance);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    allocMask |= SEND_STUFF_ALLOCED;
    /* allocate send buffers */
    nic->sendBufCount = SEND_RING_ENTRIES; /* assume we win */
    /* 
     * for hybrid mode we only want to allocate enough space for the
     * largest hybrid size we're going to set.  This is generically 
     * defined in MAX_HYBRID_SIZE in alttypes.h.  The actual hybrid size
     * will be able to be modified depending on the driver in question.
     * This may be done at initiailzation (e.g. ODI) or on the fly (e.g.
     * Solaris).  In general, it's best to keep MAX_HYBRID_SIZE a power
     * of two so that it goes into a page size correctly.  We also over
     * allocate by one page size to allow for systems that don't return
     * memory on page aligned boundaries, because we round up to a 
     * page to start the partitioning of the memory allocated.
     */
#if USE_DMA_MEMALLOC
    DMA_MEMALLOC(nic->sendData, caddr_t, 
		 ((SEND_RING_ENTRIES + 1) * MAX_HYBRID_SIZE) + PAGE_SIZE,
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->sendDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMALLOC(nic->sendData, caddr_t, 
	     ((SEND_RING_ENTRIES + 1) * MAX_HYBRID_SIZE) + PAGE_SIZE,
	     ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    /* if we fail bitch */
    if (!nic->sendData) {
	ERROR3("%s%d: Couldn't allocate kernel memory for send buffers\n",
	       nic->name, altp->instance);
	ALTTRACEE(nosndbuf, 0xf0017, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    allocMask |= SEND_DATA_ALLOCED;
    curPtr = (caddr_t)PAGE_ROUNDUP(nic->sendData);
#if USE_DMA_MEMALLOC
    HOSTZEROHI(physPtr);
    HOSTADDR(physPtr) = MAP2BUS(nic->sendDataDmaInfo.dataAddr);
    ALIGN_DMA_ADDR(physPtr, PAGE_SIZE);
#endif /* USE_DMA_MEMALLOC */
    INIT_FREE_INFOP(nic);
    /* now prepare the DMA space and keep track of individual buffers */
    for (i = 0; i < NUM_INFOPS; i++) {
	infop = &nic->smsgs[i];
	PREP_SEND_INFOP(infop, altp, nic, i, curPtr, physPtr);
	FREE_INFOP(infop, nic, spl);
#if USE_DMA_MEMALLOC
	ADD_DMA_ADDR(physPtr, physPtr, MAX_HYBRID_SIZE);
#else /* USE_DMA_MEMALLOC */
	PREP_DMA(rc, ALT_DMA_SEND, DDI_DMA_READ, infop);
	/* if we fail, bitch */
	if (!rc) {
	    ERROR3("%s%d: Couldn't prep dma send buffer\n",
		   nic->name, altp->instance);
	    ALTTRACEE(nosbfprp, 0xf0018, 0, 0, 0, 0);
	    infop = nic->smsgs;
	    for (j=0; j < i; j++) {
		UNPREP_DMA(infop);
		UNPREP_SEND_INFOP(infop);
		infop++;
	    }
	    FreePartialAfterAllocFail(altp, allocMask);
	    return(ENOMEM);
	}
#endif /* USE_DMA_MEMALLOC */
	curPtr += MAX_HYBRID_SIZE;
    }
    allocMask |= SEND_DATA_PREPPED;

    /* allocate receive buffers and associated structures */
    ALLOC_RECV_STUFF(rc, altp, nic);
    if (rc) {
	ERROR3("%s%d: Couldn't allocate receive buffer structures\n", 
	       nic->name, altp->instance);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    allocMask |= RECV_STUFF_ALLOCED;

    /* allocate receive buffers */
    nic->recvStdBufCount = RECV_STANDARD_RING_ENTRIES - 1; /* assume we win */

#if ALT_RECV_EXT
    /*
     * we can fit some number of standard buffers into a page, 
     * (2 for 4k pages, 5 for 8k pages) so we need 
     * (RECV_STANDARD_RING_ENTRIES * PAGE_SIZE)/(RECV_BUFS_PER_PAGE) length 
     * of data.
     * 
     * Note: this is because we don't want to cause a receive buffer to
     * overlap a page boundary and cause multiple bds.
     */
#if USE_DMA_MEMALLOC
    DMA_MEMALLOC(nic->recvStdData, caddr_t, 
		 (RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1) * 
		 PAGE_SIZE,
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvStdDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMALLOC(nic->recvStdData, caddr_t,
	     (RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1) * PAGE_SIZE,
	     ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    /* if we fail bitch */
    if (!nic->recvStdData) {
	ERROR3("%s%d: Couldn't allocate kernel memory for recv buffers\n",
	       nic->name, altp->instance);
	ALTTRACE(norcvbuf, 0xf0024, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    allocMask |= RECV_DATA_ALLOCED;
    curPtr = (caddr_t)PAGE_ROUNDUP(nic->recvStdData);
    pagePtr = curPtr;
#if USE_DMA_MEMALLOC
    HOSTZEROHI(physPtr);
    HOSTADDR(physPtr) = MAP2BUS(nic->recvStdDataDmaInfo.dataAddr);
    ALIGN_DMA_ADDR(physPtr, PAGE_SIZE);
    physPagePtr = physPtr;
#endif /* USE_DMA_MEMALLOC */
    /* now prepare the DMA space and keep track of individual buffers */
    for (i=0; i < RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1; i++) {
	for (j=0; j < RECV_BUFS_PER_PAGE; j++) {
	    infop = &nic->rstdmsgs[i * RECV_BUFS_PER_PAGE + j];
	    PREP_RECV_INFOP(infop, nic, i, j, 
			    RECV_STANDARD_RING_ENTRIES - 1, curPtr, 
			    RECVBLOCKSIZE, physPtr);
#if USE_DMA_MEMALLOC
	    ADD_DMA_ADDR(physPtr, physPtr, RECVBLOCKSIZE);
#else /* USE_DMA_MEMALLOC */
	    PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_READ, infop);
	    /* if we fail, bitch */
	    if (!rc) {
		ERROR3("%s%d: Couldn't prep dma recv buffer\n",
		       nic->name, altp->instance);
		ALTTRACEE(norbfprp, 0xf0021, 0, 0, 0, 0);
		infop = nic->rstdmsgs;
		for (k=0; k < i * RECV_BUFS_PER_PAGE + j; k++) {
		    UNPREP_DMA(infop);
		    UNPREP_RECV_INFOP(infop);
		    infop++;
		}
		FreePartialAfterAllocFail(altp, allocMask);
		return(ENOMEM);
	    }
#endif /* USE_DMA_MEMALLOC */
	    curPtr += RECVBLOCKSIZE;
	    /* don't do extra ones */
	    if ((i * RECV_BUFS_PER_PAGE) + j == RECV_STANDARD_RING_ENTRIES - 2)
	    {
               i =  RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 2; 
               break;
	    }
	}

	/* after we do a page, in case it isn't even go to next page */
	pagePtr += PAGE_SIZE;
	curPtr = pagePtr;
#if USE_DMA_MEMALLOC
	ADD_DMA_ADDR(physPagePtr, physPagePtr, PAGE_SIZE);
	physPtr = physPagePtr;
#endif /* USE_DMA_MEMALLOC */
    }
    allocMask |= RECV_DATA_PREPPED;

#if USE_MINI_RING
#if USE_DMA_MEMALLOC
    DMA_MEMALLOC(nic->recvMiniData, caddr_t, 
		 (RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1) * 
		 PAGE_SIZE,
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvMiniDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMALLOC(nic->recvMiniData, caddr_t,
	     (RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1) * PAGE_SIZE,
	     ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    /* if we fail bitch */
    if (!nic->recvMiniData) {
	ERROR3("%s%d: Couldn't allocate kernel memory for mini recv buffers\n",
	       nic->name, altp->instance);
	ALTTRACEE(nominbuf, 0xf0027, 0, 0, 0, 0);
	FreePartialAfterAllocFail(altp, allocMask);
	return(ENOMEM);
    }
    allocMask |= RECV_MINI_DATA_ALLOCED;

    /* allocate receive buffers */
    nic->recvMiniBufCount = RECV_MINI_RING_ENTRIES - 1; /* assume we win */

    curPtr = (caddr_t)PAGE_ROUNDUP(nic->recvMiniData);
    pagePtr = curPtr;
#if USE_DMA_MEMALLOC
    HOSTZEROHI(physPtr);
    HOSTADDR(physPtr) = MAP2BUS(nic->recvMiniDataDmaInfo.dataAddr);
    ALIGN_DMA_ADDR(physPtr, PAGE_SIZE);
    physPagePtr = physPtr;
#endif /* USE_DMA_MEMALLOC */
    /* now prepare the DMA space and keep track of individual buffers */
    for (i=0; i < RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1; i++) {
	for (j=0; j < MINI_BUFS_PER_PAGE; j++) {
	    infop = &nic->rminimsgs[i * MINI_BUFS_PER_PAGE + j];
	    PREP_RECV_MINI_INFOP(infop, nic, i, j, 
			    RECV_MINI_RING_ENTRIES - 1, curPtr, 
			    MINIBLOCKSIZE, physPtr);
	    infop->flags |= ALT_DMA_MINI;
#if USE_DMA_MEMALLOC
	    ADD_DMA_ADDR(physPtr, physPtr, MINIBLOCKSIZE);
#else /* USE_DMA_MEMALLOC */
	    PREP_MINI_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_READ, infop);
	    /* if we fail, bitch */
	    if (!rc) {
		ERROR3("%s%d: Couldn't prep dma recv buffer\n",
		       nic->name, altp->instance);
		ALTTRACEE(nombfprp, 0xf002b, 0, 0, 0, 0);
		infop = nic->rminimsgs;
		for (k=0; k < i * MINI_BUFS_PER_PAGE + j; k++) {
		    UNPREP_DMA(infop);
		    UNPREP_RECV_INFOP(infop);
		    infop++;
		}
		FreePartialAfterAllocFail(altp, allocMask);
		return(ENOMEM);
	    }
#endif /* USE_DMA_MEMALLOC */
	    curPtr += MINIBLOCKSIZE;
	    /* don't do extra ones */
	    if ((i * MINI_BUFS_PER_PAGE) + j == RECV_MINI_RING_ENTRIES - 2)
		break;
	}
	/* don't do extra ones */
	if ((i * MINI_BUFS_PER_PAGE) + j == RECV_MINI_RING_ENTRIES - 1)
	    break;

	/* after we do a page, in case it isn't even go to next page */
	pagePtr += PAGE_SIZE;
	curPtr = pagePtr;
#if USE_DMA_MEMALLOC
	ADD_DMA_ADDR(physPagePtr, physPagePtr, PAGE_SIZE);
	physPtr = physPagePtr;
#endif /* USE_DMA_MEMALLOC */
    }
    allocMask |= MINI_DATA_PREPPED;
#endif /* USE_MINI_RING */
#endif /* ALT_RECV_EXT */
    return(PASSED);
}


/*
 * alt_FreeNICmem
 *	Frees the NIC specific memory and locks
 *	Returns error or 0 for no error.
 */

int
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_FreeNICmem(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
alt_FreeNICmem(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    U32 i;
    SEND_PKT *pkt;
    struct alt_dma_info *infop;

#if ALT_RECV_EXT
    /* 
     * Unprep all the DMAs, who cares if they were in the ring or whatever,
     * as long as the firmware/card is stopped we don't worry about accesses
     * and we've marked the state as NOTREADY so we don't have to worry
     * about altRecvDataRtn() getting in the way.  The mutex may not even
     * be necessary, but it shouldn't hurt.
     */
#if !defined(WINNT)
    ALT_DISABLE(spl, &nic->recvRingMutex); /* ENTER CRITICAL SECTION */
    ALT_DISABLE(spl, &nic->recvMutex); /* ENTER CRITICAL SECTION */
#endif
    /* 
     * before we do anything make sure that we don't have any buffers
     * that are "stuck" up in the upper layers of the stack.  If we do
     * we can't be taking out the driver because they'll point to a 
     * subroutine that won't be there any more when they finally get freed.
     * Check for this by going through the buffers on the receive ring
     * and (for suns) the spill buffers.  That's where all the ones in
     * our hands are.  If we don't count nic->recvStdBufCount down to 0
     * then we aren't done.
     * return EBUSY in this case
     */
    if (nic->flags & ALT_RING_FILLED) {
	ALTTRACEE(freeStd, 0x100d3, nic->recvStdBufCount, 0, 0, 0);
	while (nic->recv_std_consumer != nic->recv_std_producer) {
	    infop = nic->rstdmsgPtrs[nic->recv_std_consumer];
#if defined(__sun)
	    if (!(infop->flags & ALT_DMA_INFO_PREALLOC)) {
		UNPREP_DMA(infop);
                FREE_RECV_BUF(altp, infop->INFOP_RPKT);
		MEMFREE(infop, sizeof(struct alt_dma_info), ALT_NOSLEEP);
	    } else
#endif /* defined(__sun) */
		nic->recvStdBufCount--;	/* go to 0 */
	    nic->recv_std_consumer = INCRING(nic->recv_std_consumer, 
					     RECV_STANDARD_RING_ENTRIES);
	}
#if defined(__sun)
	/* subtract all the bufs on the spill ring and clear the spill queue */
	nic->recvStdBufCount -= nic->spillBufs;
	NOTE4("%s%d: nic->spillBufs: 0x%08x",
	      altp->nic->name, altp->instance, nic->spillBufs);
	nic->spillBufs = 0;
	nic->recvRingSpill = (struct alt_dma_info *)0;
#endif /* defined(__sun) */
	if (nic->recvStdBufCount) {
	    NOTE4("%s%d: recvStdBufCount not zero: 0x%08x",
		  altp->nic->name, altp->instance, nic->recvStdBufCount);
	    ALTTRACEE(recvbusy, 0x10024, nic->recvStdBufCount, 0, 0, 0);
#if !defined(WINNT)
	    ALT_ENABLE(spl, &nic->recvMutex); /* LEAVE CRITICAL SECTION */
	    ALT_ENABLE(spl, &nic->recvRingMutex); /* LEAVE CRITICAL SECTION */
#endif
	    return(EBUSY);
	}
    }

    if ((nic->flags & ALT_JUMBO_ENABLED) && (nic->flags & ALT_JUMBO_FILLED)) {
	ALTTRACEE(freeJmbo, 0x100d3, nic->recvJumboBufCount, 0, 0, 0);
	/*
	 *  before we do anything else make sure that we don't have any
	 * jumbo buffers that are "stuck" up in the upper layers of the
	 * stack.  If we do we can't be taking out the driver because
	 * they'll point to a subroutine that won't be there any more when
	 * they finally get freed.  Check for this by going through the
	 * buffers on the receive jumbo ring That's where all the ones in
	 * our hands are.  If we don't count nic->recvJumboBufCount down
	 * to 0 then we aren't done.  
	 * return EBUSY in this case 
	 */
	while (nic->recv_jumbo_consumer != nic->recv_jumbo_producer) {
	    infop = nic->rjumbomsgPtrs[nic->recv_jumbo_consumer];
#if !USE_DMA_MEMALLOC
	    UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	    UNPREP_RECV_INFOP(infop);
	    nic->recvJumboBufCount--;	/* go to 0 */
	    nic->recv_jumbo_consumer = 
		INCRING(nic->recv_jumbo_consumer, RECV_JUMBO_RING_ENTRIES);
	}
	if (nic->recvJumboBufCount) {
	    NOTE4("%s%d: recvJumboBufCount not zero: 0x%08x",
		  altp->nic->name, altp->instance, nic->recvJumboBufCount);
	    ALTTRACEE(recvbusy, 0x1002e, nic->recvJumboBufCount, 0, 0, 0);
#if !defined(WINNT)
	    ALT_ENABLE(spl, &nic->recvMutex); /* LEAVE CRITICAL SECTION */
	    ALT_ENABLE(spl, &nic->recvRingMutex); /* LEAVE CRITICAL SECTION */
#endif
	    return(EBUSY);
	}
    }

#if USE_MINI_RING
    /*
     *  before we do anything else make sure that we don't have any
     * mini buffers that are "stuck" up in the upper layers of the
     * stack.  If we do we can't be taking out the driver because
     * they'll point to a subroutine that won't be there any more when
     * they finally get freed.  Check for this by going through the
     * buffers on the receive mini ring That's where all the ones in
     * our hands are.  If we don't count nic->recvMiniBufCount down
     * to 0 then we aren't done.  
     * return EBUSY in this case 
     */
    if (nic->flags & ALT_MINI_FILLED) {
	ALTTRACEE(freeMini, 0x100d3, nic->recvMiniBufCount, 0, 0, 0);
	while (nic->recv_mini_consumer != nic->recv_mini_producer) {
	    infop = nic->rminimsgPtrs[nic->recv_mini_consumer];
#if !USE_DMA_MEMALLOC
	    UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	    UNPREP_RECV_INFOP(infop);
	    nic->recvMiniBufCount--;	/* go to 0 */
	    nic->recv_mini_consumer = 
		INCRING(nic->recv_mini_consumer, RECV_MINI_RING_ENTRIES);
	}
	if (nic->recvMiniBufCount) {
	    NOTE4("%s%d: recvMiniBufCount not zero: 0x%08x",
		  altp->nic->name, altp->instance, nic->recvMiniBufCount);
	    ALTTRACEE(recvbusy, 0x1002e, nic->recvMiniBufCount, 0, 0, 0);
#if !defined(WINNT)
	    ALT_ENABLE(spl, &nic->recvMutex); /* LEAVE CRITICAL SECTION */
	    ALT_ENABLE(spl, &nic->recvRingMutex); /* LEAVE CRITICAL SECTION */
#endif
	    return(EBUSY);
	}
    }
#endif /* USE_MINI_RING */

    /* unprep the standard receive area */
    for (i=0; i < RECV_STANDARD_RING_ENTRIES - 1; i++) {
	infop = &nic->rstdmsgs[i];
	if (infop && infop->dataAddr) {
#if !USE_DMA_MEMALLOC
	    UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	    UNPREP_RECV_INFOP(infop);
	    /* protect against multiple free */
	    infop->dataAddr = (caddr_t) 0;
	}
    }

#if defined(__sun)
    /* see if we have any infops hanging out in the infop overflow ring */
    while (nic->freeOverFlowBufs) {
	infop = nic->freeOverFlowBufs;
	nic->freeOverFlowBufs = infop->next;
	nic->numFreeOverFlowBufs--;
	MEMFREE(infop, sizeof(struct alt_dma_info), ALT_NOSLEEP);
    }
#endif /* defined(__sun) */

    /* free the actual memory allocated */
#if USE_DMA_MEMALLOC
    DMA_MEMFREE(nic->recvStdData, 
		(RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1) * 
		PAGE_SIZE, &nic->recvStdDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMFREE(nic->recvStdData, 
	    (RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1) * PAGE_SIZE, 
	    ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */

    if ((nic->flags & (ALT_JUMBO_ENABLED | ALT_JUMBO_INITED)) ==
	(ALT_JUMBO_ENABLED | ALT_JUMBO_INITED)) {
	for (i=0; i < RECV_JUMBO_RING_ENTRIES-1; i++) {
	    infop = &nic->rjumbomsgs[i];
	    if (infop && infop->dataAddr) {
#if !USE_DMA_MEMALLOC
	        UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
		UNPREP_RECV_INFOP(infop);
		/* protect against multiple free */
		infop->dataAddr = (caddr_t) 0;
	    }
	    infop++;
	    nic->recvJumboBufCount--;
	}
	/* free the actual memory allocated */
#if USE_DMA_MEMALLOC
	DMA_MEMFREE(nic->recvJumboData, 
		    (RECV_JUMBO_RING_ENTRIES + 1) * 
		    PAGE_SIZE * PAGES_PER_JUMBO_BUFFER, 
		    &nic->recvJumboDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
	MEMFREE(nic->recvJumboData, 
		(RECV_JUMBO_RING_ENTRIES + 1) * 
		PAGE_SIZE * PAGES_PER_JUMBO_BUFFER, 
		ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    }

#if USE_MINI_RING
    for (i=0; i < RECV_MINI_RING_ENTRIES-1; i++) {
	infop = &nic->rminimsgs[i];
	if (infop && infop->dataAddr) {
#if !USE_DMA_MEMALLOC
	    UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	    UNPREP_RECV_INFOP(infop);
	    /* protect against multiple free */
	    infop->dataAddr = (caddr_t) 0;
	}
	infop++;
	nic->recvMiniBufCount--;
    }

    /* free the actual memory allocated */
#if USE_DMA_MEMALLOC
    DMA_MEMFREE(nic->recvMiniData, 
		(RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1) * 
		PAGE_SIZE, &nic->recvMiniDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMFREE(nic->recvMiniData, 
	    (RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1) * 
	    PAGE_SIZE, ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
#endif /* USE_MINI_RING */

#if !defined(WINNT)
    ALT_ENABLE(spl, &nic->recvMutex); /* LEAVE CRITICAL SECTION */
    ALT_ENABLE(spl, &nic->recvRingMutex); /* LEAVE CRITICAL SECTION */
#endif
#else /* ALT_RECV_EXT */
    /* free up any messages left in the recv rings */
    i = nic->recv_std_consumer;
    while (i != nic->recv_std_producer) {
	infop = &nic->rstdmsgs[i];
	/* clean up */
#if !USE_DMA_MEMALLOC
	UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	UNPREP_RECV_INFOP(infop);
	FREE_RECV_BUF(altp, infop->INFOP_RPKT);
	i = INCRING(i, RECV_STANDARD_RING_ENTRIES);
    }
    i = nic->recv_jumbo_consumer;
    while (i != nic->recv_jumbo_producer) {
	infop = &nic->rjumbomsgs[i];
	/* clean up */
#if !USE_DMA_MEMALLOC
	UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	UNPREP_RECV_INFOP(infop);
	FREE_RECV_BUF(altp, infop->INFOP_RPKT);
	i = INCRING(i, RECV_JUMBO_RING_ENTRIES);
    }
#if USE_MINI_RING
    i = nic->recv_mini_consumer;
    while (i != nic->recv_mini_producer) {
	infop = &nic->rminimsgs[i];
	/* clean up */
#if !USE_DMA_MEMALLOC
	UNPREP_DMA(infop);
#endif /* !USE_DMA_MEMALLOC */
	UNPREP_RECV_INFOP(infop);
	FREE_RECV_BUF(altp, infop->INFOP_RPKT);
	i = INCRING(i, RECV_MINI_RING_ENTRIES);
    }
#endif /* USE_MINI_RING */

    /* don't worry about the recv return ring, we've already handled 
     * everything that could be on it */
#endif /* ALT_RECV_EXT */

    /* Free up the recv ring stuff, std and jumbo */
    FREE_RECV_STUFF(altp, nic);
    if ((nic->flags & (ALT_JUMBO_ENABLED | ALT_JUMBO_INITED)) ==
	(ALT_JUMBO_ENABLED | ALT_JUMBO_INITED)) {
	nic->flags &= ~(ALT_JUMBO_ENABLED | ALT_JUMBO_INITED);
	FREE_JUMBO_RECV_STUFF(altp, nic);
    }

#if USE_MINI_RING
    FREE_MINI_RECV_STUFF(altp, nic);
#endif /* USE_MINI_RING */

    /* free up any messages left in the send ring */
    pkt = nic->smsgs[nic->send_consumer].pkt;
    i = nic->send_consumer;
    while (i != nic->send_producer) {
	/* we only have to do it once if the data was spread over multiple
	 * bds */
	infop = &nic->smsgs[i];
	if (!(infop->flags & 
	      (ALT_DMA_INFO_FLAG_CONT | ALT_DMA_INFO_PREALLOC)) &&
	    infop->dataAddrFly) {
	    /* clear off the DMA stuff */
	    UNPREP_FLY_DMA(infop);
	    UNPREP_SEND_FLY_INFOP(infop);
	    /* protect against multiple free */
	    infop->dataAddrFly = (caddr_t) 0;
	}
	if (infop->flags & ALT_DMA_INFO_FLAG_END) {
	    i = INCRING(i, SEND_RING_ENTRIES);
	    /* free the whole msg */
	    MSGFREE(pkt, MSG_SUCCESS);
	    pkt = nic->smsgs[i].pkt;
	} else
	    i = INCRING(i, SEND_RING_ENTRIES);
    }

    INIT_FREE_INFOP(nic);
    /* free up the send bufs, don't worry about active bufs, not like recv */
    for (i=0; i < NUM_INFOPS; i++) {
	infop = &nic->smsgs[i];
	FREE_INFOP(infop, nic, spl);
	/* protect yourself from badness */
	if (infop->dataAddr) {
	    UNPREP_DMA(infop);
#if USE_DMA_MEMALLOC
	    UNPREP_SEND_INFOP(infop);
#endif /* USE_DMA_MEMALLOC */
	    /* protect against multiple free */
	    infop->dataAddr = (caddr_t) 0;
	}
    }

#if USE_DMA_MEMALLOC
    DMA_MEMFREE(nic->sendData,
		((SEND_RING_ENTRIES + 1) * MAX_HYBRID_SIZE) + PAGE_SIZE,
		&nic->sendDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMFREE(nic->sendData, 
	    ((SEND_RING_ENTRIES + 1) * MAX_HYBRID_SIZE) + PAGE_SIZE,
	    ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */

    nic->sendBufCount = 0;

#if defined(__NETWARE_386__)
    CMSMServiceEvents();	/* let upper layers know */
#endif /* defined(__NETWARE_386__) */

    /* make sure we don't accidentally do it again */
    nic->send_producer = nic->send_consumer = 0;

    FREE_SEND_STUFF(altp, nic);

    /* free up the normal data structures */
    /* protect against multiple frees */
    if (nic->genInfoStats2) {
	DMA_MEMFREE((caddr_t)nic->genInfoStats2, sizeof(struct tg_stats),
		    &nic->genInfoStats2DmaInfo);
	nic->genInfoStats2 = (struct tg_stats *) 0;
    }
    if (nic->genInfo) {
	DMA_MEMFREE((caddr_t)nic->genInfoAlloc, 
		    sizeof(struct tg_gen_info) + CACHE_LINE_SIZE,
		    &nic->genInfoDmaInfo);
	nic->genInfo = (struct tg_gen_info *) 0;
	nic->genInfoAlloc = (caddr_t) 0;
    }
    if (nic->ringPointersAlloc) {
	DMA_MEMFREE((caddr_t)nic->ringPointersAlloc, CACHE_LINE_SIZE * 4,
		    &nic->ringPointersDmaInfo);
	nic->eventProdPtr = (U32 *) 0;
	nic->sendConsPtr = (U32 *) 0;
	nic->recvReturnProdPtr = (U32 *) 0;
	nic->ringPointersAlloc = (caddr_t) 0;
    }
    if (nic->eventArr) {
	DMA_MEMFREE((caddr_t)nic->eventArrAlloc, 
		    sizeof(struct tg_event) * (EVENT_RING_ENTRIES + 1),
		    &nic->eventArrDmaInfo);
	nic->eventArr = (struct tg_event (*)[EVENT_RING_ENTRIES]) 0;
    }
    if (nic->recvStdRing) {
	DMA_MEMFREE((caddr_t)nic->recvStdRingAlloc, 
		    sizeof(struct recv_bd) * (RECV_STANDARD_RING_ENTRIES + 1),
		    &nic->recvStdRingDmaInfo);
	nic->recvStdRing = (struct recv_bd (*)[RECV_STANDARD_RING_ENTRIES]) 0;
	nic->recvStdRingAlloc = (caddr_t) 0;
    }
    if (nic->recvJumboRing) {
	DMA_MEMFREE((caddr_t)nic->recvJumboRingAlloc, 
		    sizeof(struct JUMBO_RECV_BD) * 
		    (RECV_JUMBO_RING_ENTRIES + 1),
		    &nic->recvJumboRingDmaInfo);
	nic->recvJumboRing = 
	    (struct JUMBO_RECV_BD (*)[RECV_JUMBO_RING_ENTRIES]) 0;
	nic->recvJumboRingAlloc = (caddr_t) 0;
    }
#if USE_MINI_RING
    if (nic->recvMiniRing) {
	DMA_MEMFREE((caddr_t)nic->recvMiniRingAlloc, 
		    sizeof(struct recv_bd) * (RECV_MINI_RING_ENTRIES + 1),
		    &nic->recvMiniRingDmaInfo);
	nic->recvMiniRing = 
	    (struct recv_bd (*)[RECV_MINI_RING_ENTRIES]) 0;
	nic->recvMiniRingAlloc = (caddr_t) 0;
    }
#endif /* USE_MINI_RING */
    if (nic->recvReturnRing) {
	DMA_MEMFREE((caddr_t)nic->recvReturnRingAlloc, 
		    sizeof(struct recv_bd) * (RECV_RETURN_RING_ENTRIES + 1),
		    &nic->recvReturnRingDmaInfo);
	nic->recvReturnRing = (struct recv_bd (*)[RECV_RETURN_RING_ENTRIES]) 0;
	nic->recvReturnRingAlloc = (caddr_t) 0;
    }

    /* free nic snap trace info */
    freeDump(altp);

    /* clear out nic flags */
    ATOMIC_SET(spl, &nic->flagMu, nic->flags, 0);

#if ALT_LOCKS_SUPPORTED
    /* destroy the ring mutexes */
    LOCK_DESTROY(&altp->nicMu);	/* redundant nic mutex */
    LOCK_DESTROY(&nic->flagMu);
    LOCK_DESTROY(&nic->memWindowMu);
    LOCK_DESTROY(&nic->cmdMutex);
    LOCK_DESTROY(&nic->sendMutex);
    LOCK_DESTROY(&nic->recvMutex);
    LOCK_DESTROY(&nic->recvRingMutex);
    LOCK_DESTROY(&nic->recvBufsMutex);
#endif /* ALT_LOCKS_SUPPORTED */

#if defined(__sun)
    if (nic->nic_type == ALT_SBUS_NIC) {
	/* unprep the text segment we mapped for PCI bridge, b4 we call ph1 */
#if FAST_DMA
	SLOW_UNPREP_DMA(&nic->textDmaInfo);
#else /* FAST_DMA */
	UNPREP_DMA(&nic->textDmaInfo);
#endif /* FAST_DMA */
	nic->flags &= ~ALT_SBUS_MAPPED;
    }
#endif /* defined(__sun) */
    return(0);
}

/*
 * alt_InitNICph1
 *	Initializes the NIC specific hardware. Verify hardware ID.
 *	Returns error or 0 for no error.
 */
int
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_InitNICph1(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
alt_InitNICph1(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
#if defined(__sun)
    int rc;
    struct alt_dma_info *infop = &nic->textDmaInfo;
#endif /* defined(__sun) */

    ALTTRACE(NICph1, 0x10003, altp, altp->instance, nic, 0);

    /* enable memory space reads */
#if defined(__sun)
#if defined(__sparc)
    if (nic->nic_type == ALT_SBUS_NIC) {
	/* quite the wonderful hack, map the firmware's text array onto the
	 * bus, and use this for the base address we tell the PCI bus.
	 * We KNOW we'll never use these values for DMA so we'll be happy
	 * Make sure to align the data on a 0x4000 boundary to satisfy PCI
	 * requirements and not accidentally write some of the magic SBUS bits
	 */
	/* only do this once, we can get called out of the stop routine */
	if (!(nic->flags & ALT_SBUS_MAPPED)) {
	    /* set up some of the values in the infop area */
	    /* set up some of the values in the infop area */
	    /* alignment comments on all this sbus stuff:
	     * The SBUS mapping must be aligned on 0x4000 boundary, but
	     * aligning real memory on a 0x4000 byte boundary does not
	     * guarantee this the way PREP_DMA maps to virtual memory, so
	     * following the mapping (on a page boundary) for a length
	     * of double the size of the data space (0x4000) we do a second
	     * alignment to the 0x4000 boundary with the virtual address */
	    infop->dataAddr = (caddr_t)PAGE_ROUNDUP(tigonFwText);
	    infop->dataLen = 0x8000;
	    infop->nic = nic;
#if FAST_DMA
	    SLOW_PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_READ, infop)
#else /* FAST_DMA */
	    PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_READ, infop)
#endif /* FAST_DMA */
	    /* if we fail, bitch */
	    if (rc != 1) {
		ERROR4("%s%d: Couldn't prep text segment buffer for SBUS mapping, got %d spaces\n", 
	       nic->name, altp->instance, rc);
		ALTTRACEE(nosbmap, 0xf001f, rc, 0, 0, 0);
		return(FAILURE);
	    }
	    ALTTRACE(picPage, 0x10023, tigonFwText, infop->dataAddr, 
		     MAP2BUS(infop->dataAddr), 0);
	    ALIGN_DMA_ADDR(nic->textDmaInfo.dataAddrDmaAddr, 0x4000);
	    nic->flags |= ALT_SBUS_MAPPED;
	}
#if SBUS_32
	/* initialize PCI base address, to an address we'll never use */
	OUTCFG32(nic->configHandle, nic->configBase, TG_SHARED_BASE, 
		 (U32)nic->textDmaInfo.dataAddrDmaAddr | 
		 ALT_SBUS_16_WORD_XFERS);
#else /* SBUS_32 */
	/* initialize PCI base address, max 8 dword transfer,
	 * chaining on */
	OUTCFG32(nic->configHandle, nic->configBase, TG_SHARED_BASE,
		 (U32)nic->textDmaInfo.dataAddrDmaAddr | 
		 ALT_SBUS_8_WORD_XFERS);
#endif /* SBUS_32 */
	
	/* LINTED pointer cast may result in improper alignment */
	OUTCFG32(nic->configHandle, nic->configBase, TG_STATUS, 
		 SBUS_DEFAULT_PCI_COMMAND);
    } else {
#endif /* defined(__sparc) */
	/* LINTED pointer cast may result in improper alignment */
	OUTCFG16(nic->configHandle, nic->configBase, TG_STATUS, 
		 DEFAULT_PCI_COMMAND);
#if defined(__sparc)
    }
#endif /* defined(__sparc) */
#else /* defined(__sun) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
    /* Not necessary on anything with a real BIOS */
    /* LINTED pointer cast may result in improper alignment */
    OUTCFG16(nic->configHandle, nic->configBase, TG_STATUS, 
	     DEFAULT_PCI_COMMAND);
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */    
#endif /* defined(__sun) */

    /* set the endian bit, notice that this register is written to on both
     * ends.  This way it doesn't matter how the register is being accessed
     * currently
     */
#if ALT_BIG_ENDIAN
#if defined(__sun)
    if (nic->nic_type == ALT_SBUS_NIC) {
	/* hack in the latency value */
	OUTCFG32(nic->configHandle, nic->configBase, TG_BIST, 0xffffffff);

	/* make sure byte swapping is enabled and firmware is halted,
	 * and rupts are disabled */
	OUTCFG32(nic->configHandle, nic->configBase, TG_MISC_HOST_CONTROL, 
		 ((TG_MHC_WORD_SWAP | TG_MHC_CLEAR_RUPT) |
		  ((TG_MHC_WORD_SWAP | TG_MHC_CLEAR_RUPT) << 24)));

    } else {
#endif /* defined(__sun) */
	/* hack in the latency value */
	OUTCFG8(nic->configHandle, nic->configBase, TG_LAT_TIMER, 0x40);

	/* make sure byte swapping is enabled and firmware is halted,
	 * and rupts are disabled */
	OUTCFG32(nic->configHandle, nic->configBase, TG_MISC_HOST_CONTROL, 
		 ((TG_MHC_BYTE_SWAP | TG_MHC_WORD_SWAP | TG_MHC_CLEAR_RUPT) |
		  ((TG_MHC_BYTE_SWAP | TG_MHC_WORD_SWAP | TG_MHC_CLEAR_RUPT) 
		   << 24)));
#if defined(__sun)
    }
#endif /* defined(__sun) */
#else /* ALT_BIG_ENDIAN */
    /* make sure byte swapping is disabled and firmware is halted,
     * and rupts are disabled */
    OUTCFG32(nic->configHandle, nic->configBase, TG_MISC_HOST_CONTROL, 
	     TG_MHC_CLEAR_RUPT | TG_MHC_WORD_SWAP |
	     (TG_MHC_CLEAR_RUPT | TG_MHC_WORD_SWAP) << 24);
#endif /* ALT_BIG_ENDIAN */

    /* can't check our hardware until we've set up byte swapping */
    nic->tigonRev = INCFG32(nic->configHandle, nic->configBase, 
			    TG_MISC_HOST_CONTROL) & TG_MHC_TIGON_VERSION_MASK;

    switch (nic->tigonRev) {
	case TG_MHC_LSI_STANDARD_CELL_VERS:
	case TG_MHC_LSI_STANDARD_CELL_VERS_B:
#if defined(__sun)
	    /* SBus uses asynchronous memory with Tigon 2 */
	    if (nic->nic_type == ALT_SBUS_NIC) {
		/* ensure the MLC doesn't say stuff */
		OUTCFG32(nic->configHandle, nic->configBase, 
			 TG_MISC_LOCAL_CONTROL, 0);
		OUTCFG32(nic->configHandle, nic->configBase, 
			 TG_MISC_CONFIG, 0);
	    } else {
#endif /* defined(__sun) */
		/* set for 512k bank in MLC */
		OUTCFG32(nic->configHandle, nic->configBase, 
			 TG_MISC_LOCAL_CONTROL,
			 TG_MLC_SRAM_BANK_512K);
		/* setup the misc_config reg */
		OUTCFG32(nic->configHandle, nic->configBase, TG_MISC_CONFIG,
			 TG_MSC_ENA_SYNC_SRAM_TIMING);
#if defined(__sun)
	    }
#endif /* defined(__sun) */
	    break;
	case TG_MHC_LSI_GATE_VERS:
	    /* ensure the MLC doesn't say stuff */
	    OUTCFG32(nic->configHandle, nic->configBase, 
		     TG_MISC_LOCAL_CONTROL, 0);
	    break;

	default:
	    ERROR4("%s%d: unrecognized ASIC revision number %d found\n",
		   nic->name, altp->instance, nic->tigonRev >> 28);
		   
	    ASSERT(0);
    }
 
    return(PASSED);
}

/*
 * alt_InitNICph2
 *	Load up the firmware and set some variables.
 *	Returns error or 0 for no error.
 */
int
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_InitNICph2(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
alt_InitNICph2(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    char swKey[4];
    int rc;

    ALTTRACE(NICph2, 0x10004, altp, altp->instance, nic, 0);

    (void) stopFW(altp);

    /* check to see if this is a card we want to support */
    if ((rc = readTGSerEeprom(altp, 
			      (U32)((eeprom_layout_t *)TG_BEG_SER_EEPROM)->manufact.sw_key, 
			      swKey, 4, FALSE))) {
	ERROR3("%s%d: Couldn't read Serial EEPROM\n",
	       nic->name, altp->instance);
	return(FAILURE);
    }
    
#if defined(__NETWARE_386__)
    /* we accept Universal cards and any type of Alteon card */
    /* we accept Universal cards and any type of Alteon card */
    if (swKey[0] != OEM_UNIVERSAL) {
	if (swKey[0] != altp->oem) {
	    if ((altp->oem == OEM_ALTEON_2) && (swKey[0] != OEM_ALTEON_1)) {
		ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
			nic->name, altp->instance);
		return(FAILURE);
	    }
	}
    }
#elif defined(__sun) /* defined(__NETWARE_386__ */
    /* do the actual checking.  We accept universal cards or if we're OEM
     * partner 1 we also accept their cards or if we're Alteon we accept
     * our type 1 cards */
    if (swKey[0] != OEM_UNIVERSAL &&
	!((altp->flags & ALT_DRIVER_IS_OP1) && swKey[0] == OEM_PARTNER1) &&
	!(!(altp->flags & ALT_DRIVER_IS_OP1) && (swKey[0] == OEM_ALTEON_1
#if !defined(__sparc)	/* x86 Solaris allows type 2 cards as well */
					     || swKey[0] == OEM_ALTEON_2
#endif /* !defined(__sparc) */
	))) {
	ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
	       nic->name, altp->instance);
	return(FAILURE);
    }
#elif defined(WINNT) /* defined(__NETWARE_386__ */
#if defined(ALTEON)
    /* we accept Universal cards and any type of Alteon card */
    if (swKey[0] != OEM_UNIVERSAL && 
	swKey[0] != OEM_ALTEON_1 &&
        swKey[0] != OEM_ALTEON_2) {
        ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
               nic->name, altp->instance);
        return(FAILURE);
    }
#elif defined(OP2) /* defined(ALTEON) */
    /* we accept Universal cards and OP2 cards */
    if (swKey[0] != OEM_UNIVERSAL &&
        swKey[0] != OEM_PARTNER2) {
        ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
               nic->name, altp->instance);
        return(FAILURE);
    }
#elif defined(DEC) /* defined(ALTEON) */
    /* we accept Universal cards and OP3 cards */
    if (swKey[0] != OEM_UNIVERSAL &&
        swKey[0] != OEM_PARTNER3) {
        ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
               nic->name, altp->instance);
        return(FAILURE);
    }
#elif defined(OP14) /* defined(ALTEON) */
    /* we accept Universal cards and OP14 cards */
    if (swKey[0] != OEM_UNIVERSAL &&
        swKey[0] != OEM_PARTNER14) {
        ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
               nic->name, altp->instance);
        return(FAILURE);
    }
#elif defined(SGI) /* defined(ALTEON) */
    /* we accept Universal cards and SGI cards */
    if (swKey[0] != OEM_UNIVERSAL &&
        swKey[0] != OEM_PARTNER16) {
        ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
               nic->name, altp->instance);
        return(FAILURE);
    }
#elif defined(NEC) /* defined(ALTEON) */
    /* we accept Universal cards and Alteon NT cards */
    if (swKey[0] != OEM_UNIVERSAL &&
        swKey[0] != OEM_ALTEON_2) {
        ERROR3("%s%d: NIC was obtained through invalid channels, please see your reseller\n",
               nic->name, altp->instance);
        return(FAILURE);
    }
#else
    error No vendor defined...
#endif /* defined(ALTEON) */
#endif /* defined(__NETWARE_386__) */

    /* check cpu_state prom_failed bit for self test */
    /* LINTED pointer cast may result in improper alignment */
    if (IN32(nic->handle, nic->base, TG_CPU_CONTROL) & 
	TG_CPU_PROM_FAILED) {
	/* LINTED pointer cast may result in improper alignment */
	ERROR4("%s%d: Self Diagnostics failed 0x%x\n", 
	       nic->name, altp->instance,
	       IN32(nic->handle, nic->base, TG_CPU_CONTROL));
	ALTTRACEE(selfdiag, 0xf0016, 
		  IN32(nic->handle, nic->base, TG_CPU_CONTROL), 0, 0, 0);
	return(FAILURE);
    }

    /* initialize the hardware parts of the NIC structure */
    /* LINTED pointer cast may result in improper alignment */
    nic->genComm =
	(tg_shmem_t *)((char *)nic->base + TG_SHMEM_START);

    /* prepare the command ring */
    nic->cmdArr = (struct tg_command (*)[COMMAND_RING_ENTRIES])
	nic->genComm->gen_com.command_ring;

#if !HOST_SEND_RING
    /* prepare the send ring */
    nic->sendRing = (struct send_bd (*)[SEND_RING_ENTRIES])
	((char *)nic->base + TG_MEM_WINDOW);
#endif /* !HOST_SEND_RING */

    /* set up the window to point to the right place from now on */
    OUT32(nic->handle, nic->base, TG_WINDOW_BASE, SEND_RING_PTR);
    
    /* make sure MBOX 0 is cleared so we can get interrupts */
    OUT32(nic->handle, nic->base, TG_MBOX0_LOW, 0);
    
    /* find out if we've got flash, and if so what it is */
    determineTGFlash(nic);

    /* get the card going */
    if (altInitCard(altp))
	return(EFAULT);

    return(PASSED);
}

STATIC void
#if defined(__STDC__) || defined(ALT_PROTOS)
FreePartialAfterAllocFail(struct altinst *altp, U32 mask)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
FreePartialAfterAllocFail(altp, mask)
struct altinst *altp;
U32 mask;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    int i;
    struct alt_dma_info *infop;

#if ALT_RECV_EXT
#if USE_MINI_RING
    if (mask & MINI_DATA_PREPPED)
	for (i=0; i < RECV_MINI_RING_ENTRIES - 1; i++) {
	    infop = &nic->rminimsgs[i];
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
	}
    if (mask & RECV_MINI_DATA_ALLOCED) {
#if USE_DMA_MEMALLOC
	DMA_MEMFREE(nic->recvMiniData, 
		    (RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1) * 
		    PAGE_SIZE, &nic->recvMiniDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
	MEMFREE(nic->recvMiniData, 
		(RECV_MINI_RING_ENTRIES/MINI_BUFS_PER_PAGE + 1) * 
		PAGE_SIZE,
		ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    }
#endif /* USE_MINI_RING */

    if (mask & RECV_DATA_PREPPED)
	for (i=0; i < RECV_STANDARD_RING_ENTRIES - 1; i++) {
	    infop = &nic->rstdmsgs[i];
	    UNPREP_DMA(infop);
	    UNPREP_SEND_INFOP(infop);
	}
    if (mask & RECV_DATA_ALLOCED) {
#if USE_DMA_MEMALLOC
	DMA_MEMFREE(nic->recvStdData, 
		    (RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1) * 
		    PAGE_SIZE, &nic->recvStdDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
	MEMFREE(nic->recvStdData, 
		(RECV_STANDARD_RING_ENTRIES/RECV_BUFS_PER_PAGE + 1) * 
		PAGE_SIZE,
		ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    }
#endif /* ALT_RECV_EXT */
    if (mask & RECV_STUFF_ALLOCED)
	FREE_RECV_STUFF(altp, nic);
    if (mask & SEND_DATA_PREPPED)
	for (i=0; i < NUM_INFOPS; i++) {
	    infop = &nic->smsgs[i];
	    UNPREP_DMA(infop);
	    UNPREP_SEND_INFOP(infop);
	}
    if (mask & SEND_DATA_ALLOCED)
#if USE_DMA_MEMALLOC
        DMA_MEMFREE(nic->sendData,
		    ((SEND_RING_ENTRIES + 1) * MAX_HYBRID_SIZE) + PAGE_SIZE,
		    &nic->sendDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
	MEMFREE(nic->sendData, 
		((SEND_RING_ENTRIES + 1) * MAX_HYBRID_SIZE) + PAGE_SIZE,
		ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    if (mask & SEND_STUFF_ALLOCED)
	FREE_SEND_STUFF(altp, nic);

#if ALT_LOCKS_SUPPORTED
    if (mask & LOCKS_ALLOCED) {
	/* destroy the ring mutexes */
	LOCK_DESTROY(&altp->nicMu);	/* redundant nic mutex */
	LOCK_DESTROY(&nic->flagMu);
	LOCK_DESTROY(&nic->memWindowMu);
	LOCK_DESTROY(&nic->cmdMutex);
	LOCK_DESTROY(&nic->sendMutex);
	LOCK_DESTROY(&nic->recvMutex);
	LOCK_DESTROY(&nic->recvRingMutex);
	LOCK_DESTROY(&nic->recvBufsMutex);
    }
#endif /* ALT_LOCKS_SUPPORTED */

    if (mask & RECV_RETURN_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->recvReturnRingAlloc, 
		    sizeof(struct recv_bd) * (RECV_RETURN_RING_ENTRIES + 1),
		    &nic->recvReturnRingDmaInfo);
	nic->recvReturnRing = (struct recv_bd (*)[RECV_RETURN_RING_ENTRIES]) 0;
	nic->recvReturnRingAlloc = (caddr_t) 0;
    }

#if USE_MINI_RING
    if (mask & RECV_MINI_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->recvMiniRingAlloc, 
		    sizeof(struct recv_bd) * (RECV_MINI_RING_ENTRIES + 1),
		    &nic->recvMiniRingDmaInfo);
	nic->recvMiniRing = 
	    (struct recv_bd (*)[RECV_MINI_RING_ENTRIES]) 0;
	nic->recvMiniRingAlloc = (caddr_t) 0;
    }
#endif /* USE_MINI_RING */

    if (mask & RECV_JUMBO_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->recvJumboRingAlloc, 
		    sizeof(struct JUMBO_RECV_BD) * 
		    (RECV_JUMBO_RING_ENTRIES + 1),
		    &nic->recvJumboRingDmaInfo);
	nic->recvJumboRing = 
	    (struct JUMBO_RECV_BD (*)[RECV_JUMBO_RING_ENTRIES]) 0;
	nic->recvJumboRingAlloc = (caddr_t) 0;
    }

    if (mask & RECV_STD_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->recvStdRingAlloc, 
		    sizeof(struct recv_bd) * (RECV_STANDARD_RING_ENTRIES + 1),
		    &nic->recvStdRingDmaInfo);
	nic->recvStdRing = (struct recv_bd (*)[RECV_STANDARD_RING_ENTRIES]) 0;
	nic->recvStdRingAlloc = (caddr_t) 0;
    }

#if HOST_SEND_RING
    if (mask & SEND_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->sendRingAlloc, 
		    sizeof(struct send_bd) * (SEND_RING_ENTRIES + 1),
		    &nic->sendRingDmaInfo);
	nic->sendRing = (struct send_bd (*)[SEND_RING_ENTRIES]) 0;
	nic->sendRingAlloc = (caddr_t) 0;
    }
#endif /* HOST_SEND_RING */

    if (mask & EVENT_ARR_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->eventArrAlloc, 
		    sizeof(struct tg_event) * (EVENT_RING_ENTRIES + 1),
		    &nic->eventArrDmaInfo);
	nic->eventArr = (struct tg_event (*)[EVENT_RING_ENTRIES]) 0;
    }

    if (mask & RING_PTRS_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->ringPointersAlloc, CACHE_LINE_SIZE * 4,
		    &nic->ringPointersDmaInfo);
	nic->eventProdPtr = (U32 *) 0;
	nic->sendConsPtr = (U32 *) 0;
	nic->recvReturnProdPtr = (U32 *) 0;
	nic->ringPointersAlloc = (caddr_t) 0;
    }

    if (mask & STATS2_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->genInfoStats2, sizeof(struct tg_stats),
		    &nic->genInfoStats2DmaInfo);
	nic->genInfoStats2 = (struct tg_stats *) 0;
    }

    if (mask & GENINFO_ALLOCED) {
	DMA_MEMFREE((caddr_t)nic->genInfoAlloc, 
		    sizeof(struct tg_gen_info) + CACHE_LINE_SIZE,
		    &nic->genInfoDmaInfo);
	nic->genInfo = (struct tg_gen_info *) 0;
	nic->genInfoAlloc = (caddr_t) 0;
    }
}

#if defined(WINNT)
/* lovely strlen since NT doesn't let us use the systems :-( */
int
altStrlen(char *str)
{
    int cnt = 0;

    while (*str++)
	cnt++;
    return(cnt);
}
/* lovely hexchar since NT doesn't let us use sprintf :-( */
char
altHexchar(char x)
{
    if (x > 9)
	return('a' + (x-10));
    else
	return('0' + x);
}
#endif /* defined(WINNT) */

/*
 * altInitCard
 * 	Make sure that the card is running. Returns 0 for no error
 */
int
#if defined(__STDC__) || defined(ALT_PROTOS)
altInitCard(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altInitCard(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    int rc = 0;
    U32 macspot[2]={0,0};	/* space for the padded MAC address */
#if defined(ALT_BSD)
    struct ifnet *ifp = (struct ifnet *)altp;
#endif /* defined(ALT_BSD) */
    struct tg_nic *nic = altp->initNic;
    char partNumber[16];
    char boardRev[4];
#if !ALT_BIG_ENDIAN
    struct ether_addr macAddr;
#endif /* !ALT_BIG_ENDIAN */

    /* mark things down */
    altp->state = ALT_FW_LOADED;
    nic->eventCons = 0;

    /* fix DMA parms to give "best" performance for this system (tuneable) */
#if defined(__sun)
    if (nic->nic_type == ALT_SBUS_NIC) {
	switch (nic->tigonRev) {
	    case TG_MHC_LSI_STANDARD_CELL_VERS:
	    case TG_MHC_LSI_STANDARD_CELL_VERS_B:
		OUT32(nic->handle, nic->base, TG_PCI_STATE, 
		      TG_PCI_STATE_DMA_READ_MAX_64 | 
		      TG_PCI_STATE_DMA_WRITE_MAX_64 |
#if !SBUS_32
		      TG_PCI_STATE_PROVIDE_LEN |
		      TG_PCI_STATE_NO_WORD_SWAP |
#endif /* !SBUS_32 */
		      TG_PCI_STATE_READ_CMD_MEM_READ |
		      TG_PCI_STATE_WRITE_CMD_MEM_WRITE |
		      TG_PCI_STATE_PROVIDE_LEN |
		      TG_PCI_STATE_DMA_WR_ALL_ALIGN);
		break;

	    case TG_MHC_LSI_GATE_VERS:
		OUT32(nic->handle, nic->base, TG_PCI_STATE, 
		      TG_PCI_STATE_DMA_READ_MAX_64 | 
		      TG_PCI_STATE_DMA_WRITE_MAX_64 |
#if !SBUS_32
		      TG_PCI_STATE_PROVIDE_LEN |
		      TG_PCI_STATE_NO_READ_WORD_SWAP |
		      TG_PCI_STATE_NO_WRITE_WORD_SWAP |
#endif /* !SBUS_32 */
		      TG_PCI_STATE_READ_CMD_MEM_READ |
		      TG_PCI_STATE_WRITE_CMD_MEM_WRITE |
		      TG_PCI_STATE_PROVIDE_LEN);
		break;
	}
    } else {
#if defined(__sparc)
	OUT32(nic->handle, nic->base, TG_PCI_STATE, 
	      TG_PCI_STATE_DMA_READ_MAX_64 |
	      TG_PCI_STATE_DMA_WRITE_MAX_64 | 
	      TG_PCI_STATE_READ_CMD_MEM_READ |
	      TG_PCI_STATE_WRITE_CMD_MEM_WRITE);
#else /* defined(__sparc) */
	OUT32(nic->handle, nic->base, TG_PCI_STATE, 
	      TG_PCI_STATE_DMA_READ_MAX_DISA | 
	      TG_PCI_STATE_DMA_WRITE_MAX_DISA |
	      TG_PCI_STATE_DMA_WR_ALL_ALIGN | /* 450GX chipset fix */
	      TG_PCI_STATE_READ_CMD_MEM_READ |
	      TG_PCI_STATE_WRITE_CMD_MEM_WRITE);
	/*
	 * mark that we've used the 450GX chipset fix...
	 */
	nic->init_flags |= ALT_INIT_450GX_FIX;
#endif /* defined(__sparc) */
    }
#else /* defined(__sun) */
#if defined(WINNT) && defined(ALPHA)
    /*
     * Must insure that we do not cross an 8K (bytes) boundary.  Our highest
     * limit is 1K bytes.  This is a restriction on some ALPHA platforms.
     */
    OUT32(nic->handle, nic->base, TG_PCI_STATE, 
	  TG_PCI_STATE_DMA_READ_MAX_1K | 
	  TG_PCI_STATE_DMA_WRITE_MAX_1K |
	  TG_PCI_STATE_READ_CMD_MEM_READ |
	  TG_PCI_STATE_WRITE_CMD_MEM_WRITE);
#else /*  defined(WINNT) && defined(ALPHA) */
    /* fix DMA parms to give "best" performance for this system (tuneable) */
    switch (nic->tigonRev) {
        case TG_MHC_LSI_STANDARD_CELL_VERS:
        case TG_MHC_LSI_STANDARD_CELL_VERS_B:
            OUT32(nic->handle, nic->base, TG_PCI_STATE,
                  (nic->minDma << 8) |
                  nic->pci_read_max |
                  TG_PCI_STATE_DMA_WRITE_MAX_DISA |
                  TG_PCI_STATE_READ_CMD_MEM_READ |
                  TG_PCI_STATE_WRITE_CMD_MEM_WRITE);
            break;
 
        case TG_MHC_LSI_GATE_VERS:
            OUT32(nic->handle, nic->base, TG_PCI_STATE,
                  /* MinDma is broken for Tigon1 */
                  nic->pci_read_max |
                  TG_PCI_STATE_DMA_WRITE_MAX_DISA |
                  TG_PCI_STATE_READ_CMD_MEM_READ |
                  TG_PCI_STATE_WRITE_CMD_MEM_WRITE);
            break;
    }
#endif /*  defined(WINNT) && defined(ALPHA) */
#endif /* defined(__sun) */

    /*
     * on some systems using the intel 450gx chipset, doing zero length
     * writes can cause the P6 bus to hang.  This is due to a bug in the
     * 450gx chipset.  We will occasionally do zero length writes on a 
     * 32 bit pci bus when we must complete draining our PCI transmit fifo.
     * This fifo is 64 bits wide, so all writes of the length of 0x......0X
     * will result in a zero length write to complete the write transaction.
     * To prevent this, we turn on the "Assert all PBEs on write" bit in
     * the PCI state register.
     *
     * XXX Note: that this workaround BREAKS our checksum offload
     * capabilities and the firmware is aware of this bit and will prevent
     * checksum offload from being enabled when this bit is set.
     */
    if (nic->init_flags & ALT_INIT_450GX_FIX) {
	NOTE3("%s%d: Enabling all PCI byte enables on writes",
	      altp->nic->name, altp->instance);
	OUT32(nic->handle, nic->base, TG_PCI_STATE,
	      IN32(nic->handle, nic->base, TG_PCI_STATE) | 
	      TG_PCI_STATE_DMA_WR_ALL_ALIGN);
    }	

    /*
     * If the system has enabled PCI mem write & invalidate,
     * we need to set our write max length to the cache line
     * size in the PCI config region...
     */
    if (IN32(nic->handle, nic->base, TG_STATUS) &
        PCI_CONF_CMD_MEM_WRITE_INVALIDATE) {
 
        U32 cache_line_size;
        U32 pci_write_max;
	U32 mwi_disable = 0;

	if (nic->init_flags & ALT_INIT_MEM_WR_INV_DISABLE) {
	    NOTE3("%s%d: Disabling PCI memory write and invalidate",
		  altp->nic->name, altp->instance);
	    OUT32(nic->handle, nic->base, TG_STATUS,
		IN32(nic->handle, nic->base, TG_STATUS) &
		    ~PCI_CONF_CMD_MEM_WRITE_INVALIDATE);
	    mwi_disable = 1;
	} else {
	    cache_line_size = IN32(nic->handle, nic->base, TG_BIST) & 0xff;

	    switch (cache_line_size) {  /* words */
		case 1:
		    pci_write_max = TG_PCI_STATE_DMA_WRITE_MAX_4;
		    break;
     
		case 4:
		    pci_write_max = TG_PCI_STATE_DMA_WRITE_MAX_16;
		    break;
     
		case 8:
		    pci_write_max = TG_PCI_STATE_DMA_WRITE_MAX_32;
		    break;
     
		case 16:
		    pci_write_max = TG_PCI_STATE_DMA_WRITE_MAX_64;
		    break;
     
		case 32:
		    pci_write_max = TG_PCI_STATE_DMA_WRITE_MAX_128;
		    break;
     
		case 64:
		    pci_write_max = TG_PCI_STATE_DMA_WRITE_MAX_256;
		    break;
     
		default:
		    NOTE4("%s%d: Cache line size %i unsupported; disabling PCI memory write and invalidate",
			altp->nic->name, altp->instance,
			(cache_line_size << 2));
		    OUT32(nic->handle, nic->base, TG_STATUS,
			IN32(nic->handle, nic->base, TG_STATUS) &
			    ~PCI_CONF_CMD_MEM_WRITE_INVALIDATE);
		    mwi_disable = 1;
	    }
	}
 
        if (!mwi_disable) {
            NOTE4("%s%d: setting PCI Cache Line size to %i for memory write and invalidate",
                altp->nic->name, altp->instance,
                (cache_line_size << 2));
 
	    OUT32(nic->handle, nic->base, TG_PCI_STATE,
		(IN32(nic->handle, nic->base, TG_PCI_STATE) & 
		    ~TG_PCI_STATE_DMA_WRITE_MASK) |
		pci_write_max);
	}
    }

    /* print stuff out about the card */
    if ((rc = readTGSerEeprom(altp, 
			      (U32)(((eeprom_layout_t *)TG_BEG_SER_EEPROM)->
				    manufact.serial_number), 
			      (char *)macspot, 8, FALSE))) {
	NOTE3("%s%d: unable to read serial EEPROM, aborting.",
	      altp->nic->name, altp->instance);
	return(rc);
    }

#if ALT_BIG_ENDIAN
    NOTE9("%s%d: Serial Number is %x:%x:%x:%x:%x:%x",
	  altp->nic->name, altp->instance,
	  (int)((macspot[0] & 0xff00) >> 8),
	  (int)(macspot[0] & 0xff),
	  (int)((macspot[1] & 0xff000000) >> 24),
	  (int)((macspot[1] & 0xff0000) >> 16),
	  (int)((macspot[1] & 0xff00) >> 8),
	  (int)(macspot[1] & 0xff));
#else /* ALT_BIG_ENDIAN */
    /* copy it to handle byte swapping issues */
    MEMCPY((MEMCPY_TYPE)&macAddr, ((char *)macspot)+2, 6);
    NOTE9("%s%d: Serial Number is %x:%x:%x:%x:%x:%x", 
	  nic->name, altp->instance,
	  (int)(macAddr.ether_addr_octet[0] & 0xff),
	  (int)(macAddr.ether_addr_octet[1] & 0xff),
	  (int)(macAddr.ether_addr_octet[2] & 0xff),
	  (int)(macAddr.ether_addr_octet[3] & 0xff),
	  (int)(macAddr.ether_addr_octet[4] & 0xff),
	  (int)(macAddr.ether_addr_octet[5] & 0xff));
#endif /* ALT_BIG_ENDIAN */

    if ((rc = readTGSerEeprom(altp, 
			      (U32)(((eeprom_layout_t *)TG_BEG_SER_EEPROM)->
				    manufact.part_number), 
			      partNumber, 16, FALSE))) {
	NOTE3("%s%d: unable to read serial EEPROM, aborting.",
	      altp->nic->name, altp->instance);
	return(rc);
    }
    
    NOTE4("%s%d: Part number is %s",
	  altp->nic->name, altp->instance,
	  partNumber);

    if ((rc = readTGSerEeprom(altp, 
			      (U32)(((eeprom_layout_t *)TG_BEG_SER_EEPROM)->
				    manufact.board_rev), 
			      boardRev, 4, FALSE))) {
	NOTE3("%s%d: unable to read serial EEPROM, aborting.",
	      altp->nic->name, altp->instance);
	return(rc);
    }

    NOTE5("%s%d: Board Revision is %c%c",
	  altp->nic->name, altp->instance,
	  boardRev[0], boardRev[1]);

#if defined(WINNT)
    {
        char s[200];
	char *s2;
	int chars;

        /* put all this stuff into the event log, no nice way so we just 
	 * write the stuff into the data space so the ascii will get printed
	 */
	BZERO(s, 200);
        MEMCPY(s, "Serial Number is", 16);
	s2 = s + 16;
	*s2 = altHexchar((char)((macAddr.ether_addr_octet[0] & 0xf0) >> 4));
	s2++;
	*s2 = altHexchar((char)(macAddr.ether_addr_octet[0] & 0xf));
	s2++;
	*s2 = ':';
	s2++;
	*s2 = altHexchar((char)((macAddr.ether_addr_octet[1] & 0xf0) >> 4));
	s2++;
	*s2 = altHexchar((char)(macAddr.ether_addr_octet[1] & 0xf));
	s2++;
	*s2 = ':';
	s2++;
	*s2 = altHexchar((char)((macAddr.ether_addr_octet[2] & 0xf0) >> 4));
	s2++;
	*s2 = altHexchar((char)(macAddr.ether_addr_octet[2] & 0xf));
	s2++;
	*s2 = altHexchar((char)((macAddr.ether_addr_octet[3] & 0xf0) >> 4));
	s2++;
	*s2 = altHexchar((char)(macAddr.ether_addr_octet[3] & 0xf));
	s2++;
	*s2 = ':';
	s2++;
	*s2 = altHexchar((char)((macAddr.ether_addr_octet[4] & 0xf0) >> 4));
	s2++;
	*s2 = altHexchar((char)(macAddr.ether_addr_octet[4] & 0xf));
	s2++;
	*s2 = ':';
	s2++;
	*s2 = altHexchar((char)((macAddr.ether_addr_octet[5] & 0xf0) >> 4));
	s2++;
	*s2 = altHexchar((char)(macAddr.ether_addr_octet[5] & 0xf));
	s2++;
	MEMCPY(s2, " , ", 3);
	s2 += 3;
        MEMCPY(s2, "Part number is ", 15);
	s2 += 15;
	MEMCPY(s2, partNumber, altStrlen(partNumber));
	s2 += altStrlen(partNumber);
	MEMCPY(s2, " , ", 3);
	s2 += 3;
        MEMCPY(s2, "Board Revision is ", 18);
	s2 += 18;
	*s2 = boardRev[0];
	s2++;
	*s2 = boardRev[1];
	s2++;
	*s2 = '\0';		/* null terminate */

        NdisWriteErrorLogEntry(nic->handle,
			       (NDIS_ERROR_CODE) ALT_LOG_PRODUCT_INFO,
			       21,
			       *((U32 *)s + 0),
			       *((U32 *)s + 1),
			       *((U32 *)s + 2),
			       *((U32 *)s + 3),
			       *((U32 *)s + 4),
			       *((U32 *)s + 5),
			       *((U32 *)s + 6),
			       *((U32 *)s + 7),
			       *((U32 *)s + 8),
			       *((U32 *)s + 9),
			       *((U32 *)s + 10),
			       *((U32 *)s + 11),
			       *((U32 *)s + 12),
			       *((U32 *)s + 13),
			       *((U32 *)s + 14),
			       *((U32 *)s + 15),
			       *((U32 *)s + 16),
			       *((U32 *)s + 17),
			       *((U32 *)s + 18),
			       *((U32 *)s + 19),
			       *((U32 *)s + 20),
			       *((U32 *)s + 21));
    }
#endif /* defined(WINNT) */

    if (nic->flags & ALT_OVERRIDE_MAC_ADDR) {
	/* we're overriding, print it */
	NOTE9("%s%d: Using override MAC address %x:%x:%x:%x:%x:%x", 
	      nic->name, altp->instance,
	      (int)(altp->macAddr.ether_addr_octet[0] & 0xff),
	      (int)(altp->macAddr.ether_addr_octet[1] & 0xff),
	      (int)(altp->macAddr.ether_addr_octet[2] & 0xff),
	      (int)(altp->macAddr.ether_addr_octet[3] & 0xff),
	      (int)(altp->macAddr.ether_addr_octet[4] & 0xff),
	      (int)(altp->macAddr.ether_addr_octet[5] & 0xff));
    } else {
	/* if we're not overriding the mac address go get it */
	altGetMacAddr(altp, &altp->macAddr);
    }

    /* copy it to the NIC shared memory region via an 8 byte location */
    MEMCPY(((char *)macspot)+2, (MEMCPY_TYPE)&altp->macAddr, 
	   sizeof(struct ether_addr));
    ALT_SWAP_MEMCPY_TODEV((MEMCPY_TYPE)&nic->genComm->gen_com.mac_addr, 
			  (MEMCPY_TYPE)macspot, 8);

#if defined(__NETWARE_386__)	/* special flag for shutdown */
    altp->flags |= ALT_CAN_STOP_CARD;
#endif /* defined(__NETWARE_386__) */

    /* link up the ring structures */
    initRings(altp);

    /* load and start the firmware */
    if (!loadFW(altp)) {
	NOTE3("%s%d: unable to download firmware, aborting.",
	      altp->nic->name, altp->instance);
        return(EFAULT);
    }
 
    if (!verifyFW(altp)) {
	NOTE3("%s%d: firmware verification failed, aborting.",
	      altp->nic->name, altp->instance);
        return(EFAULT);
    }

#if FIRMWARE_DEBUGGED
    if (!startFW(altp)) {
	NOTE3("%s%d: firmware start failed, aborting.",
	      altp->nic->name, altp->instance);
	return(EFAULT);
    }
#endif /* FIRMWARE_DEBUGGED */
    
#if defined(ALT_BSD)
    /* make sure the IF layer is off */
    ifp->if_flags &= ~IFF_RUNNING;
#endif /* defined(ALT_BSD) */
    
    /* actual operation won't begin until a FIRMWARE_OPERATIONAL event recvd */
    return(0);
}

/*
 * altStopCard
 *    Turn off the card (hard reset)
 */
int
#if defined(__STDC__) || defined(ALT_PROTOS)
altStopCard(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altStopCard(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    U32 temp;
    struct tg_nic *nic = altp->initNic;
#if defined(ALT_BSD)
    struct ifnet *ifp = (struct ifnet *)altp;
#endif /* defined(ALT_BSD) */

    ALTTRACE(stopcard, 0x10017, altp, 0, 0, 0);

#if defined(ALT_BSD)
    /* make sure IF layer is turned off */
    ifp->if_flags &= ~IFF_RUNNING;
#endif /* defined(ALT_BSD) */

    /* 
     * In case we get an interrupt when we are not expecting it,
     * we will hit mailbox with zero in the hardware ISR.
     */
    altp->state = ALT_NOTREADY;    
	altp->nic->flags &= ~ALT_LINK_READY;
    
    /* clean shut down or Sbus cards get upset */
    stopFW(altp);		/* no more activity */

    /* make sure MBOX 0 is cleared so we can get interrupts */
    OUT32(nic->handle, nic->base, TG_MBOX0_LOW, 0);
    
    /* get these back to zero so if we restart it doesn't start by going 
     * crazy */
    nic->commandProd = 0;
    nic->commandCons = 0;
    nic->bufsInStdRecvRing = 0;
    nic->bufsInJumboRecvRing = 0;
#if USE_MINI_RING
    nic->bufsInMiniRecvRing = 0;
#endif /* USE_MINI_RING */

    /* pause the DMA assist engine */
    temp = IN32(nic->handle, nic->base, TG_ASSIST_STATE);
    OUT32(nic->handle, nic->base, TG_ASSIST_STATE, temp | TG_DMA_ASSIST_PAUSE);

    /* make sure both DMA engines are either finished or in attention */
    do {
	SNOOZE(1);
	temp = IN32(nic->handle, nic->base, TG_DMA_WRITE_STATE);
    } while (!(temp & TG_DMA_STATE_ERROR_MASK) &&
	     (temp & TG_DMA_STATE_ACTIVE));

    do {
	SNOOZE(1);
	temp = IN32(nic->handle, nic->base, TG_DMA_READ_STATE);
    } while (!(temp & TG_DMA_STATE_ERROR_MASK) && 
	     (temp & TG_DMA_STATE_ACTIVE));

    /* give it a hard reset */
    OUT32(nic->handle, nic->base, TG_MISC_HOST_CONTROL, TG_MHC_RESET);

    /* wait a whole second for the board to get better */
#if defined(__NETWARE_386__)
    /* The 'SNOOZE' function isn't accurate enough for long times so
     * use timer */
    {
	unsigned int first;

        first = CMSMGetMicroTimer();
        while (CMSMGetMicroTimer()-first < 1000000);
    }        
#else
    SNOOZE(1000000);
#endif

    /* reset the registers to the starting point */
    if (alt_InitNICph1(altp)) {
	ALTTRACE(ph1Fail, 0x10025, 0, 0, 0, 0);
	return(EIO);
    }

    return(0);
}

/*
 * altInitJumbo
 *    Allocate stuff for jumbogram ring
 */
int
#if defined(__STDC__) || defined(ALT_PROTOS)
altInitJumbo(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altInitJumbo(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    int rc = 0;
    struct tg_nic *nic = altp->initNic;
#if ALT_RECV_EXT
    struct alt_dma_info *infop;
    ALT_MSG_DATA_TYPE curPtr;
    int i, j;
#if USE_DMA_MEMALLOC
    DMA_ADDR_TYPE physPtr;
#endif /* USE_DMA_MEMALLOC */
#endif /* ALT_RECV_EXT */

    /* don't reinit */
    if (altp->flags & ALT_JUMBO_INITED)
	return(0);

    /* allocate receive buffers and associated structures */
    ALLOC_JUMBO_RECV_STUFF(rc, altp, nic);
    if (rc)
	return(rc);

    /* allocate receive buffers */
    nic->recvJumboBufCount = RECV_JUMBO_RING_ENTRIES -1; /* assume we win */

#if ALT_RECV_EXT
#if USE_DMA_MEMALLOC
    DMA_MEMALLOC(nic->recvJumboData, caddr_t, 
		 (RECV_JUMBO_RING_ENTRIES + 1) * 
		 PAGE_SIZE * PAGES_PER_JUMBO_BUFFER,
		 ALT_DMA_CONSISTENT, DDI_DMA_RDWR, 
		 &nic->recvJumboDataDmaInfo);
#else /* USE_DMA_MEMALLOC */
    MEMALLOC(nic->recvJumboData, caddr_t,
	     (RECV_JUMBO_RING_ENTRIES + 1) * 
	     PAGE_SIZE * PAGES_PER_JUMBO_BUFFER,
	     ALT_NOSLEEP);
#endif /* USE_DMA_MEMALLOC */
    /* if we fail bitch */
    if (!nic->recvJumboData) {
	ERROR3("%s%d: Couldn't allocate kernel memory for jumbo recv buffers\n",
	       nic->name, altp->instance);
	ALTTRACE(norcvbuf, 0xf0014, 0, 0, 0, 0);
	FREE_JUMBO_RECV_STUFF(altp, nic);
	return(ENOMEM);
    }
    curPtr = (caddr_t)PAGE_ROUNDUP(nic->recvJumboData);
#if USE_DMA_MEMALLOC
    HOSTZEROHI(physPtr);
    HOSTADDR(physPtr) = MAP2BUS(nic->recvJumboDataDmaInfo.dataAddr);
    ALIGN_DMA_ADDR(physPtr, PAGE_SIZE);
#endif /* USE_DMA_MEMALLOC */
    for (i=0; i < RECV_JUMBO_RING_ENTRIES; i++) {
	infop = &nic->rjumbomsgs[i];
	PREP_RECV_JUMBO_INFOP(infop, nic, 0, i, RECV_JUMBO_RING_ENTRIES - 1, 
			      curPtr, JUMBOBLOCKSIZE, physPtr);
	infop->flags |= ALT_DMA_JUMBO;
#if USE_DMA_MEMALLOC
	ADD_DMA_ADDR(physPtr, physPtr, PAGE_SIZE * PAGES_PER_JUMBO_BUFFER);
#else /* USE_DMA_MEMALLOC */
	PREP_JUMBO_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_READ, infop);
	/* if we fail, bitch */
	if (!rc) {
	    ERROR3("%s%d: Couldn't prep dma recv jumbo buffer\n",
	       nic->name, altp->instance);
	    ALTTRACEE(norbfjpr, 0xf0023, 0, 0, 0, 0);
	    infop = nic->rjumbomsgs;
	    for (j=0; j < i; j++) {
		UNPREP_DMA(infop);
		UNPREP_RECV_INFOP(infop);
		infop++;
	    }
	    MEMFREE(nic->recvJumboData, 
		    (RECV_JUMBO_RING_ENTRIES + 1) * 
		    PAGE_SIZE * PAGES_PER_JUMBO_BUFFER,
		    ALT_NOSLEEP);
	    FREE_JUMBO_RECV_STUFF(altp, nic);
	    return(ENOMEM);
	}
#endif /* USE_DMA_MEMALLOC */
	curPtr += PAGE_SIZE * PAGES_PER_JUMBO_BUFFER;
    }
#endif /* ALT_RECV_EXT */

    nic->flags |= ALT_JUMBO_INITED;
    return(0);
}

int
#if defined(__STDC__) || defined(ALT_PROTOS)
altGetMacAddr(struct altinst *altp, struct ether_addr *macAddr)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altGetMacAddr(altp, macAddr)
struct altinst *altp;
struct ether_addr *macAddr;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    U32 macspot[2];		/* space for the padded MAC address */
    int rc;
    struct tg_nic *nic = altp->initNic;
#if defined(__sun)
    U8 factAddr[6];		/* space for factory assigned MAC address */
    char *prop;
    int prop_len = sizeof (int);
#endif /* defined(__sun) */

    /* get the mac addr from the EEPROM before the firmware
     * runs and then put it into the shared memory.  It's up
     * to the NIC software to read it as well */
    if ((rc = readTGSerEeprom(altp, 
			      (U32)(((eeprom_layout_t *)TG_BEG_SER_EEPROM)->
				    manufact.serial_number), 
			      (char *)macspot, 8, FALSE)))
	return(rc);

#if defined(__sun)
    /* do some funny games with the mac addr, the one we read is the 
     * "factory address".  Check to see if the mac-address property has
     * been assigned to override our mac address, if so override it,
     * if not, look to see if we're supposed to use the "factory address"
     * in this case the local-mac-address? property will be true, if not
     * use the system ethernet address, bletch, but that's the way sun
     * wants it.
     *
     * XXX eventually when we have fcode it'll be the fcode's job to read
     * the mac address off the board and put it into the "local-mac_address"
     * property.  When this happens replace the read the mac addr from hardware
     * part of this algorithm on suns (this way the operator could override
     * the local-mac-address property with openboot).
     */
    /* save off the factory address */
    MEMCPY((MEMCPY_TYPE)&factAddr, (MEMCPY_TYPE)((char *)macspot)+2, 6);
    /*
     * Check if the adapter has published "mac-address" property.
     * If it is present, use it as the mac address for this device.
     */
    if (ddi_getlongprop(DDI_DEV_T_ANY,
			altp->dip, DDI_PROP_DONTPASS, "mac-address",
			(caddr_t)&prop, &prop_len) == DDI_PROP_SUCCESS) {
	if (prop_len >= ETHERADDRL) {
	    /* copy it into the local macspot thing, we do right below */
	    BZERO((MEMCPY_TYPE)macspot, 2);
	    MEMCPY((MEMCPY_TYPE)((char *)macspot)+2, (MEMCPY_TYPE)prop, 6);
	    kmem_free(prop, prop_len);
	    NOTE5("%s%d: Using override MAC address 0x%x%x\n", 
		  nic->name, altp->instance,
		  macspot[0], macspot[1]);
	} 
    } else if ((rc = ddi_getlongprop(DDI_DEV_T_ANY, altp->dip, 0, 
				     "local-mac-address?",
				     (caddr_t)&prop, &prop_len))
		== DDI_PROP_SUCCESS) {
	if (strncmp("true", prop, prop_len) == 0) {
	    MEMCPY((MEMCPY_TYPE)((char *)macspot)+2, 
		   (MEMCPY_TYPE)&factAddr, 6);
	    MEMCPY((MEMCPY_TYPE)macAddr, ((char *)macspot)+2, 6);
	    NOTE9("%s%d: Using Local MAC address %x:%x:%x:%x:%x:%x", 
		  nic->name, altp->instance,
		  (int)(macAddr->ether_addr_octet[0] & 0xff),
		  (int)(macAddr->ether_addr_octet[1] & 0xff),
		  (int)(macAddr->ether_addr_octet[2] & 0xff),
		  (int)(macAddr->ether_addr_octet[3] & 0xff),
		  (int)(macAddr->ether_addr_octet[4] & 0xff),
		  (int)(macAddr->ether_addr_octet[5] & 0xff));
	} else {
	    /*
	     * Get the system ethernet address.
	     */
	    localetheraddr((struct ether_addr *)NULL, 
			   (struct ether_addr *)(((char *)macspot)+2));
	    MEMCPY((MEMCPY_TYPE)macAddr, ((char *)macspot)+2, 6);
	    NOTE9("%s%d: Using system MAC address %x:%x:%x:%x:%x:%x", 
		  nic->name, altp->instance,
		  (int)(macAddr->ether_addr_octet[0] & 0xff),
		  (int)(macAddr->ether_addr_octet[1] & 0xff),
		  (int)(macAddr->ether_addr_octet[2] & 0xff),
		  (int)(macAddr->ether_addr_octet[3] & 0xff),
		  (int)(macAddr->ether_addr_octet[4] & 0xff),
		  (int)(macAddr->ether_addr_octet[5] & 0xff));
	}
	kmem_free(prop, prop_len);
    } else {
#endif /* defined(__sun) */
	/* copy it to passed location */
	MEMCPY((MEMCPY_TYPE)macAddr, ((char *)macspot)+2, 6);
	NOTE9("%s%d: Using Local MAC address %x:%x:%x:%x:%x:%x", 
	      nic->name, altp->instance,
	      (int)(macAddr->ether_addr_octet[0] & 0xff),
	      (int)(macAddr->ether_addr_octet[1] & 0xff),
	      (int)(macAddr->ether_addr_octet[2] & 0xff),
	      (int)(macAddr->ether_addr_octet[3] & 0xff),
	      (int)(macAddr->ether_addr_octet[4] & 0xff),
	      (int)(macAddr->ether_addr_octet[5] & 0xff));
#if defined(__sun)
    }
#endif /* defined(__sun) */
    return(0);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
initRings(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
initRings(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    struct send_bd bufd;
    int i;

    ALTTRACE(initRing, 0x10019, altp, nic, 0, 0);

#if !defined(__NETWARE_386__)
    /* make sure maskRupts is 0 for non-Netware platforms */
    WRSHMEM(nic->genComm->gen_com.maskRupts, 0);
    MB();
#endif /* !defined(__NETWARE_386__) */

#if defined(WINNT)
    /* set up  tx mac buffer ratio, approx 1/3 TX, 2/3 RX */
    WRSHMEM(nic->genComm->gen_com.tx_buf_ratio, 21);
    MB();
#else /* defined(WINNT) */
    /* set up default tx mac buffer ratio */
    WRSHMEM(nic->genComm->gen_com.tx_buf_ratio, 0);
    MB();
#endif /* defined(WINNT) */

    /* link up the general information page */
    BZERO((char *)nic->genInfo, sizeof(struct tg_gen_info));
    /* zero hi word of hostaddrs in genComm in case we're using 32 bit ptrs */
    SHMEMZEROHI(nic->genComm->gen_com.gen_info_ptr);
    WRSHMEM64(nic->genComm->gen_com.HOSTADDR(gen_info_ptr), 
	    MAP2BUS(nic->genInfoDmaInfo.dataAddr));
    MB();

    /* set up the event_producer_ptr */
    HOSTZEROHI(nic->genInfo->event_producer_ptr);
    nic->genInfo->HOSTADDR(event_producer_ptr) = 
        MAP2BUS(nic->ringPointersDmaInfo.dataAddr);

    /* set up the info for the stats */
#if !defined(__NETWARE_386__)
    WRSHMEM(nic->genComm->gen_com.ifIndex, (altp->instance + 1));
    MB();
#else /* !defined(__NETWARE_386__) */
    WRSHMEM(nic->genComm->gen_com.ifIndex, altp->instance);
#endif /* !defined(__NETWARE_386__) */
    /* should figure this out on fly XXX */
    if (nic->flags & ALT_JUMBO_ENABLED)
	WRSHMEM(nic->genComm->gen_com.ifMTU, JUMBOBLOCKSIZE);	
    else
	WRSHMEM(nic->genComm->gen_com.ifMTU, MAXBLOCKSIZE);	
    MB();

    /* set up all the ring stuff */
    /* command ring */
    HOSTZEROHI(nic->genInfo->command_rcb.ring_addr);
    nic->genInfo->command_rcb.HOSTADDR(ring_addr) = COMMAND_RING_PTR;
    nic->genInfo->command_rcb.RCB_max_len = 0;
    nic->genInfo->command_rcb.RCB_flags = 0;
    WRSHMEM(nic->genComm->command_prod_index, 0);
    MB();
    WRSHMEM(nic->genComm->gen_com.command_cons_index, 0);
    MB();

    /* zero out the command ring itself */
    BZERO_TODEV((MEMCPY_TYPE)nic->genComm->gen_com.command_ring, 
		sizeof(struct tg_command) * COMMAND_RING_ENTRIES);

    /* event ring */
    HOSTZEROHI(nic->genInfo->event_rcb.ring_addr);
    nic->genInfo->event_rcb.HOSTADDR(ring_addr) = 
        MAP2BUS(nic->eventArrDmaInfo.dataAddr);
    nic->genInfo->event_rcb.RCB_flags = 0;
    *nic->eventProdPtr = 0;	/* starting producer index */
    MB();
    /* starting consumer idx */
    WRSHMEM(nic->genComm->gen_com.event_cons_index, 0);
    MB();

    /* zero out the event ring itself */
    BZERO((char *)nic->eventArr, sizeof(struct tg_event) * EVENT_RING_ENTRIES);
    
    /* send ring */
    HOSTZEROHI(nic->genInfo->send_rcb.ring_addr);
#if HOST_SEND_RING
    nic->genInfo->send_rcb.HOSTADDR(ring_addr) = 
	MAP2BUS(nic->sendRingDmaInfo.dataAddr);
#else /* HOST_SEND_RING */
    nic->genInfo->send_rcb.HOSTADDR(ring_addr) = SEND_RING_PHYS_ADDR;
#endif /* HOST_SEND_RING */
    nic->genInfo->send_rcb.RCB_max_len = SEND_RING_ENTRIES;
    nic->genInfo->send_rcb.RCB_flags = 0;
    if (nic->flags & ALT_USE_VLAN_ASSIST)
	nic->genInfo->send_rcb.RCB_flags |= RCB_FLAG_VLAN_ASSIST;

    if (nic->init_flags & ALT_INIT_SEND_UPDATE_ONLY)
	nic->genInfo->send_rcb.RCB_flags |= RCB_FLAG_COAL_UPDATE_ONLY;

#if SEND_CKSUM_DEBUG || RECV_CKSUM_DEBUG
    nic->csumFlags = 0;
#endif /* SEND_CKSUM_DEBUG || RECV_CKSUM_DEBUG */

#if SEND_CKSUM_DEBUG
    send_bdflags = 0;
    if (do_send_ip_cksum) {
	nic->csumFlags |= ALT_CKSUM_DO_XMIT_IP;
	send_bdflags |= BD_FLAG_IP_CKSUM;
    }
    if (do_send_tcpudp_cksum) {
	nic->csumFlags |= ALT_CKSUM_DO_XMIT_TCP | ALT_CKSUM_DO_XMIT_UDP;
	send_bdflags |= BD_FLAG_TCP_UDP_CKSUM;
    }
    if (!do_send_pseudo_cksum)
	nic->csumFlags |= ALT_CKSUM_XMIT_NO_PSEUDO;
#endif /* SEND_CKSUM_DEBUG */
#if HOST_SEND_RING
    nic->genInfo->send_rcb.RCB_flags |= RCB_FLAG_HOST_RING;
#endif /* HOST_SEND_RING */

#if USE_CKSUM_OFFLOAD
    if (nic->init_flags & ALT_INIT_450GX_FIX) {
	ERROR3("%s%d: Illegal settings, cksum offload and 450GX fix, disabling 450 GX fix",
	      altp->nic->name, altp->instance);
	OUT32(nic->handle, nic->base, TG_PCI_STATE,
	      IN32(nic->handle, nic->base, TG_PCI_STATE) &
	      ~TG_PCI_STATE_DMA_WR_ALL_ALIGN);
    }
    if (nic->csumFlags & ALT_CKSUM_DO_XMIT_IP)
        nic->genInfo->send_rcb.RCB_flags |= RCB_FLAG_IP_CKSUM;
    if (nic->csumFlags & (ALT_CKSUM_DO_XMIT_TCP | ALT_CKSUM_DO_XMIT_UDP))
        nic->genInfo->send_rcb.RCB_flags |= RCB_FLAG_TCP_UDP_CKSUM;
    if (nic->csumFlags & ALT_CKSUM_XMIT_NO_PSEUDO)
        nic->genInfo->send_rcb.RCB_flags |= RCB_FLAG_NO_PSEUDO_HDR_CKSUM;
#endif /* USE_CKSUM_OFFLOAD */

    nic->send_producer = 0;
    nic->send_consumer = 0;
    *nic->sendConsPtr = 0;
    /* set up the send_consumer_ptr */
    HOSTZEROHI(nic->genInfo->send_consumer_ptr);
    ADD_DMA_ADDR(nic->genInfo->HOSTADDR(send_consumer_ptr),
		 MAP2BUS(nic->ringPointersDmaInfo.dataAddr),
		 CACHE_LINE_SIZE);
    /* pre-init whole ring with zeros */
    BZERO((MEMCPY_TYPE)&bufd, sizeof(struct send_bd));
    for (i=0; i< SEND_RING_ENTRIES; i++) {
        /* move the window to point to the correct descriptor */
        SET_NIC_MEM_WINDOW(i, nic);
        ALT_MEMCPY_TODEV((MEMCPY_TYPE)(&(*nic->sendRing)
				       [i & SEND_RING_BDS_IN_WINDOW]),
			 (MEMCPY_TYPE)(&bufd), sizeof(bufd));
    }

    /* set up the window to point to the right place from now on */
    SET_NIC_MEM_WINDOW_NOW(0, nic);

    /* recv ring(s) */
    HOSTZEROHI(nic->genInfo->recv_standard_rcb.ring_addr);
    nic->genInfo->recv_standard_rcb.HOSTADDR(ring_addr) = 
        MAP2BUS(nic->recvStdRingDmaInfo.dataAddr);
#if 0				/* when we're ready XXX */
    nic->genInfo->recv_standard_rcb.RCB_flags = RCB_FLAG_SPLIT_HDRS;
#endif /* 0 */
    nic->genInfo->recv_standard_rcb.RCB_flags = 0;
    if (nic->flags & ALT_USE_VLAN_ASSIST)
	nic->genInfo->recv_standard_rcb.RCB_flags |= RCB_FLAG_VLAN_ASSIST;

#if RECV_CKSUM_DEBUG
    if (do_recv_ip_cksum)
	nic->csumFlags |= ALT_CKSUM_DO_RECV_IP;
    if (do_recv_tcpudp_cksum)
	nic->csumFlags |= ALT_CKSUM_DO_RECV_TCP | ALT_CKSUM_DO_RECV_UDP;
    if (!do_recv_pseudo_cksum)
	nic->csumFlags |= ALT_CKSUM_RECV_NO_PSEUDO;
#endif /* RECV_CKSUM_DEBUG */

#if USE_CKSUM_OFFLOAD
    if (nic->csumFlags & ALT_CKSUM_DO_RECV_IP)
        nic->genInfo->recv_standard_rcb.RCB_flags |= RCB_FLAG_IP_CKSUM;
    if (nic->csumFlags & (ALT_CKSUM_DO_RECV_TCP | ALT_CKSUM_DO_RECV_UDP))
        nic->genInfo->recv_standard_rcb.RCB_flags |= RCB_FLAG_TCP_UDP_CKSUM;
    if (nic->csumFlags & ALT_CKSUM_RECV_NO_PSEUDO)
        nic->genInfo->recv_standard_rcb.RCB_flags |= 
	  RCB_FLAG_NO_PSEUDO_HDR_CKSUM;
#endif /* USE_CKSUM_OFFLOAD */

    nic->genInfo->recv_standard_rcb.RCB_max_len = MAXBLOCKSIZE; 
    nic->recv_std_producer = 0;
    nic->recv_std_consumer = 0;

    HOSTZEROHI(nic->genInfo->recv_jumbo_rcb.ring_addr);
    nic->genInfo->recv_jumbo_rcb.HOSTADDR(ring_addr) = 
        MAP2BUS(nic->recvJumboRingDmaInfo.dataAddr);
#if 0				/* when we're ready XXX */
    nic->genInfo->recv_jumbo_rcb.RCB_flags = RCB_FLAG_SPLIT_HDRS;
#endif /* 0 */
    nic->genInfo->recv_jumbo_rcb.RCB_flags = 0;
    if (nic->flags & ALT_USE_VLAN_ASSIST)
	nic->genInfo->recv_jumbo_rcb.RCB_flags |= RCB_FLAG_VLAN_ASSIST;

#if USE_CKSUM_OFFLOAD
    if (nic->csumFlags & ALT_CKSUM_DO_RECV_IP)
        nic->genInfo->recv_jumbo_rcb.RCB_flags |= RCB_FLAG_IP_CKSUM;
    if (nic->csumFlags & (ALT_CKSUM_DO_RECV_TCP | ALT_CKSUM_DO_RECV_UDP))
        nic->genInfo->recv_jumbo_rcb.RCB_flags |= RCB_FLAG_TCP_UDP_CKSUM;
    if (nic->csumFlags & ALT_CKSUM_RECV_NO_PSEUDO)
        nic->genInfo->recv_jumbo_rcb.RCB_flags |= RCB_FLAG_NO_PSEUDO_HDR_CKSUM;
#endif /* USE_CKSUM_OFFLOAD */

#if USE_EXTENDED_JUMBO
    nic->genInfo->recv_jumbo_rcb.RCB_flags |= RCB_FLAG_USE_EXT_RECV_BD;
#endif /* USE_EXTENDED_JUMBO */

    nic->genInfo->recv_jumbo_rcb.RCB_max_len = 0;
    nic->recv_jumbo_producer = 0;
    nic->recv_jumbo_consumer = 0;

#if USE_MINI_RING
    HOSTZEROHI(nic->genInfo->recv_mini_rcb.ring_addr);
    nic->genInfo->recv_mini_rcb.HOSTADDR(ring_addr) = 
        MAP2BUS(nic->recvMiniRingDmaInfo.dataAddr);
#if 0				/* when we're ready XXX */
    nic->genInfo->recv_mini_rcb.RCB_flags = RCB_FLAG_SPLIT_HDRS;
#endif /* 0 */
    nic->genInfo->recv_mini_rcb.RCB_flags = 0;
    if (nic->flags & ALT_USE_VLAN_ASSIST)
	nic->genInfo->recv_mini_rcb.RCB_flags |= RCB_FLAG_VLAN_ASSIST;

#if USE_CKSUM_OFFLOAD
    if (nic->csumFlags & ALT_CKSUM_DO_RECV_IP)
        nic->genInfo->recv_mini_rcb.RCB_flags |= RCB_FLAG_IP_CKSUM;
    if (nic->csumFlags & (ALT_CKSUM_DO_RECV_TCP | ALT_CKSUM_DO_RECV_UDP))
        nic->genInfo->recv_mini_rcb.RCB_flags |= RCB_FLAG_TCP_UDP_CKSUM;
    if (nic->csumFlags & ALT_CKSUM_RECV_NO_PSEUDO)
        nic->genInfo->recv_mini_rcb.RCB_flags |= 
	  RCB_FLAG_NO_PSEUDO_HDR_CKSUM;
#endif /* USE_CKSUM_OFFLOAD */

    nic->genInfo->recv_mini_rcb.RCB_max_len = MINIBLOCKSIZE;
    nic->recv_mini_producer = 0;
    nic->recv_mini_consumer = 0;
#else /* USE_MINI_RING */
        nic->genInfo->recv_mini_rcb.RCB_flags |= 
	  RCB_FLAG_RING_DISABLED;
#endif /* USE_MINI_RING */

    ALTTRACEE(RCBflags, 0x1002f,
        nic->genInfo->send_rcb.RCB_flags,
        nic->genInfo->recv_standard_rcb.RCB_flags,
        nic->genInfo->recv_jumbo_rcb.RCB_flags,
        nic->genInfo->recv_mini_rcb.RCB_flags);

    nic->recv_return_consumer = 0;
    nic->recv_return_producer = 0;
    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	WRSHMEM(nic->genComm->gen_com.recv_return_cons_index, 0);
	MB();
    }
    *nic->recvReturnProdPtr = 0;
    /* set up the recv_consumer_ptr */
    HOSTZEROHI(nic->genInfo->recv_return_producer_ptr);
    ADD_DMA_ADDR(nic->genInfo->HOSTADDR(recv_return_producer_ptr),
		 MAP2BUS(nic->ringPointersDmaInfo.dataAddr),
		 2 * CACHE_LINE_SIZE);

    /* zero out the recv rings themselves */
    BZERO((char *)nic->recvStdRing, 
	  sizeof(struct recv_bd) * RECV_STANDARD_RING_ENTRIES);
    BZERO((char *)nic->recvJumboRing, 
	  sizeof(struct JUMBO_RECV_BD) * RECV_JUMBO_RING_ENTRIES);
#if USE_MINI_RING
    BZERO((char *)nic->recvMiniRing, 
	  sizeof(struct recv_bd) * RECV_MINI_RING_ENTRIES);
#endif /* USE_MINI_RING */

    HOSTZEROHI(nic->genInfo->recv_return_rcb.ring_addr);
    nic->genInfo->recv_return_rcb.HOSTADDR(ring_addr) = 
        MAP2BUS(nic->recvReturnRingDmaInfo.dataAddr);
#if 0				/* when we're ready XXX */
    nic->genInfo->recv_return_rcb.RCB_flags = RCB_FLAG_SPLIT_HDRS;
#endif /* 0 */
    nic->genInfo->recv_return_rcb.RCB_flags = 0;
    nic->genInfo->recv_return_rcb.RCB_max_len = 0; /* not used on return */

    /* zero out the return recv ring itself */
    BZERO((char *)nic->recvReturnRing, 
	  sizeof(struct recv_bd) * RECV_RETURN_RING_ENTRIES);

    /* put the stats2 pointer in place */
    HOSTZEROHI(nic->genInfo->stats2_ptr);
    nic->genInfo->HOSTADDR(stats2_ptr) = 
        MAP2BUS(nic->genInfoStats2DmaInfo.dataAddr);

    /* initialize some stuff in the shared memory */
#if ALT_BIG_ENDIAN
#if defined(__sun)
    if (nic->nic_type == ALT_SBUS_NIC) {
#if SBUS_32
	WRSHMEM(nic->genComm->gen_com.mode_status, 
		TG_CFG_MODE_WARN | TG_CFG_MODE_FATAL |
		TG_CFG_MODE_1_DMA_ACTIVE | TG_CFG_MODE_SBUS);
	WRSHMEM(nic->genComm->gen_com.dma_write_config, 
		TG_DMA_STAT_THRESH_16W | TG_DMA_STATE_FORCE_32_BIT);
	WRSHMEM(nic->genComm->gen_com.dma_read_config, 
		TG_DMA_STAT_THRESH_16W | TG_DMA_STATE_FORCE_32_BIT);
#else /* SBUS_32 */
	WRSHMEM(nic->genComm->gen_com.mode_status, 
		TG_CFG_MODE_WARN | TG_CFG_MODE_FATAL |
		TG_CFG_MODE_1_DMA_ACTIVE | TG_CFG_MODE_WORD_SWAP_BD | 
		TG_CFG_MODE_SBUS);
	/* this code was changed from 16W to 8W to reduce the probability
	 * of bumping into a bug in the X chip */
	WRSHMEM(nic->genComm->gen_com.dma_write_config, 
		TG_DMA_STATE_THRESH_8W);
	WRSHMEM(nic->genComm->gen_com.dma_read_config, TG_DMA_STATE_THRESH_8W);
#endif /* SBUS_32 */
    } else {
#endif /* defined(__sun) */
	WRSHMEM(nic->genComm->gen_com.mode_status, TG_CFG_MODE_BYTE_SWAP_BD |
		TG_CFG_MODE_BYTE_SWAP_DATA | TG_CFG_MODE_WARN | 
		TG_CFG_MODE_FATAL | TG_CFG_MODE_WORD_SWAP_BD);
	WRSHMEM(nic->genComm->gen_com.dma_write_config, 
		TG_DMA_STATE_THRESH_8W);
	WRSHMEM(nic->genComm->gen_com.dma_read_config, TG_DMA_STATE_THRESH_8W);
#if defined(__sun) 
    }
#endif /* defined(__sun) */
#else /* ALT_BIG_ENDIAN */

#if defined(WINNT)
    WRSHMEM(nic->genComm->gen_com.mode_status, 
	    TG_CFG_MODE_BYTE_SWAP_DATA |
	    TG_CFG_MODE_DONT_FRAG_JUMBOS |
	    TG_CFG_MODE_WARN | TG_CFG_MODE_FATAL | TG_CFG_MODE_WORD_SWAP_BD);
#else /* defined(WINNT) */
    WRSHMEM(nic->genComm->gen_com.mode_status, 
	    TG_CFG_MODE_BYTE_SWAP_DATA |
	    TG_CFG_MODE_WARN | TG_CFG_MODE_FATAL | TG_CFG_MODE_WORD_SWAP_BD);
#endif /* defined(WINNT) */

#if defined(OP14)
    /*
     * Disable 64 bit mode for OP14...
     */
    WRSHMEM(nic->genComm->gen_com.dma_write_config,
        TG_DMA_STATE_THRESH_8W | TG_DMA_STATE_FORCE_32_BIT);
    WRSHMEM(nic->genComm->gen_com.dma_read_config,
        TG_DMA_STATE_THRESH_8W | TG_DMA_STATE_FORCE_32_BIT);
#else /* defined(OP14) */
    WRSHMEM(nic->genComm->gen_com.dma_write_config, TG_DMA_STATE_THRESH_8W);
    WRSHMEM(nic->genComm->gen_com.dma_read_config, TG_DMA_STATE_THRESH_8W);
#endif /* defined(OP14) */

#endif /* ALT_BIG_ENDIAN */

    /* set up firmware for alternative LED usage */
    if (altp->flags & ALT_DRIVER_IS_OP1)
	WRSHMEM(nic->genComm->gen_com.mode_status,
		RDSHMEM(nic->genComm->gen_com.mode_status) | 
		TG_CFG_MODE_USE_OP1_LEDS);
    MB();

    /* special tuning stuff, modification via ioctl or ndd */
    altUpdateTuneParms(nic);
}
