/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: altftns.c,v $
 * Revision 1.1.4.21  1999/01/07  23:09:15  ted
 * 	ifdef out proto for KeQueryPerformanceCounter
 * 	[1999/01/07  23:02:37  ted]
 *
 * Revision 1.1.4.20  1998/08/03  17:11:22  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:35  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:51  hayes]
 * 
 * 	host based send ring now works off RCB flag
 * 	[1998/07/29  18:31:23  hayes]
 * 
 * Revision 1.1.4.19  1998/06/12  23:47:14  ted
 * 	snapshot of merge with new Registry handling
 * 	[1998/06/10  22:15:14  ted]
 * 
 * Revision 1.1.4.18  1998/06/08  23:55:29  ted
 * 	Cleanup tracing messages and identifiers
 * 	[1998/06/08  23:39:04  ted]
 * 
 * 	Add higher resolution timer to NT trace entries
 * 	[1998/06/08  22:50:16  ted]
 * 
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:14  ted]
 * 
 * Revision 1.1.4.17  1998/04/14  21:42:36  ted
 * 	Merge ODI 1.8 fixes, add VLAN assist support
 * 	[1998/04/14  21:26:55  ted]
 * 
 * Revision 1.1.4.16  1997/12/23  19:49:03  ted
 * 	add function that snapshots a NIC trace buffer in the snap trace area
 * 	[1997/12/23  19:29:42  ted]
 * 
 * Revision 1.1.4.15  1997/12/18  23:21:27  venkat
 * 	merged from ge_0_37_latest
 * 	[1997/12/18  23:14:29  venkat]
 * 
 * Revision 1.1.4.14  1997/12/03  01:22:58  ted
 * 	Bring forward ODI fixes from release 2
 * 	[1997/12/03  01:14:17  ted]
 * 
 * Revision 1.1.4.13  1997/11/19  00:14:01  ted
 * 	merged from release 2.0
 * 	[1997/11/19  00:11:12  ted]
 * 
 * Revision 1.1.4.12  1997/10/21  00:12:58  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:00:02  ted]
 * 
 * Revision 1.1.9.1  1997/10/16  17:30:38  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:24:35  ted]
 * 
 * Revision 1.1.4.11  1997/09/16  03:11:24  ted
 * 	Change s to spl for better coding style
 * 	[1997/09/16  03:00:27  ted]
 * 
 * Revision 1.1.4.10  1997/07/28  22:40:25  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:39:38  ted]
 * 
 * Revision 1.1.4.9  1997/05/01  19:17:28  akhan
 * 	Changed casting from signed ints to unsigned ints, since it was causing a
 * 	bogus network mac address to be generated for NIC with serial no above 80h.
 * 	[1997/05/01  19:16:41  akhan]
 * 
 * Revision 1.1.4.8  1997/04/04  06:22:28  akhan
 * 	NT merge.
 * 	[1997/04/04  06:21:55  akhan]
 * 
 * Revision 1.1.4.7  1997/03/28  01:39:45  ted
 * 	Major merge of NDIS and ODI with mainstream Unix ports
 * 	[1997/03/28  01:33:11  ted]
 * 
 * Revision 1.1.4.6  1997/03/20  00:02:00  suresh
 * 	 re-fix alt_copyout
 * 	[1997/03/20  00:01:50  suresh]
 * 
 * Revision 1.1.4.5  1997/03/19  05:54:21  suresh
 * 	 fix alt_copy(in/out) routines for AIX
 * 	[1997/03/19  05:54:10  suresh]
 * 
 * Revision 1.1.4.4  1997/02/23  01:49:23  ted
 * 	Fix unaligned problems in ioctls for gdb
 * 	[1997/02/23  01:49:02  ted]
 * 
 * Revision 1.1.4.3  1997/02/20  21:54:55  ted
 * 	Add swap_bytes() routine support to take an aligned buffer
 * 	and swap the data in place.
 * 	[1997/02/20  21:50:30  ted]
 * 
 * Revision 1.1.4.2  1997/02/07  23:23:09  ted
 * 	Get AIX to compile
 * 	[1997/02/07  23:21:40  ted]
 * 
 * Revision 1.1.4.1  1997/02/07  21:58:03  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:47:49  ted]
 * 
 * Revision 1.1.2.1  1996/11/21  18:01:36  ted
 * 	Moved from ../unix/common and merged in WINNT changes
 * 	[1996/11/21  17:42:27  ted]
 * 
 * Revision 1.5.2.2  1996/11/20  20:04:44  ted
 * 	Redo include file structuring.
 * 	[1996/11/20  19:56:29  ted]
 * 
 * Revision 1.5.2.1  1996/11/01  18:25:34  ted
 * 	change rr_ to tg_ and add proper copyright
 * 	[1996/10/30  22:58:35  ted]
 * 
 * $EndLog$
 */
/*
 * FILE altftns.c
 *
 * COPYRIGHT (c) Essential Communication Corp. 1995
 * $Source: /projects/rcs/sw/ge/./nic/host/common/altftns.c,v $
 * $Revision: 1.1.4.21 $ $Locker:  $
 * $Date: 1999/01/07 23:09:15 $ $Author: ted $ $State: Exp $
 */

#ifndef __lint
static char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/common/altftns.c,v 1.1.4.21 1999/01/07 23:09:15 ted Exp $";
#endif /* __lint */

/* general include files */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include <strings.h>		/* for bzero, ... */
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */

#if !defined(WINNT)
#include <sys/types.h>		/* generic types */
#include <sys/errno.h>		/* EXXXXX errors */
#endif /* !defined(WINNT) */

/* System V include files */
#if defined(ALT_SYSV)
#include <sys/ethernet.h>	/* ether_addr */
#include <sys/cmn_err.h>
#endif /* defined(ALT_SYSV) */

/* BSD include files */
#if defined(ALT_BSD)
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#endif /* defined(ALT_BSD) */

/* system specific include files */
#if defined(__sun)
#include <sys/byteorder.h>	/* htonl... */
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ddidmareq.h>	/* ddi dma structs */
#include <sys/time.h>		/* struct timespec */
#include <sys/ksynch.h>		/* kconfvar_t */
#include <sys/stream.h>		/* queue_t */
#include <sys/cpuvar.h>		/* cpu struct */
#endif /* defined(__sun) */

#if defined(WINNT)
#include <ndis.h>
#endif /* defined(WINNT) */

#if defined(__NETWARE_386__)
#include <odi.h>
#include <odi_nbi.h>
#include <odi_nesl.h>
#include <parser.h>
#include <cmsm.h>
#include <splat.h>
#include <portable.h>
#include <string.h>
#endif /* defined(__NETWARE_386__) */

/* alteon include files */
#include "alt.h"
#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include "altioctl.h"
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */
#include "pub_tg.h"
#include "altreg.h"
#include "altos.h"
#include "althdr.h"
#include "altftns.h"
#include "altbpdu.h"
#include "altdrv.h"

/* for some reasons WATCOM compiler does not understand these extern
   in the include file
*/

#if defined(__NETWARE_386__)      
extern u_long alt_tbuf[];
extern u_long *alt_curtb;
extern u_long *alt_endtb;
extern u_long alt_stbuf[];
extern u_long *alt_curstb;
extern u_long *alt_endstb;
#endif /* defined(__NETWARE_386__) */

/* ----------------- TRACING ROUTINES ---------------------- */
/* build the trace buffer backward so we can read it forwards */

#if defined(WINNT) && 0
LARGE_INTEGER KeQueryPerformanceCounter(LARGE_INTEGER *);
#endif /* defined(WINNT) && 0 */

void
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_itrace(void)
#else	/* defined(__STDC__) || defined(ALT_PROTOS) */
alt_itrace()
#endif	/* defined(__STDC__) || defined(ALT_PROTOS) */
{
#if ALT_TRACE
    char *tbp = (char *)alt_endtb;
    char *pounds = "########";
    
    if (!altTraceInited) {
	BZERO((char *)alt_tbuf,
	      sizeof(u_long)*ALT_TRACE_ELEM_SIZE*ALT_TRACE_SIZE);
	/* indicate the "past the end" entry */
	MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)pounds, 8);
        tbp += 8;
	
	altTraceInited = TRUE;
    }
#endif /* ALT_TRACE */
}


void
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_trace(char *string, u_long id, u_long a, u_long b, u_long c, u_long d)
#else	/* defined(__STDC__) || defined(ALT_PROTOS) */
alt_trace(string, id, a, b, c, d)
char *string;
u_long id;
u_long a, b, c, d;
#endif	/* defined(__STDC__) || defined(ALT_PROTOS) */
{
#if ALT_TRACE
    u_long *tbp;
    char *stars = "********";
#if defined(__hpux)
    int s;
    struct timeval t;
    u_long tod;

    t = ms_gettimeofday();
    tod = (t.tv_sec << 20) | t.tv_usec;
#endif /* defined(__hpux) */
#if defined(__sun)
    hrtime_t t;
    u_long tod;

    tod = gethrtime();
#endif /* defined(__sun) */
#if defined(__sgi)
    int s;
    u_long tod = *(u_long *)PHYS_TO_K1(RPSS_CTR); /* clock in 100 ns incs */
#endif /* defined(__sgi) */
#if defined(WINNT)
    LARGE_INTEGER time;
    u_long tod = 0;

#if (0)
    time = KeQueryPerformanceCounter((LARGE_INTEGER *)0);
    tod = time.u.LowPart;
#else /* XXX */
    tod = 0;
#endif /* XXX */
#endif /* defined(WINNT) */
#if defined(__NETWARE_386__)
    u_long tod = CMSMGetMicroTimer();
#endif /* defined(__NETWARE_386__) */

    ALT_DISABLE(spl, &altTraceMu);     /* ENTER CRITICAL SECTION */
    tbp = alt_curtb;
    MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)string, 2 * sizeof(u_long));
    tbp += 2;
#if defined(__sun)
    *tbp++ = (id & 0xfffff) | (CPU->cpu_seqid << 20);
#else /* defined(__sun) */
    *tbp++ = id;
#endif /* defined(__sun) */
    *tbp++ = tod;

    *tbp++ = a;
    *tbp++ = b;
    *tbp++ = c;
    *tbp++ = d;
    alt_curtb -= ALT_TRACE_ELEM_SIZE;

    if (alt_curtb < alt_tbuf)   /* wrap at end */
	alt_curtb = alt_endtb;
    tbp = alt_curtb;
    MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)stars, 2 * sizeof(u_long));

    ALT_ENABLE(spl, &altTraceMu);      /* LEAVE CRITICAL SECTION */
#endif /* ALT_TRACE */
}


void
#if defined(__STDC__) || defined(ALT_PROTOS)
alt_ltrace(char *string, u_long id, 
	u_long a, u_long b, u_long c, u_long d, caddr_t ptr)
#else	/* defined(__STDC__) || defined(ALT_PROTOS) */
alt_ltrace(string, id, a, b, c, d, ptr)
char *string;
u_long id;
u_long a, b, c, d;
caddr_t ptr;
#endif	/* defined(__STDC__) || defined(ALT_PROTOS) */
{
#if ALT_TRACE
    char *pluses = "++++++++";
    char *stars = "********";
    u_long *tbp;
#if defined(__hpux)
    int s;
    struct timeval t;
    u_long tod;

    t = ms_gettimeofday();
    tod = (t.tv_sec << 20) | t.tv_usec;
#endif /* defined(__hpux) */
#if defined(__sun)
    hrtime_t t;
    u_long tod;

    tod = gethrtime();
#endif /* defined(__sun) */
#if defined(__sgi)
    int s;
    u_long tod = *(u_long *)PHYS_TO_K1(RPSS_CTR); /* clock in 100 ns incs */
#endif /* defined(__sgi) */
#if defined(WINNT)
    LARGE_INTEGER time;
    u_long tod = 0;

#if (0)
    time = KeQueryPerformanceCounter((LARGE_INTEGER *)0);
    tod = time.u.LowPart;
#else /* XXX */
    tod = 0;
#endif /* XXX */
#endif /* defined(WINNT) */

#if defined(__NETWARE_386__)
    u_long tod = CMSMGetMicroTimer();
#endif /* defined(__NETWARE_386__) */

    ALT_DISABLE(spl, &altTraceMu);     /* ENTER CRITICAL SECTION */
    tbp = alt_curtb;
    MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)pluses, 2 * sizeof(u_long));
    tbp += 2;

    if (ptr)			/* simple check to avoid silly panics */
	MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)ptr, 6*sizeof(u_long));
    else
	BZERO((char *)tbp, 6*sizeof(u_long)); /* zero it out */

    alt_curtb -= ALT_TRACE_ELEM_SIZE;
    if (alt_curtb < alt_tbuf)	/* wrap at end */
	alt_curtb = alt_endtb;
    
    tbp = alt_curtb;
    MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)string, 2 * sizeof(u_long));
    tbp += 2;
#if defined(__sun)
    *tbp++ = (id & 0xfffff) | (CPU->cpu_seqid << 20);
#else /* defined(__sun) */
    *tbp++ = id;
#endif /* defined(__sun) */
    *tbp++ = tod;

    *tbp++ = a;
    *tbp++ = b;
    *tbp++ = c;
    *tbp++ = d;
    alt_curtb -= ALT_TRACE_ELEM_SIZE;

    if (alt_curtb < alt_tbuf)   /* wrap at end */
	alt_curtb = alt_endtb;
    tbp = alt_curtb;
    MEMCPY((MEMCPY_TYPE)tbp, (MEMCPY_TYPE)stars, 2 * sizeof(u_long));

    ALT_ENABLE(spl, &altTraceMu);      /* LEAVE CRITICAL SECTION */
#endif /* ALT_TRACE */
}


#if (defined(__STDC__))
void
alt_trace_snap(void)
#else /* (defined(__STDC__)) */
void
alt_trace_snap()
#endif /* (defined(__STDC__)) */
{
#if ALT_TRACE
    if (altTraceSnap) {
	ALTTRACEE(snapFail, 0xf3001, 1, 0, 0, 0);
	ERROR1("Couldn't do snap trace, one already active\n");
    } else {
	ALTTRACE(snapTrc, 0x30000, 0,0,0,0);
	MEMCPY((char *)alt_stbuf, (char *)alt_tbuf,
	       ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE*sizeof (u_long));
	alt_curstb = alt_stbuf + (alt_curtb - alt_tbuf);
	altTraceSnap = TRUE;
	ERROR1("DOING A SNAP TRACE\n");
    }
#endif /* ALT_TRACE */
}

#if (defined(__STDC__))
void
alt_nic_trace_snap(struct altinst *altp, struct tg_nic *nic)
#else /* (defined(__STDC__)) */
void
alt_nic_trace_snap(altp, nic)
struct altinst *altp;
struct tg_nic *nic;
#endif /* (defined(__STDC__)) */
{
#if ALT_TRACE
    U32 nicTb, curNicTb, endNicTb;

    if (altTraceSnap) {
	ALTTRACEE(nicSnapF, 0xf3002, 1, 0, 0, 0);
	ERROR1("Couldn't do snap trace, one already active\n");
    } else {
	ALTTRACE(nicSnap, 0x30001, 0,0,0,0);
	/* now get the NIC's trace buffer */
	curNicTb = RDSHMEM(nic->genComm->gen_com.nic_trace_ptr);
	nicTb = RDSHMEM(nic->genComm->gen_com.nic_trace_start);
	endNicTb = nicTb + RDSHMEM(nic->genComm->gen_com.nic_trace_len);
	if (readTGMem(altp, curNicTb + (ALT_TRACE_ELEM_SIZE * sizeof(U32)), 
		      (char *)alt_stbuf, endNicTb - curNicTb -
		      (ALT_TRACE_ELEM_SIZE * sizeof(U32)), FALSE, TRUE) < 0) {
	    ERROR1("Couldn't read NIC memory\n");
	    return;
	}
	if (readTGMem(altp, nicTb, 
		      ((char *)(alt_stbuf - ALT_TRACE_ELEM_SIZE)) + 
		      endNicTb - curNicTb,
		      curNicTb - nicTb, FALSE, TRUE) < 0) {
	    ERROR1("Couldn't read NIC memory\n");
	    return;
	}
	alt_curstb = alt_stbuf;
	altTraceSnap = TRUE;
	ERROR1("DOING A SNAP TRACE\n");
    }
#endif /* ALT_TRACE */
}

/* the Tigon doesn't like byte by byte accesses for the shared memory area */

#if defined(ALT_BSD)
int
alt_copyin(caddr_t userAddr, caddr_t busAddr, int len)
{
    char *bp;
    int origLen = len;
    char *origBp;
    MEMALLOC(bp, char *, len, ALT_NOSLEEP);
    if (!bp)
	return(ENOMEM);
    origBp = bp;
    if (copyin(userAddr, bp, len) < 0) 
	return(-1);
	
    while (len) {
	/* LINTED pointer cast may result in improper alignment */
	*(U32 *)busAddr = *(U32 *)bp;
	bp += 4;
	busAddr += 4;
	len -= 4;
    }
    MEMFREE(origBp, origLen, ALT_NOSLEEP);
    return(0);
}

int
alt_copyout(caddr_t busAddr, caddr_t userAddr, int len)
{
    char *bp;
    int origLen = len;
    char *origBp;
    MEMALLOC(bp, char *, len, ALT_NOSLEEP);
    if (!bp)
	return(ENOMEM);
    origBp = bp;
    while (len) {
	/* LINTED pointer cast may result in improper alignment */
	*(U32 *)bp = *(U32 *)busAddr;
	bp += 4;
	busAddr += 4;
	len -= 4;
    }

    if (copyout(origBp, userAddr, origLen) < 0) {
	MEMFREE(origBp, origLen, ALT_NOSLEEP);
	return(-1);
    }
    MEMFREE(origBp, origLen, ALT_NOSLEEP);
    return(0);
}
#if !ALT_BIG_ENDIAN
int
alt_swap_copyin(caddr_t userAddr, caddr_t busAddr, int len)
{
    char *bp;
    int origLen = len;
    char *origBp;
    MEMALLOC(bp, char *, len, ALT_NOSLEEP);
    if (!bp)
	return(ENOMEM);
    origBp = bp;
    if (copyin(userAddr, bp, len) < 0) 
	return(-1);
	
    while (len) {
	/* LINTED pointer cast may result in improper alignment */
	*(U32 *)busAddr = htonl(*(U32 *)bp);
	bp += 4;
	busAddr += 4;
	len -= 4;
    }
    MEMFREE(origBp, origLen, ALT_NOSLEEP);
    return(0);
}

int
alt_copyout(caddr_t busAddr, caddr_t userAddr, int len)
{
    char *bp;
    int origLen = len;
    char *origBp;
    MEMALLOC(bp, char *, len, ALT_NOSLEEP);
    if (!bp)
	return(ENOMEM);
    origBp = bp;
    while (len) {
	/* LINTED pointer cast may result in improper alignment */
	*(U32 *)bp = htonl(*(U32 *)busAddr);
	bp += 4;
	busAddr += 4;
	len -= 4;
    }

    if (copyout(origBp, userAddr, origLen) < 0) {
	MEMFREE(origBp, origLen, ALT_NOSLEEP);
	return(-1);
    }
    MEMFREE(origBp, origLen, ALT_NOSLEEP);
    return(0);
}
#endif /* !ALT_BIG_ENDIAN */
#endif /* defined(ALT_BSD) */

void *
alt_memcpy(MEMCPY_TYPE toAddr, MEMCPY_TYPE fromAddr, MEMCPY_SZT len)
{
    int intLen = len;		/* signed so we don't loop forever */
    char * locToAddr = (char *) toAddr;
    char * locFromAddr = (char *) fromAddr;

    while (intLen > 0) {
	/* LINTED pointer cast may result in improper alignment */
	*(U32 *)locToAddr = *(U32 *)locFromAddr;
	locFromAddr += 4;
	locToAddr += 4;
	intLen -= 4;
    }
    MB();
    return(toAddr);
}

#if !ALT_BIG_ENDIAN
void *
alt_swap_memcpy(MEMCPY_TYPE toAddr, MEMCPY_TYPE fromAddr, MEMCPY_SZT len)
{
    int intLen = len;		/* signed so we don't loop forever */
    char * locToAddr = (char *) toAddr;
    char * locFromAddr = (char *) fromAddr;

    while (intLen > 0) {
	/* LINTED pointer cast may result in improper alignment */
	*(U32 *)locToAddr = htonl(*(U32 *)locFromAddr);
	locFromAddr += 4;
	locToAddr += 4;
	intLen -= 4;
    }
    MB();
    return(toAddr);
}

/* must be called with a 4 byte aligned address or will panic */
void
swap_bytes(MEMCPY_TYPE addr, MEMCPY_SZT len, int swaplen)
{
    int intLen = len;		/* signed so we don't loop forever  */

    if ((int)addr & 3)
	panic("swap_bytes, non-aligned address");

    /* this hack may swap things round correctly for gdb */
    /* swap all bytes in a word for word boundary, half words for short,
     * no swap on byte boundaries (1 or 3) */
    switch (swaplen) {
    case 0:
	while (intLen > 0) {
	    /* LINTED pointer cast may result in improper alignment */
	    *(U32 *)addr = htonl(*(U32 *)addr);
	    addr = (char *)addr + 4;
	    intLen -= 4;
	}
	break;

    case 2:
	while (intLen > 0) {
	    /* LINTED pointer cast may result in improper alignment */
	    *(U16 *)addr = htons(*(U16 *)addr);
	    addr = (char *)addr + 2;
	    intLen -= 2;
	}
	break;
    }
}
#endif /* !ALT_BIG_ENDIAN */
