/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: altftns.h,v $
 * Revision 1.1.5.51  1999/02/02  00:01:59  fhwang
 * 	to put leonid's changes back.
 * 	[1999/02/02  00:01:44  fhwang]
 *
 * Revision 1.1.5.50  1999/01/30  02:32:16  fhwang
 * 	add alt_param_snap_set routine protocol.
 * 	[1999/01/30  00:54:04  fhwang]
 * 
 * Revision 1.1.5.48  1998/11/04  19:38:01  ted
 * 	Split altdrv.c into altcfg.c, altcinit.c, and altintr.c
 * 	[1998/11/04  19:36:55  ted]
 * 
 * Revision 1.1.5.47  1998/11/03  23:25:23  ted
 * 	New prototype for altReapSendRing recursion protection
 * 	[1998/11/03  22:08:49  ted]
 * 
 * Revision 1.1.5.46  1998/09/29  21:57:17  ted
 * 	add non-shared rupt support
 * 	[1998/09/29  21:38:45  ted]
 * 
 * Revision 1.1.5.45  1998/09/03  20:04:57  ted
 * 	NDIS 5.0 deserialized code, mostly working
 * 	[1998/09/03  19:55:06  ted]
 * 
 * Revision 1.1.5.44  1998/08/12  01:58:01  ted
 * 	bci by hand because bmerge ran out of open file descriptors, sigh
 * 	[1998/08/10  22:47:54  ted]
 * 
 * 	Refine send deserialization
 * 	[1998/08/10  21:27:59  ted]
 * 
 * 	Add NT 5.0 checksum offload code
 * 	[1998/07/24  19:01:54  ted]
 * 
 * Revision 1.1.5.43  1998/08/03  17:11:24  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:37  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:53  hayes]
 * 
 * Revision 1.1.5.43  1998/08/03  17:11:24  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:37  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:53  hayes]
 * 
 * Revision 1.1.5.43  1998/08/03  17:11:24  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:37  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:53  hayes]
 * 
 * Revision 1.1.5.42  1998/07/14  02:32:37  ted
 * 	SendPackets must be global in Deserialized send world
 * 	[1998/07/14  02:13:02  ted]
 * 
 * Revision 1.1.5.41  1998/06/16  16:45:46  ted
 * 	NT initialization cleanup/rewrite
 * 	[1998/06/16  16:42:59  ted]
 * 
 * Revision 1.1.5.40  1998/06/12  23:47:17  ted
 * 	snapshot of merge with new Registry handling
 * 	[1998/06/10  22:15:15  ted]
 * 
 * Revision 1.1.5.39  1998/06/08  23:55:31  ted
 * 	Snapshot NT generification phase 1
 * 	[1998/06/04  19:52:17  ted]
 * 
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:16  ted]
 * 
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:08:38  ted]
 * 
 * 	snapshot 12.0 NT jumbo support
 * 	[1998/05/20  20:29:24  ted]
 * 
 * Revision 1.1.5.38  1998/05/01  05:35:09  hayes
 * 	alpha NT works with transparent shmem accesses
 * 	[1998/05/01  05:34:40  hayes]
 * 
 * Revision 1.1.5.37  1998/04/24  01:40:36  hayes
 * 	fixed ERRORx() and NOTEx() macros.
 * 	[1998/04/24  01:33:29  hayes]
 * 
 * Revision 1.1.5.36  1998/04/22  21:34:22  ted
 * 	Fix Non-copydata mode IP fragged test case
 * 	[1998/04/22  21:23:54  ted]
 * 
 * Revision 1.1.5.35  1998/04/14  21:42:37  ted
 * 	New proto for VLAN assist
 * 	[1998/04/14  21:25:57  ted]
 * 
 * Revision 1.1.5.34  1998/04/07  06:35:52  ted
 * 	bring ODI driver fixes from 1.8 release forward to ge_latest
 * 	[1998/04/07  06:34:12  ted]
 * 
 * Revision 1.1.5.33  1998/04/02  06:03:09  ted
 * 	Add checksum debugging support
 * 	[1998/04/02  05:55:40  ted]
 * 
 * Revision 1.1.5.32  1998/03/03  22:23:48  ted
 * 	Implement faster dual homing code
 * 	[1998/03/03  22:22:49  ted]
 * 
 * Revision 1.1.5.31  1998/01/30  03:40:25  ted
 * 	New function prototypes
 * 	[1998/01/30  03:37:09  ted]
 * 
 * Revision 1.1.5.30  1997/12/23  19:49:04  ted
 * 	new prototypes
 * 	[1997/12/23  19:30:25  ted]
 * 
 * Revision 1.1.5.29  1997/12/18  23:21:29  venkat
 * 	merged from ge_0_37_latest
 * 	[1997/12/18  23:18:14  venkat]
 * 
 * Revision 1.1.5.28  1997/12/03  01:22:59  ted
 * 	Bring forward ODI fixes from release 2
 * 	[1997/12/03  01:14:19  ted]
 * 
 * Revision 1.1.5.27  1997/11/19  00:14:03  ted
 * 	merged from release 2.0
 * 	[1997/11/19  00:11:16  ted]
 * 
 * Revision 1.1.5.26  1997/11/14  19:17:14  hayes
 * 	first checkin after mongo merge...
 * 	[1997/11/14  19:13:12  hayes]
 * 
 * Revision 1.1.5.25  1997/10/28  17:11:30  hayes
 * 	New function for verify firmware download.
 * 	Changed format for reading and writing Scratchpad because of PROCESSOR_B support (TIGON_REV5)
 * 	[1997/10/28  01:59:50  hayes]
 * 
 * Revision 1.1.5.24  1997/10/21  00:12:59  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:00:05  ted]
 * 
 * Revision 1.1.31.1  1997/10/16  17:30:41  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:24:38  ted]
 * 
 * Revision 1.1.5.23  1997/09/16  21:47:03  ted
 * 	Change from MIB-II V1 (RFC 1213) to MIB-II V2 (RFC 1573)
 * 	[1997/09/16  21:43:07  ted]
 * 
 * Revision 1.1.5.22  1997/09/16  03:11:26  ted
 * 	remove old __alpha referring to DEC OSF #ifdefs
 * 	[1997/09/16  03:01:27  ted]
 * 
 * Revision 1.1.5.21  1997/09/11  18:06:21  ted
 * 	Mixing vlans, jumbos, and redundancy works, plus small fixes from release 1.1 and better NIC tracing
 * 	[1997/09/11  18:00:53  ted]
 * 
 * Revision 1.1.5.20  1997/08/23  18:18:01  ted
 * 	Merged with changes from 1.1.5.19
 * 	[1997/08/23  18:17:44  ted]
 * 
 * 	Separate out allocating the memory for the NIC structure from the rest of the
 * 	memory allocation.
 * 	[1997/08/23  18:04:03  ted]
 * 
 * Revision 1.1.5.19  1997/08/23  17:40:28  skapur
 * 	Solaris jumbogram support
 * 	[1997/08/23  17:38:45  skapur]
 * 
 * Revision 1.1.5.18  1997/07/28  22:40:27  ted
 * 	Merge
 * 	[1997/07/28  22:37:29  ted]
 * 
 * 	Solaris dual homing support
 * 	[1997/07/28  21:39:42  ted]
 * 
 * Revision 1.1.5.17  1997/07/25  22:59:37  ted
 * 	Merged with changes from 1.1.5.16
 * 	[1997/07/25  22:57:55  ted]
 * 
 * 	Merge fixes from ge_0_22 and add link negotiation support
 * 	[1997/07/25  22:33:15  ted]
 * 
 * 	Support flow control for STREAMS
 * 	[1997/07/19  20:37:38  ted]
 * 
 * 	Add NOTE8 and NOTE9 for longer notice reporting
 * 	[1997/07/07  22:56:42  ted]
 * 
 * Revision 1.1.5.16  1997/07/05  21:17:41  ted
 * 	Fix naming issues as reported in bug 317
 * 	[1997/07/05  21:15:05  ted]
 * 
 * Revision 1.1.5.16  1997/07/05  21:17:41  ted
 * 	Fix naming issues as reported in bug 317
 * 	[1997/07/05  21:15:05  ted]
 * 
 * Revision 1.1.5.15  1997/06/11  02:45:51  akhan
 * 	Added function prototypes.
 * 	[1997/06/11  02:45:37  akhan]
 * 
 * Revision 1.1.5.14  1997/05/03  05:00:27  ted
 * 	Add Intel flash support and fix x86_solaris compile problem
 * 	[1997/04/27  21:31:54  ted]
 * 
 * Revision 1.1.5.13  1997/04/11  23:12:19  suresh
 * 	AIX - setup NOTE/ERRORx macros for printf
 * 	[1997/04/11  23:10:51  suresh]
 * 
 * Revision 1.1.5.12  1997/04/04  22:38:24  ted
 * 	Fix problems with statics following altdrv.c split
 * 	[1997/04/04  22:01:18  ted]
 * 
 * Revision 1.1.5.11  1997/04/04  06:22:29  akhan
 * 	nt code merge.
 * 	[1997/04/02  18:19:20  akhan]
 * 
 * 	code merge for NT
 * 	[1997/04/02  18:18:30  akhan]
 * 
 * Revision 1.1.5.10  1997/03/28  01:39:48  ted
 * 	Major merge of NDIS and ODI with mainstream Unix ports
 * 	[1997/03/28  01:33:15  ted]
 * 
 * Revision 1.1.5.9  1997/03/25  23:51:44  ted
 * 	Function prototypes for reading and writing scratch pad areas
 * 	[1997/03/25  23:22:13  ted]
 * 
 * Revision 1.1.5.8  1997/03/19  05:45:17  suresh
 * 	add NOTE6 and NOTE7 for AIX
 * 	[1997/03/19  05:45:04  suresh]
 * 
 * Revision 1.1.5.7  1997/03/17  08:47:58  skapur
 * 	add altClearNicStats prototype
 * 	[1997/03/17  08:36:51  skapur]
 * 
 * Revision 1.1.5.6  1997/03/02  18:36:52  ted
 * 	Merged with changes from 1.1.5.5
 * 	[1997/03/02  18:36:16  ted]
 * 
 * 	redundancy support and a few bug fixes
 * 	[1997/03/02  18:25:50  ted]
 * 
 * Revision 1.1.5.5  1997/02/28  23:01:20  ted
 * 	Change Parallel EEPROM accesses to flash accesses
 * 	[1997/02/28  23:00:51  ted]
 * 
 * Revision 1.1.5.4  1997/02/23  01:49:25  ted
 * 	Fix unaligned problems in ioctls for gdb
 * 	[1997/02/23  01:49:06  ted]
 * 
 * Revision 1.1.5.3  1997/02/21  02:06:42  ted
 * 	Merged with changes from 1.1.5.2
 * 	[1997/02/21  02:06:19  ted]
 * 
 * 	Prepare data structures and code structures to support redundant operation
 * 	[1997/02/21  01:56:49  ted]
 * 
 * Revision 1.1.5.2  1997/02/20  21:54:54  ted
 * 	Add swap_bytes() routine support to take an aligned buffer
 * 	and swap the data in place.
 * 	[1997/02/20  21:50:21  ted]
 * 
 * Revision 1.1.5.1  1997/02/07  21:58:05  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:47:53  ted]
 * 
 * Revision 1.1.2.1  1996/11/21  18:01:37  ted
 * 	Moved from ../unix/common and merged in WINNT changes
 * 	[1996/11/21  17:42:50  ted]
 * 
 * Revision 1.4.2.2  1996/11/09  02:32:14  ted
 * 	Add function prototypes for reading and writing serial eeprom
 * 	[1996/11/09  02:30:07  ted]
 * 
 * Revision 1.4.2.1  1996/11/01  18:25:35  ted
 * 	change rr_ to tg_ and add proper copyright
 * 	[1996/10/30  22:58:39  ted]
 * 
 * $EndLog$
 */
/*
 * FILE altftns.h
 *
 * COPYRIGHT (c) Essential Communication Corp. 1995
 * $Source: /projects/rcs/sw/ge/./nic/host/common/altftns.h,v $
 * $Revision: 1.1.5.51 $ $Locker:  $
 * $Date: 1999/02/02 00:01:59 $ $Author: fhwang $ $State: Exp $
 */

#ifndef _ALTFTNS_H_
#define _ALTFTNS_H_

#if defined(__hpux)
/* various things that may be renamed from system to system */
#define ERROR1 (void) printf
#define ERROR2 (void) printf
#define ERROR3 (void) printf
#define ERROR4 (void) printf
#define ERROR5 (void) printf
#define NOTE1  (void) printf
#define NOTE2  (void) printf
#define NOTE3  (void) printf
#define NOTE4  (void) printf
#define NOTE5  (void) printf
#define NOTE6  (void) printf
#define NOTE7  (void) printf
#define NOTE8  (void) printf
#define NOTE9  (void) printf
#endif /* defined(__hpux) */

#if defined(__sgi) || defined(__sun)
/* various things that may be renamed from system to system */
#define ERROR1(arg1) cmn_err(CE_WARN, arg1)
#define ERROR2(arg1, arg2) cmn_err(CE_WARN, arg1, arg2)
#define ERROR3(arg1, arg2, arg3) cmn_err(CE_WARN, arg1, arg2, arg3)
#define ERROR4(arg1, arg2, arg3, arg4) cmn_err(CE_WARN, arg1, arg2, arg3, arg4)
#define ERROR5(arg1, arg2, arg3, arg4, arg5) cmn_err(CE_WARN, arg1, arg2, arg3, arg4, arg5)
#define NOTE1(arg1) cmn_err(CE_NOTE, arg1)
#define NOTE2(arg1, arg2) cmn_err(CE_NOTE, arg1, arg2)
#define NOTE3(arg1, arg2, arg3) cmn_err(CE_NOTE, arg1, arg2, arg3)
#define NOTE4(arg1, arg2, arg3, arg4) cmn_err(CE_NOTE, arg1, arg2, arg3, arg4)
#define NOTE5(arg1, arg2, arg3, arg4, arg5) \
cmn_err(CE_NOTE, arg1, arg2, arg3, arg4, arg5)
#define NOTE6(arg1, arg2, arg3, arg4, arg5, arg6) \
cmn_err(CE_NOTE, arg1, arg2, arg3, arg4, arg5, arg6)
#define NOTE7(arg1, arg2, arg3, arg4, arg5, arg6, arg7) \
cmn_err(CE_NOTE, arg1, arg2, arg3, arg4, arg5, arg6, arg7)
#define NOTE8(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) \
cmn_err(CE_NOTE, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
#define NOTE9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) \
cmn_err(CE_NOTE, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
#endif /* defined(__sgi) || defined(__sun) */

#if defined(WINNT)
#if (DBG)
/* various things that may be renamed from system to system */
#define ERROR1(arg1) \
{ \
    (void) DbgPrint(arg1); \
    (void) DbgPrint("\n"); \
}
#define ERROR2(arg1, arg2) \
{ \
    (void) DbgPrint(arg1, arg2); \
    (void) DbgPrint("\n"); \
}
#define ERROR3(arg1, arg2, arg3) \
{ \
    (void) DbgPrint(arg1, arg2, arg3); \
    (void) DbgPrint("\n"); \
}
#define ERROR4(arg1, arg2, arg3, arg4) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4); \
    (void) DbgPrint("\n"); \
}
#define ERROR5(arg1, arg2, arg3, arg4, arg5) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4, arg5); \
    (void) DbgPrint("\n"); \
}
#define NOTE1(arg1) \
{ \
    (void) DbgPrint(arg1); \
    (void) DbgPrint("\n"); \
}
#define NOTE2(arg1, arg2) \
{ \
    (void) DbgPrint(arg1, arg2); \
    (void) DbgPrint("\n"); \
}
#define NOTE3(arg1, arg2, arg3) \
{ \
    (void) DbgPrint(arg1, arg2, arg3); \
    (void) DbgPrint("\n"); \
}
#define NOTE4(arg1, arg2, arg3, arg4) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4); \
    (void) DbgPrint("\n"); \
}
#define NOTE5(arg1, arg2, arg3, arg4, arg5) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4, arg5); \
    (void) DbgPrint("\n"); \
}
#define NOTE6(arg1, arg2, arg3, arg4, arg5, arg6) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4, arg5, arg6); \
    (void) DbgPrint("\n"); \
}
#define NOTE7(arg1, arg2, arg3, arg4, arg5, arg6, arg7) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4, arg5, arg6, arg7); \
    (void) DbgPrint("\n"); \
}
#define NOTE8(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8); \
    (void) DbgPrint("\n"); \
}
#define NOTE9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) \
{ \
    (void) DbgPrint(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9); \
    (void) DbgPrint("\n"); \
}
#else /* (DBG) */
/*
 * Can't use DbgPrint for conformant driver...
 * XXX these should turn into log messages, somehow
 */
#define ERROR1(arg1)
#define ERROR2(arg1, arg2)
#define ERROR3(arg1, arg2, arg3)
#define ERROR4(arg1, arg2, arg3, arg4)
#define ERROR5(arg1, arg2, arg3, arg4, arg5)
#define NOTE1(arg1)
#define NOTE2(arg1, arg2)
#define NOTE3(arg1, arg2, arg3)
#define NOTE4(arg1, arg2, arg3, arg4)
#define NOTE5(arg1, arg2, arg3, arg4, arg5)
#define NOTE6(arg1, arg2, arg3, arg4, arg5, arg6)
#define NOTE7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
#define NOTE8(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
#define NOTE9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
#endif /* (DBG) */

/*
 * but we can always use the syslog facility...
 */
#define LOG0(handle, code) \
    (void)NdisWriteErrorLogEntry((handle), (NDIS_ERROR_CODE)(code), 0);

#define LOG1(handle, code, extra1) \
    (void)NdisWriteErrorLogEntry((handle), (NDIS_ERROR_CODE)(code), 1, \
				 (extra1));

#define LOG2(handle, code, extra1, extra2)				\
    (void)NdisWriteErrorLogEntry((handle), (NDIS_ERROR_CODE)(code), 2,	\
				 (extra1), (extra2));

#define LOG3(handle, code, extra1, extra2, extra3)			\
    (void)NdisWriteErrorLogEntry((handle), (NDIS_ERROR_CODE)(code), 3,	\
				 (extra1), (extra2), (extra3));

#define LOG4(handle, code, extra1, extra2, extra3, extra4)		  \
    (void)NdisWriteErrorLogEntry((handle), (NDIS_ERROR_CODE)(code), 4,	  \
				 (extra1), (extra2), (extra3), (extra4));
#endif /* defined(WINNT) */

#if defined(__NETWARE_386__)
#include <stdio.h>		/* for sprintf */
#define ERROR1(arg1)							\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1);						\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_ERROR, s, 0, 0);	\
}
#define ERROR2(arg1, arg2)						\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2);					\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_ERROR, s, 0, 0);	\
}
#define ERROR3(arg1, arg2, arg3)					\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3);					\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_ERROR, s, 0, 0);	\
}
#define ERROR4(arg1, arg2, arg3, arg4)					\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4);				\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_ERROR, s, 0, 0);	\
}
#define ERROR5(arg1, arg2, arg3, arg4, arg5)				\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4, arg5);			\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_ERROR, s, 0, 0);	\
}
#define NOTE1(arg1)							\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1);						\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE2(arg1, arg2)						\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2);					\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE3(arg1, arg2, arg3)					\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3);					\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE4(arg1, arg2, arg3, arg4)					\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4);				\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE5(arg1, arg2, arg3, arg4, arg5)				\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4, arg5);			\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE6(arg1, arg2, arg3, arg4, arg5, arg6)			\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4, arg5, arg6);		\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)		        \
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4, arg5, arg6, arg7);		\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE8(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)		\
{									\
    char s[120];							\
									\
    (void)sprintf(s, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);	\
    (void)strcat(s, "\n");						\
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	\
}
#define NOTE9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)	    \
{									    \
    char s[120];							    \
									    \
    (void)sprintf(s, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9); \
    (void)strcat(s, "\n");						    \
    CMSMPrintString(altConfigTable, MSG_TYPE_INIT_INFO, s, 0, 0);	    \
}
#endif /* defined(__NETWARE_386__) */

/* ------------------- Tracing --------------------- */
/*
 * Tracing is instrumented at three levels:
 * 	Diagostic/error reporting and key events
 * 	Verbose
 *
 * Tracing is compiled into the driver based on these flags
 * 	ALT_TRACE_ALL	- verbose and firmware debugger
 * 	ALT_TRACE	- key events
 * Tracing is run-time controlable (assuming it has been compiled in) 
 * as follows:
 *      altTracing == 4 - extra verbose (includes debugger ioctl info)
 * 	altTracing == 3 - verbose
 * 	altTracing == 2 - key events
 *      altTracing == 1 - errors only
 * The variables are set in ess_data.c
 */
#define ALT_TRACE_ALL	1	/* verbose TRACE calls */
#define ALT_TRACE	1	/* key events */
#define ALT_TRACE_SIZE 1024     /* number of trace entries */

#if ALT_TRACE && ALT_TRACE_ALL
#ifdef __STDC__
#define ALTTRACEV(a, b, c, d, e, f) if (altTracing > 2) \
    alt_trace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2V(a, b, c, d, e, f, g) if (altTracing > 2) \
    alt_ltrace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))

/* TRACEG elements are used for debugging the GDB tracing events and top
 * level ioctls */
#define ALTTRACEG(a, b, c, d, e, f) if (altTracing > 3) \
    alt_trace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2G(a, b, c, d, e, f, g) if (altTracing > 3) \
    alt_ltrace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))

#else /* __STDC__ */
#define ALTTRACEV(a, b, c, d, e, f) if (altTracing > 2) \
    alt_trace("a", (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2V(a, b, c, d, e, f, g) if (altTracing > 2) \
    alt_ltrace("a", (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))

#define ALTTRACEG(a, b, c, d, e, f) if (altTracing > 3) \
    alt_trace("a", (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2G(a, b, c, d, e, f, g) if (altTracing > 3) \
    alt_ltrace("a", (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))
#endif /* __STDC__ */

#else	/* ALT_TRACE && ALT_TRACE_ALL */
#define ALTTRACEV(a, b, c, d, e, f)
#define ALTTRACE2V(a, b, c, d, e, f, g)

#define ALTTRACEG(a, b, c, d, e, f)
#define ALTTRACE2G(a, b, c, d, e, f, g)
#endif	/* ALT_TRACE && ALT_TRACE_ALL */

#if ALT_TRACE
#ifdef __STDC__
#define ALTTRACE(a, b, c, d, e, f) if (altTracing > 1) \
    alt_trace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2(a, b, c, d, e, f, g) if (altTracing> 1) \
    alt_ltrace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))
#else /* __STDC__ */
#define ALTTRACE(a, b, c, d, e, f) if (altTracing > 1) \
    alt_trace("a", (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2(a, b, c, d, e, f, g) if (altTracing > 1) \
    alt_ltrace("a", (int)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))
#endif /* __STDC__ */
#ifdef __STDC__
#define ALTTRACEE(a, b, c, d, e, f) if (altTracing) \
    alt_trace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2E(a, b, c, d, e, f, g) if (altTracing) \
    alt_ltrace(#a, (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))
#else /* __STDC__ */
#define ALTTRACEE(a, b, c, d, e, f) if (altTracing) \
    alt_trace("a", (u_long)(b), (u_long)(c), (u_long)(d), (u_long)(e), (u_long)(f))
#define ALTTRACE2E(a, b, c, d, e, f, g) if (altTracing) \
    alt_ltrace("a", (int)(b), (u_long)(c), (u_long)(d), (u_long)(e), \
	(u_long)(f), (caddr_t)(g))
#endif /* __STDC__ */
#else	/* ALT_TRACE */
#define ALTTRACE(a, b, c, d, e, f)
#define ALTTRACE2(a, b, c, d, e, f, g)
#define ALTTRACEE(a, b, c, d, e, f)
#define ALTTRACE2E(a, b, c, d, e, f, g)
#endif	/* ALT_TRACE */

/* tracing functions */
#if defined(_KERNEL)
#if defined(__STDC__) || defined(ALT_PROTOS)

extern void alt_trace_snap(void);
extern void alt_nic_trace_snap(struct altinst *, struct tg_nic *);
extern void alt_itrace(void);
extern void alt_trace(char *, u_long, u_long, u_long, u_long, u_long);
extern void alt_ltrace(char *, u_long, u_long, u_long, u_long, u_long, 
		       caddr_t);

#else	/* defined(__STDC__) || defined(ALT_PROTOS) */

extern void alt_trace_snap();
extern void alt_nic_trace_snap();
extern void alt_itrace();
extern void alt_trace();
extern void alt_ltrace();

#endif	/* defined(__STDC__) || defined(ALT_PROTOS) */

#if defined(ALT_BSD)
extern struct altinst *altInstP;
#endif /* defined(ALT_BSD) */

/* Tracing variables */
extern int altTracing;
extern int altTraceInited;
extern int altTraceSnap;
extern int altTraceWholePacket;

#if defined(ALT_LOCKS_SUPPORTED)
extern bool altTraceMutexInited;
extern LOCK_TYPE altTraceMu;
#endif /* defined(ALT_LOCKS_SUPPORTED) */

extern struct bpduMsg initBPDU;
extern struct ether_addr etherBPDUaddr;

extern struct ether_addr broadcastAddr;

extern U16 altVlanTagId;

extern u_long alt_tbuf[];
extern u_long *alt_curtb;
extern u_long *alt_endtb;

extern u_long alt_stbuf[];
extern u_long *alt_curstb;
extern u_long *alt_endstb;

#if defined(ALT_STREAM) || defined(WINNT)
extern u_long alt_trtmp[];
#endif /* defined(ALT_STREAM) || defined(WINNT) */

#if defined(__sun)
extern struct alt_param alt_param_arr[];
#endif /* defined(__sun) */

#if defined(WINNT)
extern const NDIS_PHYSICAL_ADDRESS cmdRingPtr;
extern const NDIS_PHYSICAL_ADDRESS sendRingPtr;
extern alt_nt_tune_parms_t ntp;
extern alt_nt_inst_parms_t inst_tp;
extern alt_reg_tab_t alt_glob_reg_tab[];
extern alt_reg_tab_t alt_inst_reg_tab[];
#endif /* defined(WINNT) */

#if defined(__NETWARE_386__)
extern CONFIG_TABLE *altConfigTable;
#endif /* defined(__NETWARE_386__) */

/* checksum debugging constants */
#if SEND_CKSUM_DEBUG
extern int do_send_ip_cksum;
extern int do_send_tcpudp_cksum;
extern int do_send_pseudo_cksum;

extern int send_bdflags;
#endif /* SEND_CKSUM_DEBUG */

#if RECV_CKSUM_DEBUG
extern int do_recv_ip_cksum;
extern int do_recv_tcpudp_cksum;
extern int do_recv_pseudo_cksum;
#endif /* RECV_CKSUM_DEBUG */

/* defines for altReapSendRing */
#define SEND_RING_BUSY      2	/* altReapSendRing active elsewhere */
#define SEND_RING_PROCESSED 1	/* altReapSendRing entries processed */
#define SEND_RING_EMPTY     0	/* altReapSendRing was empty */

/* miscellaneous functions */
#if defined(__STDC__)|| defined(ALT_PROTOS)
extern int alt_InitNICstruct(struct altinst *);
extern int alt_FreeNICstruct(struct altinst *);
extern int alt_InitNICmem(struct altinst *);
extern int alt_FreeNICmem(struct altinst *);
extern int alt_InitNICph1(struct altinst *);
extern int alt_InitNICph2(struct altinst *);
extern int altInitCard(struct altinst *);
extern int altInitJumbo(struct altinst *);
extern int altStopCard(struct altinst *);
extern void ALTINTRWORK(struct tg_nic *);
extern int altReapSendRing(struct tg_nic *);
extern void altFreeSendMsgs(struct tg_nic *, U16, U16);
extern void altHostState(struct altinst *, bool);
#if defined(WINNT)
extern bool altWatchdog(struct altinst *);
#else /* defined(WINNT) */
extern void altWatchdog(struct altinst *);
#endif /* defined(WINNT) */
extern void altRedundTimer(struct altinst *);

extern void altAddMultiCast(struct altinst *, struct ether_addr *);
extern void altDelMultiCast(struct altinst *, struct ether_addr *);
extern int altGetMacAddr(struct altinst *, struct ether_addr *);
extern void altSetMacaddr(struct tg_nic *, struct ether_addr *);
extern void altSetPromiscuous(struct altinst *, bool);
extern void altSetMultiCastMode(struct altinst *, bool);
extern void altUpdateGencomStats(struct altinst *);
extern void altClearProfile(struct altinst *);
extern void altClearNicStats(struct altinst *);
extern void altSetFdrMode(struct altinst *, bool);
extern void altRefreshNicStats(struct altinst *);
extern void altDoLinkNegotiation(struct altinst *);
extern int altAddRedund(struct altinst *, struct altinst *);
extern void altRemRedund(struct altinst *);
extern void altSendPkt(struct altinst *);
extern void altRecvPkt(struct altinst *);
extern bool altQueueSendMsg(struct tg_nic *, SEND_PKT *, U32, U32);
extern void initRings(struct altinst *);
extern void FillJumboRecvRing(struct altinst *);
extern void altUpdateTuneParms(struct tg_nic *);

extern bool stopFW(struct altinst *);
extern bool startFW(struct altinst *);
extern bool restartFW(struct altinst *);
extern bool loadFW(struct altinst *);
extern bool verifyFW(struct altinst *);
extern bool dumpFW(struct altinst *);
extern void freeDump(struct altinst *);
extern bool stopMAC(struct altinst *);
extern int writeTGMem(struct altinst *, U32, char *, int, bool, bool);
extern int readTGMem(struct altinst *, U32, char *, int, bool, bool);
extern int writeTGScratch(struct altinst *, U32, char *, int, bool, bool, int);
extern int readTGScratch(struct altinst *, U32, char *, int, bool, bool, int);
extern int writeTGFlash(struct altinst *, U32, char *, int, bool);
extern int readTGFlash(struct altinst *, U32, char *, int, bool);
extern void determineTGFlash(struct tg_nic *);
extern int writeTGSerEeprom(struct altinst *, U32, char *, int, bool);
extern int readTGSerEeprom(struct altinst *, U32, char *, int, bool);
extern void *alt_memcpy(MEMCPY_TYPE, MEMCPY_TYPE, MEMCPY_SZT);
extern void altCheckBPDU(struct tg_nic *, SEND_PKT *);

#if defined(ALT_STREAM)
extern bool ALTSTART(struct altinst *, mblk_t *);
extern void altread(struct tg_nic *, mblk_t *);
#endif /* defined(ALT_STREAM) */

#if defined(ALT_BSD)
extern int ALTSTART(struct ifnet *);
extern int ALTIOCTL(struct ifnet *, U32, char *);
extern int alt_copyin(caddr_t, caddr_t, int);
extern int alt_copyout(caddr_t, caddr_t, int);
#endif /* defined(ALT_BSD) */

#if ALT_BIG_ENDIAN
#define alt_swap_memcpy alt_memcpy
#define alt_swap_copyin alt_copyin
#define alt_swap_copyout alt_copyout
#define swap_bytes(a, b, c) 
#else /* ALT_BIG_ENDIAN */
extern void *alt_swap_memcpy(MEMCPY_TYPE, MEMCPY_TYPE, MEMCPY_SZT);
extern void *alt_swap_copyin(caddr_t, caddr_t, int);
extern void *alt_swap_copyout(caddr_t, caddr_t, int);
extern void swap_bytes(MEMCPY_TYPE, MEMCPY_SZT, int);
#endif /* ALT_BIG_ENDIAN */

#if USE_CKSUM_OFFLOAD
#if defined(__sun)
extern U16 prepSendCksumPkt(ALT_MSG *);
extern void verifyRecvCksum(struct tg_nic *, struct alt_dma_info *,
			    struct recv_bd *);
#elif defined(WINNT) /* defined(__sun) */
extern U16 prepSendCksumPkt(SEND_PKT *);
extern void verifyRecvCksum(struct tg_nic *, struct alt_dma_info *,
			    struct recv_bd *, RECV_PKT *);
#endif /* defined(__sun) */
#endif /* USE_CKSUM_OFFLOAD */

#if defined(__sun)
extern void altUpdateNddParms(struct tg_nic *);
extern int alt_param_get(queue_t *, mblk_t *, caddr_t);
extern int alt_param_vlan_tag_get(queue_t *, mblk_t *, caddr_t);
extern int alt_param_tag_id_get(queue_t *, mblk_t *, caddr_t);
extern int alt_param_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_jumbo_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_vlan_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_vlan_tag_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_tag_id_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_redund_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_fdr_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_link_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_rx_flow_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_tx_flow_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_hybrid_len_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_share_rupt_set(queue_t *, mblk_t *, char *, caddr_t);
extern int alt_param_snap_set(queue_t *, mblk_t *, char *, caddr_t);
#endif /* defined(__sun) */

#if defined(WINNT)
extern NDIS_STATUS altQueryInfo(NDIS_HANDLE, NDIS_OID, void *, 
				U32, U32 *, U32 *);
extern NDIS_STATUS altSetInfo(NDIS_HANDLE, NDIS_OID, void *, 
			      U32, U32 *, U32 *);
extern NDIS_STATUS altReadTuneParms(struct tg_nic *, U32 *);
extern NDIS_STATUS ResetInstance(bool *, NDIS_HANDLE);
#if ALT_DESERIALIZE
extern void SendPackets(NDIS_HANDLE, NDIS_PACKET **, UINT);
#endif /* ALT_DESERIALIZE */
#endif /* defined(WINNT) */

#if ALT_RECV_EXT
#if defined(WINNT)
extern void altRecvDataRtn(NDIS_HANDLE, PNDIS_PACKET);
#else /* defined(WINNT) */
extern void altRecvDataRtn(struct alt_dma_info *);
#endif /* defined(WINNT) */
#endif /* ALT_RECV_EXT */

#else /* defined(__STDC__)|| defined(ALT_PROTOS) */
extern int alt_InitNICstruct();
extern int alt_FreeNICstruct();
extern int alt_InitNICmem();
extern int alt_FreeNICmem();
extern int alt_InitNICph1();
extern int alt_InitNICph2();
extern int altInitCard();
extern int altInitJumbo();
extern int altStopCard();
extern void ALTINTRWORK();
extern bool altReapSendRing();
extern void altFreeSendMsgs();
extern void altHostState();
extern void altWatchdog();
extern void altAddMultiCast();
extern void altDelMultiCast();
extern void altGetMacAddr();
extern void altSetMacaddr();
extern void altSetPromiscuous();
extern void altSetMultiCastMode();
extern void altUpdateGencomStats();
extern void altClearProfile();
extern void altClearNicStats();
extern void altSetFdrMode();
extern void altRefreshNicStats();
extern void altDoLinkNegotiation();
extern int altAddRedund();
extern void altRemRedund();
extern void altSendPkt();
extern void altRecvPkt();
extern bool altQueueSendMsg();
extern void initRings();
extern void FillJumboRecvRing();
extern void altUpdateTuneParms();
extern bool stopFW();
extern bool startFW();
extern bool restartFW();
extern bool loadFW();
extern bool verifyFW();
extern bool dumpFW();
extern void freeDump();
extern bool stopMAC();
extern int writeTGMem();
extern int readTGMem();
extern int writeTGScratch();
extern int readTGScratch();
extern int writeTGFlash();
extern int readTGFlash();
extern void determineTGFlash();
extern int writeTGSerEeprom();
extern int readTGSerEeprom();
extern void *alt_memcpy();
extern void altCheckBPDU();
extern int ALTSTART();
#if defined(ALT_STREAM)
extern int altread();
#endif /* defined(ALT_STREAM) */
#if defined(ALT_BSD)
extern int alt_copyin();
extern int alt_copyout();
#endif /* defined(ALT_BSD) */
#if ALT_BIG_ENDIAN
#define alt_swap_memcpy alt_memcpy
#else /* ALT_BIG_ENDIAN */
extern void *alt_swap_memcpy();
#endif /* ALT_BIG_ENDIAN */
#if SEND_CKSUM_DEBUG
extern U16 prepSendCksumPkt();
#endif /* SEND_CKSUM_DEBUG */
#if RECV_CKSUM_DEBUG
extern void verifyRecvCksum();
#endif /* RECV_CKSUM_DEBUG */
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
#endif /* _KERNEL */
#endif /* _ALTFTNS_H_ */

