/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997, 1998 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altintr.c,v $
 * Revision 1.1.2.13  1999/02/02  02:17:18  dfoy
 * 	Fixed evenizing 802.3 packets for Netware.
 * 	[1999/02/02  02:14:14  dfoy]
 *
 * Revision 1.1.2.12  1998/12/30  00:25:25  leonid
 * 	Fixes 1.1.2.8 (fix recvRingSpill) and 1.1.2.9 (fix potential receive mangling bug) are back after being removed by my 1.1.2.10 submission
 * 	[1998/12/30  00:17:56  leonid]
 * 
 * Revision 1.1.2.11  1998/12/23  16:45:49  leonid
 * 	Change the lock in ReceivePostProcessing from ALT_DISABLE to ALT_DISABLE_AT_DISPATCH_LEVEL
 * 	[1998/12/23  16:35:49  leonid]
 * 
 * 	"corrupted WrapperReserved" problem is fixed
 * 	[1998/12/18  23:29:35  leonid]
 * 
 * Revision 1.1.2.7  1998/12/07  23:33:31  ted
 * 	Fix two deserialized bugs and change some trace levels
 * 	[1998/12/07  23:31:14  ted]
 * 
 * Revision 1.1.2.6  1998/11/24  23:37:44  ted
 * 	Move refresh stats ahead of filling ring so various recvbds nic stats are correct
 * 	[1998/11/24  23:37:35  ted]
 * 
 * Revision 1.1.2.5  1998/11/23  22:50:24  ted
 * 	Remove extra checking from NDEBUG code
 * 	[1998/11/23  22:48:24  ted]
 * 
 * Revision 1.1.2.4  1998/11/19  00:15:58  dfoy
 * 	Added NESL call for OP2.
 * 	[1998/11/18  23:56:23  dfoy]
 * 
 * Revision 1.1.2.3  1998/11/17  00:19:32  hayes
 * 	update cksum offload testing framework
 * 	[1998/11/17  00:17:31  hayes]
 * 
 * Revision 1.1.2.2  1998/11/09  19:33:48  ted
 * 	support jumbos on x86 Solaris (test extended recv BD)
 * 	[1998/11/09  19:33:20  ted]
 * 
 * Revision 1.1.2.1  1998/11/04  19:38:03  ted
 * 	Split altdrv.c into altcfg.c, altcinit.c, and altintr.c
 * 	[1998/11/04  19:36:57  ted]
 * 
 * Revision 1.1.2.10  1998/12/18  23:30:01  leonid
 * 	"corrupted WrapperReserved" problem is fixed
 * 	[1998/12/18  23:29:35  leonid]
 * 
 * Revision 1.1.2.7  1998/12/07  23:33:31  ted
 * 	Fix two deserialized bugs and change some trace levels
 * 	[1998/12/07  23:31:14  ted]
 * 
 * Revision 1.1.2.6  1998/11/24  23:37:44  ted
 * 	Move refresh stats ahead of filling ring so various recvbds nic stats are correct
 * 	[1998/11/24  23:37:35  ted]
 * 
 * Revision 1.1.2.5  1998/11/23  22:50:24  ted
 * 	Remove extra checking from NDEBUG code
 * 	[1998/11/23  22:48:24  ted]
 * 
 * Revision 1.1.2.4  1998/11/19  00:15:58  dfoy
 * 	Added NESL call for OP2.
 * 	[1998/11/18  23:56:23  dfoy]
 * 
 * Revision 1.1.2.3  1998/11/17  00:19:32  hayes
 * 	update cksum offload testing framework
 * 	[1998/11/17  00:17:31  hayes]
 * 
 * Revision 1.1.2.2  1998/11/09  19:33:48  ted
 * 	support jumbos on x86 Solaris (test extended recv BD)
 * 	[1998/11/09  19:33:20  ted]
 * 
 * Revision 1.1.2.1  1998/11/04  19:38:03  ted
 * 	Split altdrv.c into altcfg.c, altcinit.c, and altintr.c
 * 	[1998/11/04  19:36:57  ted]
 * 
 * Revision 1.1.2.9  1998/12/18  22:01:21  ted
 * 	Fix potential receive mangling bug
 * 	[1998/12/18  21:58:09  ted]
 * 
 * Revision 1.1.2.8  1998/12/16  01:00:18  hayes
 * 	fix recvRingSpill
 * 	[1998/12/16  00:56:01  hayes]
 * 
 * Revision 1.1.2.7  1998/12/07  23:33:31  ted
 * 	Fix two deserialized bugs and change some trace levels
 * 	[1998/12/07  23:31:14  ted]
 * 
 * Revision 1.1.2.6  1998/11/24  23:37:44  ted
 * 	Move refresh stats ahead of filling ring so various recvbds nic stats are correct
 * 	[1998/11/24  23:37:35  ted]
 * 
 * Revision 1.1.2.5  1998/11/23  22:50:24  ted
 * 	Remove extra checking from NDEBUG code
 * 	[1998/11/23  22:48:24  ted]
 * 
 * Revision 1.1.2.4  1998/11/19  00:15:58  dfoy
 * 	Added NESL call for OP2.
 * 	[1998/11/18  23:56:23  dfoy]
 * 
 * Revision 1.1.2.3  1998/11/17  00:19:32  hayes
 * 	update cksum offload testing framework
 * 	[1998/11/17  00:17:31  hayes]
 * 
 * Revision 1.1.2.2  1998/11/09  19:33:48  ted
 * 	support jumbos on x86 Solaris (test extended recv BD)
 * 	[1998/11/09  19:33:20  ted]
 * 
 * Revision 1.1.2.1  1998/11/04  19:38:03  ted
 * 	Split altdrv.c into altcfg.c, altcinit.c, and altintr.c
 * 	[1998/11/04  19:36:57  ted]
 * 
 * $EndLog$
 */

#ifndef __lint
static char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/common/altintr.c,v 1.1.2.13 1999/02/02 02:17:18 dfoy Exp $";
#endif /* __lint */

/* General include files */
#if !defined(ALT_SYSV) && !defined(WINNT)
#include <string.h>		/* get these from systm.h via conf.h below */
#endif /* !defined(ALT_SYSV) && !defined(WINNT) */ 

#if !defined(WINNT)
#include <sys/types.h>
#include <sys/errno.h>
#endif /* !defined(WINNT) */

/* System V include files */
#if defined(ALT_SYSV)
#include <sys/kmem.h>
#include <sys/ethernet.h>	/* ether_addr */
#include <sys/cmn_err.h>
#include <sys/conf.h>
#endif /* defined(ALT_SYSV) */

/* streams specific files */
#if defined(ALT_STREAM)
#include <sys/stream.h>		/* queue_t, before sunddi.h or warning */
#include <sys/dlpi.h>
#endif /* defined(ALT_STREAM) */

/* BSD include files */
#if defined(ALT_BSD)
#include <sys/socket.h>
#include <sys/mbuf.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#endif /* defined(ALT_BSD) */

/* system specific include files */
#if defined(__sun)
#include <sys/byteorder.h>	/* htonl... */
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ddi.h>		/* min */
#include <sys/ddidmareq.h>	/* ddi dma structs */
#include <sys/sunddi.h>		/* DDI_SUCCESS... */
#include <sys/ksynch.h>		/* kconfvar_t */
/* non-ddi defined function, not proto available in standard header files */
extern mblk_t *desballoc(unsigned char *, int, int, frtn_t *);
#endif /* defined(__sun) */

#if defined(WINNT)
#include <ndis.h>
#include "altntmsg.h"
#endif /* defined(WINNT) */	

#if defined(__NETWARE_386__)
#include <odi.h>
#include <odi_nbi.h>
#include <odi_nesl.h>
#include <parser.h>
#include <cmsm.h>
#include <splat.h>
#include <portable.h>
#endif /* defined(__NETWARE_386__) */

/* alteon include files */
#include "alt.h"
#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include "altioctl.h"
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */
#include "eeprom.h"
#include "pub_tg.h"
#include "altos.h"
#include "althdr.h"
#include "altreg.h"		/* must follow althdr.h */
#include "altftns.h"
#include "altbpdu.h"
#include "altdrv.h"
#include "link.h"

#if defined(WINNT)
#include "drvstat.h"
#endif /* defined(WINNT) */	

#if defined(__sun)
#include "sbus.h"
#endif /* defined(__sun) */

#if defined(__NETWARE_386__)
#include <ethertsm.h>
#endif /* defined(__NETWARE_386__) */

/*
 * miscellaneous function forwards
 */
#if defined(__STDC__) || defined(ALT_PROTOS)
STATIC void RingDequeueMsgs(struct tg_nic *, U16, U16);
STATIC void FillRecvRing(struct altinst *);
#if USE_MINI_RING
STATIC void FillMiniRecvRing(struct altinst *);
#endif /* USE_MINI_RING */
#if !ALT_RECV_EXT
STATIC void RefillRecvRing(struct altinst *);
STATIC void RefillJumboRecvRing(struct altinst *);
#if USE_MINI_RING
STATIC void RefillMiniRecvRing(struct altinst *);
#endif /* USE_MINI_RING */
#endif /* !ALT_RECV_EXT */
#if defined(WINNT)
STATIC void RecvPostProcessing(struct tg_nic *, int);
#elif defined(__sun) /* defined(WINNT) */
STATIC void RecvPostProcessing(struct tg_nic *);
#endif /* defined(WINNT) */

#else /* defined(__STDC__) || defined(ALT_PROTOS) */
STATIC void RingDequeueMsgs();
STATIC void FillRecvRing();
#if USE_MINI_RING
STATIC void FillMiniRecvRing(struct altinst *);
#endif /* USE_MINI_RING */
#if !ALT_RECV_EXT
STATIC void RefillRecvRing();
STATIC void RefillJumboRecvRing();
#if USE_MINI_RING
STATIC void RefillMiniRecvRing();
#endif /* USE_MINI_RING */
#endif /* !ALT_RECV_EXT */
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */

void
#if defined(__STDC__) || defined(ALT_PROTOS)
ALTINTRWORK(struct tg_nic *nic)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
ALTINTRWORK(nic)
struct tg_nic *nic;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{	
    struct altinst *altp = nic->altp;
    struct tg_eci event;
    bool did10010, firstTime, didSomething;
    U16 shadEventCons, shadRecvProd;
    int shadState = altp->state;
    struct tg_eci *eventP;
#if REAP_FROM_SEND
    bool sendRingBusy = FALSE;
#endif /* REAP_FROM_SEND */
#if defined(__sun)
#define RUPT_TIMEOUT  10000000	/* 10 ms for Sun, goes to alttypes someday */
    hrtime_t tod;
#endif /* defined(__sun) */
    U32 i;
    int rc;

#if ALT_TRACE_ALL
    /* improve performance in non-tracing mode */
    if (altTracing > 1) {
	did10010 = TRUE;
	firstTime = TRUE;
	didSomething = FALSE;
    }
#endif /* ALT_TRACE_ALL */

    /* the following should be generified and ifdefed with a define like
     * ALT_RECV_EXT, or ALT_LOCKS_SUPPORTED, XXX */
#if defined(__sun)
    /* get a starting time, if we sit in the interrupt for longer than
     * some fixed time bail and give somebody else a chance */
    tod = gethrtime();
#endif /* defined(__sun) */

    /* 
     * look for three different cases to do things,
     * 1) recv_consumer (*nic->recvConsPtr) has been updated
     * 2) send_consumer (*nic->sendConsPtr) has been updated
     * 3) event_producer(*nic->eventProtPtr) has been updated
     */
    while (nic->recv_return_producer != (U16)*nic->recvReturnProdPtr ||
	   (nic->send_consumer != *nic->sendConsPtr 
#if REAP_FROM_SEND
	    && !sendRingBusy
#endif /* REAP_FROM_SEND */
	    ) ||
	   nic->eventCons != *nic->eventProdPtr) {
	didSomething = TRUE;
#if defined(__sun)
	if (gethrtime() > tod + RUPT_TIMEOUT)
	    break;
#endif /* defined(__sun) */

	/* don't do this stuff unless we're already up */
	if (shadState == ALT_FW_RUNNING) {
	    /* if we get ANY action, say the nic is okay */
	    nic->watchdog_ok = 1;
	    nic->watchdog_first = 1;

	    /* do the receive checks first, most important */
	    if (nic->recv_return_producer != 
		(shadRecvProd = (U16)*nic->recvReturnProdPtr)) { 
		ALTTRACEV(altirdq, 0x10009, nic->recv_return_producer,
			  shadRecvProd, 0, 0);
		/* dequeue and build mbuf chain */
		RingDequeueMsgs(nic, shadRecvProd, nic->recv_return_producer);

	    }
	    /* do the send checks second, more important than any event */
	    if ((rc = altReapSendRing(nic)) == SEND_RING_PROCESSED) {
#if FLOW_CONTROL_SUPPORTED
		/* in case we're flow controlled be sure we restart things
		 * now that resources are available */
		if (altp->flow_controlled)
		    REENABLE_SEND(nic);
#endif /* FLOW_CONTROL_SUPPORTED */
#if REAP_FROM_SEND
	    } else if (rc == SEND_RING_BUSY) {
	        sendRingBusy = TRUE;
#endif /* REAP_FROM_SEND */
	    }
	}
   
	while ((shadEventCons = nic->eventCons) != (U16)*nic->eventProdPtr) { 
	    eventP = &((*nic->eventArr)[shadEventCons].w0.eci);
	    /* invalidate the cache */
	    MALLOC_CACHE_INVAL(nic->eventArrDmaInfo.handle, 
			       nic->eventArr, 
			       shadEventCons * sizeof(struct tg_event), 
			       sizeof(struct tg_event));
	    event = *eventP; /* STRUCT COPY */

#if ALT_TRACE_ALL
	    if (altTracing > 1) { /* improve performance in non-tracing mode */
		if (event.event == TG_EVENT_STATS_UPDATED) {
		    ALTTRACEG(altintr, 0x1001e, &event, event.event,
			      event.code, event.index);
		    did10010 = FALSE;
		} else {
		    ALTTRACEV(altintr, 0x10010, &event, event.event, 
			      event.code, event.index);
		    if (firstTime) {
			ALTTRACEV(altintr1, 0x10020, shadEventCons, 
				  *nic->eventProdPtr, nic, 0);
			firstTime = FALSE;
		    }
		}
	    }
#endif /* ALT_TRACE_ALL */

	    /* bump for next time through */
	    shadEventCons = INCRING(shadEventCons, EVENT_RING_ENTRIES);
	    eventP += sizeof(struct tg_event) / sizeof(struct tg_eci);
	    if (shadEventCons == 0)
		eventP = &((*nic->eventArr)[0].w0.eci);

	    /* we look for a FIRMWARE_OPERATIONAL event, 
	     * if firmware is stopped */
	    if (altp->state == ALT_FW_RUNNING) {
		switch (event.event) {
		case TG_EVENT_STATS_UPDATED:
		    /* bleat every few seconds if we throw away frames
		     * that are too large and we aren't in jumbo mode 
		     * for ease in administration */
		    if (!(nic->flags & ALT_JUMBO_ENABLED) &&
			nic->lastCount++ > MAX_LAST_COUNTS &&
			nic->genInfo->stats.dot3StatsFrameTooLongs != 
			nic->lastTooLongs) {
#if defined(__NETWARE_386__)
			if (altp->oem != OEM_PARTNER2) { /* OP2 Does not want message */
			    sprintf(nic->string1, 
				"%s%d: Received oversize frames\n",
				nic->name, altp->instance);
				nic->flags |= ALT_STR1_PRESENT;
			}
#else /* defined(__NETWARE_386__) */
			ERROR3("%s%d: Received oversize frames\n",
			       nic->name, altp->instance);
#endif /* defined(__NETWARE_386__) */
			nic->lastTooLongs = 
			    nic->genInfo->stats.dot3StatsFrameTooLongs;
			nic->lastCount = 0;
		    }
		    /* mostly for ODI, need some way to go get buffers
		     * when the system ran out.  Normally, I suppose this
		     * would go on the "overflow" error case, but we haven't
		     * got one of those, so just do it occasionally */
#if !ALT_RECV_EXT
		    /* fill up the rings */
		    if ((nic->flags & ALT_JUMBO_FILLED) &&
			INCRING(nic->recv_jumbo_producer, 
				RECV_JUMBO_RING_ENTRIES) != 
			nic->recv_jumbo_consumer)
			RefillJumboRecvRing(altp);
		    if (INCRING(nic->recv_std_producer, 
				RECV_STANDARD_RING_ENTRIES) != 
			nic->recv_std_consumer)
			RefillRecvRing(altp);
#if USE_MINI_RING
		    if (INCRING(nic->recv_mini_producer, 
				RECV_MINI_RING_ENTRIES) != 
			nic->recv_mini_consumer)
			RefillMiniRecvRing(altp);
#endif /* USE_MINI_RING */
#endif /* !ALT_RECV_EXT */
		    break;

		case TG_EVENT_FIRMWARE_OPERATIONAL:
		    ALTTRACE(spurEvt, 0xf0028, event.event, 0, 0, 0);
		    break;
		
		case TG_EVENT_ERROR:
		    switch (event.code) {
		    case TG_EVENT_CODE_ERR_INVALID_CMD:
#if defined(__NETWARE_386__)
			sprintf(nic->string1, 
				"%s%d: Got invalid command error event, type %d\n",
				nic->name, altp->instance, event.code);
			nic->flags |= ALT_STR1_PRESENT;
#else /* defined(__NETWARE_386__) */
			ERROR4("%s%d: Got invalid command error event, type %d\n",
			       nic->name, altp->instance, event.code);
#endif /* defined(__NETWARE_386__) */
			ALTTRACEE(invalcmd, 0xf000a, event.code, 0, 0, 0);
			break;
		    
		    case TG_EVENT_CODE_ERR_UNIMP_CMD:
#if defined(__NETWARE_386__)
			sprintf(nic->string1, 
				"%s%d: Got unimplemented command error event, type %d\n",
				nic->name, altp->instance, event.code);
			nic->flags |= ALT_STR1_PRESENT;
#else /* defined(__NETWARE_386__) */
			ERROR4("%s%d: Got unimplemented command error event, type %d\n",
			       nic->name, altp->instance, event.code);
#endif /* defined(__NETWARE_386__) */
			ALTTRACEE(unimpcmd, 0xf000b, event.code, 0, 0, 0);
			break;
		    
		    default:
#if defined(__NETWARE_386__)
			sprintf(nic->string1, 
				"%s%d: Got unknown error event\n",
				nic->name, altp->instance);
			nic->flags |= ALT_STR1_PRESENT;
#else /* defined(__NETWARE_386__) */
			ERROR3("%s%d: Got unknown error event\n",
			       nic->name, altp->instance);
#endif /* defined(__NETWARE_386__) */
			ALTTRACEE(unkevter, 0xf0009, 0, 0, 0, 0);
			break;
		    }
		    break;

		case TG_EVENT_LINK_STATE_CHANGED:
		    switch (event.code) {
		    case TG_EVENT_CODE_LINK_UP:
#if defined(__NETWARE_386__)
			if (altp->oem == OEM_PARTNER2) 
			   ReportLinkStatus(altp->drvData, nic->initAltp->instance, 0);
			sprintf(nic->string1, 
				"%s%d: Gigabit Ethernet link is %s",
				nic->name, nic->initAltp->instance,
				nic->genComm->gen_com.linkState &
				LNK_NEGOTIATE ? "negotiated" : "up");
			sprintf(nic->string2, 
				"%s%d: Rx flow control is %s, Tx flow control is %s",
				nic->name, nic->initAltp->instance,
				nic->genComm->gen_com.linkState & 
				LNK_RX_FLOW_CTL_Y ? "enabled" : "disabled",
				nic->genComm->gen_com.linkState & 
				LNK_TX_FLOW_CTL_Y ? "enabled" : "disabled");
			nic->flags |= ALT_STR1_PRESENT | ALT_STR2_PRESENT;
#else /* defined(__NETWARE_386__) */
			NOTE4("%s%d: Gigabit Ethernet link is %s",
			      nic->name, nic->initAltp->instance,
			      RDSHMEM(nic->genComm->gen_com.linkState) &
			      LNK_NEGOTIATE ? "negotiated" : "up");
			NOTE5("%s%d: rx flow control is %s, tx flow control is %s",
			      nic->name, nic->initAltp->instance,
			      RDSHMEM(nic->genComm->gen_com.linkState) & 
			      LNK_RX_FLOW_CTL_Y ? "enabled" : "disabled",
			      RDSHMEM(nic->genComm->gen_com.linkState) & 
			      LNK_TX_FLOW_CTL_Y ? "enabled" : "disabled");
#endif /* defined(__NETWARE_386__) */
#if defined(WINNT)
			LOG1(nic->handle, ALT_LOG_LINK_UP, 
			     nic->initAltp->instance);
#endif /* defined(WINNT) */
			ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
			nic->flags |= ALT_LINK_READY;
			ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
                        LINK_STATE_INDICATION(TG_EVENT_CODE_LINK_UP);
			break;
			
		    case TG_EVENT_CODE_LINK_DOWN:
#if defined(__NETWARE_386__)
			if (altp->oem == OEM_PARTNER2) 
			   ReportLinkStatus(altp->drvData, nic->initAltp->instance, 1);
			sprintf(nic->string1,
				"%s%d: Gigabit Ethernet link is down",
				nic->name, nic->initAltp->instance);
			nic->flags |= ALT_STR1_PRESENT;
#else /* defined(__NETWARE_386__) */
			NOTE3("%s%d: Gigabit Ethernet link is down",
			      nic->name, nic->initAltp->instance);
#endif /* defined(__NETWARE_386__) */
#if defined(WINNT)
			LOG1(nic->handle, ALT_LOG_LINK_DOWN,
			     nic->initAltp->instance);
#endif /* defined(WINNT) */
			ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
			nic->flags &= ~ALT_LINK_READY;
			ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
                        LINK_STATE_INDICATION(TG_EVENT_CODE_LINK_DOWN);
			break;
			
		    case TG_EVENT_CODE_FAST_LINK_UP:
			NOTE6("%s%d: %s Ethernet %s duplex link is %s",
			      nic->name, nic->initAltp->instance,
			      RDSHMEM(nic->genComm->gen_com.fastLinkState) &
			      LNK_100MB ? "100 Mbps" : "10 Mbps",
			      RDSHMEM(nic->genComm->gen_com.fastLinkState) &
			      LNK_FULL_DUPLEX ? "full" : "half",
			      RDSHMEM(nic->genComm->gen_com.fastLinkState) &
			      LNK_NEGOTIATE ? "negotiated" : "up");
			NOTE5("%s%d: rx flow control is %s, tx flow control is %s",
			      nic->name, nic->initAltp->instance,
			      RDSHMEM(nic->genComm->gen_com.fastLinkState) & 
			      LNK_RX_FLOW_CTL_Y ? "enabled" : "disabled",
			      RDSHMEM(nic->genComm->gen_com.fastLinkState) & 
			      LNK_TX_FLOW_CTL_Y ? "enabled" : "disabled");
			ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
			nic->flags |= ALT_LINK_READY;
			ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
                        LINK_STATE_INDICATION(TG_EVENT_CODE_LINK_UP);
			break;

		    default:
#if defined(__NETWARE_386__)
			sprintf(nic->string1, 
				"%s%d: Got unknown link state changed event\n",
				nic->name, altp->instance);
			nic->flags |= ALT_STR1_PRESENT;
#else /* defined(__NETWARE_386__) */
			ERROR3("%s%d: Got unknown link state changed event\n",
			      nic->name, altp->instance);
#endif
			ALTTRACEE(unklink, 0xf0003, 0, 0, 0, 0);
			break;
		    }
		    break;
		    
		case TG_EVENT_MULTICAST_LIST_UPDATED:
		    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
			ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
			nic->flags &= ~ALT_MULTI_ACTIVE;
			ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->flagMu);
		    }
#if 0				/* maybe later if we get our rupts enabled */
#if defined(__NETWARE_386__)
		    CMSMControlComplete(altp->drvData, CHSM_COMPLETE_MULTICAST,
					ODISTAT_SUCCESSFUL);
#endif /* defined(__NETWARE_386__) */
#endif /* 0 */
		    break;
		    
		default:
		    ALTTRACEE(unimpEvt, 0xf0011, event.event, 
			      0, 0, 0);
		}
	    } else if (altp->state == ALT_FW_LOADED) {
		if (event.event != TG_EVENT_FIRMWARE_OPERATIONAL) {
		    ERROR4("%s%d: Got event type %x before FIRMWARE_OPERATIONAL event\n",
			   nic->name, altp->instance, event.event);
		    ALTTRACEE(spurevt, 0xf000c, event.event, 0, 0, 0);
		    break;
		} else {
		    altp->state = ALT_FW_RUNNING;
		    shadState = ALT_FW_RUNNING;

#if defined(ALT_BSD)
		    /* mark that we can start the IF layer */
		    ((struct ifnet *)altp)->if_flags |= IFF_RUNNING;
#endif /* defined(ALT_BSD) */

		    /* indicate the first time that watchdog is ok */
		    nic->watchdog_ok = 1;

#if defined(__NETWARE_386__) || defined(WINNT)
		    /* do this first so we get the recvbd stats right */
		    if (nic->flags & ALT_RESET_STATS) {
			altRefreshNicStats(altp);
			nic->flags &= ~ALT_RESET_STATS;
		    }
#endif /* defined(__NETWARE_386__) || defined(WINNT) */

		    /* Fill up the receive ring, we're ready for business */
		    FillRecvRing(altp);

		    /* Fill up the jumbo receive ring, too, maybe */
		    if (nic->flags & ALT_JUMBO_ENABLED)
			FillJumboRecvRing(altp);

#if USE_MINI_RING
		    FillMiniRecvRing(altp);
#endif /* USE_MINI_RING */

#if defined(WINNT) || defined(__NETWARE_386__)
		    /* set the host stack up for NT or NETWARE
		     * 'cause if we're here it is */
		    altHostState(altp, TRUE);
#endif /* defined(WINNT) || defined(__NETWARE_386__) */

		    /* start by saying link is down so if it doesn't come
		     * up we'll still have SOME message */
#if defined(__NETWARE_386__)
			sprintf(nic->string1,
				"%s%d: Gigabit Ethernet link is down",
				nic->name, nic->initAltp->instance);
			nic->flags |= ALT_STR1_PRESENT;
#else /* defined(__NETWARE_386__) */
			NOTE3("%s%d: Gigabit Ethernet link is down",
			      nic->name, nic->initAltp->instance);
#endif /* defined(__NETWARE_386__) */

		    /* look for an indication to do FDR Filtering */
		    if ((nic->flags & ALT_DO_FDR_FILTERING) &&
			nic->tigonRev == TG_MHC_LSI_GATE_VERS)
			altSetFdrMode(altp, TRUE);
		    /* look for an indication to set promiscuous mode */
		    if (nic->flags & ALT_PROM_MODE)
			altSetPromiscuous(altp, TRUE);
		    /* look for an indication to set multicast mode */
		    if (nic->flags & ALT_MULTICAST_MODE)
			altSetMultiCastMode(altp, TRUE);
		    /* look for an indication to add multicast addresses */
		    for (i = 0; i < altp->mccount; i++) {
			altAddMultiCast(altp, &altp->mctab[i].addr);
		    }
		}
	    }
	    /* write the real consumer back into the card too */
	    nic->eventCons = shadEventCons;
	    WRSHMEM(nic->genComm->gen_com.event_cons_index, shadEventCons);
	    MB();
	}
    }

#if defined(WINNT)
    /* we don't have a wrapper */
    OUT32(nic->handle, nic->base, TG_MBOX0_LOW, 0); 
#endif /* defined(WINNT) */

#if ALT_TRACE_ALL
    /* trace end of rupt */
    if (altTracing > 1 && did10010 && didSomething)
	ALTTRACEV(endrupt, 0x1001f, nic->recv_return_producer, shadRecvProd,
		  nic->send_consumer, 0);
#endif /* ALT_TRACE_ALL */
}

int
#if defined(__STDC__) || defined(ALT_PROTOS)
altReapSendRing(struct tg_nic *nic)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altReapSendRing(nic, getLock)
struct tg_nic *nic;
bool getLock;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    U16 shadSendCons, saveSendCons;

#if ALT_LOCKS_SUPPORTED && (REAP_FROM_SEND || ALT_DESERIALIZE)
#if REAP_FROM_SEND
    /* protect against recursion out of altFreeSendMsgs() */
    if (nic->inSendReap) {
        ALTTRACE(altifrsb, 0x10046, nic->send_consumer, *nic->sendConsPtr, 
		 nic->inSendReap, 0);
	return(SEND_RING_BUSY);
    }
#endif /* REAP_FROM_SEND */
    ALT_DISABLE(spl, &nic->sendReapMu); /* ENTER CRITICAL SECTION */
#if REAP_FROM_SEND
    nic->inSendReap = TRUE;
#endif /* REAP_FROM_SEND */
#endif /* ALT_LOCK_SUPPORTED && (REAP_FROM_SEND || ALT_DESERIALIZE) */
    /* make sure to snapshot current sendConsPtr and don't
     * reaccess it */
    if ((saveSendCons = nic->send_consumer) != 
	(shadSendCons = (U16)*nic->sendConsPtr)) { 
        ALTTRACEV(altifrs, 0x1000a, nic->send_consumer, shadSendCons, 0, 0);
	/* can't deserialize this because upper layers don't take kindly
	 * to the out of order return */
	altFreeSendMsgs(nic, saveSendCons, shadSendCons);
	/* update the local send consumer value */
	nic->send_consumer = shadSendCons;
#if ALT_LOCKS_SUPPORTED && (REAP_FROM_SEND || ALT_DESERIALIZE)
#if REAP_FROM_SEND
	nic->inSendReap = FALSE;
#endif /* REAP_FROM_SEND */
	ALT_ENABLE(spl, &nic->sendReapMu); /* LEAVE CRITICAL SECTION */
#endif /* ALT_LOCKS_SUPPORTED && (REAP_FROM_SEND || ALT_DESERIALIZE) */
	return(SEND_RING_PROCESSED);
    } else {
#if ALT_LOCKS_SUPPORTED && (REAP_FROM_SEND || ALT_DESERIALIZE)
#if REAP_FROM_SEND
	nic->inSendReap = FALSE;
#endif /* REAP_FROM_SEND */
	ALT_ENABLE(spl, &nic->sendReapMu);  /* LEAVE CRITICAL SECTION */
#endif /* ALT_LOCKS_SUPPORTED && (REAP_FROM_SEND || ALT_DESERIALIZE) */
	return(SEND_RING_EMPTY);
    }
}

#if defined(WINNT)
bool
#else /* defined(WINNT) */
void
#endif /* defined(WINNT) */
#if defined(__STDC__) || defined(ALT_PROTOS)
altWatchdog(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altWatchdog(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    int i;
#define WDOG_MULTIPLIER 100	/* number of times we can miss watchdog */

    /* if the firmware isn't inited, forget this */
    if (altp->state != ALT_FW_RUNNING || !nic->watchdog_first) {
#if defined(ALT_SYSV)
	/* restart the watchdog timer running at 1/nth freq of stats */
	/* if the watchdog is set to 0, timer it every 1 second but don't
         * die on missing watchdog */
	if (RDSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks)) {
	    altp->timeoutId = 
		timeout(altWatchdog, (char *)altp, 
			drv_usectohz(WDOG_MULTIPLIER * 
		         (RDSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks) *
			  (USECS_PER_SEC / TG_TICKS_PER_SEC))));
	} else {
	    altp->timeoutId = timeout(altWatchdog, (char *)altp,
				      drv_usectohz(USECS_PER_SEC));
	}
#endif /* defined(ALT_SYSV) */
#if defined(WINNT)
        return(FALSE);		/* say we're okay, even though we're not up */
#else /* defined(WINNT) */
	return;
#endif /* defined(WINNT) */
    }

    if (!nic->watchdog_ok && 
	RDSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks)) {
	ERROR3("%s%d: NIC watchdog event missed",
	       nic->name, altp->instance);
	ALTTRACEE(wdoglost, 0xf000d, altp->instance, nic->flags, 0, 0);
	/*	stopFW(altp); */
	/* snapshot the firmware PC a few times and then get the fw mem */
	for (i=0; i<10; i++) {
	    ALTTRACEE(nicpc, 0xf0022, 
		      IN32(nic->handle, nic->base, TG_CPU_CONTROL),
		      IN32(nic->handle, nic->base, TG_PROG_CTR),
		      0, 0);
	    SNOOZE(1);
	}
	if (dumpFW(altp)) {
	    ALTTRACEE(dumpFW, 0xf0013, nic->nicDump, nic->nicRegs, 0, 0);
	} else {
	    ERROR3("%s%d: Couldn't dump NIC firmware\n",
		   nic->name, altp->instance);
	    ALTTRACEE(nodump, 0xf0020, 0, 0, 0, 0);
	}
	alt_trace_snap();
#if defined(WINNT)
        return(TRUE);		/* we're bad tell system */
#else /* defined(WINNT) */
	return;			/* don't reenable watchdog, once is enuf */
#endif /* defined(WINNT) */
    }
    nic->watchdog_ok = 0;

#if defined(ALT_SYSV)
    /* restart the watchdog timer running at 1/nth freq of stats */
    /* if the watchdog is set to 0, timer it every 1 second but don't
     * die on missing watchdog */
    if (RDSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks)) {
	altp->timeoutId = 
	    timeout(altWatchdog, (char *)altp,
		    drv_usectohz(WDOG_MULTIPLIER *
		       (RDSHMEM(nic->genComm->gen_com.tuneParms.stat_ticks) *
			(USECS_PER_SEC / TG_TICKS_PER_SEC))));
    } else {
	altp->timeoutId = timeout(altWatchdog, (char *)altp,
				  drv_usectohz(USECS_PER_SEC));
    }
#endif /* defined(ALT_SYSV) */
#if defined(WINNT)
    return(FALSE);		/* say we're okay, 'cause we are */
#else /* defined(WINNT) */
    return;
#endif /* defined(WINNT) */
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altSendPkt(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altSendPkt(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altRecvPkt(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altRecvPkt(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
}

bool
#if defined(__STDC__) || defined(ALT_PROTOS)
altQueueSendMsg(struct tg_nic *nic, SEND_PKT *pkt, U32 vlanTag, U32 coal_now)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altQueueSendMsg(nic, pkt, vlanTag, coal_now)
struct tg_nic *nic;
SEND_PKT *pkt;
int len;
U32 vlanTag;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct send_bd bufd[MAX_BUFDS_PER_FRAME];
    struct send_bd *bufdp;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U16 start_producer;
    int rc = TRUE;
    struct alt_dma_info *infop;
    U32 len;
    U32 totLen = 0;
    char *datap;
    U32 i;
    int preprc = 0;
    bool firstTime;
    U16 flags;
    bool didLastFrag = FALSE;
    U16 csum_flags = 0;
#if ALT_DESERIALIZE
    bool needAnotherInfop = FALSE;
    struct alt_dma_info *firstInfop, *oldInfop;
    U32 usedBufds = 0;
#endif /* ALT_DESERIALIZE */
#if defined(__NETWARE_386__)
    U32 count, maxCount;
    struct altinst *altp = nic->altp;
#endif /* defined(__NETWARE_386__) */

    /* Be sure link is ready */
    if (!(nic->flags & ALT_LINK_READY)) {
	return(FALSE);
    }

    SENDPKT2MSG(pkt, msg);	/* get message associated with packet */

    PREP_SEND_CKSUM_PKT(csum_flags, pkt, msg);

    ALTTRACE(qSendMsg, 0x1000b, pkt, nic->send_producer, 
	     nic->send_consumer, vlanTag);

    firstTime = TRUE;		/* keep track for stats calculation */
    bufdp = bufd;
    /* get an infop for the first bit of data */
    GET_FREE_INFOP(infop, nic, spl, nic->send_producer);

#if ALT_DESERIALIZE
    if (!infop) {
        ALTTRACE(nomorbd1, 0xf002a, nic->smsgsFree, 0, 0, 0);
        return(FALSE);
    }

    firstInfop = infop;
    infop->next = (struct alt_dma_info *)0;
#else /* ALT_DESERIALIZE */
    /* need to set this up fron in the non-deserialized case, we change
     * the nic->send_producer throughout the function.  See deserialized
     * critical section below for deserialized logic */
    start_producer = nic->send_producer;
#endif /* ALT_DESERIALIZE */
    datap = infop->dataAddr;

    totLen = 0;
#if HAVE_MSGHDR
    if ((len = MSGHDRLEN(pkt)) <= nic->hybridLen) {
	MEMCPY((MEMCPY_TYPE)datap, MSGHDR(pkt, MEMCPY_TYPE), len);
	datap += len;
	totLen += len;
    } else if (len) {
	PREP_SEND_FLY_INFOP(infop, nic, nic->send_producer, 
			    MSGHDR(pkt, caddr_t), MSGHDRLEN(pkt), 
			    msg, pkt);
	/* PREP_DMA returns 0 on failure, or the count of physical addresses */
	PREP_FLY_DMA(preprc, ALT_DMA_SEND, DDI_DMA_WRITE, infop);
	/* the header has to be in one physical page */
	if (preprc == 1) {
	    /* zero the high order word of the buffer desc for 32 bit ptrs */
	    HOSTZEROHI(bufdp->host_addr);
	    bufdp->sendbd_length = infop->dataLen;
	    bufdp->HOSTADDR(host_addr) = MAP2BUS(infop->dataAddrFly);
	    /* for Tigon 1 and 2 to do statistics we must tell it 
	     * the packet type */
	    flags = 0;
	    SEND_STAT_PREP(infop, flags);
	    if (NON_HDR_FRAGS(pkt))
		bufdp->sendbd_flags = 0;
	    else {
		bufdp->sendbd_flags = BD_FLAG_END | flags;
                if (coal_now) {
                    bufdp->sendbd_flags |= BD_FLAG_COAL_NOW;
		}
	    }
	    if (vlanTag != NO_VLAN_TAG) {
		bufdp->sendbd_flags |= BD_FLAG_VLAN_TAG;
		bufdp->sendbd_vlan_tag = vlanTag;
	    }
	    bufdp->sendbd_flags |= csum_flags;
	    firstTime = FALSE;
	
	    ALTTRACE2V(sdmahdr, 0x10006, infop->dataLen,
		       infop->dataAddr, nic->send_producer,
		       bufdp->sendbd_flags, infop->dataAddr);
	
	    /* invalidate the cache data */
	    PREP_CACHE_WB(infop, infop->dataLen);

#if ALT_DESERIALIZE
	    /* move on to the next bufd */
	    bufdp++;
	    usedBufds++;
#else /* ALT_DESERIALIZE */
	    ENQ_SEND_RING(bufdp, nic->send_producer, nic->send_consumer, 
			  nic->sendRing, spl, rc);
	    if (!rc) {
		ALTTRACE(sringful, 0xf0004, nic->send_consumer, 
			 nic->send_producer,
			 nic->eventCons, *nic->eventProdPtr);
		/* clean up DMA PREP */
		GET_NEXT_INFOP(infop, nic, spl, start_producer);
		UNPREP_FLY_DMA(infop);
		UNPREP_SEND_FLY_INFOP(infop);
		nic->outDrops++;
		nic->outDropsNoSpace++;
		    
		/* back up producer to where we started */
		nic->send_producer = start_producer;

		/* check for memory window in the right place */
		SET_NIC_MEM_WINDOW_NOW(start_producer, nic);
		return(FALSE);
	    }
#endif /* ALT_DESERIALIZE */
	} else {
	    panic("Invalid preparation of header, can't happen");
	}
    }
#endif /* HAVE_MSGHDR */

    /* walk down the MSG chain until we get one that shouldn't be 
     * tacked together */
    LOOP_THRU_PACKET(pkt, msg, count, maxCount) {
	MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	if (totLen + len <= nic->hybridLen) {
	    /* copy the data into the buffer */
	    MEMCPY((MEMCPY_TYPE)datap, (MEMCPY_TYPE)addr, len);
	    datap += len;
	    totLen += len;
	} else {
	    break;
	}
	/* save notice of last frag so we can set the BD_FLAG_END properly */
	if (LASTFRAG(msg, count, maxCount))
	    didLastFrag = TRUE;
	/* on to the next MSG */
	MSGNEXT(msg);
    }

    if (totLen > 0) {
#if ALT_DESERIALIZE
	/* indicate to below that we've used the infop */
	needAnotherInfop = TRUE;
#endif /* ALT_DESERIALIZE */

	/* indicate which addr to use */
	infop->flags = ALT_DMA_INFO_PREALLOC;

	/* save pkt for later so we can free things if we end up only
	 * doing copydata */
	infop->INFOP_SPKT = pkt;

	/* enqueue the data as a bd */
	bufdp->sendbd_length = (U16)totLen;

	/* indicate we've already set the stats info for non-copydata
	 * data coming later */
	if (firstTime) {
	    flags = 0;
	    SEND_STAT_PREP(infop, flags);
	    firstTime = FALSE;
	    if (vlanTag != NO_VLAN_TAG) {
		bufdp->sendbd_flags = BD_FLAG_VLAN_TAG;
		bufdp->sendbd_vlan_tag = (U16)vlanTag;
	    } else
		bufdp->sendbd_flags = 0;
	} else
	    bufdp->sendbd_flags = 0;
	bufdp->sendbd_flags |= csum_flags;

	/* check to see if we need to set the end flag, because no hybrid
	 * data following copydata data */
	if (didLastFrag) {
#if defined(__NETWARE_386__)
	    /* evenize for 802.3 packets */
	    if (totLen & 1)
		bufdp->sendbd_length++;
#endif /* defined(__NETWARE_386__) */
	    bufdp->sendbd_flags |= BD_FLAG_END | flags;
	    infop->flags |= ALT_DMA_INFO_FLAG_END;
            if (coal_now) {
                bufdp->sendbd_flags |= BD_FLAG_COAL_NOW;
            }
	}

	/* zero the high order word of the buffer desc for 32 bit ptrs */
	HOSTZEROHI(bufdp->host_addr);
	bufdp->HOSTADDR(host_addr) = MAP2BUS(infop->dataAddr);
	
	/* flush the cache data, no need to do the whole block just
           what we use */
	infop->dataLen = totLen;
	PREP_CACHE_WB(infop, infop->dataLen);

	ALTTRACE2V(sdmainfo, 0x10042, infop->dataLen, 
		  infop->dataAddr, nic->send_producer, 
		  bufdp->sendbd_flags, infop->dataAddr);

#if USE_CKSUM_OFFLOAD && DO_CKSUM_DEBUG && defined(WINNT)
	{
	    /* extern prototype */
	    extern U16 ckSum_pseudo(struct ip *);
	    extern U16 ckSumIt(char *, S32);
	    U32 sum1;

	    /* look for a case where I'm told to checksum but seed isn't
	     * the pseudo-header */
	    sum1 = ckSum_pseudo((struct ip *)(infop->dataAddr + 14));
	    ALTTRACEE(cksumsd, 0xfffff, sum1, 
		      *(U16 *)(infop->dataAddr + 50), csum_flags, 0);
	    if (csum_flags & BD_FLAG_TCP_UDP_CKSUM) {
		ASSERT(sum1 == (U32)ntohs(*(U16 *)(infop->dataAddr + 50)));
	    } 
#if 0
	    else {
		ASSERT(sum1 != (U32)ntohs(*(U16 *)(infop->dataAddr + 50)));
	    }
	    sum2 = ckSumIt(infop->dataAddr + 34, 
			   MIN((S32)totLen - 34,
			       (S32)(htons(*(U16 *)(infop->dataAddr + 16)))
			       - 20));
#endif /* 0 */
	}
	ALTTRACE2V(sdmaip, 0x10142, 0, 0, 0, 0, infop->dataAddr + 14);
	ALTTRACE2V(sdmatcp, 0x10242, 0, 0, 0, 0, infop->dataAddr + 34);
#endif /* USE_CKSUM_OFFLOAD && DO_CKSUM_DEBUG && defined(WINNT) */

#if ALT_DESERIALIZE
	/* move on to the next bufd */
	bufdp++;
	usedBufds++;
#else /* ALT_DESERIALIZE */
	ENQ_SEND_RING(bufdp, nic->send_producer, nic->send_consumer, 
		      nic->sendRing, spl, rc);
	if (!rc) {
	    ALTTRACE(sringful, 0xf0012, nic->send_consumer, nic->send_producer,
		     nic->eventCons, *nic->eventProdPtr);
	    nic->outDrops++;
	    nic->outDropsNoSpace++;
	    
	    /* back up producer to where we started */
	    nic->send_producer = start_producer;

	    /* check for memory window in the right place */
	    SET_NIC_MEM_WINDOW_NOW(start_producer, nic);
	    return(FALSE);
	}
#endif /* ALT_DESERIALIZE */
    }

    /* walk down the rest of the MSG chain */
    CONT_LOOP_THRU_PACKET(pkt, msg, count, maxCount) {
	MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	totLen += len;
	/* we don't bother doing something with a 0 length mblk */
	if (len) {
#if ALT_DESERIALIZE
	    /* don't get a new one if we didn't copy anything */
	    if (needAnotherInfop) {
		oldInfop = infop;
		/* see if we can get another */
		GET_FREE_INFOP(infop, nic, spl, 0);
		if (!infop) {
		    /* clean up prev DMA Preps, if any */
		    infop = firstInfop;
		    while (infop) {
		        if (!(infop->flags & 
			      (ALT_DMA_INFO_FLAG_CONT | 
			       ALT_DMA_INFO_PREALLOC))) {
			    UNPREP_FLY_DMA(infop);
		            UNPREP_SEND_FLY_INFOP(infop);
			}
			oldInfop = infop;
			infop = infop->next;
			FREE_INFOP(oldInfop, nic, spl);
		    }
		    nic->outDrops++;
		    nic->outDropsDmaResources++;
		    
		    ALTTRACE(nomorebd, 0xf0029, nic->smsgsFree, 0, 0, 0);
		    return(FALSE);
		}
		
		/* chain it up so we can send the data */
		oldInfop->next = infop;
		infop->next = (struct alt_dma_info *)0;
	    } else {
		/* say we need another in case we loop through here */
		needAnotherInfop = TRUE;
	    }
#else /* ALT_DESERIALIZE */
	    /* keep track of the msgs we're using */
	    GET_FREE_INFOP(infop, nic, smsgs, nic->send_producer);
#endif /* ALT_DESERIALIZE */
	    PREP_SEND_FLY_INFOP(infop, nic, nic->send_producer, 
				addr, len, msg, pkt);
	    /* PREP_DMA returns 0 on failure, or the count of physical addrs */
	    PREP_FLY_DMA(preprc, ALT_DMA_SEND, DDI_DMA_WRITE, infop);
	    if (!preprc) {
#if ALT_DESERIALIZE
		/* clean up prev DMA Preps, if any */
		infop = firstInfop;
		while (infop) {
		    if (!(infop->flags & 
			  (ALT_DMA_INFO_FLAG_CONT | ALT_DMA_INFO_PREALLOC))) {
			UNPREP_FLY_DMA(infop);
			UNPREP_SEND_FLY_INFOP(infop);
		    }
		    oldInfop = infop;
		    infop = infop->next;
		    FREE_INFOP(oldInfop, nic, spl);
		}
#else /* ALT_DESERIALIZE */
		/* clean up prev DMA PREPs, if any */
		if (start_producer != nic->send_producer) {
		    i = start_producer;
		    while (i != nic->send_producer) {
			infop = &nic->smsgs[i];
			if (!(infop->flags & 
			      (ALT_DMA_INFO_FLAG_CONT | 
			       ALT_DMA_INFO_PREALLOC))) {
			    UNPREP_FLY_DMA(infop);
			    UNPREP_SEND_FLY_INFOP(infop);
			}
			i = INCRING(i, SEND_RING_ENTRIES);
		    }
		}
#endif /* ALT_DESERIALIZE */

		nic->outDrops++;
		nic->outDropsDmaResources++;
		
		ALTTRACE(prepdfail, 0xf0025, 0, 0, 0, 0);

#if !ALT_DESERIALIZE
		/* back up producer to where we started */
		nic->send_producer = start_producer;

		/* check for memory window in the right place */
		SET_NIC_MEM_WINDOW_NOW(start_producer, nic);
#endif /* !ALT_DESERIALIZE */
		return(FALSE);
	    }

	    /* loop through the infops set up by PREP_DMA */
	    while (preprc) {
		bufdp->sendbd_length = infop->dataLen;
		/* zero the high order word of the buf desc for 32 bit ptrs */
		HOSTZEROHI(bufdp->host_addr);
		bufdp->HOSTADDR(host_addr) = MAP2BUS(infop->dataAddrFly);
		/* on first BD set the packet type for Tigon 1 statistics */
		if (firstTime) {
		    flags = 0;
		    SEND_STAT_PREP(infop, flags);
		    firstTime = FALSE;
		    if (vlanTag != NO_VLAN_TAG) {
			bufdp->sendbd_flags = BD_FLAG_VLAN_TAG;
			bufdp->sendbd_vlan_tag = (U16)vlanTag;
		    } else
			bufdp->sendbd_flags = 0;
		} else
		    bufdp->sendbd_flags = 0;

		/* set the flag to not end if there's more to go.  More to
		 * go means there's more fragments or there's more physical
		 * addrs in this fragment */
		if (!LASTFRAG(msg, count, maxCount) || preprc > 1) {
		    bufdp->sendbd_flags |= csum_flags;
		} else {
#if defined(__NETWARE_386__)
		    /* evenize for 802.3 packets */
		    if (totLen & 1)
			bufdp->sendbd_length++;
#endif /* defined(__NETWARE_386__) */
		    bufdp->sendbd_flags |= BD_FLAG_END | flags;
		    bufdp->sendbd_flags |= csum_flags;
                    if (coal_now) {
                        bufdp->sendbd_flags |= BD_FLAG_COAL_NOW;
                    }
		    /* need to put it here too, don't want to read the card */
		    infop->flags |= ALT_DMA_INFO_FLAG_END;
		}
	
		/* check this trace and make sure the packet data print
		 * is ok (is either long enough or doesn't overflow onto
		 * a new page */
		if (altTracing > 2) {
		    if (infop->dataLen <= 24 && 
			PAGE_OFFSET(infop->dataAddrFly) + 24 > PAGE_SIZE) {
			ALTTRACEV(sdmainfo, 0x1003e, infop->dataLen, 
				  infop->dataAddrFly, nic->send_producer, 
				  bufdp->sendbd_flags);
		    } else {
			ALTTRACE2V(sdmainfo, 0x1002b, infop->dataLen,
				   infop->dataAddrFly, nic->send_producer,
				   bufdp->sendbd_flags, infop->dataAddrFly);
		    }
		}
		/* invalidate the cache data */
		PREP_CACHE_WB(infop, infop->dataLen);
		preprc--;
#if ALT_DESERIALIZE
		/* move on to the next bufd */
		bufdp++;
		usedBufds++;

		/* check because we've got an outer loop and this'll mess
		 * things up */
		if (preprc) {
		    /* next infop */
		    infop = infop->next;
		}
#else /* ALT_DESERIALIZE */
		ENQ_SEND_RING(bufdp, nic->send_producer, nic->send_consumer, 
			      nic->sendRing, spl, rc);
		if (!rc) {
		    ALTTRACE(sringful, 0xf001d, nic->send_consumer, 
			     nic->send_producer,
			     nic->eventCons, *nic->eventProdPtr);
		    /* clean up DMA PREPs */
		    i = start_producer;
		    while (i != nic->send_producer) {
			infop = &nic->smsgs[i];
			if (!(infop->flags & 
			      (ALT_DMA_INFO_FLAG_CONT | 
			       ALT_DMA_INFO_PREALLOC))) {
			    UNPREP_FLY_DMA(infop);
			    UNPREP_SEND_FLY_INFOP(infop);
			}
			i = INCRING(i, SEND_RING_ENTRIES);
		    }
		    nic->outDrops++;
		    nic->outDropsNoSpace++;
		    
		    /* back up producer to where we started */
		    nic->send_producer = start_producer;

		    /* check for memory window in the right place */
		    SET_NIC_MEM_WINDOW_NOW(start_producer, nic);
		    return(FALSE);
		}
		/* next infop, handle wrap case */
		infop = (infop->index == infop->lastIndex) ?
		    nic->smsgs : infop + 1;
#endif /* ALT_DESERIALIZE */

	    }
	}
	MSGNEXT(msg);
    }

#if ALT_DESERIALIZE 
    /* LOCK things up and copy the buffer descriptors into the NIC */
    ALT_DISABLE(spl, &nic->sendMutex);	/* ENTER CRITICAL SECTION */
    /* this variable has to be protected.  We haven't moved the
     * nic->send_producer yet (that's only done in this critical section
     * for deserialized) so we can set the start_producer here, inside
     * the critical section */
    start_producer = nic->send_producer;
    for (i = 0, bufdp = bufd, infop = firstInfop; 
	 i < usedBufds; i++, bufdp++) {
	ASSERT(infop);
	/* do this before we put the data on the send ring, otherwise
	 * possible timing window, no problem with overwriting because
	 * send_producer is one less than consumer when ring is full */
	nic->smsgPtrs[nic->send_producer] = infop;
	ASSERT(!((i+1 != usedBufds) && (bufdp->sendbd_flags & BD_FLAG_END)));
	ENQ_SEND_RING_NO_MUTEX(bufdp, nic->send_producer, nic->send_consumer, 
			       nic->sendRing, spl, rc);
	if (!rc) {
	    ALTTRACE(sringful, 0xf001e, nic->send_consumer, 
		     nic->send_producer,
		     firstInfop, firstInfop->next);
	    /* clean up prev DMA Preps, if any */
	    infop = firstInfop;
	    while (infop) {
	        ALTTRACE(unprep, 0xf001c, infop, infop->flags, infop->next, 0);
		if (!(infop->flags & 
		      (ALT_DMA_INFO_FLAG_CONT | ALT_DMA_INFO_PREALLOC))) {
		    UNPREP_FLY_DMA(infop);
		    UNPREP_SEND_FLY_INFOP(infop);
		}
		oldInfop = infop;
		infop = infop->next;
		FREE_INFOP(oldInfop, nic, spl);
	    }
	    nic->outDrops++;
	    nic->outDropsNoSpace++;
	    
	    /* back up producer to where we started */
	    nic->send_producer = start_producer;

	    /* check for memory window in the right place */
	    SET_NIC_MEM_WINDOW_NOW(start_producer, nic);

	    ALT_ENABLE(spl, &nic->sendMutex);	/* LEAVE CRITICAL SECTION */
	    return(FALSE);
	}
	infop = infop->next;
    }
    /* statistics update */
    nic->outpkts++;

    /* tell the adapter, stuff's available, inside crit section */
    OUT32(nic->handle, nic->base, TG_MBOX2_LOW, nic->send_producer);

    ALT_ENABLE(spl, &nic->sendMutex);	/* LEAVE CRITICAL SECTION */
#else /* ALT_DESERIALIZE  */
    /* statistics update */
    nic->outpkts++;

    /* tell the adapter, stuff's available */
    OUT32(nic->handle, nic->base, TG_MBOX2_LOW, nic->send_producer);
#endif /* ALT_DESERIALIZE  */

    return(TRUE);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altFreeSendMsgs(struct tg_nic *nic, U16 oldCons, U16 newCons)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altFreeSendMsgs(nic, newCons)
struct tg_nic *nic;
U16 newCons;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct altinst *altp = nic->altp;
    SEND_PKT *pkt;
    struct alt_dma_info *infop;

    /* free up DMA resources for each of the MSGs */
    GET_NEXT_INFOP(infop, nic, spl, oldCons);
    ASSERT(infop);

    pkt = infop->INFOP_SPKT;
    while (oldCons != newCons) {
	ALTTRACE2(FrSdMsg, 0x10015, oldCons, infop->flags, infop, pkt, infop);

	/* if split DMA, don't do UNPREP, already done */
	if (!(infop->flags & 
	      (ALT_DMA_INFO_FLAG_CONT | ALT_DMA_INFO_PREALLOC))) {
	    UNPREP_FLY_DMA(infop);
	    UNPREP_SEND_FLY_INFOP(infop);
	}
	if (infop->flags & ALT_DMA_INFO_FLAG_END) {
	    oldCons = INCRING(oldCons, SEND_RING_ENTRIES);
	    nic->xmit_acked++;

	    /* free the msg chain */
	    MSGFREE(pkt, MSG_SUCCESS);

	    /* free infop and get next pointer */
	    FREE_INFOP(infop, nic, spl);
	    GET_NEXT_INFOP(infop, nic, spl, oldCons);
	    if (infop)
	        pkt = infop->INFOP_SPKT;
	} else {
	    oldCons = INCRING(oldCons, SEND_RING_ENTRIES);
	    FREE_INFOP(infop, nic, spl);
	    GET_NEXT_INFOP(infop, nic, spl, oldCons);
	}
	nic->bufsOnSendRing--;
    }

#if defined(__NETWARE_386__)
    CMSMServiceEvents();	/* let upper layers know */
#endif /* defined(__NETWARE_386__) */
}

STATIC void
#if defined(__STDC__) || defined(ALT_PROTOS)
FillRecvRing(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
FillRecvRing(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    struct recv_bd bufd;
    struct tg_command command;
    U32 i;
    int rc;
    struct alt_dma_info *infop;
#if !ALT_RECV_EXT
    RECV_PKT *pkt;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U32 len;
#if defined(__NETWARE_386__)
    void *physAddr;
#endif /* defined(__NETWARE_386__) */
#endif /* !ALT_RECV_EXT */

    ALTTRACE(fillRecv, 0x10011, altp, nic, nic->recvStdBufCount, 0);
    bufd.BD_type = TIGON_TYPE_RECV_BD;
    bufd.BD_flags = 0;
    HOSTZEROHI(bufd.BD_host_addr);

    /* fill the ring with our data buffers */
    for (i=0; i < nic->recvStdBufCount; i++) {
	/* save the info pointer away */
	infop = &nic->rstdmsgs[i];
#if ALT_RECV_EXT
	nic->rstdmsgPtrs[i] = infop;
#else /* ALT_RECV_EXT */
	if (pkt = ALLOC_RECV_BUF(altp, RECVBLOCKSIZE, BPRI_MED, physAddr)) {
	    RECVPKT2MSG(pkt, msg);
	    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	    PREP_RECV_INFOP(infop, nic, i, 0, addr, RECVBLOCKSIZE, msg, pkt);
	} else {
	    ALTTRACEE(shortfill, 0xf0026, nic->bufsInStdRecvRing, 0, 0, 0);
	    break;
	}

	/* prepare the area for dmaing */
	PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_WRITE, infop);
	if (rc != 1) {
	    if (rc > 1) {
		panic("Can't let this happen with this firmware\n");
	    } else {
		/* unprep everything and get outta here */
		UNPREP_RECV_INFOP(infop);
		break;
	    }
	}
#endif /* ALT_RECV_EXT */

	/* finish filling in the struct recv_bd */
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);

	bufd.BD_len = MAXBLOCKSIZE;
	bufd.BD_index = nic->recv_std_producer;

	ENQ_RECV_RING(bufd, nic->recv_std_producer, nic->recv_std_consumer, 
		      nic->recvStdRing, RECV_STANDARD_RING_ENTRIES, 
		      nic->recvStdRingDmaInfo.handle, spl, 
		      &nic->recvRingMutex, rc);
	if (!rc) {
	    ERROR3("%s%d: Couldn't fill recv ring, huh?\n",
		   nic->name, altp->instance);
	    ALTTRACEE(norcvfll, 0xf000f, 0, 0, 0, 0);
#if !ALT_RECV_EXT
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
#endif /* !ALT_RECV_EXT */
	    break;
	}
	ALT_DISABLE(spl, &nic->recvBufsMutex); /* ENTER CRITICAL SECTION */
	nic->bufsInStdRecvRing++;
	nic->bufsLowWater = nic->bufsInStdRecvRing;
	ALT_ENABLE(spl, &nic->recvBufsMutex); /* LEAVE CRITICAL SECTION */
    }

    /* tell the adapter, stuff's available */
    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	DO_TG_COMMAND(TG_CMD_SET_RECV_PRODUCER_INDEX, 
		      nic->recv_std_producer, 0);
    } else {
	OUT32(nic->handle, nic->base, TG_MBOX3_LOW, nic->recv_std_producer);
    }

    /* keep track for cleanup */
    nic->flags |= ALT_RING_FILLED;
}

#if !ALT_RECV_EXT
STATIC void
#if defined(__STDC__) || defined(ALT_PROTOS)
RefillRecvRing(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
RefillRecvRing(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->nic;
    U32 next;
    struct recv_bd bufd;
    struct tg_command command;
    int rc;
    struct alt_dma_info *infop;
    RECV_PKT *pkt;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U32 len;
#if defined(__NETWARE_386__)
    void *physAddr;
#endif /* defined(__NETWARE_386__) */

    /* initialize bits of the bufd */
    bufd.BD_type = TIGON_TYPE_RECV_BD;
    bufd.BD_flags = 0;
    bufd.BD_len = MAXBLOCKSIZE;
    HOSTZEROHI(bufd.BD_host_addr);

    next = INCRING(nic->recv_std_producer, RECV_STANDARD_RING_ENTRIES);
    while (next != nic->recv_std_consumer) {
	if (pkt = ALLOC_RECV_BUF(altp, RECVBLOCKSIZE, BPRI_HI, physAddr)) {
	    infop = &nic->rstdmsgs[nic->recv_std_producer];
	    RECVPKT2MSG(pkt, msg);
	    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	    PREP_RECV_INFOP(infop, nic, i, 0, addr, RECVBLOCKSIZE, msg, pkt);
	} else
	    break;

	/* prepare the area for dmaing */
	PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_WRITE, infop);
	if (rc != 1) {
	    if (rc > 1) {
		panic("Can't let this happen with this firmware\n");
	    } else {
		/* unprep everything and get outta here */
		UNPREP_RECV_INFOP(infop);
		break;
	    }
	}

	/* finish filling in the struct recv_bd */
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	bufd.BD_index = nic->recv_std_producer;
	infop->dataLen = RECVBLOCKSIZE;

	ENQ_RECV_RING(bufd, nic->recv_std_producer, nic->recv_std_consumer, 
		      nic->recvStdRing, RECV_STANDARD_RING_ENTRIES, 
		      nic->recvStdRingDmaInfo.handle, spl, 
		      &nic->recvRingMutex, rc);
	if (!rc) {
	    /* clean up */
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
	    FREE_RECV_BUF(altp, pkt);
	    /* take note */
	    nic->noRecvResources++;
	    break;
	}
	if (rc)
	    ATOMIC_INCREMENT(spl, &nic->recvBufsMutex, nic->recvStdCoal);
	next = INCRING(nic->recv_std_producer, RECV_STANDARD_RING_ENTRIES);
    }

    /* tell the adapter, stuff's available, coallesce somewhat */
    if (nic->recvStdCoal >= ALT_RECV_COAL) {
	ALTTRACEV(srcvprod, 0x10038, nic->recv_std_producer, nic->recvStdCoal,
		  nic->bufsInStdRecvRing, 0);
	/* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvBufsMutex); 
	nic->bufsInStdRecvRing += nic->recvStdCoal;
	ASSERT(nic->bufsInStdRecvRing <= RECV_STANDARD_RING_ENTRIES);
	nic->recvStdCoal = 0;
	ALT_ENABLE(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	    DO_TG_COMMAND(TG_CMD_SET_RECV_PRODUCER_INDEX, 
			  nic->recv_std_producer, 0);
	} else {
	    OUT32(nic->handle, nic->base, TG_MBOX3_LOW, 
		  nic->recv_std_producer);
	}
    }
}
#endif /* !ALT_RECV_EXT */

void
#if defined(__STDC__) || defined(ALT_PROTOS)
FillJumboRecvRing(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
FillJumboRecvRing(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
#if !DONT_INIT_JUMBO
    struct tg_nic *nic = altp->initNic;
    struct JUMBO_RECV_BD bufd;
    struct tg_command command;
    U32 i;
    int rc;
    struct alt_dma_info *infop;
#if !ALT_RECV_EXT
    RECV_PKT *pkt;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U32 len;
#if defined(__NETWARE_386__)
    void *physAddr;
#endif /* defined(__NETWARE_386__) */
#endif /* !ALT_RECV_EXT */

    ALTTRACE(fillJRcv, 0x1002c, altp, nic, nic->recvJumboBufCount, 0);
    bufd.BD_type = TIGON_TYPE_RECV_BD;
    bufd.BD_flags = BD_FLAG_JUMBO_RING;
    HOSTZEROHI(bufd.BD_host_addr);
#if USE_EXTENDED_JUMBO
    HOSTZEROHI(bufd.BD_host_addr_1);
    HOSTZEROHI(bufd.BD_host_addr_2);
    HOSTZEROHI(bufd.BD_host_addr_3);
#endif /* USE_EXTENDED_JUMBO */

    /* fill the ring with our data buffers */
    for (i=0; i < nic->recvJumboBufCount; i++) {
	/* save the info pointer away */
        infop = &nic->rjumbomsgs[i];
#if ALT_RECV_EXT
        nic->rjumbomsgPtrs[i] = infop;
#else /* ALT_RECV_EXT */
	if (pkt = ALLOC_RECV_BUF(altp, JUMBOBLOCKSIZE, BPRI_MED, physAddr)) {

	    RECVPKT2MSG(pkt, msg);
	    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	    PREP_RECV_INFOP(infop, nic, i, 0, addr, JUMBOBLOCKSIZE, msg, pkt);
	} else
	    break;

	/* prepare the area for dmaing */
	PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_WRITE, infop);
	if (rc != 1) {
	    if (rc > 1) {
		panic("Can't have fragmented recv buf with this firmware\n");
	    } else {
		/* unprep everything and get outta here */
		UNPREP_RECV_INFOP(infop);
		break;
	    }
	}
#endif /* ALT_RECV_EXT */

	/* finish filling in the struct recv_bd */
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);

	bufd.BD_len = infop->dataLen;
	bufd.BD_index = nic->recv_jumbo_producer;

#if USE_EXTENDED_JUMBO
	/* fill in the rest of the data addresses and lengths */
	bufd.HOSTADDR(BD_host_addr_1) = MAP2BUS(infop->extDataAddr1);
	bufd.BD_len_1 = infop->extDataLen[0];
	bufd.HOSTADDR(BD_host_addr_2) = MAP2BUS(infop->extDataAddr2);
	bufd.BD_len_2 = infop->extDataLen[1];
	bufd.HOSTADDR(BD_host_addr_3) = MAP2BUS(infop->extDataAddr3);
	bufd.BD_len_3 = infop->extDataLen[2];
#endif /* USE_EXTENDED_JUMBO */

	ENQ_RECV_RING(bufd, nic->recv_jumbo_producer, 
		      nic->recv_jumbo_consumer, 
		      nic->recvJumboRing, RECV_JUMBO_RING_ENTRIES, 
		      nic->recvJumboRingDmaInfo.handle, spl, 
		      &nic->recvRingMutex, rc);
	if (!rc) {
	    ERROR3("%s%d: Couldn't fill jumbo recv ring, huh?\n",
		   nic->name, altp->instance);
	    ALTTRACEE(norcvjfl, 0xf000e, 0, 0, 0, 0);
#if !ALT_RECV_EXT
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
#endif /* !ALT_RECV_EXT */
	    break;
	}
	ALT_DISABLE(spl, &nic->recvBufsMutex); /* ENTER CRITICAL SECTION */
	nic->bufsInJumboRecvRing++;
	ALT_ENABLE(spl, &nic->recvBufsMutex); /* LEAVE CRITICAL SECTION */
    }

    ALTTRACE(fillJRcv, 0x10013, altp, nic, nic->recvJumboBufCount, 
	     nic->recv_jumbo_producer);
    /* tell the adapter, stuff's available */
    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	DO_TG_COMMAND(TG_CMD_SET_RECV_JUMBO_PRODUCER_INDEX,
		      nic->recv_jumbo_producer, 0);
    } else {
	OUT32(nic->handle, nic->base, TG_MBOX4_LOW, 
	      nic->recv_jumbo_producer);
    }

    /* keep track for cleanup */
    nic->flags |= ALT_JUMBO_FILLED;
#endif /* !DONT_INIT_JUMBO */
}

#if !ALT_RECV_EXT
void
#if defined(__STDC__) || defined(ALT_PROTOS)
RefillJumboRecvRing(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
RefillJumboRecvRing(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
#if !DONT_INIT_JUMBO
    struct tg_nic *nic = altp->nic;
    U32 next;
    struct JUMBO_RECV_BD bufd;
    struct tg_command command;
    int rc;
    struct alt_dma_info *infop;
    RECV_PKT *pkt;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U32 len;
#if defined(__NETWARE_386__)
    void *physAddr;
#endif /* defined(__NETWARE_386__) */

    /* initialize bits of the bufd */
    bufd.BD_type = TIGON_TYPE_RECV_BD;
    bufd.BD_flags = BD_FLAG_JUMBO_RING;
    bufd.BD_len = JUMBOBLOCKSIZE;
    HOSTZEROHI(bufd.BD_host_addr);

    next = INCRING(nic->recv_jumbo_producer, RECV_JUMBO_RING_ENTRIES);
    while (next != nic->recv_jumbo_consumer) {
	if (pkt = ALLOC_RECV_BUF(altp, JUMBOBLOCKSIZE, BPRI_HI, physAddr)) {
	    infop = &nic->rjumbomsgs[nic->recv_jumbo_producer];
	    RECVPKT2MSG(pkt, msg);
	    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	    PREP_RECV_INFOP(infop, nic, i, 0, addr, JUMBOBLOCKSIZE, msg, pkt);
	} else
	    break;

	/* prepare the area for dmaing */
	PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_WRITE, infop);
	if (rc != 1) {
	    if (rc > 1) {
		panic("Can't let this happen with this firmware\n");
	    } else {
		/* unprep everything and get outta here */
		UNPREP_RECV_INFOP(infop);
		break;
	    }
	}

	/* finish filling in the struct recv_bd */
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	bufd.BD_index = nic->recv_jumbo_producer;
	bufd.BD_len = infop->dataLen;

	ENQ_RECV_RING(bufd, nic->recv_jumbo_producer, 
		      nic->recv_jumbo_consumer, 
		      nic->recvJumboRing, RECV_JUMBO_RING_ENTRIES, 
		      nic->recvJumboRingDmaInfo.handle, spl, 
		      &nic->recvRingMutex, rc);
	if (!rc) {
	    /* clean up */
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
	    FREE_RECV_BUF(altp, pkt);
	    /* take note */
	    nic->noRecvResources++;
	    break;
	}
	if (rc)
	    nic->recvJumboCoal++;
	next = INCRING(nic->recv_jumbo_producer, RECV_JUMBO_RING_ENTRIES);
    }

    /* tell the adapter, stuff's available, coallesce somewhat */
    if (nic->recvJumboCoal >= ALT_JUMBO_RECV_COAL) {
	ALTTRACEV(srcvjprod, 0x10039, nic->recv_jumbo_producer, 
		  nic->recvJumboCoal, nic->bufsInJumboRecvRing, 0);
	/* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvBufsMutex); 
	nic->bufsInJumboRecvRing += nic->recvJumboCoal;
	ASSERT(nic->bufsInJumboRecvRing <= RECV_JUMBO_RING_ENTRIES);
	nic->recvJumboCoal = 0;
	ALT_ENABLE(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	    DO_TG_COMMAND(TG_CMD_SET_RECV_JUMBO_PRODUCER_INDEX,
			  nic->recv_jumbo_producer, 0);
	} else {
	    OUT32(nic->handle, nic->base, TG_MBOX4_LOW, 
		  nic->recv_jumbo_producer);
	}
    }
#endif /* !DONT_INIT_JUMBO */
}
#endif /* !ALT_RECV_EXT */

#if USE_MINI_RING
void
#if defined(__STDC__) || defined(ALT_PROTOS)
FillMiniRecvRing(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
FillMiniRecvRing(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->initNic;
    struct recv_bd bufd;
    struct tg_command command;
    U32 i;
    int rc;
    struct alt_dma_info *infop;
#if !ALT_RECV_EXT
    RECV_PKT *pkt;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U32 len;
#if defined(__NETWARE_386__)
    void *physAddr;
#endif /* defined(__NETWARE_386__) */
#endif /* !ALT_RECV_EXT */

    ALTTRACE(fillMRcv, 0x10014, altp, nic, nic->recvMiniBufCount, 0);
    bufd.BD_type = TIGON_TYPE_RECV_BD;
    bufd.BD_flags = BD_FLAG_MINI_RING;
    HOSTZEROHI(bufd.BD_host_addr);

    /* fill the ring with our data buffers */
    for (i=0; i < nic->recvMiniBufCount; i++) {
	/* save the info pointer away */
        infop = &nic->rminimsgs[i];
#if ALT_RECV_EXT
        nic->rminimsgPtrs[i] = infop;
#else /* ALT_RECV_EXT */
	if (pkt = ALLOC_RECV_BUF(altp, MINIBLOCKSIZE, BPRI_MED, physAddr)) {
	    RECVPKT2MSG(pkt, msg);
	    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	    PREP_RECV_INFOP(infop, nic, i, 0, addr, MINIBLOCKSIZE, msg, pkt);
	} else
	    break;

	/* prepare the area for dmaing */
	PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_WRITE, infop);
	if (rc != 1) {
	    if (rc > 1) {
		panic("Can't have fragmented recv buf with this firmware\n");
	    } else {
		/* unprep everything and get outta here */
		UNPREP_RECV_INFOP(infop);
		break;
	    }
	}
#endif /* ALT_RECV_EXT */

	/* finish filling in the struct recv_bd */
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);

	bufd.BD_len = MINIBLOCKSIZE;
	bufd.BD_index = nic->recv_mini_producer;

	ENQ_RECV_RING(bufd, nic->recv_mini_producer, 
		      nic->recv_mini_consumer, 
		      nic->recvMiniRing, RECV_MINI_RING_ENTRIES, 
		      nic->recvMiniRingDmaInfo.handle, spl, 
		      &nic->recvRingMutex, rc);
	if (!rc) {
	    ERROR3("%s%d: Couldn't fill mini recv ring, huh?\n",
		   nic->name, altp->instance);
	    ALTTRACEE(norcvmfl, 0xf001b, 0, 0, 0, 0);
#if !ALT_RECV_EXT
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
#endif /* !ALT_RECV_EXT */
	    break;
	}
	ALT_DISABLE(spl, &nic->recvBufsMutex); /* ENTER CRITICAL SECTION */
	nic->bufsInMiniRecvRing++;
	ALT_ENABLE(spl, &nic->recvBufsMutex); /* LEAVE CRITICAL SECTION */
    }

    ALTTRACE(fillMRcv, 0x10012, altp, nic, nic->recvMiniBufCount, 
	     nic->recv_mini_producer);
    /* tell the adapter, stuff's available */
    OUT32(nic->handle, nic->base, TG_MBOX5_LOW, 
	  nic->recv_mini_producer);

    /* keep track for cleanup */
    nic->flags |= ALT_MINI_FILLED;
}

#if !ALT_RECV_EXT
void
#if defined(__STDC__) || defined(ALT_PROTOS)
RefillMiniRecvRing(struct altinst *altp)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
RefillMiniRecvRing(altp)
struct altinst *altp;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct tg_nic *nic = altp->nic;
    U32 next;
    struct recv_bd bufd;
    struct tg_command command;
    int rc;
    struct alt_dma_info *infop;
    RECV_PKT *pkt;
    ALT_MSG *msg;
    ALT_MSG_DATA_TYPE addr;
    U32 len;
#if defined(__NETWARE_386__)
    void *physAddr;
#endif /* defined(__NETWARE_386__) */

    /* initialize bits of the bufd */
    bufd.BD_type = TIGON_TYPE_RECV_BD;
    bufd.BD_flags = BD_FLAG_MINI_RING;
    bufd.BD_len = MINIBLOCKSIZE;
    HOSTZEROHI(bufd.BD_host_addr);

    next = INCRING(nic->recv_mini_producer, RECV_MINI_RING_ENTRIES);
    while (next != nic->recv_mini_consumer) {
	if (pkt = ALLOC_RECV_BUF(altp, MINIBLOCKSIZE, BPRI_HI, physAddr)) {
	    infop = &nic->rminimsgs[nic->recv_mini_producer];
	    RECVPKT2MSG(pkt, msg);
	    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
	    PREP_RECV_INFOP(infop, nic, i, 0, addr, MINIBLOCKSIZE, msg, pkt);
	} else
	    break;

	/* prepare the area for dmaing */
	PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_WRITE, infop);
	if (rc != 1) {
	    if (rc > 1) {
		panic("Can't let this happen with this firmware\n");
	    } else {
		/* unprep everything and get outta here */
		UNPREP_RECV_INFOP(infop);
		break;
	    }
	}

	/* finish filling in the struct recv_bd */
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	bufd.BD_index = nic->recv_mini_producer;
	infop->dataLen = MINIBLOCKSIZE;

	ENQ_RECV_RING(bufd, nic->recv_mini_producer, 
		      nic->recv_mini_consumer, 
		      nic->recvMiniRing, RECV_MINI_RING_ENTRIES, 
		      nic->recvMiniRingDmaInfo.handle, spl, 
		      &nic->recvRingMutex, rc);
	if (!rc) {
	    /* clean up */
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
	    FREE_RECV_BUF(altp, pkt);
	    /* take note */
	    nic->noRecvResources++;
	    break;
	}
	if (rc)
	    nic->recvMiniCoal++;
	next = INCRING(nic->recv_mini_producer, RECV_MINI_RING_ENTRIES);
    }

    /* tell the adapter, stuff's available, coallesce somewhat */
    if (nic->recvMiniCoal >= ALT_MINI_RECV_COAL) {
	ALTTRACEV(srcvmprod, 0x1000e, nic->recv_mini_producer, 
		  nic->recvMiniCoal, nic->bufsInMiniRecvRing, 0);
	/* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvBufsMutex); 
	nic->bufsInMiniRecvRing += nic->recvMiniCoal;
	ASSERT(nic->bufsInMiniRecvRing <= RECV_MINI_RING_ENTRIES);
	ALT_ENABLE(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	nic->recvMiniCoal = 0;
	OUT32(nic->handle, nic->base, TG_MBOX5_LOW, 
	      nic->recv_mini_producer);
    }
}
#endif /* !ALT_RECV_EXT */
#endif /* USE_MINI_RING */

#if ALT_RECV_EXT
STATIC void
#if defined(__STDC__) || defined(ALT_PROTOS)
RingDequeueMsgs(struct tg_nic *nic, U16 newProd, U16 oldProd)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
RingDequeueMsgs(nic, newProd, oldProd)
struct tg_nic *nic;
U16 newProd;
U16 oldProd;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct altinst *altp = nic->altp;
    int len;
    ALT_MSG *msg;
    RECV_PKT *pkt;
    struct alt_dma_info *infop;
    int rc;
    struct recv_bd *bdp = &(*nic->recvReturnRing)[oldProd];
    struct recv_bd *endOfRecvRing = 
	&(*nic->recvReturnRing)[RECV_RETURN_RING_ENTRIES-1];
#if defined(WINNT)
    RECV_PKT **packetEntryPtr = nic->tmpPacketArr;
    int packet_count = 0;
#endif /* defined(WINNT) */

    /* create the message and pass it up stream */
    while (oldProd != newProd) {
	/* so we know if we did anything */
	len = bdp->BD_len;
	/* ENTER CRIT SECT */
	ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	if (bdp->BD_flags & BD_FLAG_JUMBO_RING) {
	    infop = nic->rjumbomsgPtrs[bdp->BD_index];
	    ALTTRACE2V(RgDQMsgJ, 0x10002, oldProd, infop, len,
		       nic->bufsInJumboRecvRing, infop); 
	    nic->bufsInJumboRecvRing--;
	    ASSERT(nic->bufsInJumboRecvRing >= 0);
#if USE_MINI_RING
	} else if (bdp->BD_flags & BD_FLAG_MINI_RING) {
	    infop = nic->rminimsgPtrs[bdp->BD_index];
	    ALTTRACE2V(RgDQMsgM, 0x1000f, oldProd, infop, len, 
		       nic->bufsInMiniRecvRing, infop); 
	    nic->bufsInMiniRecvRing--;
	    ASSERT(nic->bufsInMiniRecvRing >= 0);
#endif /* USE_MINI_RING */
	} else {
	    infop = nic->rstdmsgPtrs[bdp->BD_index];
	    ALTTRACE2V(RgDQMsg, 0x10016, oldProd, infop, len,
		       nic->bufsInStdRecvRing, infop);
	    nic->bufsInStdRecvRing--;
	    ASSERT(nic->bufsInStdRecvRing >= 0);
	    
	    if (nic->bufsInStdRecvRing < nic->bufsLowWater)
		nic->bufsLowWater = nic->bufsInStdRecvRing;
	}
	ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */

	/* invalidate the cache data */
	PREP_CACHE_INVAL(infop, len);

	/* OS specific preparation for a single receive packet */
	SINGLE_PACKET_PREP(nic, pkt, msg, len, infop, packetEntryPtr, 
			   packet_count, bdp);
	
	/* check for a valid checksum, maybe */
	VERIFY_RECV_CKSUM(nic, infop, bdp, pkt);

	if (bdp->BD_flags & BD_FLAG_JUMBO_RING) {
	    /* update the ring's consumer */
	    nic->recv_jumbo_consumer = 
		INCRING(bdp->BD_index, RECV_JUMBO_RING_ENTRIES);
#if USE_MINI_RING
	} else if (bdp->BD_flags & BD_FLAG_MINI_RING) {
	    /* update the ring's consumer */
	    nic->recv_mini_consumer = 
		INCRING(bdp->BD_index, RECV_MINI_RING_ENTRIES);
#endif /* USE_MINI_RING */
	} else {
	    /* update the ring's consumer */
	    nic->recv_std_consumer = 
		INCRING(bdp->BD_index, RECV_STANDARD_RING_ENTRIES);
	}

	/* OS specific pass packet upstream, for systems that pass a
	 * single packet at a time */
	PASS_RECV_PKT_UP(nic);

	oldProd = INCRING(oldProd, RECV_RETURN_RING_ENTRIES);
	if (bdp >= endOfRecvRing)
	    bdp = &(*nic->recvReturnRing)[0];
	else
	    bdp++;
    }

    /* update NIC's copy of the recv_return_consumer (Tigon 1 only) */
    nic->recv_return_producer = newProd;
    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	WRSHMEM(nic->genComm->gen_com.recv_return_cons_index, newProd);    
	MB();
    }

    /* OS specific pass packet array upstream or generic post processing */
    RECV_POST_PROCESSING(nic, packet_count);
}

#if defined(WINNT)
STATIC void
RecvPostProcessing(struct tg_nic *nic, int packet_count)
{
    NDIS_STATUS status;
    int i;
    struct JUMBO_RECV_BD jbufd;
    struct recv_bd bufd;
    struct tg_command command;
    struct alt_dma_info *infop;
    RECV_PKT *pkt;
    RECV_PKT **packetEntryPtr = nic->tmpPacketArr;
    int rc;

    if (packet_count) {
	/* indicate the packets */
	NdisMIndicateReceivePacket(nic->handle,
				   nic->tmpPacketArr,
				   packet_count);

	/* put the packets back onto the queue if they're done, else we
	 * have to wait for the completion handler to fire */
	    ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvRingMutex); 
	for (i = 0, packetEntryPtr = nic->tmpPacketArr;
	     i < packet_count;
	     i++, packetEntryPtr++) {
	    pkt = *packetEntryPtr;
	    /* check to see if upper level is done with packet */
	    if ((status = NDIS_GET_PACKET_STATUS(pkt)) !=
		NDIS_STATUS_PENDING){
		infop = *(struct alt_dma_info **)(pkt->MiniportReserved);
		if (infop->flags & ALT_DMA_JUMBO) {
		    HOSTZEROHI(jbufd.BD_host_addr);
		    jbufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		    jbufd.BD_index = nic->recv_jumbo_producer;
		    jbufd.BD_flags = BD_FLAG_JUMBO_RING;
		    jbufd.BD_len = infop->dataLen;
#if USE_EXTENDED_JUMBO
		    /* fill in the rest of the data addresses and lengths */
		    HOSTZEROHI(jbufd.BD_host_addr_1);
		    jbufd.HOSTADDR(BD_host_addr_1) = 
			MAP2BUS(infop->extDataAddr1);
		    jbufd.BD_len_1 = infop->extDataLen[0];
		    HOSTZEROHI(jbufd.BD_host_addr_2);
		    jbufd.HOSTADDR(BD_host_addr_2) = 
			MAP2BUS(infop->extDataAddr2);
		    jbufd.BD_len_2 = infop->extDataLen[1];
		    HOSTZEROHI(jbufd.BD_host_addr_3);
		    jbufd.HOSTADDR(BD_host_addr_3) = 
			MAP2BUS(infop->extDataAddr3);
		    jbufd.BD_len_3 = infop->extDataLen[2];
#endif /* USE_EXTENDED_JUMBO */
                    nic->recvJumboCoal++;
                    nic->rjumbomsgPtrs[nic->recv_jumbo_producer] = infop;

		    ENQ_RECV_RING_NO_MUTEX(jbufd, nic->recv_jumbo_producer,
				  nic->recv_jumbo_consumer,
				  nic->recvJumboRing,
				  RECV_JUMBO_RING_ENTRIES,
				  nic->recvJumboRingDmaInfo.handle, rc);
		    if (!rc) {
			/* XXX error case to handle, we're losing a */
			/* buffer/packet here actually, may never happen */
			/* but should be better analyzed  */
			panic("we're losing a jumbo receive buffer resource!!!\n");
		    }
#if USE_MINI_RING
		} else if (infop->flags & ALT_DMA_MINI) {
		    HOSTZEROHI(bufd.BD_host_addr);
		    bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		    bufd.BD_index = nic->recv_mini_producer;
		    bufd.BD_flags = BD_FLAG_MINI_RING;
		    bufd.BD_len = infop->dataLen;

		    nic->recvMiniCoal++;
		    nic->rminimsgPtrs[nic->recv_mini_producer] = infop;

		    ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_mini_producer,
				  nic->recv_mini_consumer,
				  nic->recvMiniRing,
				  RECV_MINI_RING_ENTRIES,
				  nic->recvMiniRingDmaInfo.handle, rc);
		    if (!rc) {
			/* XXX error case to handle, we're losing a */
			/* buffer/packet here actually, may never happen */
			/* but should be better analyzed  */
			panic("we're losing a mini receive buffer resource!!!\n");
		    }
#endif /* USE_MINI_RING */
		} else {
		    HOSTZEROHI(bufd.BD_host_addr);
		    bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		    bufd.BD_index = nic->recv_std_producer;
		    bufd.BD_flags = 0;
		    bufd.BD_len = infop->dataLen;

		    nic->recvStdCoal++;
		    nic->rstdmsgPtrs[nic->recv_std_producer] = infop;

		    ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_std_producer,
				  nic->recv_std_consumer,
				  nic->recvStdRing,
				  RECV_STANDARD_RING_ENTRIES,
				  nic->recvStdRingDmaInfo.handle, rc);
		    if (!rc) {
			/* XXX error case to handle, we're losing a */
			/* buffer/packet here actually, may never happen */
			/* but should be better analyzed  */
			panic("we're losing a receive buffer resource!!!\n");
		    } 
		}
		ALTTRACE2V(requeue, 0x10040, bufd.BD_index, infop,
			   status, pkt, infop);
		nic->requeuedPkts++;
	    } else {
		ALTTRACEV(pending, 0x10041, bufd.BD_index, pkt, infop, 0);
		nic->pendPkts++;
	    }
	}
	    ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvRingMutex); 
	if (nic->recvStdCoal >= ALT_RECV_COAL) {
	    /* ENTER CRIT SECT */
	    ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	    nic->bufsInStdRecvRing += nic->recvStdCoal;
	    nic->recvStdCoal = 0;
	    ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	    /* LEAVE CRIT SECT */
	    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
		DO_TG_COMMAND(TG_CMD_SET_RECV_PRODUCER_INDEX,
			      nic->recv_std_producer, 0);
	    } else {
		OUT32(nic->handle, nic->base, TG_MBOX3_LOW, 
		      nic->recv_std_producer);
	    }
	}
	if (nic->recvJumboCoal >= ALT_JUMBO_RECV_COAL) {
	    /* ENTER CRIT SECT */
	    ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	    nic->bufsInJumboRecvRing += nic->recvJumboCoal;
	    nic->recvJumboCoal = 0;
	    ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	    /* LEAVE CRIT SECT */
	    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
		DO_TG_COMMAND(TG_CMD_SET_RECV_JUMBO_PRODUCER_INDEX,
			      nic->recv_jumbo_producer, 0);
	    } else {
		OUT32(nic->handle, nic->base, TG_MBOX4_LOW, 
		      nic->recv_jumbo_producer);
	    }
	}
#if USE_MINI_RING
	if (nic->recvMiniCoal >= ALT_MINI_RECV_COAL) {
	    /* ENTER CRIT SECT */
	    ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	    nic->bufsInMiniRecvRing += nic->recvMiniCoal;
	    nic->recvMiniCoal = 0;
	    ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	    /* LEAVE CRIT SECT */
	    OUT32(nic->handle, nic->base, TG_MBOX5_LOW, 
		  nic->recv_mini_producer);
	}
#endif /* USE_MINI_RING */
    }
}

#elif defined(__sun) /* defined(WINNT) */
STATIC void
RecvPostProcessing(struct tg_nic *nic)
{
    int ourCount;
    struct alt_dma_info **rmsgp, **endOfRmsgs;
    struct recv_bd bufd;
    struct tg_command command;
    struct alt_dma_info *infop;
    ALT_MSG *msg;
    RECV_PKT *pkt;
    int rc;

    if (nic->bufsInStdRecvRing < ALT_RECV_LOW_LOW) {
	ALT_DISABLE(spl, &nic->recvRingMutex); /* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvMutex); /* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvBufsMutex); /* ENTER CRIT SECT */
	rmsgp = &nic->rstdmsgPtrs[nic->recv_std_producer];
	endOfRmsgs = &nic->rstdmsgPtrs[RECV_STANDARD_RING_ENTRIES-1];
	bufd.BD_type = TIGON_TYPE_RECV_BD;
	bufd.BD_flags = 0;
	bufd.BD_len = MAXBLOCKSIZE;
	HOSTZEROHI(bufd.BD_host_addr);
	ourCount = nic->bufsInStdRecvRing;

	/* only fill up a little, then back to normal processing */
	while (ourCount++ < ALT_RECV_LOW_HIGH) {
	    /* first try putting free spilled buffers on the ring */
	    if (nic->recvRingSpill) {
		ALTTRACE(replspil, 0x10030, nic, nic->numFreeOverFlowBufs, 
			 nic->freeOverFlowBufs, nic->bufsInStdRecvRing);
		/* check again after entering critical section */
		if (!nic->recvRingSpill)
		    break;
		infop = nic->recvRingSpill;
		bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		bufd.BD_index = nic->recv_std_producer;
    
		/* save the info pointer away */
		*rmsgp = infop;

		ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_std_producer, 
				       nic->recv_std_consumer,
				       nic->recvStdRing, 
				       RECV_STANDARD_RING_ENTRIES,
				       nic->recvStdRingDmaInfo.handle, rc);
		/* if we can't enqueue, we're outta here */
		if (!rc)
		    break;

		if (rmsgp >= endOfRmsgs)
		    rmsgp = nic->rstdmsgPtrs;
		else
		    rmsgp++;
		nic->recvRingSpill = infop->next;
		nic->recvStdCoal++;
		nic->spillBufs--;
	    } else {
		/* if we didn't have enough of these, then fall back
		 * to overflow buffers */
		ALTTRACE(overflow, 0x10026, nic, nic->numFreeOverFlowBufs, 
			 nic->freeOverFlowBufs, nic->bufsInStdRecvRing);
		/* get a buffer and add it on, if we can */
		if (nic->numFreeOverFlowBufs) {
		    infop = nic->freeOverFlowBufs;
		    nic->freeOverFlowBufs = infop->next;
		    nic->numFreeOverFlowBufs--;
		} else
		    MEMZALLOC(infop, struct alt_dma_info *, 
			      sizeof(struct alt_dma_info), ALT_NOSLEEP);
		if (infop) {
		    if (pkt = ALLOC_RECV_BUF(altp, 2 * RECVBLOCKSIZE, 
					     BPRI_HI, physAddr)) {
			/* align the data on a field */
			infop->INFOP_RPKT = pkt;
			RECVPKT2MSG(pkt, msg);
			/* if the msgptr + blocksize doesn't fit in page */
			if ((PAGE_OFFSET(msg->b_rptr + RECVBLOCKSIZE) <
			     RECVBLOCKSIZE))
			    /* move to align on page boundary */
			    msg->b_rptr = 
				(unsigned char *)PAGE_ROUNDUP(msg->b_rptr);
			/* for performance reasons */
			msg->b_rptr += ALT_BUF_OFFSET; 
			msg->b_wptr = msg->b_rptr;
			infop->dataAddr = (caddr_t)msg->b_rptr;
			infop->dataLen = RECVBLOCKSIZE;
			infop->nic = nic;
			PREP_DMA(rc, ALT_DMA_CONSISTENT, DDI_DMA_READ, infop);
			/* if we fail, bitch */
			if (!rc) {
			    UNPREP_DMA(infop);
			    FREE_RECV_BUF(altp, infop->INFOP_RPKT);
			    if (nic->numFreeOverFlowBufs > SPILL_HIGH_WATER) {
				MEMFREE(infop, sizeof(struct alt_dma_info), 
					ALT_NOSLEEP);
			    } else {
				infop->next = nic->freeOverFlowBufs;
				nic->freeOverFlowBufs = infop;
				nic->numFreeOverFlowBufs++;
			    }
			    break;
			}
			bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
			bufd.BD_index = nic->recv_std_producer;
    
			ALTTRACE(slowRecv, 0x1001d, infop, nic, 0, 0);

			/* save the info pointer away */
			*rmsgp = infop;

			ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_std_producer, 
					       nic->recv_std_consumer,
					       nic->recvStdRing, 
					       RECV_STANDARD_RING_ENTRIES,
					       nic->recvStdRingDmaInfo.handle, 
					       rc);
			if (!rc) {
			    UNPREP_DMA(infop);
			    FREE_RECV_BUF(altp, infop->INFOP_RPKT);
			    if (nic->numFreeOverFlowBufs > SPILL_HIGH_WATER) {
				MEMFREE(infop, sizeof(struct alt_dma_info), 
					ALT_NOSLEEP);
			    } else {
				infop->next = nic->freeOverFlowBufs;
				nic->freeOverFlowBufs = infop;
				nic->numFreeOverFlowBufs++;
			    }
			    break;
			}
			if (rmsgp >= endOfRmsgs)
			    rmsgp = nic->rstdmsgPtrs;
			else
			    rmsgp++;
			nic->overFlowRecvBufs++;
			nic->totOverFlowRecvBufs++;
			nic->recvStdCoal++;
		    } else {
			if (nic->numFreeOverFlowBufs > SPILL_HIGH_WATER) {
			    MEMFREE(infop, sizeof(struct alt_dma_info), 
				    ALT_NOSLEEP);
			} else {
			    infop->next = nic->freeOverFlowBufs;
			    nic->freeOverFlowBufs = infop;
			    nic->numFreeOverFlowBufs++;
			}
			break;
		    }
		} else 
		    break;	/* can't do any more, outta here */
	    }
	}

	/* tell the NIC what we did, coallesce somewhat */
	if (nic->recvStdCoal >= ALT_RECV_COAL) {
	    nic->bufsInStdRecvRing += nic->recvStdCoal;
	    nic->recvStdCoal = 0;
	    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
		DO_TG_COMMAND(TG_CMD_SET_RECV_PRODUCER_INDEX, 
			      nic->recv_std_producer, 0);
	    } else {
		OUT32(nic->handle, nic->base, TG_MBOX3_LOW, 
		      nic->recv_std_producer);
	    }
	}
	ALT_ENABLE(spl, &nic->recvBufsMutex); /* LEAVE CRIT SECT */
	ALT_ENABLE(spl, &nic->recvMutex); /* LEAVE CRIT SECT */
	ALT_ENABLE(spl, &nic->recvRingMutex); /* LEAVE CRIT SECT */
    }
}
#endif /* defined(WINNT) */

#if defined(WINNT) 
void
altRecvDataRtn(NDIS_HANDLE context, PNDIS_PACKET pkt)
#else /* defined(WINNT) */
#if defined(__STDC__) || defined(ALT_PROTOS)
void
altRecvDataRtn(struct alt_dma_info *infop)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
altRecvDataRtn(infop)
struct alt_dma_info *infop;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
#endif /* defined(WINNT) */
{
    struct JUMBO_RECV_BD jbufd;
    struct recv_bd bufd;
    struct tg_command command;
    int i;
    int rc;
    bool wasJumbo;
#if USE_MINI_RING
    bool wasMini;
#endif /* USE_MINI_RING */

#if defined(WINNT)    
    struct tg_nic *nic = (struct tg_nic *)context;
    struct altinst *altp = nic->altp;
    struct alt_dma_info *infop = 
	*(struct alt_dma_info **)(pkt->MiniportReserved);
#else /* defined(WINNT) */
    struct tg_nic *nic = infop->nic;
    struct altinst *altp = nic->altp;
#endif /* defined(WINNT) */

    /* add data back into the recv ring, if we're up */
    if (altp->state != ALT_FW_RUNNING) {
	ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvMutex);
	if (infop->flags & ALT_DMA_JUMBO)
	    nic->recvJumboBufCount--; /* go to 0 */
#if USE_MINI_RING
	else if (infop->flags & ALT_DMA_MINI)
	    nic->recvMiniBufCount--; /* go to 0 */
#endif /* USE_MINI_RING */
	else
	    nic->recvStdBufCount--;	/* go to 0 */
	ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvMutex);
	return;
    }

    nic->dataRtnPkts++;
    
    /* ENTER CRIT SECT */
    ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvRingMutex); 

    /* save the info pointer away */
    if (wasJumbo = (infop->flags & ALT_DMA_JUMBO)) {
	i = nic->recv_jumbo_producer;	/* after we're in a critical section */
	ALTTRACE(recvRtnj, 0x10005, infop, altp, nic, i);
	nic->rjumbomsgPtrs[i] = infop;
	jbufd.BD_type = TIGON_TYPE_RECV_BD;
	HOSTZEROHI(jbufd.BD_host_addr);
	jbufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	jbufd.BD_index = nic->recv_jumbo_producer;
	jbufd.BD_flags = BD_FLAG_JUMBO_RING;
	jbufd.BD_len = infop->dataLen;
#if USE_EXTENDED_JUMBO
	/* fill in the rest of the data addresses and lengths */
	HOSTZEROHI(jbufd.BD_host_addr_1);
	jbufd.HOSTADDR(BD_host_addr_1) = MAP2BUS(infop->extDataAddr1);
	jbufd.BD_len_1 = infop->extDataLen[0];
	HOSTZEROHI(jbufd.BD_host_addr_2);
	jbufd.HOSTADDR(BD_host_addr_2) = MAP2BUS(infop->extDataAddr2);
	jbufd.BD_len_2 = infop->extDataLen[1];
	HOSTZEROHI(jbufd.BD_host_addr_3);
	jbufd.HOSTADDR(BD_host_addr_3) = MAP2BUS(infop->extDataAddr3);
	jbufd.BD_len_3 = infop->extDataLen[2];
#endif /* USE_EXTENDED_JUMBO */
	ENQ_RECV_RING_NO_MUTEX(jbufd, nic->recv_jumbo_producer, 
			       nic->recv_jumbo_consumer, 
			       nic->recvJumboRing, 
			       RECV_JUMBO_RING_ENTRIES,
			       nic->recvJumboRingDmaInfo.handle, rc);
#if USE_MINI_RING
    } else if (wasMini = (infop->flags & ALT_DMA_MINI)) {
	i = nic->recv_mini_producer;	/* after we're in a critical section */
	ALTTRACE(recvRtnm, 0x1002d, infop, altp, nic, i);
	nic->rminimsgPtrs[i] = infop;
	bufd.BD_type = TIGON_TYPE_RECV_BD;
	HOSTZEROHI(bufd.BD_host_addr);
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	bufd.BD_index = nic->recv_mini_producer;
	bufd.BD_flags = BD_FLAG_MINI_RING;
	bufd.BD_len = infop->dataLen;
	ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_mini_producer, 
			       nic->recv_mini_consumer, 
			       nic->recvMiniRing, 
			       RECV_MINI_RING_ENTRIES,
			       nic->recvMiniRingDmaInfo.handle, rc);
#endif /* USE_MINI_RING */
    } else {
	i = nic->recv_std_producer;	/* after we're in a critical section */
	ALTTRACE(recvRtn, 0x10018, infop, nic, i, nic->recvStdCoal);
	nic->rstdmsgPtrs[i] = infop;
	bufd.BD_type = TIGON_TYPE_RECV_BD;
	HOSTZEROHI(bufd.BD_host_addr);
	bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	bufd.BD_index = nic->recv_std_producer;
	bufd.BD_flags = 0;
	bufd.BD_len = infop->dataLen;
	ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_std_producer, 
			       nic->recv_std_consumer, 
			       nic->recvStdRing, 
			       RECV_STANDARD_RING_ENTRIES,
			       nic->recvStdRingDmaInfo.handle, rc);
    }
    if (!rc) {
#if defined(__sun)
	if (wasJumbo) {
	    panic("no room for jumbogram on jumbo recv ring, huh?");
#if USE_MINI_RING
	} else if (wasMini) {
	    panic("no room for minigram on mini recv ring, huh?");
#endif /* USE_MINI_RING */
	} else {
	    ALT_DISABLE(spl, &nic->recvBufsMutex); /* ENTER CRIT SECT */
	    ALTTRACE(addspill, 0x1002f, nic->recvRingSpill, infop, 
		     nic->recv_std_consumer, nic->recv_std_producer);
	    /* we could have filled the ring up with "slow" buffers, stash
	     * them away till next time */
	    if (nic->recvRingSpill) {
		infop->next = nic->recvRingSpill;
		nic->recvRingSpill = infop;
	    } else {
		nic->recvRingSpill = infop;
		infop->next = (struct alt_dma_info *)0;
	    }
	    nic->spillBufs++;
	    nic->totSpillBufs++;
#else   /* defined(__sun) */
	    ALTTRACEE(norcvenq, 0xf0010, 0, 0, 0, 0);
#endif  /* defined(__sun) */
#if defined(__sun)
	    ALT_ENABLE(spl, &nic->recvBufsMutex); /* LEAVE CRIT SECT */
	}
#endif  /* defined(__sun) */
        ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvRingMutex); 
	/* LEAVE CRIT SECT */
	return;
    }

    if (wasJumbo) {
	ATOMIC_INCREMENT(spl, &nic->recvBufsMutex, nic->recvJumboCoal);
#if USE_MINI_RING
    } else if (wasMini) {
	ATOMIC_INCREMENT(spl, &nic->recvBufsMutex, nic->recvMiniCoal);
#endif /* USE_MINI_RING */
    } else {
	ATOMIC_INCREMENT(spl, &nic->recvBufsMutex, nic->recvStdCoal);
    }

#if defined(__sun)
    /* see if we can put extra stuff into the ring */
    if (nic->recvRingSpill) {
	/* preinit some areas that could have been trashed by jumbos above */
	bufd.BD_flags = 0;
	bufd.BD_len = MAXBLOCKSIZE;

	ALT_DISABLE(spl, &nic->recvMutex); /* ENTER CRITICAL SECTION */
	ALT_DISABLE(spl, &nic->recvBufsMutex); /* ENTER CRIT SECT */
	while (nic->recvRingSpill) {
	    infop = nic->recvRingSpill;
	    infop->dataLen = MAXBLOCKSIZE;
	    bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
	    bufd.BD_index = nic->recv_std_producer;

	    i = nic->recv_std_producer;	/* after we're in a critical section */

	    ALTTRACE(recvOFRtn, 0x10022, infop, altp, nic, i);

	    /* save the info pointer away */
	    nic->rstdmsgPtrs[i] = infop;

	    ENQ_RECV_RING_NO_MUTEX(bufd, nic->recv_std_producer, 
				   nic->recv_std_consumer, 
				   nic->recvStdRing, 
				   RECV_STANDARD_RING_ENTRIES,
				   nic->recvStdRingDmaInfo.handle, rc);
	    if (rc) {
		nic->recvRingSpill = infop->next;
		nic->recvStdCoal++;
		nic->spillBufs--;
		ASSERT(nic->spillBufs >= 0);
	    } else
		break;
	}
	ALT_ENABLE(spl, &nic->recvBufsMutex); /* LEAVE CRIT SECT */
	ALT_ENABLE(spl, &nic->recvMutex); /* LEAVE CRITICAL SECTION */
    }
#endif /* defined(__sun) */
    
    /* tell the adapter, stuff's available, coallesce somewhat */
    if (nic->recvStdCoal >= ALT_RECV_COAL) {
	ALTTRACE(srcvprod, 0x10031, nic->recv_std_producer, nic->recvStdCoal,
		 nic->bufsInStdRecvRing, 0);
	/* ENTER CRIT SECT */
	ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	nic->bufsInStdRecvRing += nic->recvStdCoal;
	ASSERT(nic->bufsInStdRecvRing <= RECV_STANDARD_RING_ENTRIES);
	nic->recvStdCoal = 0;
	ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	    DO_TG_COMMAND(TG_CMD_SET_RECV_PRODUCER_INDEX, 
			  nic->recv_std_producer, 0);
	} else {
	    OUT32(nic->handle, nic->base, TG_MBOX3_LOW, 
		  nic->recv_std_producer);
	}
    }

#if !DONT_INIT_JUMBO
    if (nic->recvJumboCoal >= ALT_JUMBO_RECV_COAL) {
	ALTTRACE(srcvjprod, 0x10032, nic->recv_jumbo_producer, 
		 nic->recvJumboCoal, nic->bufsInJumboRecvRing, 0);
	/* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvBufsMutex); 
	nic->bufsInJumboRecvRing += nic->recvJumboCoal;
	ASSERT(nic->bufsInJumboRecvRing <= RECV_JUMBO_RING_ENTRIES);
	nic->recvJumboCoal = 0;
	ALT_ENABLE(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	    DO_TG_COMMAND(TG_CMD_SET_RECV_JUMBO_PRODUCER_INDEX, 
			  nic->recv_jumbo_producer, 0);
	} else {
	    OUT32(nic->handle, nic->base, TG_MBOX4_LOW, 
		  nic->recv_jumbo_producer);
	}
    }
#endif /* !DONT_INIT_JUMBO */

#if USE_MINI_RING
    if (nic->recvMiniCoal >= ALT_MINI_RECV_COAL) {
	ALTTRACE(srcvjprod, 0x10037, nic->recv_mini_producer, 
		 nic->recvMiniCoal, nic->bufsInMiniRecvRing, 0);
	/* ENTER CRIT SECT */
	ALT_DISABLE(spl, &nic->recvBufsMutex); 
	nic->bufsInMiniRecvRing += nic->recvMiniCoal;
	ASSERT(nic->bufsInMiniRecvRing <= RECV_MINI_RING_ENTRIES);
	ALT_ENABLE(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	nic->recvMiniCoal = 0;
	OUT32(nic->handle, nic->base, TG_MBOX5_LOW, 
	      nic->recv_mini_producer);
    }
#endif /* USE_MINI_RING */

    ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvRingMutex);  
    /* LEAVE CRIT SECT */
}
#else /* ALT_RECV_EXT */

STATIC void
#if defined(__STDC__) || defined(ALT_PROTOS)
RingDequeueMsgs(struct tg_nic *nic, U16 newProd, U16 oldProd)
#else /* defined(__STDC__) || defined(ALT_PROTOS) */
RingDequeueMsgs(nic, newProd, oldProd)
struct tg_nic *nic;
U16 newProd;
U16 oldProd;
#endif /* defined(__STDC__) || defined(ALT_PROTOS) */
{
    struct altinst *altp = nic->altp;
    U32 len;
    RECV_PKT *pkt;
    ALT_MSG *msg;
    struct JUMBO_RECV_BD jbufd;
    struct recv_bd bufd;
    int rc = 1;
    struct alt_dma_info *infop;
    struct recv_bd *bdp = &(*nic->recvReturnRing)[oldProd];
    struct recv_bd *endOfRecvRing = 
	&(*nic->recvReturnRing)[RECV_RETURN_RING_ENTRIES-1];
    bool jumbo;
#if USE_MINI_RING
    bool mini;
#endif /* USE_MINI_RING */
    ALT_MSG_DATA_TYPE addr;
    U32 *data;

	
    /* create the messages, pass 'em up stream */
    while (oldProd != newProd) {
	len = bdp->BD_len;
	/* ENTER CRIT SECT */
	ALT_DISABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	if (jumbo = (bdp->BD_flags & BD_FLAG_JUMBO_RING)) {
	    infop = &nic->rjumbomsgs[bdp->BD_index];
	    if (altTracing > 2) {
		ALTTRACE2V(RgDQMsgJ, 0x10033, oldProd, newProd, len, 
			   nic->bufsInJumboRecvRing, infop); 
		data = TRUNC_ADDR(infop->dataAddr, 4, U32 *);
		ALTTRACE2V(jpktdata, 0x1003c, *data, *(data + 1), *(data + 2),
			   *(data + 3), (data+4));
	    }
	    nic->bufsInJumboRecvRing--;
	    ASSERT(nic->bufsInJumboRecvRing >= 0);

	    /* update the ring's consumer */
	    nic->recv_jumbo_consumer = 
		INCRING(bdp->BD_index, RECV_JUMBO_RING_ENTRIES);
#if USE_MINI_RING
	} else if (mini = (bdp->BD_flags & BD_FLAG_MINI_RING)) {
	    infop = &nic->rminimsgs[bdp->BD_index];
	    if (altTracing > 2) {
		ALTTRACE2V(RgDQMsgM, 0x10043, oldProd, newProd, len, 
			   nic->bufsInMiniRecvRing, infop); 
		data = TRUNC_ADDR(infop->dataAddr, 4, U32 *);
		ALTTRACE2V(mpktdata, 0x10044, *data, *(data + 1), *(data + 2),
			   *(data + 3), (data+4));
	    }
	    nic->bufsInMiniRecvRing--;
	    ASSERT(nic->bufsInMiniRecvRing >= 0);

	    /* update the ring's consumer */
	    nic->recv_mini_consumer = 
		INCRING(bdp->BD_index, RECV_MINI_RING_ENTRIES);
#endif /* USE_MINI_RING */
	} else {
	    infop = &nic->rstdmsgs[bdp->BD_index];
	    if (altTracing > 2) {
		ALTTRACE2V(RgDQMsg, 0x10034, oldProd, newProd, len, 
			   nic->bufsInStdRecvRing, infop);
		data = TRUNC_ADDR(infop->dataAddr, 4, U32 *);
		ALTTRACE2V(pktdata, 0x1003d, *data, *(data + 1), *(data + 2),
			   *(data + 3), (data+4));
	    }
	    nic->bufsInStdRecvRing--;
	    ASSERT(nic->bufsInStdRecvRing >= 0);
	    
	    if (nic->bufsInStdRecvRing < nic->bufsLowWater)
		nic->bufsLowWater = nic->bufsInStdRecvRing;

	    /* update the ring's consumer */
	    nic->recv_std_consumer = 
		INCRING(bdp->BD_index, RECV_STANDARD_RING_ENTRIES);
	}
	ALT_ENABLE_AT_DISPATCH_LEVEL(spl, &nic->recvBufsMutex); 
	/* LEAVE CRIT SECT */
	
	/* invalidate the cache data */
	PREP_CACHE_INVAL(infop, len);

	/* make it easier to deal with */
	pkt = infop->rpkt;
	
	/* unprep the old area so we don't lose resources */
	UNPREP_DMA(infop);

	/* pass the packet upstream, we assume for now that it all fit in
	 * one BD.  If this isn't so (e.g. jumbo that didn't fit) we gotta
	 * fix this. XXX
	 */
#if defined(__NETWARE_386__)
	/* pass back status of 0, we can't give bad frames, too bad 
	 * see DriverPromiscuousChange for more info on this. */
	/* this sucks, but we have to look into the packet and find out
	 * if it's 802.2/3, and if so, adjust the length to match */
	{
	    U32 mylen;
	    S8 vlan;

	    mylen = (*(infop->dataAddr + 12) << 8) + *(infop->dataAddr + 13);
	    if (mylen <= 1514) {
		/* not ethertype II frame, grab the length */
		if (mylen < 46)
		    mylen = 60;
		else
		    mylen += 14;
	    } else {
		/* handle the case where a VLAN shortens the packet below
		 * the minimum, sigh */
		mylen = (len < 60) ? 60 : len;
	    }
	    pkt->RCBFragStruct.FragmentLength = mylen;
	    /* if we have VLANS active, look for the indication that we
	     * have received a VLAN frame with a VLAN tag we recognize.  
	     * If not, toss it up the first interface activated */
	    ALTTRACEV(odiup, 0x10007, altp->flags, bdp->BD_flags,
		      bdp->BD_vlan_tag, altp->drvData);
	    if ((altp->flags & ALT_VLANS_ACTIVE) &&
		(bdp->BD_flags & BD_FLAG_VLAN_TAG) &&
		((vlan = altp->vlan_translate[bdp->BD_vlan_tag]) != -1)) {
		ALTTRACEV(odiup2, 0x10008, 
			  vlan, altp->vlanDrvData[vlan], 0, 0);
		pkt = CEtherTSMProcessGetRCB(altp->vlanDrvData[vlan],
					     pkt, mylen, 0,
					     jumbo ? JUMBOBLOCKSIZE : 
#if USE_MINI_RING
					     mini ? MINIBLOCKSIZE :
#endif /* USE_MINI_RING */
					     RECVBLOCKSIZE);
	    } else {
		pkt = CEtherTSMProcessGetRCB(altp->drvData, pkt, mylen, 0,
					     jumbo ? JUMBOBLOCKSIZE : 
#if USE_MINI_RING
					     mini ? MINIBLOCKSIZE :
#endif /* USE_MINI_RING */
					     RECVBLOCKSIZE);
	    }
	}
#endif /* defined(__NETWARE_386__) */

	if (pkt) {
	    if (jumbo) {
		jbufd.BD_type = TIGON_TYPE_RECV_BD;
		jbufd.BD_flags = 0;
		HOSTZEROHI(jbufd.BD_host_addr);
		jbufd.BD_index = nic->recv_jumbo_producer;
		jbufd.BD_flags = BD_FLAG_JUMBO_RING;
		jbufd.BD_len = JUMBOBLOCKSIZE;
		infop = &nic->rjumbomsgs[nic->recv_jumbo_producer];
		infop->dataLen = JUMBOBLOCKSIZE;
		RECVPKT2MSG(pkt, msg);
		MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
		PREP_RECV_INFOP(infop, nic, 0, nic->recv_jumbo_producer,
				addr, JUMBOBLOCKSIZE, msg, pkt);
		ALTTRACE2(recvRtnj, 0x10035, nic->recv_jumbo_producer, pkt, 
			  msg, addr, infop);
		PREP_DMA(rc, ALT_DMA_STREAMING, DDI_DMA_WRITE, infop);
		if (rc != 1) {
		    if (rc > 1) {
			panic("Can't have fragmented recv buf with this firmware\n");
		    } else {
			/* unprep everything and get outta here */
			UNPREP_RECV_INFOP(infop);
		    }
		} else {
		    /* finish filling in the struct recv_bd */
		    jbufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		    ENQ_RECV_RING(jbufd, nic->recv_jumbo_producer, 
				  nic->recv_jumbo_consumer, 
				  nic->recvJumboRing, RECV_JUMBO_RING_ENTRIES,
				  nic->recvJumboRingDmaInfo.handle, spl, 
				  &nic->recvRingMutex, rc);
		    if (rc)
			nic->recvJumboCoal++;
		}
#if USE_MINI_RING
	    } else if (mini) {
		bufd.BD_type = TIGON_TYPE_RECV_BD;
		bufd.BD_flags = 0;
		HOSTZEROHI(bufd.BD_host_addr);
		bufd.BD_index = nic->recv_mini_producer;
		bufd.BD_flags = BD_FLAG_MINI_RING;
		bufd.BD_len = MINIBLOCKSIZE;
		infop = &nic->rminimsgs[nic->recv_mini_producer];
		infop->dataLen = MINIBLOCKSIZE;
		RECVPKT2MSG(pkt, msg);
		MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
		PREP_RECV_INFOP(infop, nic, 0, nic->recv_mini_producer,
				addr, MINIBLOCKSIZE, msg, pkt);
		ALTTRACE2(recvRtnj, 0x10045, nic->recv_mini_producer, pkt, 
			  msg, addr, infop);
		PREP_DMA(rc, ALT_DMA_STREAMING, DDI_DMA_WRITE, infop);
		if (rc != 1) {
		    if (rc > 1) {
			panic("Can't have fragmented recv buf with this firmware\n");
		    } else {
			/* unprep everything and get outta here */
			UNPREP_RECV_INFOP(infop);
		    }
		} else {
		    /* finish filling in the struct recv_bd */
		    bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		    ENQ_RECV_RING(bufd, nic->recv_mini_producer, 
				  nic->recv_mini_consumer, 
				  nic->recvMiniRing, RECV_MINI_RING_ENTRIES,
				  nic->recvMiniRingDmaInfo.handle, spl, 
				  &nic->recvRingMutex, rc);
		    if (rc)
			nic->recvMiniCoal++;
		}
#endif /* USE_MINI_RING */
	    } else {
		bufd.BD_type = TIGON_TYPE_RECV_BD;
		bufd.BD_flags = 0;
		HOSTZEROHI(bufd.BD_host_addr);
		bufd.BD_index = nic->recv_std_producer;
		bufd.BD_flags = 0;
		bufd.BD_len = MAXBLOCKSIZE;
		infop = &nic->rstdmsgs[nic->recv_std_producer];
		infop->dataLen = RECVBLOCKSIZE;
		RECVPKT2MSG(pkt, msg);
		MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
		PREP_RECV_INFOP(infop, nic, 0, nic->recv_std_producer,
				addr, RECVBLOCKSIZE, msg, pkt);
		ALTTRACE2(recvRtn, 0x10036, nic->recv_std_producer, pkt, 
			  msg, addr, infop);
		PREP_DMA(rc, ALT_DMA_STREAMING, DDI_DMA_WRITE, infop);
		if (rc != 1) {
		    if (rc > 1) {
			panic("Can't have fragmented recv buf with this firmware\n");
		    } else {
			/* unprep everything and get outta here */
			UNPREP_RECV_INFOP(infop);
		    }
		} else {
		    /* finish filling in the struct recv_bd */
		    bufd.HOSTADDR(BD_host_addr) = MAP2BUS(infop->dataAddr);
		    ENQ_RECV_RING(bufd, nic->recv_std_producer, 
				  nic->recv_std_consumer, nic->recvStdRing, 
				  RECV_STANDARD_RING_ENTRIES,
				  nic->recvStdRingDmaInfo.handle, spl, 
				  &nic->recvRingMutex, rc);
		    if (rc)
			nic->recvStdCoal++;
		}
	    }
	} else {
	    /* no pkt returned from OS, just keep stats */
	    nic->noRecvResources++;
	    rc = 1;
	}

	/* couldn't get it onto the ring, or couldn't do a DMA preparation */
	if (!rc) {
	    /* clean up */
	    UNPREP_DMA(infop);
	    UNPREP_RECV_INFOP(infop);
	    FREE_RECV_BUF(altp, pkt);
	    /* take note */
	    nic->noRecvResources++;
	    break;
	}

	nic->inpkts++;		/* keep stats */
	oldProd = INCRING(oldProd, RECV_RETURN_RING_ENTRIES);
	if (bdp >= endOfRecvRing)
	    bdp = &(*nic->recvReturnRing)[0];
	else
	    bdp++;
    }

    /* update NIC's copy of the recv_return_consumer (Tigon 1 only) */
    nic->recv_return_producer = newProd;
    if (nic->tigonRev == TG_MHC_LSI_GATE_VERS) {
	WRSHMEM(nic->genComm->gen_com.recv_return_cons_index, newProd);    
	MB();
    }

    /* fill up the rings */
    if (nic->flags & ALT_JUMBO_FILLED)
	RefillJumboRecvRing(altp);
    RefillRecvRing(altp);
#if USE_MINI_RING 
    RefillMiniRing(altp);
#endif /* USE_MINI_RING */

#if defined(__NETWARE_386__)
    CMSMServiceEvents();	/* let upper layers know */
#endif /* defined(__NETWARE_386__) */
}
#endif /* ALT_RECV_EXT */
