/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altred.c,v $
 * Revision 1.1.2.19  1998/08/03  17:11:26  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:39  hayes]
 *
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:56  hayes]
 *
 * Revision 1.1.2.18  1998/06/08  23:55:35  ted
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:19  ted]
 * 
 * Revision 1.1.2.17  1998/04/14  21:42:40  ted
 * 	Merge ODI 1.8 fixes, add VLAN assist support
 * 	[1998/04/14  21:26:54  ted]
 * 
 * Revision 1.1.2.16  1998/03/28  21:19:53  ted
 * 	Fixes for dual homing problems (PR 980)
 * 	[1998/03/28  21:19:38  ted]
 * 
 * Revision 1.1.2.15  1998/03/09  21:37:00  venkat
 * 	WINNT specific. Temporarily training packet capability disabled. Need to
 * 	design dual homing capability on WINNT to turn this back on
 * 	[1998/03/09  21:32:17  venkat]
 * 
 * Revision 1.1.2.14  1998/03/04  00:01:55  ted
 * 	send second training packet, better for our switch
 * 	[1998/03/03  23:59:41  ted]
 * 
 * Revision 1.1.2.13  1998/03/03  22:23:53  ted
 * 	Implement faster dual homing code
 * 	[1998/03/03  22:22:52  ted]
 * 
 * Revision 1.1.2.12  1997/12/03  01:23:03  ted
 * 	Bring forward ODI fixes from release 2
 * 	[1997/12/03  01:14:25  ted]
 * 
 * Revision 1.1.2.11  1997/10/21  00:13:02  ted
 * 	Merged with changes from 1.1.2.10
 * 	[1997/10/21  00:12:02  ted]
 * 
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:00:14  ted]
 * 
 * Revision 1.1.10.1  1997/10/16  17:30:50  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:24:53  ted]
 * 
 * Revision 1.1.2.10  1997/10/20  23:47:12  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:00:14  ted]
 * 
 * Revision 1.1.10.1  1997/10/16  17:30:50  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:24:53  ted]
 * 
 * Revision 1.1.2.9  1997/09/16  03:11:34  ted
 * 	Change s to spl for better coding style
 * 	[1997/09/16  03:00:42  ted]
 * 
 * Revision 1.1.2.8  1997/08/13  18:53:59  ted
 * 	minor tracing improvement
 * 	[1997/08/03  21:35:30  ted]
 * 
 * Revision 1.1.2.7  1997/07/29  04:15:08  ted
 * 	Merge in changes from dualnt work
 * 	[1997/07/29  04:14:58  ted]
 * 
 * Revision 1.1.2.6  1997/07/28  22:40:33  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:39:53  ted]
 * 
 * Revision 1.1.2.1  1997/03/02  18:36:55  ted
 * 	redundancy support and a few bug fixes
 * 	[1997/03/02  18:25:57  ted]
 * 
 * $EndLog$
 */

/*
 * FILE altred.c
 *
 * $Source: /projects/rcs/sw/ge/./nic/host/common/altred.c,v $
 * $Revision: 1.1.2.19 $ $Locker:  $
 * $Date: 1998/08/03 17:11:26 $ $Author: hayes $ $State: Exp $
 */

#ifndef __lint
static char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/common/altred.c,v 1.1.2.19 1998/08/03 17:11:26 hayes Exp $";
#endif /* __lint */

/* general include files */
#if !defined(WINNT) && !defined(__sun) && !defined(__NETWARE_386__)
#include <strings.h>		/* for bzero, ... */
#endif /* !defined(WINNT) && !defined(__sun) && !defined(__NETWARE_386__) */
#if !defined(WINNT)
#include <sys/types.h>		/* generic types */
#include <sys/errno.h>		/* EXXXXX errors */
#endif /* !defined(WINNT) */

/* System V include files */
#if defined(ALT_SYSV)
#include <sys/ethernet.h>	/* ether_addr */
#include <sys/cmn_err.h>
#endif /* defined(ALT_SYSV) */

/* BSD include files */
#if defined(ALT_BSD)
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#endif /* defined(ALT_BSD) */

/* system specific include files */
#if defined(__sun)
#include <sys/byteorder.h>	/* htonl... */
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ddidmareq.h>	/* ddi dma structs */
#include <sys/time.h>		/* struct timespec */
#include <sys/ksynch.h>		/* kconfvar_t */
#include <sys/stream.h>		/* queue_t */
#include <sys/cpuvar.h>		/* cpu struct */
#include <sys/conf.h>		/* for timeout() */
#include <sys/ddi.h>		/* drv_usecstohz */
#endif /* defined(__sun) */

#if defined(WINNT)
#include <ndis.h>
#endif /* defined(WINNT) */

#if defined(__NETWARE_386__)
#include <odi.h>
#include <odi_nbi.h>
#include <odi_nesl.h>
#include <parser.h>
#include <cmsm.h>
#include <splat.h>
#include <portable.h>
#include <string.h>
#endif /* defined(__NETWARE_386__) */

/* alteon include files */
#include "alt.h"
#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#if !defined(WINNT) && !defined(__NETWARE_386__)
#include "altioctl.h"
#endif /* !defined(WINNT) && !defined(__NETWARE_386__) */
#include "pub_tg.h"
#include "altos.h"
#include "althdr.h"
#include "altreg.h"		/* must follow althdr.h */
#include "altftns.h"
#include "altbpdu.h"
#include "altdrv.h"

#if defined(__NETWARE_386__)
#include <ethertsm.h>
#endif /* defined(__NETWARE_386__) */

unsigned char zero8023[] = 
{0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0, 0, 0, 0, 0, 0, 0, 0};

/* forwards */
STATIC bool altReconfigNeeded(struct tg_nic *, ALT_MSG *, struct tg_nic *);

void
altCheckBPDU(struct tg_nic *nic, SEND_PKT *pkt)
{
    struct altinst *altp = nic->altp;
    struct tg_nic *outNic;
    ALT_MSG *msg;
#if defined(__sun)
    ALT_MSG *msg2;
    SEND_PKT *pkt2;
#endif /* defined(__sun) */
    bool switched = FALSE;

    SENDPKT2MSG(pkt, msg);
    
    /* drop the message if firmware isn't running */
    if (altp->state != ALT_FW_RUNNING) {
	MSGFREE(pkt, MSG_SUCCESS);
	return;
    }

    /* check for reconfig */
    ALT_DISABLE(spl, &altp->nicMu);
    /* figure out which nic we received it on and send it out the other */
    if (nic == altp->ifconfigNic)
	outNic = altp->attachNic;
    else
	outNic = altp->ifconfigNic;

    ALTTRACE(fwdbpdu, 0x70000, nic, altp, outNic, msg);

    if (altReconfigNeeded(nic, msg, outNic) ||
	!(altp->nic->flags & ALT_LINK_READY)) {
	ALTTRACE(switchn, 0x70001, nic, altp, outNic, nic->flags);
	/* if the link went down then reset the bpdu timer on that link */
	altp->nic->bpduAge = 0;
	/* swap the active with the standby */
	altp->nic = nic;
	outNic->flags &= ~ALT_RED_ACTIVE;
	outNic->flags |= ALT_RED_STANDBY;
	nic->flags &= ~ALT_RED_STANDBY;
	nic->flags |= ALT_RED_ACTIVE;
	switched = TRUE;
	/* Zero length 802.3 packet sent here to "train" the forwarding
	 * databases out there.
	 * XXX only working for Suns right now, other host specific
	 * frame building will need to happen here */
#if defined(__sun)
	/* copy in the basic frame and then fill in the local MAC address */
	MEMCPY((MEMCPY_TYPE)msg->b_rptr, (MEMCPY_TYPE)zero8023, 14);
	MEMCPY((MEMCPY_TYPE)msg->b_rptr + 6, (MEMCPY_TYPE)&altp->macAddr, 6);
	msg->b_wptr = msg->b_rptr + 14;
	if (msg->b_cont)
	    MSGFREE(msg->b_cont, MSG_SUCCESS);
	msg->b_cont = 0;
	/* allocate and send a second packet, works better for our switch */
	pkt2 = allocb(14, BPRI_MED);
	MEMCPY((MEMCPY_TYPE)pkt2->b_rptr, (MEMCPY_TYPE)msg->b_rptr, 14);
	pkt2->b_wptr = pkt2->b_rptr + 14;
#endif /* defined(__sun) */
	/* we should be able to ignore the return code, it'd seem pretty
	 * odd to not be able to send a packet to an interface we're not
	 * using */
	ALT_DISABLE(spl, &altp->nic->sendMutex);
#if defined(__sun)
	altQueueSendMsg(altp->nic, pkt, NO_VLAN_TAG, 0);
	altQueueSendMsg(altp->nic, pkt2, NO_VLAN_TAG, 0);
#endif /* defined(__sun) */

	ALT_ENABLE(spl, &altp->nic->sendMutex);
    } else
	MSGFREE(pkt, MSG_SUCCESS);
    ALT_ENABLE(spl, &altp->nicMu);

    return;
}

STATIC bool
altReconfigNeeded(struct tg_nic *nic, ALT_MSG *msg, struct tg_nic *nic2)
{
    struct bpduMsg *saveBPDU = &nic->curBPDU;
    struct bpduMsg *saveBPDU2 = &nic2->curBPDU;
    bool newBPDUValue = FALSE;
    U32 len;
    ALT_MSG_DATA_TYPE addr;
    /* have to copy the structure onto an aligned boundary so we can
     * work with it */
    struct bpduMsg bpduData;
    struct bpduMsg *bpdu = &bpduData;

    MSGINFO(msg, addr, len, ALT_MSG_DATA_TYPE);
#if HAVE_MSGHDR
    MEMCPY((MEMCPY_TYPE)bpdu, addr, sizeof(struct bpduMsg));
#else /* HAVE_MSGHDR */
    MEMCPY((MEMCPY_TYPE)bpdu, addr + sizeof(struct ether_header), 
	   sizeof(struct bpduMsg));
#endif /* HAVE_MSGHDR */

    /* compare the new message's BPDU info against that saved away */
    if (BETTER_ID(bpdu->rootId, saveBPDU->rootId)) {
	MEMCPY((MEMCPY_TYPE)saveBPDU, (MEMCPY_TYPE)bpdu, 
	       sizeof(struct bpduMsg));
	newBPDUValue = TRUE;
    } else  if (EQUAL_ID(bpdu->rootId, saveBPDU->rootId)) {
	if ((U32)ntohl(bpdu->pathCost) < (U32)ntohl(saveBPDU->pathCost)) {
	    MEMCPY((MEMCPY_TYPE)saveBPDU, (MEMCPY_TYPE)bpdu, 
		   sizeof(struct bpduMsg));
	    newBPDUValue = TRUE;
	} else if (bpdu->pathCost == saveBPDU->pathCost) {
	    if (BETTER_ID(bpdu->bridgeId, saveBPDU->bridgeId)) {
		MEMCPY((MEMCPY_TYPE)saveBPDU, (MEMCPY_TYPE)bpdu, 
		       sizeof(struct bpduMsg));
		newBPDUValue = TRUE;
	    } else  if (EQUAL_ID(bpdu->bridgeId, saveBPDU->bridgeId)) {
		if ((U16)(ntohs(bpdu->portId) & 0xffff) < 
		    (U16)(ntohs(saveBPDU->portId)) & 0xffff) {
		    MEMCPY((MEMCPY_TYPE)saveBPDU, (MEMCPY_TYPE)bpdu, 
			   sizeof(struct bpduMsg));
		    newBPDUValue = TRUE;
		}
	    }
	}
    }

    /* replace the age with the latest message's age */
    /* endian's ok, they're both backwards on little endian hosts */
    saveBPDU->msgAge = bpdu->msgAge;

    /* the STP will be all the way up when we've gone through 3 state
     * transitions, blocking->listening->learning->forwarding, wait for
     * four to allow slop in timing calculations */
    /* endian is an issue here because we do arithmetic */
    nic->stpReadyAge = 4 * ntohs(bpdu->forwardDelay);

    /* don't switch over on a spanning tree reorg unless we've been
     * getting bpdus long enough to get to forwarding state */
    if (nic->bpduAge < nic->stpReadyAge)
	return(FALSE);
    
    /* if we got a new value, compare it against the other nic's value */
    /* also, if we are standby, go ahead and check, the other side could
     * have timed out and we could get stuck then */
    if (newBPDUValue || (nic->flags & ALT_RED_STANDBY)) {
	if (BETTER_ID(saveBPDU->rootId, saveBPDU2->rootId)) {
	    return(TRUE);
	} else  if (EQUAL_ID(saveBPDU->rootId, saveBPDU2->rootId)) {
	    if (saveBPDU->pathCost < saveBPDU2->pathCost) {
		return(TRUE);
	    } else if (saveBPDU->pathCost == saveBPDU2->pathCost) {
		if (BETTER_ID(saveBPDU->bridgeId, saveBPDU2->bridgeId)) {
		    return(TRUE);
		} else  if (EQUAL_ID(saveBPDU->bridgeId, 
				     saveBPDU2->bridgeId)) {
		    if (saveBPDU->portId < saveBPDU2->portId) {
			return(TRUE);
		    }
		}
	    }
	}
    }
    return(FALSE);
}

void
#if defined(__STDC__) || defined(ALT_PROTOS)
altRedundTimer(struct altinst *altp)
#else	/* defined(__STDC__) || defined(ALT_PROTOS) */
altRedundTimer(altp)
struct altinst *altp;
#endif	/* defined(__STDC__) || defined(ALT_PROTOS) */
{
    /* if redundancy isn't turned on forget this */
    if (((altp->flags & (ALT_REDUNDANT | ALT_RED_IFCONFIG)) != 
	 (ALT_REDUNDANT | ALT_RED_IFCONFIG))) {
#if defined(ALT_SYSV)
	altp->redTimeoutId = 
	    timeout(altRedundTimer, (char *)altp, drv_usectohz(250000));
#endif /* defined(ALT_SYSV) */
	return;
    }

    ALTTRACEG(redtimer, 0x70010, 
	      ntohs(altp->ifconfigNic->curBPDU.msgAge) & 0xffff,
	      ntohs(altp->ifconfigNic->curBPDU.maxAge) & 0xffff,
	      ntohs(altp->attachNic->curBPDU.msgAge) & 0xffff,
	      ntohs(altp->attachNic->curBPDU.maxAge) & 0xffff);
    /* build up the ages, (1/4 second is 64 1/256ths */
    altp->ifconfigNic->curBPDU.msgAge = 
	ntohs((ntohs(altp->ifconfigNic->curBPDU.msgAge) & 0xffff) + 64);
    /* already in proper endian */
    altp->ifconfigNic->bpduAge += 64;

    if ((U16)(ntohs(altp->ifconfigNic->curBPDU.msgAge) & 0xffff) > 
	(U16)(ntohs(altp->ifconfigNic->curBPDU.maxAge) & 0xffff)) {
	altp->ifconfigNic->curBPDU = initBPDU;  /* struct copy */
	altp->ifconfigNic->bpduAge = 0;
    }

    altp->attachNic->curBPDU.msgAge = 
	ntohs((ntohs(altp->attachNic->curBPDU.msgAge) & 0xffff) + 64);
    /* already in proper endian */
    altp->attachNic->bpduAge += 64;

    if ((U16)(ntohs(altp->attachNic->curBPDU.msgAge) & 0xffff) > 
	(U16)(ntohs(altp->attachNic->curBPDU.maxAge) & 0xffff)) {
	altp->attachNic->curBPDU = initBPDU;  /* struct copy */
	altp->attachNic->bpduAge = 0;
    }

    ALTTRACEG(redtimer, 0x70011, 
	      ntohs(altp->ifconfigNic->curBPDU.msgAge) & 0xffff,
	      ntohs(altp->ifconfigNic->curBPDU.maxAge) & 0xffff,
	      ntohs(altp->attachNic->curBPDU.msgAge) & 0xffff,
	      ntohs(altp->attachNic->curBPDU.maxAge) & 0xffff);

#if defined(ALT_SYSV)
    altp->redTimeoutId = 
	timeout(altRedundTimer, (char *)altp, drv_usectohz(250000));
#endif /* defined(ALT_SYSV) */
    return;
}
