/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: altreg.h $
 * Revision nic_api_12_4_latest_shuang/2 1999/12/14 03:10:34 shuang
 * 	increase MAX_TEXT_LEN to 104k
 * 
 * Revision 1.1.5.24  1998/06/12  23:47:22  ted
 * 	snapshot of merge with new Registry handling
 * 	[1998/06/10  22:15:18  ted]
 *
 * Revision 1.1.5.23  1998/06/08  23:55:37  ted
 * 	Redo ODI generification
 * 	[1998/06/08  22:59:19  ted]
 * 
 * 	Snapshot NT generification phase 1
 * 	[1998/06/04  19:52:19  ted]
 * 
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:21  ted]
 * 
 * Revision 1.1.5.22  1998/05/01  05:35:10  hayes
 * 	alpha NT works with transparent shmem accesses
 * 	[1998/05/01  05:34:42  hayes]
 * 
 * 	checkpoint new ALPHA NT initialization and memory handling
 * 	[1998/04/29  23:32:16  hayes]
 * 
 * Revision 1.1.5.21  1998/04/07  21:04:16  hayes
 * 	increase TEXT_SIZE to 96K
 * 	[1998/04/07  21:03:40  hayes]
 * 
 * Revision 1.1.5.20  1998/04/01  07:32:38  shuang
 * 	incrase max text size to 84k, max rddata size to 8k
 * 	[1998/04/01  06:39:48  shuang]
 * 
 * Revision 1.1.5.19  1998/03/09  21:37:01  venkat
 * 	introduced shared memory access MACROs to let individual platforms define
 * 	them to be system specific
 * 	[1998/03/09  21:32:32  venkat]
 * 
 * Revision 1.1.5.18  1998/01/26  23:54:25  venkat
 * 	putback SMP safe write
 * 	[1998/01/26  23:53:49  venkat]
 * 
 * Revision 1.1.5.17  1998/01/24  04:06:52  venkat
 * 	removed usage of NdisWriteRegisterUlong to pass conformance
 * 	[1998/01/24  04:02:53  venkat]
 * 
 * Revision 1.1.5.16  1998/01/14  01:52:53  venkat
 * 	replaced WRITE_REGISTER_* macros with proper NDIS calls
 * 	[1998/01/14  01:47:59  venkat]
 * 
 * Revision 1.1.5.15  1997/12/17  02:53:31  venkat
 * 	Merged with changes from 1.1.5.14
 * 	[1997/12/17  02:53:26  venkat]
 * 
 * 	clean out merge text
 * 	[1997/12/17  02:50:37  venkat]
 * 
 * 	Merged with changes from 1.1.5.13
 * 	[1997/12/17  02:33:40  venkat]
 * 
 * 	increase fw size to 80K
 * 	[1997/12/17  02:32:30  venkat]
 * 
 * 	Merged with changes from 1.1.5.12
 * 	[1997/12/17  02:30:58  venkat]
 * 
 * 	changed fw size from 64 to 80!
 * 	[1997/12/17  02:30:00  venkat]
 * 
 * 	fw size changed from 56k to 64k
 * 	[1997/12/17  02:16:58  venkat]
 * 
 * Revision 1.1.5.14  1997/12/17  02:33:44  venkat
 * 	Merged with changes from 1.1.5.13
 * 	[1997/12/17  02:33:40  venkat]
 * 
 * 	increase fw size to 80K
 * 	[1997/12/17  02:32:30  venkat]
 * 
 * 	Merged with changes from 1.1.5.12
 * 	[1997/12/17  02:30:58  venkat]
 * 
 * 	changed fw size from 64 to 80!
 * 	[1997/12/17  02:30:00  venkat]
 * 
 * 	fw size changed from 56k to 64k
 * 	[1997/12/17  02:16:58  venkat]
 * 
 * Revision 1.1.5.13  1997/12/17  02:31:04  venkat
 * 	Merged with changes from 1.1.5.12
 * 	[1997/12/17  02:30:58  venkat]
 * 
 * 	changed fw size from 64 to 80!
 * 	[1997/12/17  02:30:00  venkat]
 * 
 * 	fw size changed from 56k to 64k
 * 	[1997/12/17  02:16:58  venkat]
 * 
 * Revision 1.1.5.12  1997/12/17  02:17:32  venkat
 * 	fw size changed from 56k to 64k
 * 	[1997/12/17  02:16:58  venkat]
 * 
 * Revision 1.1.5.11  1997/12/03  01:23:04  ted
 * 	Bring forward ODI fixes from release 2
 * 	[1997/12/03  01:14:27  ted]
 * 
 * Revision 1.1.11.3  1997/10/20  21:44:10  ted
 * 	Merged with changes from 1.1.11.2
 * 	[1997/10/20  21:43:38  ted]
 * 
 * 	Make ODI code compile
 * 	[1997/10/20  21:39:01  ted]
 * 
 * Revision 1.1.11.2  1997/10/17  21:49:11  hayes
 * 	inclease text and data sizes
 * 	[1997/10/17  21:48:09  hayes]
 * 
 * Revision 1.1.11.1  1997/10/16  17:30:52  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:24:57  ted]
 * 
 * Revision 1.1.5.8  1997/09/16  03:11:36  ted
 * 	remove old __alpha referring to DEC OSF #ifdefs
 * 	[1997/09/16  03:01:33  ted]
 * 
 * Revision 1.1.5.7  1997/05/24  21:21:02  akhan
 * 	outcfg32 and outcfg16 had wrong cast value.
 * 	[1997/05/24  21:20:47  akhan]
 * 
 * Revision 1.1.5.6  1997/04/25  18:49:04  ted
 * 	Support single driver for Sbus and PCI on Solaris
 * 	[1997/04/25  18:44:51  ted]
 * 
 * Revision 1.1.5.5  1997/04/12  00:11:30  ted
 * 	Merged Sbus code, some performance enhancements
 * 	[1997/04/12  00:07:43  ted]
 * 
 * Revision 1.1.5.4  1997/03/28  01:39:51  ted
 * 	Major merge of NDIS and ODI with mainstream Unix ports
 * 	[1997/03/28  01:33:25  ted]
 * 
 * Revision 1.1.5.3  1997/03/19  05:32:10  suresh
 * 	AIX : changes to IN32, OUT32.. macros
 * 	[1997/03/19  05:31:57  suresh]
 * 
 * Revision 1.1.5.2  1997/02/07  23:23:10  ted
 * 	Get AIX to compile
 * 	[1997/02/07  23:21:43  ted]
 * 
 * Revision 1.1.5.1  1997/02/07  21:58:06  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:48:00  ted]
 * 
 * Revision 1.1.2.1  1996/11/21  18:01:40  ted
 * 	Moved from ../unix/common and merged in WINNT changes
 * 	[1996/11/21  17:43:23  ted]
 * 
 * Revision 1.4.2.1  1996/11/01  18:25:37  ted
 * 	change rr_ to tg_ and add proper copyright
 * 	[1996/10/30  22:58:45  ted]
 * 
 * $EndLog$
 */
/*
 * FILE altreg.h
 *
 * COPYRIGHT (c) Essential Communication Corp. 1995
 * $Source: /projects/rcs/sw/ge/./nic/host/common/altreg.h,v $
 * $Revision: 1.1.5.24 $ $Locker:  $
 * $Date: 1998/06/12 23:47:22 $ $Author: ted $ $State: Exp $
 */

#ifndef _ALTREG_H_
#define _ALTREG_H_

/* some basic constants */

#ifndef TRUE
#define TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

#ifndef bool
#define bool char
#endif /* bool */

#ifndef byte
#define byte unsigned char
#endif /* byte */

/* -------------------------------- SunOS Solaris 2------------------ */
#if defined(__sun)
#define MB()
#define RD_CONS(a) a

/* NOTE: Non-32 bit accesses are not allowed on Sbus systems, these are
 * not enforced at compile or run time.  You'll just crash!!!!! */

/* these bypass cache */
#define IN32(handle, base, addr) ddi_getl(handle, (U32 *)((base) + (addr)))

#define IN8(handle, base, addr) \
ddi_getb(handle, (U8 *)((base) + (addr)))

#define OUT32(handle, base, addr, value) \
ddi_putl(handle, (U32 *)((base) + (addr)), value)

#define OUT16(handle, base, addr, value) \
ddi_putw(handle, (U16 *)((base) + (addr)), value)

#define OUT8(handle, base, addr, value) \
ddi_putb(handle, (U8 *)((base) + (addr)), value)

/* these bypass cache */
#define INCFG32(handle, base, addr) ddi_getl(handle, (U32 *)((base) + (addr)))

#define INCFG8(handle, base, addr) \
ddi_getb(handle, (U8 *)((base) + (addr)))

#define OUTCFG32(handle, base, addr, value) \
ddi_putl(handle, (U32 *)((base) + (addr)), value)

#define OUTCFG16(handle, base, addr, value) \
ddi_putw(handle, (U16 *)((base) + (addr)), value)

#define OUTCFG8(handle, base, addr, value) \
ddi_putb(handle, (U8 *)((base) + (addr)), value)

#define MAP2BUS(prefix) ((U32)(prefix##DmaAddr))

/* expected dev ID/vendor ID */
#define TG_DEV_VALUE          0x000112ae

/* what to put into the PCI command register to enable memory accesses */
#if defined(__sparc)
#define SBUS_DEFAULT_PCI_COMMAND 0x02000006 /* bus master memory access */
#define DEFAULT_PCI_COMMAND 0x600 /* bus master memory access */
#else /* defined(__sparc) */
#define DEFAULT_PCI_COMMAND 0x6	/* bus master, memory access */
#endif /* defined(__sparc) */

/* -------------------------------- SunOS Solaris 2 ------------------ */

/* ----------------------- Microsoft Windows NT (NDIS) ---------------- */
#elif defined(WINNT)

#if defined(ALPHA) && defined(SHMEM_TRANSPARENT)
#define MB() __MB()
#else /* defined(ALPHA) && defined(SHMEM_TRANSPARENT) */
#define MB()
#endif /* defined(ALPHA) && defined(SHMEM_TRANSPARENT) */

#define RD_CONS(a) a

/* shared memory access routines */
void altWrite32(U32 *w, U32 value);
void altWrite16(U16 *w, U16 value);
void altWrite8(U8 *w, U8 value);
U32 altRead32(U32 *pul);
U16 altRead16(U16 *pus);
U8 altRead8(U8 *puc);

#if defined(ALPHA)

#define IN32(handle, base, addr) altRead32((U32 *)(base+addr))
#define IN8(handle, base, addr) altRead8((U8 *)(base+addr))

#define OUT32(handle, base, addr, val) altWrite32((U32 *)((base)+(addr)),val)
#define OUT16(handle, base, addr, val) altWrite16((U16 *)((base)+(addr)), val)
#define OUT8(handle, base, addr, val) altWrite8((U8 *)((base)+(addr)), val)

#define INCFG32(handle, base, addr) altRead32((U32 *)(base+addr))
#define INCFG8(handle, base, addr) altRead8((U8 *)(base+addr))

#define OUTCFG32(handle, base, addr, val) altWrite32((U32 *)((base)+(addr)),val)
#define OUTCFG16(handle, base, addr, val) altWrite16((U16 *)(addr+(ULONG) base),val)
#define OUTCFG8(handle, base, addr, val) altWrite8((U8 *)(addr+base),val)

#else /* defined(ALPHA) */

/* these bypass cache */

#define IN32(handle, base, addr) altRead32((U32 *)(base+addr))
#define IN8(handle, base, addr) altRead8((U8 *)(base+addr))

#define OUT32(handle, base, addr, value) \
	NdisWriteRegisterUlong((U32 *)((base) + (addr)),value)
 
#define OUT16(handle, base, addr, value) \
	NdisWriteRegisterUshort((U16 *)((base) + (addr)), value)

#define OUT8(handle, base, addr, value) \
	NdisWriteRegisterUchar((U8 *)((base) + (addr)), value)

/* these bypass cache */
#define INCFG32(handle, base, addr) altRead32((U32 *)(base+addr))
#define INCFG8(handle, base, addr) altRead8((U8 *)(base+addr))

#define OUTCFG32(handle, base, addr, value) \
	NdisWriteRegisterUlong((U32 *)((base) + (addr)),value)

#define OUTCFG16(handle, base, addr, value) \
	NdisWriteRegisterUshort((U16 *)(addr+(ULONG) base),value)

#define OUTCFG8(handle, base, addr, value) \
	NdisWriteRegisterUchar((addr+base),value)

#endif /* defined(ALPHA) */

#define MAP2BUS(prefix) (prefix##DmaAddr)

/* expected dev ID/vendor ID */
#define TG_DEV_VALUE          0x000112ae

#define DEFAULT_PCI_COMMAND 0x6	/* bus master, memory access */

/* ----------------------- Microsoft Windows NT (NDIS) ---------------- */

/* ----------------------- Novell ODI --------------------------------- */
#elif defined(__NETWARE_386__)
#define MB()
#define RD_CONS(a) a

/* these bypass cache */
#define IN32(handle, base, addr) Rd32(handle, NULL, (char *)base + addr)
#define IN8(handle, base, addr) Rd8(handle, NULL, (char *)base + addr)

#define OUT32(handle, base, addr, value) \
    Wrt32(handle, NULL, (char *)base + addr, value)
#define OUT16(handle, base, addr, value) \
    Wrt16(handle, NULL, (char *)base + addr, value)
#define OUT8(handle, base, addr, value) \
    Wrt8(handle, NULL, (char *)base + addr, value)

/* these bypass cache */
#define INCFG32(handle, base, addr) Rd32(handle, NULL, (char *)base + addr)
#define INCFG8(handle, base, addr) Rd8(handle, NULL, (char *)base + addr)

#define OUTCFG32(handle, base, addr, value) \
    Wrt32(handle, NULL, (char *)base + addr, value)
#define OUTCFG16(handle, base, addr, value) \
    Wrt16(handle, NULL, (char *)base + addr, value)
#define OUTCFG8(handle, base, addr, value) \
    Wrt8(handle, NULL, (char *)base + addr, value)

#define MAP2BUS(addr) ((HOSTADDR_TYPE)CMSMGetPhysical(addr))

/* expected dev ID/vendor ID */
#define TG_DEV_VALUE          0x000112ae

#define DEFAULT_PCI_COMMAND 0x6	/* bus master, memory access */
/* ----------------------- Novell ODI --------------------------------- */

#else  /* make sure that this is looked at on a new port */
#define MAP2BUS(addr) WHOKNOWS(addr)

/* expected dev ID/vendor ID */
#define TG_DEV_VALUE          ####
#endif /* defined(__hpux) */


/* maximum size of the firmware data */
#define MAX_TEXT_LEN   104*1024
#define MAX_RODATA_LEN 8*1024
#define MAX_DATA_LEN   2*1024
#define MAX_BSS_LEN    64*1024
#define MAX_SBSS_LEN   512
#define MAX_STACK_LEN  0x6000
#define FW_STACK_LOC   (0x1dd000 - MAX_STACK_LEN)

/* trace buffer info about firmware */
#define NIC_TRACE_LEN   0x1000
#define NIC_TRACE_ALIGN ~(NIC_TRACE_LEN - 1)

/* macros for working with the memory window */
#define WINDOW_LEN      (2*1024) 
#define WINDOW_ALIGNED(addr) (((int)(addr) & (WINDOW_LEN-1)) == 0)
#define WINDOW_RESID(addr) (WINDOW_LEN - ((int)(addr) & (WINDOW_LEN-1)))
#define WINDOW_OFFSET(addr) ((int)(addr) & (WINDOW_LEN-1))
#define WINDOW_PAGE(addr) ((int)(addr) & ~(WINDOW_LEN-1))

#endif /* _ALTREG_H_ */

