/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: althdr.h,v $
 * Revision 1.1.2.11  1998/09/03  22:16:55  hayes
 * 	add bugfixes from nt_r1_9_5
 * 	[1998/09/03  22:13:22  hayes]
 *
 * Revision 1.1.2.10  1998/08/03  22:06:32  hayes
 * 	cleanup, add registry options
 * 	[1998/08/03  22:05:15  hayes]
 * 
 * Revision 1.1.2.9  1998/08/03  17:11:33  hayes
 * 	finish update for API changes
 * 	[1998/08/03  17:07:48  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:16:04  hayes]
 * 
 * Revision 1.1.2.8  1998/07/14  02:32:45  ted
 * 	new registry names
 * 	[1998/07/14  02:15:17  ted]
 * 
 * Revision 1.1.2.7  1998/07/08  22:26:26  hayes
 * 	add 450gx fix
 * 	[1998/07/08  22:25:33  hayes]
 * 
 * Revision 1.1.2.6  1998/06/18  00:06:38  hayes
 * 	add caching fixes
 * 	[1998/06/17  23:57:17  hayes]
 * 
 * Revision 1.1.2.5  1998/06/12  23:47:30  ted
 * 	Rework NT data structures and peripheral changes
 * 	[1998/06/12  23:42:22  ted]
 * 
 * 	snapshot of merge with new Registry handling
 * 	[1998/06/10  22:15:23  ted]
 * 
 * Revision 1.1.2.4  1998/06/08  23:55:42  ted
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:26  ted]
 * 
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:08:44  ted]
 * 
 * 	snapshot 12.0 NT jumbo support
 * 	[1998/05/20  20:29:33  ted]
 * 
 * Revision 1.1.2.3  1998/04/18  21:28:21  hayes
 * 	added resource list pointer
 * 	[1998/04/18  21:26:24  hayes]
 * 
 * Revision 1.1.2.2  1997/12/18  23:44:15  venkat
 * 	merged from ge_0_37_latest
 * 	[1997/12/18  23:31:23  venkat]
 * 
 * Revision 1.1.2.1  1997/06/13  00:54:31  akhan
 * 	Move from ndis/src to ndis
 * 	[1997/06/13  00:53:57  akhan]
 * 
 * Revision 1.1.2.5  1997/06/11  02:58:08  akhan
 * 	Added variables for send queuing.
 * 	[1997/06/11  02:57:43  akhan]
 * 
 * Revision 1.1.2.4  1997/05/23  00:06:00  akhan
 * 	Deleted SendLock and some other variables.
 * 	[1997/05/23  00:05:46  akhan]
 * 
 * Revision 1.1.2.3  1997/04/26  01:27:08  akhan
 * 	Added more variables.
 * 	[1997/04/26  01:17:35  akhan]
 * 
 * Revision 1.1.2.2  1997/04/04  06:22:38  akhan
 * 	Added send spin lock and some other stuff.
 * 	[1997/04/04  05:04:02  akhan]
 * 
 * Revision 1.1.2.1  1996/11/21  18:01:43  ted
 * 	New file for WINNT instance structure and associated items
 * 	[1996/11/21  17:44:22  ted]
 * 
 * Revision 1.4.2.1  1996/11/01  18:25:44  ted
 * 	change rr_ to tg_ and put in proper copyright
 * 	[1996/10/30  23:04:17  ted]
 * 
 * $EndLog$
 */
/*
 * FILE althdr.h
 *
 * $Source: /projects/rcs/sw/ge/./nic/host/ndis/althdr.h,v $
 * $Revision: 1.1.2.11 $ $Locker:  $
 * $Date: 1998/09/03 22:16:55 $ $Author: hayes $ $State: Exp $
 */

#ifndef _ALTHDR_H_
#define _ALTHDR_H_

/* configuration constants */
#define FIRMWARE_DEBUGGED 1	/* set to 1 for production */
#define TG_WINDOW_WORKS 1	/* possibly not on some systems */

#define SAMPLE_SIZE 150
#define BIN_SIZE_1 (1500 / SAMPLE_SIZE ) + 1 

/*
 * global registry entries - apply to all adapters
 *
 * types are used as an index into the alteon global registry table
 */
#define MAX_REG_KEY_SIZE	64

#define ALT_REG_KEY_GLOB_STAT_TICKS		"StatTicks"
#define ALT_REG_KEY_GLOB_STAT_TICKS_INDEX	0

#define ALT_REG_KEY_GLOB_SEND_COAL_TICKS	"SendCoalTicks"
#define ALT_REG_KEY_GLOB_SEND_COAL_TICKS_INDEX	1

#define ALT_REG_KEY_GLOB_RECV_COAL_TICKS	"RecvCoalTicks"
#define ALT_REG_KEY_GLOB_RECV_COAL_TICKS_INDEX	2

#define ALT_REG_KEY_GLOB_SEND_COAL_MAX		"SendCoalMax"
#define ALT_REG_KEY_GLOB_SEND_COAL_MAX_INDEX	3

#define ALT_REG_KEY_GLOB_RECV_COAL_MAX		"RecvCoalMax"
#define ALT_REG_KEY_GLOB_RECV_COAL_MAX_INDEX	4

#define ALT_REG_KEY_GLOB_PCI_MEM_INV	        "PciMemInvalidate"
#define ALT_REG_KEY_GLOB_PCI_MEM_INV_INDEX      5

#define ALT_REG_KEY_GLOB_PCI_READ_MAX		"PciReadMax"
#define ALT_REG_KEY_GLOB_PCI_READ_MAX_INDEX	6

#define ALT_REG_KEY_GLOB_PCI_WRITE_MAX		"PciWriteMax"
#define ALT_REG_KEY_GLOB_PCI_WRITE_MAX_INDEX	7

#define ALT_REG_KEY_GLOB_PCI_LATENCY_TIMER	"PciLatencyTimer"
#define ALT_REG_KEY_GLOB_PCI_LATENCY_TIMER_INDEX 8

#define ALT_REG_KEY_GLOB_450GX_FIX		"Fix450GX"
#define ALT_REG_KEY_GLOB_450GX_FIX_INDEX 	9

#define ALT_REG_KEY_GLOB_RUPT_TIMEOUT           "RuptTimeout"
#define ALT_REG_KEY_GLOB_RUPT_TIMEOUT_INDEX     10
 
#define ALT_REG_KEY_GLOB_HYBRID_LEN             "HybridLen"
#define ALT_REG_KEY_GLOB_HYBRID_LEN_INDEX       11
 
#define ALT_REG_KEY_GLOB_SHARED_RUPT            "SharedRupt"
#define ALT_REG_KEY_GLOB_SHARED_RUPT_INDEX      12
 
#define ALT_REG_KEY_GLOB_REAP_AFTER_SEND        "ReapAfterSend"
#define ALT_REG_KEY_GLOB_REAP_AFTER_SEND_INDEX  13
 
#define ALT_REG_KEY_GLOB_MIN_DMA                "MinDma"
#define ALT_REG_KEY_GLOB_MIN_DMA_INDEX          14
 
#define ALT_REG_KEY_GLOB_SEND_UPDATE_ONLY       "SendUpdateOnly"
#define ALT_REG_KEY_GLOB_SEND_UPDATE_ONLY_INDEX 15
 
#define ALT_REG_KEY_GLOB_LAST_INDEX ALT_REG_KEY_GLOB_SEND_UPDATE_ONLY_INDEX

/*
 * per adapter registry entries
 */

/* the following are used internally */
#define ALT_REG_KEY_INST_INSTANCE		"Instance"
#define ALT_REG_KEY_INST_INSTANCE_INDEX		0

#define ALT_REG_KEY_INST_SLOT			"SlotNumber"
#define ALT_REG_KEY_INST_SLOT_INDEX		1

/* the following are always available via configuration utility */
#define ALT_REG_KEY_INST_TX_FLOW_CONTROL	"TxFlowControl"
#define ALT_REG_KEY_INST_TX_FLOW_CONTROL_INDEX	2

#define ALT_REG_KEY_INST_RX_FLOW_CONTROL	"RxFlowControl"
#define ALT_REG_KEY_INST_RX_FLOW_CONTROL_INDEX	3

#define ALT_REG_KEY_INST_LINK_NEGOTIATION	"LinkNegotiation"
#define ALT_REG_KEY_INST_LINK_NEGOTIATION_INDEX	4

#define ALT_REG_KEY_INST_FDR_FILTER		"FdrFilter"
#define ALT_REG_KEY_INST_FDR_FILTER_INDEX	5


/* the following are for Dual Homing capability */
#define ALT_REG_KEY_INST_RSL_ENABLE		"RslEnable"
#define ALT_REG_KEY_INST_RSL_ENABLE_INDEX	6

#define ALT_REG_KEY_INST_RSL_PRIMARY_INST	"RslPrimaryInst"
#define ALT_REG_KEY_INST_RSL_PRIMARY_INST_INDEX	7

#define ALT_REG_KEY_INST_RSL_SECONDARY_INST	"RslSecondaryInst"
#define ALT_REG_KEY_INST_RSL_SECONDARY_INST_INDEX 8

/* the following are for Jumbo Frame support */
#define ALT_REG_KEY_INST_JUMBO_FRAMES		"JumboFrames"
#define ALT_REG_KEY_INST_JUMBO_FRAMES_INDEX	9

#define ALT_REG_KEY_INST_JUMBO_MTU		"JumboMtu"
#define ALT_REG_KEY_INST_JUMBO_MTU_INDEX	10


/* the following are for VLAN support */
#define ALT_REG_KEY_INST_VLAN_ENABLE		"VlanEnable"
#define ALT_REG_KEY_INST_VLAN_ENABLE_INDEX	11

#define ALT_REG_KEY_INST_VLAN_COUNT		"VlanCount"
#define ALT_REG_KEY_INST_VLAN_COUNT_INDEX	12


/* the following are used internally */
#define ALT_REG_KEY_INST_REGISTRY_CONSISTENT	"RegistryConsistent"
#define ALT_REG_KEY_INST_REGISTRY_CONSISTENT_INDEX 13

#define ALT_REG_KEY_INST_NIC_TRACING		"NicTracing"
#define ALT_REG_KEY_INST_NIC_TRACING_INDEX	14

#define ALT_REG_KEY_INST_COMMAND		"Command"
#define ALT_REG_KEY_INST_COMMAND_INDEX		15

#define ALT_REG_KEY_INST_HOST_TRACING		"HostTracing"
#define ALT_REG_KEY_INST_HOST_TRACING_INDEX	16

#define ALT_REG_KEY_INST_DEBUG_PCI		"DebugPci"
#define ALT_REG_KEY_INST_DEBUG_PCI_INDEX	17

#define ALT_REG_KEY_INST_LAST_INDEX ALT_REG_KEY_INST_DEBUG_PCI_INDEX	

/* the following are per VLAN, a level below the per NIC instance */
#define ALT_REG_KEY_INST_VLAN_INSTANCE		"VlanInstance"
#define ALT_REG_KEY_INST_VLAN_INSTANCE_INDEX	0

#define ALT_REG_KEY_INST_VLAN_NEXT		"VlanNextInstance"
#define ALT_REG_KEY_INST_VLAN_NEXT_INDEX	1

#define ALT_REG_KEY_INST_VLAN_VALUE		"VlanValue"
#define ALT_REG_KEY_INST_VLAN_VALUE_INDEX	2

#define ALT_REG_KEY_INST_VLAN_BINDING		"VlanBinding"
#define ALT_REG_KEY_INST_VLAN_BINDING_INDEX	3

#define ALT_REG_KEY_INST_VLAN_LAST_INDEX ALT_REG_KEY_INST_VLAN_BINDING_INDEX

/* registry structures */
typedef struct alt_nt_glob_parms {
    U32 stat_ticks;
    U32 send_coal_ticks;
    U32 recv_coal_ticks;
    U32 send_coal_max;
    U32 recv_coal_max;
    U32 pci_mem_inv;
    U32 pci_read_max;
    U32 pci_write_max;
    U32 pci_latency_timer;
    U32 i450gx_fix;
    U32 ruptTimeout;
    U32 hybridLen;
    U32 sharedRupt;
    U32 hostSendRing;
    U32 reapAfterSend;
    U32 minDma;
    U32 sendUpdateOnly;
} alt_nt_glob_parms_t;

typedef struct alt_nt_vlan_parms {
    U32 instance;
    U32 next;
    U32 value;
    U32 binding;
} alt_nt_vlan_parms_t;

typedef struct alt_nt_inst_parms {
    U32 tx_flow_control;
    U32 rx_flow_control;
    U32 link_negotiation;
    U32 fdr_filter;
    U32 rsl_enable;
    U32 rsl_pri_inst;
    U32 rsl_sec_inst;
    U32 jumbo_frames;
    U32 jumbo_mtu;
    U32 vlan_enable;
    U32 vlan_count;
    alt_nt_vlan_parms_t vlan[MAX_VLANS];
    U32 instance;
    U32 slot;
    U32 registry_consistent;
    U32 nic_tracing;
    U32 command;
    U32 host_tracing;
    U32 debug_pci;
} alt_nt_inst_parms_t;

typedef struct alt_nt_tune_parms {
    alt_nt_glob_parms_t glob;
    alt_nt_inst_parms_t inst[NALT];
} alt_nt_tune_parms_t;

/*
 * registry table definition
 */
typedef struct alt_reg_tab {
    U8 string[MAX_REG_KEY_SIZE];
    NDIS_PARAMETER_TYPE ndis_type;
    U32 *cfg_parm;
    NDIS_STATUS ndis_status;
    U32 min;
    U32 max;
    U32 def;
} alt_reg_tab_t;

/* struct to hold all the data about an Acteon driver instance */
struct altinst {
    U32 instance;	        /* instance number */
    U32 state;			/* state of the device */
    U32 flags;			/* misc flags */
    bool flow_controlled;	/* flow control on write stream */
    struct ether_addr macAddr;	/* mac address */

    /* NDIS specific variables */
    U32 look_ahead_size;

    struct tg_nic *nic;		/* pointer to nic specific structures */
    struct tg_nic *initNic;	/* pointer to initialized nic */
    struct tg_nic *ifconfigNic;	/* pointer to ifonfiged nic specific data */
    struct tg_nic *attachNic;	/* ptr to "configured redund" nic spec data */
#if ALT_LOCKS_SUPPORTED
    LOCK_TYPE nicMu;		/* flag bits mutex */
#endif /* ALT_LOCKS_SUPPORTED */

    /* multicast information */
    U32 mccount;		/* # enabled multicast addrs */
    /* struct for compatibility with other OS that need it this way */
    struct inst_multicast {
	struct ether_addr addr;	/* multicast address */
    } mctab[MAX_MCAST_ENTRIES];	/* table of multicast addrs */
    U32 addmccount;		/* # enabled multicast addrs */
    struct ether_addr addtab[MAX_MCAST_ENTRIES]; /* multicast address */
    U32 delmccount;		/* # enabled multicast addrs */
    struct ether_addr deltab[MAX_MCAST_ENTRIES]; /* multicast address */

    /* per VLAN info */
    U16 vlan_id[MAX_VLANS];     /* VLAN ID */
    bool jumbo[MAX_VLANS];      /* per VLAN jumbo indication */
    U32 inPackets[MAX_VLANS];   /* per VLAN input statistics */
    U32 outPackets[MAX_VLANS];  /* per VLAN output statistics */              
    S8 vlan_translate[MAX_VLAN_IDS]; /* table for reverse trans vlan to ipq */     
};


/* states (struct altinst) */
#define ALT_NOTREADY	0
#define ALT_FW_LOADED   1
#define ALT_FW_RUNNING  2

/* flag bits (struct altinst) */
#define ALT_HOST_UP      0x00000001  /* for when the host stack is enabled */
#define ALT_PROMISC      0x00000002  /* set when in physical promisc mode */
#define ALT_REDUNDANT    0x00000004  /* involved in a redundant setup */
#define ALT_RED_IFCONFIG 0x00000008  /* nic was ifconfiged for redundancy */
#define ALT_RED_ATTACH   0x00000010  /* nic was "configured redundant" */
#define ALT_DRIVER_IS_OP1 0x00000040 /* special flag for vge driver */
#define ALT_VLANS_ACTIVE 0x00000080  /* if VLANS are on on this interface */

#endif /* _ALTHDR_H_ */
