;// COPYRIGHT NOTICE
;// Copyright (c) Alteon Networks, Inc. 1996, 1997
;// All rights reserved
;
;
;// HISTORY
;// $Log: altntmsg.mc $
;// Revision ge_l_leonid/1 1999/03/19 18:10:44 leonid
;// 	adapter name/instance added to custom messages
;// 
;// Revision 1.1.6.5  1998/09/03  22:06:13  ted
;// 	Bring forward log messages and cache line size fix from release 1.9
;// 	[1998/09/03  22:01:39  ted]
;//
;// Revision 1.1.6.4  1998/06/18  16:15:51  hayes
;// 	fix comment leader...
;// 	[1998/06/18  16:15:30  hayes]
;// 
;// Revision 1.1.3.2  1998/06/18  15:50:34  hayes
;// 	     complete merge
;// 
;// $EndLog$
;

MessageIdTypedef = NTSTATUS

SeverityNames = (
	Success		  = 0x0:STATUS_SEVERITY_SUCCESS
	Informational     = 0x1:STATUS_SEVERITY_INFORMATIONAL
	Warning		  = 0x2:STATUS_SEVERITY_WARNING
	Error		  = 0x3:STATUS_SEVERITY_ERROR
	)

FacilityNames = (
	System		= 0x0
	RpcRuntime	= 0x2:FACILITY_RPC_RUNTIME
	RpcStubs	= 0x3:FACILITY_RPC_STUBS
	Io		= 0x4:FACILITY_IO_ERROR_CODE
	altndis  	= 0x7:FACILITY_XX_ERROR_CODE
	)
;//
;// All messages will start with ALT_LOG_ERR_, ALT_LOG_WARN_ or ALT_LOG_INFO_
;//

;//
;// Error Messages
;//

MessageId=0x0001
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_MEM_ERR1
Language=English
%2: Unable to Allocate Memory for Adapter.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName= ALT_LOG_ERR_MAP_REG
Language=English
%2: Unable to Allocate Map Registers.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName= ALT_LOG_ERR_READ_CONFIG
Language=English
%2: Unable to Read Adapter Configuration.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_MAP_IO
Language=English
%2: NdisMMapIoSpace failed.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName= ALT_LOG_ERR_INIT_MEM
Language=English
%2: Unable to allocate and initialize NIC structures.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_INIT_PH1
Language=English
%2: NIC phase 1 initialization error.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_INIT_INTERRUPT
Language=English
%2: NdisMRegisterInterrupt failed.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_64_BIT_PROBLEM
Language=English
%2: System Board Problem.  System BIOS has configured NIC card to use PCI in
64 bit mode while system does not support 64 bit PCI on this bus.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_INIT_PH2
Language=English
%2: NIC phase 2 initialization error.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_FIRMWARE_NOT_LOADED
Language=English
%2: Adapter Firmware did not load properly.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_UNSUPPORTED_MEDIA
Language=English
%2: Unsupported Media.
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_INVAL_PCI_CONF
Language=English
%2: The BIOS has failed to initialize the NICs PCI config area properly
.

MessageId=+1
Facility=altndis
Severity=Error
SymbolicName=ALT_LOG_ERR_NO_ASSIGN_PCI_RESOURCES
Language=English
%2: The NdisMPciAssignResources function returned a failure, according to the 
DDK this is not possible
.

;//
;// Warning messages
;//

MessageId=+1
Facility=altndis
Severity=Warning
SymbolicName=ALT_LOG_WARN_INVAL_PCI_CONF
Language=English
%2: The BIOS has failed to initialize the NICs PCI config area properly
.

;//
;// Informational messages
;//

MessageId=+1
Facility=altndis
Severity=Informational
SymbolicName=ALT_LOG_INFO_PCI_DEBUG_PRE
Language=English
%2: PCI config space dump, pre driver registration
.

MessageId=+1
Facility=altndis
Severity=Informational
SymbolicName=ALT_LOG_INFO_PCI_DEBUG_POST
Language=English
%2: PCI config space dump, post driver registration
.

MessageId=+1
Facility=altndis
Severity=Informational
SymbolicName=ALT_LOG_INFO_JUMBO_ENABLED
Language=English
%2: Jumbo frames are enabled
.


MessageId=+1
Facility=altndis
Severity=Informational
SymbolicName=ALT_LOG_PRODUCT_INFO
Language=English
%2: Gigabit Ethernet Adapter Product Information
.

MessageId=+1
Facility=altndis
Severity=Informational
SymbolicName=ALT_LOG_LINK_UP
Language=English
%2: Gigabit Ethernet Link is up
.

MessageId=+1
Facility=altndis
Severity=Informational
SymbolicName=ALT_LOG_LINK_DOWN
Language=English
%2: Gigabit Ethernet Link is down
.
