/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altos.h,v $
 * Revision 1.1.2.12  1998/11/03  23:25:36  ted
 * 	Add new low water marks for out of resources check
 * 	[1998/11/03  22:23:07  ted]
 *
 * Revision 1.1.2.11  1998/10/13  03:33:42  ted
 * 	Support Mini ring, compiles on Solaris
 * 	[1998/10/13  03:31:11  ted]
 * 
 * Revision 1.1.2.10  1998/09/03  20:05:09  ted
 * 	NDIS 5.0 deserialized code, mostly working
 * 	[1998/09/03  19:55:20  ted]
 * 
 * Revision 1.1.2.9  1998/08/12  01:58:15  ted
 * 	First shot at real deserialization
 * 	[1998/08/06  18:11:00  ted]
 * 
 * Revision 1.1.2.8  1998/06/18  00:06:39  hayes
 * 	add caching fixes
 * 	[1998/06/17  23:57:19  hayes]
 * 
 * Revision 1.1.2.7  1998/06/12  23:47:33  ted
 * 	Rework NT data structures and peripheral changes
 * 	[1998/06/12  23:42:26  ted]
 * 
 * Revision 1.1.2.6  1998/06/08  23:55:43  ted
 * 	Add CONT_LOOP_THRU_PACKET macro
 * 	[1998/06/08  22:50:51  ted]
 * 
 * 	Snapshot NT generification phase 1
 * 	[1998/06/04  19:52:25  ted]
 * 
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:28  ted]
 * 
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:08:46  ted]
 * 
 * 	snapshot 12.0 NT jumbo support
 * 	[1998/05/20  20:29:35  ted]
 * 
 * Revision 1.1.2.5  1998/01/05  01:31:58  ted
 * 	remove unnecessary count and maxcount from altCheckMsgFrags routine)
 * 	[1998/01/05  01:29:24  ted]
 * 
 * Revision 1.1.2.4  1998/01/03  00:40:40  venkat
 * 	added LASTFRAG macro used in NON-copydata mode.
 * 	[1998/01/03  00:36:50  venkat]
 * 
 * Revision 1.1.2.3  1997/12/18  23:51:32  venkat
 * 	merged from ge_0_37_latest
 * 	[1997/12/18  23:31:24  venkat]
 * 
 * Revision 1.1.2.2  1997/10/21  00:13:09  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:00:37  ted]
 * 
 * Revision 1.1.9.1  1997/10/16  17:31:04  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:25:16  ted]
 * 
 * Revision 1.1.2.1  1997/06/13  00:55:35  akhan
 * 	 move from ndis/src to ndis
 * 	[1997/06/13  00:55:22  akhan]
 * 
 * Revision 1.1.2.4  1997/06/11  02:59:15  akhan
 * 	Changes to support send queuing.
 * 	[1997/06/11  02:59:04  akhan]
 * 
 * Revision 1.1.2.3  1997/04/26  01:27:43  akhan
 * 	Added more NDIS variables.
 * 	[1997/04/26  01:18:21  akhan]
 * 
 * Revision 1.1.2.2  1997/04/04  06:22:39  akhan
 * 	MSGFREE changed
 * 	[1997/04/04  06:16:10  akhan]
 * 
 * Revision 1.1.2.1  1997/03/28  01:40:23  ted
 * 	Major merge of NDIS and ODI with mainstream Unix ports
 * 	[1997/03/28  01:34:33  ted]
 * 
 * Revision 1.1.2.2  1997/02/21  02:06:48  ted
 * 	Prepare data structures and code structures to support redundant operation
 * 	[1997/02/21  01:56:58  ted]
 * 
 * Revision 1.1.2.1  1997/02/07  21:58:10  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:48:14  ted]
 * 
 * $EndLog$
 */

#ifndef _ALTOS_H
#define _ALTOS_H

/*forwards*/
extern bool altCheckMsgFrags(PNDIS_BUFFER);

/* generification of messages */
#define SEND_PKT NDIS_PACKET
#define RECV_PKT SEND_PKT
#define ALT_MSG  NDIS_BUFFER
#define ALT_MSG_DATA_TYPE caddr_t
#define LOOP_THRU_PACKET(pkt, msg, count, maxCount) while (msg)
#define CONT_LOOP_THRU_PACKET LOOP_THRU_PACKET
#define SENDPKT2MSG(pkt, msg) \
        NdisQueryPacket(pkt, (UINT *)0, (UINT *)0, &msg, (UINT *)0);
#define RECVPKT2MSG SENDPKT2MSG

#define MSGINFO(msg, addr, len, type) \
    NdisQueryBuffer(msg, (void *)&(addr), &(len))

#define HAVE_MSGHDR 0
#define MSGNEXT(msg) NdisGetNextBuffer(msg, &msg)
#define PEEKMSGNEXT(msg, nextmsg, count, maxCount) \
    NdisGetNextBuffer(msg, &nextmsg)
#define LASTFRAG(msg, count, maxCount) altCheckMsgFrags(msg)
     
#define MSGFREE(mp, status) \
    NdisMSendComplete(nic->handle, mp, NDIS_STATUS_SUCCESS);

#define MSG_SUCCESS NDIS_STATUS_SUCCESS
/* XXX this needs fixed
CAN NOT pass anything other than NDIS_STATUS_SUCCESS to
NdisSendComplete. NT throughs a blue screen if you do that
*/
#define MSG_FAILURE NDIS_STATUS_SUCCESS 

#define INFOP_SPKT pkt
#define INFOP_RPKT rpkt
/* structure for keeping track of dma info for MSG chain, write side */
struct alt_dma_info {
#if ALT_DESERIALIZE
    SINGLE_LIST_ENTRY slistNext;
    struct alt_dma_info *next;
#endif /* ALT_DESERIALIZE */
    caddr_t dataAddr;
    u_int dataLen;		/* for split dma */
    NDIS_HANDLE handle;	     /* provided during call to Miniportinitialize() */
    DMA_ADDR_TYPE dataAddrDmaAddr; /* post word swap addr */
    DMA_ADDR_TYPE dataAddrPhys;	/* pre-word swap addr */
    ALT_MSG *msg;
    ALT_MSG *fly_msg;
    SEND_PKT *pkt;
    RECV_PKT *rpkt;
    U32 index;
    U32 lastIndex;
    int flags;
    caddr_t dataAddrFly;	/* on the fly buffer addr */
    DMA_ADDR_TYPE dataAddrFlyDmaAddr; /*  on the fly phys buffer addr */
};

#define ALT_DMA_INFO_FLAG_CONT 1 /* when MSG data receives two DMA cookies */
#define ALT_DMA_INFO_PREALLOC  2 /* preallocated buffer */
#define ALT_DMA_JUMBO          4 /* for preallocated jumbo frames */
#define ALT_DMA_INFO_FLAG_END  8 /* same as in BD, indicate end of packet */
#if USE_MINI_RING
#define ALT_DMA_MINI           0x10 /* for preallocated jumbo frames */
#endif /* USE_MINI_RING */

/* constants for handling the receive ring low on resources case */
#define ALT_RECV_LOW_LOW        64  /* send back NDIS_STATUS_RESOURCES here */
#define ALT_RECV_JUMBO_LOW_LOW  32  /* send back NDIS_STATUS_RESOURCES here */
#if USE_MINI_RING
#define ALT_RECV_MINI_LOW_LOW   128 /* send back NDIS_STATUS_RESOURCES here */
#endif /* USE_MINI_RING */

#endif /* _ALTOS_H */
