/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997, 1998 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: Proper.cpp $
 * Revision api_leonid/2 1999/03/27 02:15:27 leonid
 * 	back to nt1_10
 * 
 * Revision 1.1.4.1  1998/09/01  21:22:48  ted
 * 	Get dll from 1.9 release
 * 	[1998/09/01  21:20:16  ted]
 *
 * Revision 1.1.2.1  1998/08/22  21:34:06  ted
 * 	Add jumbo, rx/tx flow control to dlls and put under source control
 * 	[1998/08/22  21:24:38  ted]
 * 
 * $EndLog$
 */

#include "stdafx.h"
#include "param.h"
#include "netcard.h"
#include "Proper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProper dialog


CProper::CProper(CWnd* pParent /*=NULL*/)
    : CDialog(CProper::IDD, pParent)
{
    //{{AFX_DATA_INIT(CProper)
    m_link = FALSE;
    m_jumbo = FALSE;
    m_rx_flow = FALSE;
    m_tx_flow = FALSE;
    //}}AFX_DATA_INIT
}


void CProper::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CProper)
    DDX_Control(pDX, IDC_Link, m_check);
    DDX_Control(pDX, IDC_CARD, m_theCard);
    DDX_Check(pDX, IDC_Link, m_link);
    DDX_Check(pDX, IDC_Jumbo, m_jumbo);
    DDX_Check(pDX, IDC_RX_FLOW, m_rx_flow);
    DDX_Check(pDX, IDC_TX_FLOW, m_tx_flow);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProper, CDialog)
    //{{AFX_MSG_MAP(CProper)
    ON_CBN_SELCHANGE(IDC_CARD, OnSelchangeCard)
    ON_BN_CLICKED(IDC_Link, OnLink)
    ON_BN_CLICKED(IDC_Jumbo, OnJumbo)
    ON_BN_CLICKED(IDC_RX_FLOW, OnRxFlow)
    ON_BN_CLICKED(IDC_TX_FLOW, OnTxFlow)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProper message handlers

BOOL CProper::OnInitDialog() 
{
    CDialog::OnInitDialog();
	
    // TODO: Add extra initialization here
    int i;
    char *pbuf;

    for (i = 0; i < (int)m_Reg.GetNumberofCards(); i++) {
	pbuf = GetTheDisplayString(i);
	m_theCard.AddString(pbuf);
    }
    m_theCard.SetCurSel(0);
    OnSelchangeCard();
    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

void CProper::OnSelchangeCard() 
{
    // TODO: Add your control notification handler code here
    int	theSel;
	
    theSel = m_theCard.GetCurSel();
    m_link = (m_Reg.GetTheCard(theSel)->m_link) ? TRUE : FALSE;
    m_jumbo = (m_Reg.GetTheCard(theSel)->m_jumbo) ? TRUE : FALSE;
    m_rx_flow =  (m_Reg.GetTheCard(theSel)->m_rx_flow) ? TRUE : FALSE;
    m_tx_flow =  (m_Reg.GetTheCard(theSel)->m_tx_flow) ? TRUE : FALSE;
    UpdateData(FALSE);
}

char *CProper::GetTheDisplayString(int inst)
{
    static char buf[256];

    sprintf(buf, "Adapter Instance[%d], bus=%d, slot=%d",
	    m_Reg.GetTheCard(inst)->m_Instance,
	    m_Reg.GetTheCard(inst)->m_BusNumber,
	    m_Reg.GetTheCard(inst)->m_SlotNumber);
    return buf;
}

int CProper::GetTheInstance(char *str)
{
    int i;
    char *p, *p2;

    if (strlen(str) <= 8)
	return -1;
    p = &str[8];
    p2 = strchr(p, ' ');
    if (p2) 
	*p2 = 0;
    i = atoi(p);
    return i;
}

int CProper::FindAskedInstance(int inst)
{
    int i;

    for (i = 0; i < m_Reg.GetNumberofCards(); i++) {
	if ((int)m_Reg.GetTheCard(i)->m_Instance == inst)
	    return i;
    }
    return -1;
}

void CProper::OnOK() 
{
    // TODO: Add extra validation here
    CDialog::OnOK();
    m_Reg.WriteBack();
    m_Reg.WriteDisplayName();
}

void CProper::OnLink() 
{
    // TODO: Add your control notification handler code here
    int cursel = m_theCard.GetCurSel();
    UpdateData(TRUE);
    m_Reg.GetTheCard(cursel)->m_link = m_link;	
	
}

void CProper::OnJumbo() 
{
    // TODO: Add your control notification handler code here
    int cursel = m_theCard.GetCurSel();
    UpdateData(TRUE);
    m_Reg.GetTheCard(cursel)->m_jumbo = m_jumbo;
	
}

void CProper::OnRxFlow() 
{
    // TODO: Add your control notification handler code here
    int cursel = m_theCard.GetCurSel();
    UpdateData(TRUE);
    m_Reg.GetTheCard(cursel)->m_rx_flow = m_rx_flow;
	
}

void CProper::OnTxFlow() 
{
    // TODO: Add your control notification handler code here
    int cursel = m_theCard.GetCurSel();
    UpdateData(TRUE);
    m_Reg.GetTheCard(cursel)->m_tx_flow = m_tx_flow;
	
}
