/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: altos.h,v $
 * Revision 1.1.2.26  1999/02/03  01:05:11  fhwang
 * 	Change SNAP to 19.
 * 	[1999/02/03  01:03:15  fhwang]
 *
 * Revision 1.1.2.25  1999/01/30  02:32:27  fhwang
 * 	add llc support
 * 	[1999/01/30  00:42:59  fhwang]
 * 
 * Revision 1.1.2.24  1998/11/09  19:33:54  ted
 * 	support jumbos on x86 Solaris (test extended recv BD)
 * 	[1998/11/09  19:33:24  ted]
 * 
 * Revision 1.1.2.23  1998/10/15  20:59:55  ted
 * 	Fix ndd array defines
 * 	[1998/10/15  20:58:29  ted]
 * 
 * Revision 1.1.2.22  1998/10/13  03:33:50  ted
 * 	Support Mini ring, compiles on Solaris
 * 	[1998/10/13  03:31:18  ted]
 * 
 * Revision 1.1.2.21  1998/06/08  23:56:37  ted
 * 	Add CONT_LOOP_THRU_PACKET macro
 * 	[1998/06/08  22:49:03  ted]
 * 
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:34:43  ted]
 * 
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:09:03  ted]
 * 
 * Revision 1.1.2.20  1998/04/01  21:25:52  ted
 * 	Solaris driver now handled changed tick default (1ms vs. 100 ms.)
 * 	[1998/04/01  21:25:23  ted]
 * 
 * Revision 1.1.2.19  1998/01/30  03:40:30  ted
 * 	new ndd array names for flow control parms
 * 	[1998/01/30  03:38:33  ted]
 * 
 * Revision 1.1.2.18  1997/12/23  19:49:16  ted
 * 	New macros to support modified non-copydata send code
 * 	[1997/12/23  19:42:56  ted]
 * 
 * Revision 1.1.2.17  1997/11/26  19:18:54  ted
 * 	Fix macros required for non-copydata mode
 * 	[1997/11/26  19:18:18  ted]
 * 
 * Revision 1.1.2.16  1997/10/21  19:42:44  ted
 * 	Fix typo
 * 	[1997/10/21  19:42:35  ted]
 * 
 * Revision 1.1.2.15  1997/10/21  18:00:45  ted
 * 	correct array entry list for param array
 * 	[1997/10/21  18:00:37  ted]
 * 
 * Revision 1.1.2.14  1997/10/21  00:13:31  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:01:20  ted]
 * 
 * Revision 1.1.17.1  1997/10/16  17:32:12  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:28:43  ted]
 * 
 * Revision 1.1.2.13  1997/09/11  18:06:39  ted
 * 	Mixing vlans, jumbos, and redundancy works, plus small fixes from release 1.1 and better NIC tracing
 * 	[1997/09/11  18:01:33  ted]
 * 
 * Revision 1.1.2.12  1997/08/23  18:18:11  ted
 * 	Merged with changes from 1.1.2.11
 * 	[1997/08/23  18:17:53  ted]
 * 
 * 	Changes to support Sun's FAST_DMA
 * 	[1997/08/23  18:06:02  ted]
 * 
 * Revision 1.1.2.11  1997/08/23  17:40:37  skapur
 * 	Solaris jumbogram support
 * 	[1997/08/23  17:39:06  skapur]
 * 
 * Revision 1.1.2.10  1997/07/29  01:13:49  ted
 * 	Merge by hand due to bsubmit core dump, sigh
 * 	[1997/07/29  01:13:11  ted]
 * 
 * Revision 1.1.2.9  1997/07/28  22:40:43  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:40:37  ted]
 * 
 * Revision 1.1.2.8  1997/07/25  22:59:54  ted
 * 	Merge fixes from ge_0_22 and add link negotiation support
 * 	[1997/07/25  22:33:39  ted]
 * 
 * Revision 1.1.8.1  1997/07/11  02:26:02  ted
 * 	add link negotiation support
 * 	[1997/07/11  02:11:55  ted]
 * 
 * Revision 1.1.2.7  1997/06/03  18:55:18  ted
 * 	Changes to support Sun naming of drivers (vge vs. alt)
 * 	[1997/06/03  18:54:22  ted]
 * 
 * Revision 1.1.2.6  1997/05/03  05:00:36  ted
 * 	Fix up statistics
 * 	[1997/05/03  04:57:07  ted]
 * 
 * Revision 1.1.2.5  1997/04/12  00:11:54  ted
 * 	Merged Sbus code, some performance enhancements
 * 	[1997/04/12  00:08:20  ted]
 * 
 * Revision 1.1.2.4  1997/04/04  22:38:35  ted
 * 	Change data structure to support overflow ring.
 * 	[1997/04/04  22:16:53  ted]
 * 
 * Revision 1.1.2.3  1997/03/28  01:41:16  ted
 * 	Major merge of NDIS and ODI with mainstream Unix ports
 * 	[1997/03/28  01:38:20  ted]
 * 
 * Revision 1.1.2.2  1997/02/12  00:28:10  ted
 * 	Implement ndd support using code borrowed from Sun
 * 	[1997/02/12  00:27:46  ted]
 * 
 * Revision 1.1.2.1  1997/02/07  21:58:38  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:50:18  ted]
 * 
 * $EndLog$
 */
/*
 * FILE altos.h
 *
 * $Source: /projects/rcs/sw/ge/./nic/host/unix/streams/SunOS/altos.h,v $
 * $Revision: 1.1.2.26 $ $Locker:  $
 * $Date: 1999/02/03 01:05:11 $ $Author: fhwang $ $State: Exp $
 */

#ifndef _ALTOS_H
#define _ALTOS_H

/* generify the messaging between streams and BSD(mbufs) */
#define SEND_PKT mblk_t
#define RECV_PKT SEND_PKT
#define ALT_MSG mblk_t
#define ALT_MSG_DATA_TYPE caddr_t
#define LOOP_THRU_PACKET(pkt, msg, count, maxCount) while (msg)
#define CONT_LOOP_THRU_PACKET LOOP_THRU_PACKET
#define SENDPKT2MSG(pkt, msg) msg = pkt
#define RECVPKT2MSG SENDPKT2MSG
#define MSGINFO(msg, addr, len, type)		\
{						\
    len = (msg)->b_wptr - (msg)->b_rptr;	\
    addr = (type)(msg)->b_rptr;			\
}
#define MSGNEXT(msg) msg = (msg)->b_cont

/* on Solaris I've never seen more than one 0 length msg in a row */
#define LASTFRAG(msg, count, maxCount)					\
    ((msg)->b_cont == 0 ||						\
     (((msg)->b_cont)->b_cont == 0 &&					\
      (((msg)->b_cont)->b_wptr - ((msg)->b_cont)->b_rptr) == 0))

#define HAVE_MSGHDR 0
#define MSGFREE(msg, status) freemsg(msg)
#define APPEND_MSG_NEXT(msgStart, msg)		\
{						\
    mblk_t *msgNext, *curMsg = msgStart;	\
						\
    while (msgNext = curMsg->b_cont)		\
	curMsg = msgNext;			\
    curMsg->b_cont = msg;			\
}

#define INFOP_SPKT pkt
#define INFOP_RPKT pkt
/* structure for keeping track of dma info for MSG chain, write side */
struct alt_dma_info {
    struct alt_dma_info *next;
    caddr_t dataAddr;
    U16 dataLen;		/* for split dma */
    ddi_dma_handle_t handle;
    ddi_acc_handle_t accHandle;
    DMA_ADDR_TYPE dataAddrDmaAddr;
    int index;
    int lastIndex;		/* sometimes used in FAST_DMA case for slow */
    SEND_PKT *pkt;		/* same */
    int flags;
    struct tg_nic *nic;		/* so we can figure out where we are */
    frtn_t freeRtn;		/* free routine, with self pointer */
    ddi_dma_handle_t handleFly;	/* on the fly dma handle for unprep */
    caddr_t dataAddrFly;	/* on the fly for send hybrid */
    DMA_ADDR_TYPE dataAddrFlyDmaAddr; /* phys addr for above */
#if !defined(__sparc)
    DMA_ADDR_TYPE extDataAddr1DmaAddr;
    DMA_ADDR_TYPE extDataAddr2DmaAddr;
    DMA_ADDR_TYPE extDataAddr3DmaAddr;
    U16 extDataLen[3];
#endif /* !defined(__sparc) */
};

#define ALT_DMA_INFO_FLAG_CONT 1 /* when MSG data receives two DMA cookies */
#define ALT_DMA_INFO_PREALLOC  2 /* preallocated buffer */
#define ALT_DMA_JUMBO          4 /* for preallocated jumbo frames */
#define ALT_DMA_INFO_FLAG_END  8 /* same as in BD, indicate end of packet */
#if USE_MINI_RING
#define ALT_DMA_MINI           0x10 /* for preallocated jumbo frames */
#endif /* USE_MINI_RING */
#if !defined(__sparc)
#define ALT_DMA_INFO_EXT_BD    0x20 /* use extended recv bd for jumbos */
#endif /* !defined(__sparc) */

/* constants for handling the receive ring overflow case */
#define ALT_RECV_LOW_LOW      64  /* add when we get here */
#define ALT_RECV_LOW_HIGH     128 /* until we get here */

/* structure for initialization of tuning parms */
struct alt_param {
    U32 parm_min;
    U32 parm_max;
    U32 parm_val;
    char *parm_name;
    int (*get_func)(queue_t *, mblk_t *, caddr_t);
    int (*set_func)(queue_t *, mblk_t *, char *, caddr_t);
    struct altinst *altp;
};

/* array entries for param array */
#define STAT_TICKS     0
#define SEND_BDS       1
#define SEND_TICKS     2
#define RECV_BDS       3
#define RECV_TICKS     4
#define NIC_TRACE      5
#define LINK_NEGOTIATE 6
#define DUMP_NIC       7
#define JUMBO          8
#define VLAN_STATE     9
#define VLAN_TAG       10
#define VLAN_TAG_ID    11
#define REDUND         12
#define REDUND_VAL     13
#define FDR_FILTERING  14
#define RX_FLOW_CTL    15
#define TX_FLOW_CTL    16
#define HYBRID_LENGTH  17
#define SHARED_RUPT    18
#define SNAP           19
#define ND_INSTANCE    20
#define NUM_TUNE_PARMS 21

#endif /* _ALTOS_H */
