/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: altstr.h,v $
 * Revision 1.1.4.5  1997/09/11  18:06:42  ted
 * 	Mixing vlans, jumbos, and redundancy works, plus small fixes from release 1.1 and better NIC tracing
 * 	[1997/09/11  18:01:43  ted]
 *
 * Revision 1.1.4.4  1997/07/28  22:40:46  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:40:47  ted]
 * 
 * Revision 1.1.4.3  1997/02/22  00:20:55  ted
 * 	Make debugger a special stream that doesn't effect the HostState down call
 * 	[1997/02/22  00:12:18  ted]
 * 
 * Revision 1.1.4.2  1997/02/15  04:41:23  ted
 * 	Generify lock
 * 	[1997/02/15  04:37:49  ted]
 * 
 * Revision 1.1.4.1  1997/02/07  21:58:41  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:50:30  ted]
 * 
 * Revision 1.1.2.1  1996/11/01  18:25:45  ted
 * 	change rr_ to tg_ and put in proper copyright
 * 	[1996/10/30  23:04:20  ted]
 * 
 * $EndLog$
 */
/*
 * FILE altstr.h
 *
 * $Source: /projects/rcs/sw/ge/./nic/host/unix/streams/common/altstr.h,v $
 * $Revision: 1.1.4.5 $ $Locker:  $
 * $Date: 1997/09/11 18:06:42 $ $Author: ted $ $State: Exp $
 */

#ifndef _ALTSTR_H_
#define _ALTSTR_H_

extern struct altstr *altstrup;	/* per stream struct list */
extern krwlock_t altstruplock;

/* struct to hold all the data about an Acteon driver stream */
struct altstr {
    struct altstr *sl_nextp;	/* next in list */
    queue_t *sl_rq;		/* pointer to our rq */
    queue_t *sl_wq;		/* pointer to our wq */
    ulong sl_instance;		/* match dl_ppa */
    struct altinst *sl_altp;	/* attached device */
    u_long sl_state;		/* current DL state */
    u_long sl_sap;		/* bound sap */
    u_long sl_flags;		/* misc. flags */
    u_int sl_mccount;		/* # enabled multicast addrs */
    struct ether_addr sl_mctab[MAX_MCAST_ENTRIES]; 
				/* table of multicast addrs */
    u_long sl_minor;		/* minor device number */
#if ALT_LOCKS_SUPPORTED
    LOCK_TYPE sl_lock;		/* protect this structure */
#endif /* ALT_LOCKS_SUPPORTED */
};

/* per-stream flags */
#define	SLFAST		0x01	/* "M_DATA fastpath" mode */
#define	SLRAW		0x02	/* M_DATA plain raw mode */
#define	SLALLPHYS	0x04	/* "promiscuous mode" */
#define	SLALLMULTI	0x08	/* enable all multicast addresses */
#define	SLALLSAP	0x10	/* enable all ether type values */
#define SLDEBUG         0x20	/* debugger stream */

#endif /* _ALTSTR_H_ */

