/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: alttb.c,v $
 * Revision 1.7.5.14  1998/06/08  23:56:56  ted
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:35:01  ted]
 *
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:09:21  ted]
 *
 * Revision 1.7.5.13  1997/07/28  22:41:05  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:41:32  ted]
 * 
 * Revision 1.7.5.12  1997/06/23  23:34:16  suresh
 * 	fix compile errors for the AIX case
 * 	[1997/06/23  23:33:33  suresh]
 * 
 * Revision 1.7.5.11  1997/06/03  18:55:23  ted
 * 	Changes to support Sun naming of drivers (vge vs. alt)
 * 	[1997/06/03  18:54:36  ted]
 * 
 * Revision 1.7.5.10  1997/05/06  00:07:52  suresh
 * 	AIX: change default dev to /dev/ent1 from /dev/alt0
 * 	[1997/05/06  00:03:37  suresh]
 * 
 * Revision 1.7.5.9  1997/03/19  18:41:54  suresh
 * 	fix compile errors
 * 	[1997/03/19  18:41:40  suresh]
 * 
 * Revision 1.7.5.8  1997/03/19  04:57:32  suresh
 * 	AIX changes for xlc compiler support
 * 	[1997/03/19  04:51:31  suresh]
 * 
 * Revision 1.7.5.7  1997/03/04  22:14:30  ted
 * 	Forgot to byte swap the first non-name column
 * 	[1997/03/04  22:14:17  ted]
 * 
 * Revision 1.7.5.6  1997/03/03  05:17:25  ted
 * 	endian fixes, non-copydata mode fixes
 * 	[1997/03/03  05:16:52  ted]
 * 
 * Revision 1.7.5.5  1997/02/21  19:09:42  suresh
 * 	include file changes to compile on AIX
 * 	[1997/02/21  19:09:05  suresh]
 * 
 * Revision 1.7.5.4  1997/02/15  04:41:29  ted
 * 	Add ability to clear the snap trace
 * 	Tidy up the printing in error cases
 * 	[1997/02/15  04:39:35  ted]
 * 
 * Revision 1.7.5.3  1997/02/11  00:02:30  ted
 * 	Finish merging
 * 	[1997/02/11  00:02:09  ted]
 * 
 * Revision 1.7.5.2  1997/02/10  22:11:09  suresh
 * 	Merged with changes from 1.7.5.1
 * 	[1997/02/10  22:10:58  suresh]
 * 
 * 	added multiple adapter support for completeness
 * 	[1997/02/10  22:07:29  suresh]
 * 
 * Revision 1.7.5.1  1997/02/07  21:58:54  ted
 * 	     Updates for AIX/NT/new Solaris options (fast DMA)
 * 	     [1997/02/07  21:51:02  ted]
 * 
 * Revision 1.7.5.1  1997/02/07  21:58:54  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:51:02  ted]
 * 
 * Revision 1.7.2.2  1996/11/09  02:32:21  ted
 * 	clean up compiler warnings
 * 	[1996/11/09  02:31:13  ted]
 * 
 * Revision 1.7.2.1  1996/11/01  18:26:03  ted
 * 	changed rr_ to tg_ and put in proper copyrights
 * 	[1996/10/30  23:08:09  ted]
 * 
 * $EndLog$
 */
/*
 * FILE alttb.c
 *
 * COPYRIGHT (c) Essential Communication Corp. 1995
 * $Source: /projects/rcs/sw/ge/./nic/host/unix/utils/common/alttb.c,v $
 * $Revision: 1.7.5.14 $ $Locker:  $
 * $Date: 1998/06/08 23:56:56 $ $Author: ted $ $State: Exp $
 */
 
#ifndef __lint
static const char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/unix/utils/common/alttb.c,v 1.7.5.14 1998/06/08 23:56:56 ted Exp $";
#endif /* __lint */

#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/byteorder.h>
#include <errno.h>
#include <time.h>
int gethostname(char *name, int namelen);

/* streams specific include files */
#if defined(ALT_STREAM)
#include <sys/stream.h>
#endif /* defined(ALT_STREAM) */

/* system specific files */
#if defined(__sun)
#include <sys/ioccom.h>
typedef void *ddi_acc_handle_t; /* to keep prototypes from bitching */
#include <sys/dditypes.h>
#include <sys/ethernet.h>
#endif /* defined(__sun) */

#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#include "altioctl.h"
#include "altftns.h"

static void PrintTable(u_long *, bool, int, int);
static void usage(char *);

/* Stuff for getopt()   */
extern char *   optarg;
extern int      optint, opterr;

/* location for the current trace */
static u_long traceBuf[ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE];

#if defined(ALT_STREAM)
#define ALTDEV "/dev/alt"
#define OPTARGS "csn:d:"
#else /* defined(ALT_STREAM) */
#define ALTDEV "/dev/alt0"
#define OPTARGS "csn:"
#endif /* defined(ALT_STREAM) */

int
main(int argc, char *argv[])
{
    int fd;
    int rc;
    u_long *tbp = traceBuf;
    char s[80];
    int c;
#if defined(ALT_STREAM)
    int instance =0;
#endif /* defined(ALT_STREAM) */
    char altName[80] = ALTDEV;
    int snapTrace = 0; 
    int nicTrace = -1;
    int clearSnap = 0;
    int errs = 0;

    opterr = 0 ;  /* keep getopt quiet */
    /*
     * Handle command line args 
     */
    while ((c = getopt(argc, argv, OPTARGS)) != EOF) {
	switch (c) {
	case 'c':
	    clearSnap++;
	    break;
	case 's': 
	    snapTrace++;
	    break;

	case 'n': 
#if defined(ALT_STREAM)
	    instance = atoi(optarg);
	    nicTrace = instance;
#else  /* defined(ALT_STREAM) */
	    nicTrace = 0;
            if (strlen(optarg) > 80)
                errs++;
            else
                strcpy(altName, optarg);
#endif /* defined(ALT_STREAM) */
	    break;

#if defined(ALT_STREAM)
	case 'd': 
	    if (strlen(optarg) > 80)
		errs++;
	    else
		strcpy(altName, optarg);
	    break;
#endif /* defined(ALT_STREAM) */

	default:
	    errs++;
	    break;
	}
    }

    if (errs || (snapTrace && (nicTrace != -1))) {
	usage(argv[0]);
	exit(1);
    }

    fd = open(altName, O_RDWR);
    if (fd < 0) {
	(void) sprintf(s, "open failed %s", altName);
	perror(s);
	exit(1);
    }

#if defined(ALT_STREAM)
    if (nicTrace != -1)
	/* for streams we've got to specify which hardware device */
	if (ioctl(fd, ALT_ATTACH, instance) < 0) {
	    perror("ioctl ALT_ATTACH failed");
	    exit(1);
	}
#endif /* defined(ALT_STREAM) */

    if (snapTrace) {
	rc = ioctl(fd, ALT_GETSTRACE, tbp);
	if (rc < 0) {
	    if (errno == ENOENT)
		(void) printf("No snap trace available\n");
	    else
		perror("ALT_GETSTRACE ioctl failed");
	    exit(1);
	}
	(void) printf("tbp %lx %lx traceBuf %lx len %d\n", (u_long)tbp, 
		      (u_long)&tbp, (u_long)traceBuf, 
		      ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE);
    } else if (nicTrace != -1) {
	(void) printf("tbp %lx %lx traceBuf %lx len %d\n", (u_long)tbp, 
		      (u_long)&tbp, (u_long)traceBuf, 
		      ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE);
	rc = ioctl(fd, ALT_GETNTRACE, tbp);
	if (rc < 0) {
	    perror("ALT_GETNTRACE ioctl failed");
	    exit(1);
	}
    } else if (clearSnap) {
	rc = ioctl(fd, ALT_CLRSTRACE);
	if (rc < 0) {
	    perror("ALT_CLRSTRACE ioctl failed");
	    exit(1);
	}
    } else {
	(void) printf("tbp %lx %lx traceBuf %lx len %d\n", (u_long)tbp, 
		      (u_long)&tbp, (u_long)traceBuf, 
		      ALT_TRACE_SIZE*ALT_TRACE_ELEM_SIZE);
	rc = ioctl(fd, ALT_GETTRACE, tbp);
	if (rc < 0) {
	    perror("ALT_GETTRACE ioctl failed");
	    exit(1);
	}
    }
    if (!clearSnap)
	PrintTable(traceBuf, (nicTrace != -1) ? TRUE : FALSE, 
		   nicTrace, snapTrace);
    rc = close(fd);
    if (rc < 0) {
	perror("close failed");
	exit(1);
    }
    exit(0);
    return(0);
}

static void
usage(char *str)
{
    (void) printf("%s\n", str);
#if defined(ALT_STREAM)
    (void) printf("usage : alttb [-s] [-c] [-n<instance>] [-d <device_name>]\n");
#else /* defined(ALT_STREAM) */
    (void) printf("usage : alttb [-s] [-c] [-n device]\n");
#endif /* defined(ALT_STREAM) */
    exit(1);
}

static void
PrintTable(u_long *tbp, bool swap, int nicTrace, int snapTrace)
{
    int i, len;
    u_long ltmp;
    char *cpi;
    int size = (nicTrace != -1) ? ALT_NTRACE_SIZE : ALT_TRACE_SIZE;
    char hostname[256];
    time_t timenow;
    
    (void) gethostname(hostname, sizeof(hostname));
    (void) time(&timenow);
    if (nicTrace != -1)
        (void) printf("Alteon NIC %d trace buffer on `%s' at %s",
                      nicTrace, hostname, ctime(&timenow));
    else if (snapTrace)
        (void) printf("Alteon snap trace buffer on `%s' at %s",
                      hostname, ctime(&timenow));
    else
        (void) printf("Alteon host trace buffer on `%s' at %s",
                      hostname, ctime(&timenow));
    for (i=0; i < size; i++) {
	/* early break when we get done with buffer */
	if (*tbp == 0)
	    break;
	cpi = (char *)tbp;
	len = 6 * sizeof(long);

	(void) printf("%8.8s ", (char *)tbp);

	tbp += 2;
	ltmp = *tbp++;
	if (swap) 
	    (void) printf("%8.8lx ", ntohl(ltmp));
	else
	    (void) printf("%8.8lx ", ltmp);
	ltmp = *tbp++;
#if 1  /* figure this out later XXX (sizeof u_long == 32) */
	if (swap) {
	    (void) printf("%8.8lx ", ntohl(ltmp));
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ntohl(ltmp));
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ntohl(ltmp));
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ntohl(ltmp));
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ntohl(ltmp));
	} else {
	    (void) printf("%8.8lx ", ltmp);
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ltmp);
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ltmp);
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ltmp);
	    ltmp = *tbp++;
	    (void) printf("%8.8lx ", ltmp);
	}
#else /* sizeof(u_long) == 32 */
	if (ltmp & 0xffffffff00000000L)
	    (void) printf("%16.16lx ", ltmp);
	else
	    (void) printf("%8.8lx ", ltmp);
	ltmp = *tbp++;
	if (ltmp & 0xffffffff00000000L)
	    (void) printf("%16.16lx ", ltmp);
	else
	    (void) printf("%8.8lx ", ltmp);
	ltmp = *tbp++;
	if (ltmp & 0xffffffff00000000L)
	    (void) printf("%16.16lx ", ltmp);
	else
	    (void) printf("%8.8lx ", ltmp);
	ltmp = *tbp++;
	if (ltmp & 0xffffffff00000000L)
	    (void) printf("%16.16lx ", ltmp);
	else
	    (void) printf("%8.8lx ", ltmp);
	ltmp = *tbp++;
	if (ltmp & 0xffffffff00000000L)
	    (void) printf("%16.16lx ", ltmp);
	else
	    (void) printf("%8.8lx ", ltmp);
#endif	/* sizeof(u_long) == 32 */
	(void) printf("\n");
    }
}
