/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: alttune.c,v $
 * Revision 1.3.4.18  1998/06/08  23:56:57  ted
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:35:03  ted]
 *
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:09:23  ted]
 *
 * Revision 1.3.4.17  1997/10/21  00:13:41  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:01:58  ted]
 * 
 * Revision 1.3.16.1  1997/10/16  17:32:28  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:29:06  ted]
 * 
 * Revision 1.3.4.16  1997/08/23  17:40:49  skapur
 * 	Solaris jumbogram support
 * 	[1997/08/23  17:39:33  skapur]
 * 
 * Revision 1.3.4.15  1997/07/29  01:13:59  ted
 * 	Merge by hand due to bsubmit core dump, sigh
 * 	[1997/07/29  01:13:32  ted]
 * 
 * Revision 1.3.4.14  1997/07/28  22:41:08  ted
 * 	Solaris dual homing support
 * 	[1997/07/28  21:41:37  ted]
 * 
 * Revision 1.3.4.13  1997/07/25  23:00:16  ted
 * 	Merge fixes from ge_0_22 and add link negotiation support
 * 	[1997/07/25  22:34:20  ted]
 * 
 * Revision 1.3.4.12  1997/06/24  17:03:55  suresh
 * 	fix compile errors introduced by newly added device name handling for Solaris
 * 	[1997/06/24  17:03:35  suresh]
 * 
 * Revision 1.3.4.11  1997/06/03  18:55:24  ted
 * 	Changes to support Sun naming of drivers (vge vs. alt)
 * 	[1997/06/03  18:54:39  ted]
 * 
 * Revision 1.3.4.10  1997/05/21  03:36:28  ted
 * 	Use pub_tg.h
 * 	[1997/05/21  03:32:38  ted]
 * 
 * Revision 1.3.4.9  1997/05/06  00:07:56  suresh
 * 	Merged with changes from 1.3.4.8
 * 	[1997/05/06  00:07:44  suresh]
 * 
 * 	AIX: change default dev to /dev/ent1 from /dev/alt0
 * 	[1997/05/06  00:03:41  suresh]
 * 
 * Revision 1.3.4.8  1997/05/03  05:00:44  ted
 * 	Fix up statistics
 * 	[1997/05/03  04:57:25  ted]
 * 
 * Revision 1.3.4.7  1997/03/19  18:55:39  suresh
 * 	fix compile errors
 * 	[1997/03/19  18:55:27  suresh]
 * 
 * Revision 1.3.4.6  1997/03/19  04:57:33  suresh
 * 	include AIX specific header files
 * 	[1997/03/19  04:29:30  suresh]
 * 
 * Revision 1.3.4.5  1997/03/04  03:21:53  suresh
 * 	no sys/fcntl.h in AIX, ifdef it
 * 	[1997/03/04  03:21:40  suresh]
 * 
 * Revision 1.3.4.4  1997/02/13  21:56:33  suresh
 * 	Minor problem with previous change to prevent coredumps for 0 values
 * 	on stat ticks. If the user enters a value of 0, it does not get stored into
 * 	tgp->stat_ticks as 0 but previous non-zero value was being retained. This
 * 	change corrects it..
 * 	[1997/02/13  21:56:13  suresh]
 * 
 * Revision 1.3.4.3  1997/02/11  04:08:21  ted
 * 	Merged with changes from 1.3.4.2
 * 	[1997/02/11  04:07:54  ted]
 * 
 * 	protect against core dumps for 0 values on rupt ticks and stat ticks
 * 	[1997/02/11  04:06:51  ted]
 * 
 * Revision 1.3.4.2  1997/02/10  22:11:08  suresh
 * 	added multiple adapter support for completeness
 * 	[1997/02/10  22:07:43  suresh]
 * 
 * Revision 1.3.4.1  1997/02/07  21:58:55  ted
 * 	Updates for AIX/NT/new Solaris options (fast DMA)
 * 	[1997/02/07  21:51:06  ted]
 * 
 * Revision 1.3.2.3  1996/11/20  20:04:57  ted
 * 	Redo include file structuring.
 * 	[1996/11/20  19:59:27  ted]
 * 
 * Revision 1.3.2.2  1996/11/09  02:32:22  ted
 * 	clean up compiler warnings
 * 	[1996/11/09  02:31:25  ted]
 * 
 * Revision 1.3.2.1  1996/11/01  18:26:04  ted
 * 	changed rr_ to tg_ and put in proper copyrights
 * 	[1996/10/30  23:08:12  ted]
 * 
 * $EndLog$
 */
/*
 * FILE alttune.c
 *
 * $Source: /projects/rcs/sw/ge/./nic/host/unix/utils/common/alttune.c,v $
 * $Revision: 1.3.4.18 $ $Locker:  $
 * $Date: 1998/06/08 23:56:57 $ $Author: ted $ $State: Exp $
 */
 
#ifndef __lint
static const char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/unix/utils/common/alttune.c,v 1.3.4.18 1998/06/08 23:56:57 ted Exp $";
#endif /* __lint */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/errno.h>

/* streams specific include files */
#if defined(ALT_STREAM)
#include <sys/stream.h>
#endif /* defined(ALT_STREAM) */

/* system specific files */
#if defined(__sun)
#include <sys/ioccom.h>
typedef void *ddi_acc_handle_t; /* to keep prototypes from bitching */
#include <sys/dditypes.h>
#include <sys/ethernet.h>
#endif /* defined(__sun) */

#include "alttypes.h"
#include "nic_conf.h"
#include "nic_api.h"
#include "altftns.h"
#if defined(ALT_STREAM)
#include "altstr.h"
#endif /* defined(ALT_STREAM) */
#include "altioctl.h"
#include "pub_tg.h"


#if defined(ALT_STREAM)
#define ALTDEV "/dev/alt"
#define usage "%s [-D|-c] [-d <device_name>] <instance>\n"
#define OPTARGS "Dcd:"
#else /* defined(ALT_STREAM) */
#define ALTDEV "/dev/alt0"
#define usage "%s [-D|-c] [<devicename>]\n"
#define OPTARGS "Dc"
#endif /* defined(ALT_STREAM) */


/* forwards */
static void TuneIt(struct tg_tune *);
static void TuneDma(int);
static void getline(char *);

int
main(int argc, char **argv)
{
    int fd;
    int rc;
#if defined(ALT_STREAM)
    int instance = 0 ;
#endif /* defined(ALT_STREAM) */
    char altName[80] = ALTDEV ;
    struct tg_tune parms, *parmp;
    int configDma = 0;
    int clearProf = 0;
    char errstr[80];
    int c;
    int errs = 0;

    /*
     * Handle command line args 
     */
    opterr = 0 ;  /* keep getopt quiet */
    /*
     * Handle command line args 
     */
    while ((c = getopt(argc, argv, OPTARGS)) != EOF) {
	switch (c) {
	case 'c':
	    clearProf++;
	    break;
	case 'D': 
	    configDma++;
	    break;

#if defined(ALT_STREAM)
	case 'd': 
	    if (strlen(optarg) > 80)
		errs++;
	    else
		strcpy(altName, optarg);
	    break;
#endif /* defined(ALT_STREAM) */

	default:
	    errs++;
	    break;
	}
    }

    if (errs) {
	(void) printf(usage, argv[0]);
	exit(1);
    }


    if (argc == optind+1) {
#if defined(ALT_STREAM) 
	/* get the instance number */
	instance = atoi(argv[optind]);
#else  /* defined(ALT_STREAM) */
	/* get the device name */
	strcpy(altName, argv[optind]);
#endif /* defined(ALT_STREAM) */
    }

    fd = open(altName, O_RDWR);
    if (fd < 0) {
	sprintf(errstr, "open failed for device %s", altName);
	perror(errstr);
	exit(1);
    }

#if defined(ALT_STREAM)
    /* for streams we've got to specify which hardware device */
    rc = ioctl(fd, ALT_ATTACH, instance);
    if (rc < 0) {
	perror("ioctl ALT_ATTACH failed");
	exit(1);
    }
#endif /* defined(ALT_STREAM) */

    if (configDma)
	TuneDma(fd);
    else if (clearProf) {
	if (ioctl(fd, ALT_CLEAR_PROFILE) < 0) {
	    perror("couldn't do ALT_CLEAR_PROFILE");
	    exit(1);
	}
    } else {
	/* read out the parms */
	parmp = &parms;
	rc = ioctl(fd, ALT_GET_TUNEPARMS, parmp);
	if (rc < 0) {
	    perror("ioctl ALT_GET_TUNEPARMS failed");
	    exit(1);
	}
	
	/* set the parms, interactively */
	TuneIt(parmp);
	
	/* put back the parms */
	rc = ioctl(fd, ALT_SET_TUNEPARMS, parmp);
	if (rc < 0) {
	    perror("ioctl ALT_SET_TUNEPARMS failed");
	    exit(1);
	}
    }

    rc = close(fd);
    if (rc < 0) {
	perror("close failed");
	exit(1);
    }

    return(0);
}

static void
TuneIt(struct tg_tune *tgp)
{
    S32 tmp = -1;
    char string[80];
    char *str2;

    /* if the tg_tune structure changes, so does this code !!! */
    (void) printf("Tuning parameters:\n");
    (void) fflush(stdin);

    tmp = -1;
    while (tmp < 0 || tmp > 1000) {
	(void) printf("   statistics frequency in times per second [0-1000](%ld): ",
		      tgp->stat_ticks ? 
		      TG_TICKS_PER_SEC / tgp->stat_ticks : 0);
	getline(string);
	if (string[0] == '\n') {
	    if (tgp->stat_ticks)
		tmp = TG_TICKS_PER_SEC / tgp->stat_ticks;
	    else
		tmp = 0;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    if (tmp)
	tgp->stat_ticks = TG_TICKS_PER_SEC / tmp;
    else
	tgp->stat_ticks = 0;

    tmp = -1;
    while (tmp < 0 || tmp > SEND_RING_ENTRIES) {
	(void) printf("   max coallesce count for send bds [0-%d](%ld): ",
		      SEND_RING_ENTRIES, tgp->send_max_coalesced_bds);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->send_max_coalesced_bds;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    tgp->send_max_coalesced_bds = tmp;

    tmp = -1;
    while (tmp < 0 || tmp > RECV_RETURN_RING_ENTRIES) {
	(void) printf("   max coallesce count for recv bds [0-%d](%ld): ",
		      RECV_RETURN_RING_ENTRIES, tgp->recv_max_coalesced_bds);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->recv_max_coalesced_bds;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    tgp->recv_max_coalesced_bds = tmp;

#if 0
    tmp = -1;
    while (tmp < 0 || tmp > EVENT_RING_ENTRIES) {
	(void) printf("   max number of events queued prior to rupt [0-%d](%ld): ",
		      EVENT_RING_ENTRIES, tgp->event_threshold);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->event_threshold;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    tgp->event_threshold = tmp;
#endif /* 0 */

    tmp = -1;
    while (tmp < 0 || tmp > 0x3fffffff) {
	(void) printf("   tracing level [0-0x3fffffff](0x%lx): ", 
		      tgp->tracing);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->tracing;
	    break;
	} else {
	    tmp = strtoul(string, &str2, 0);
	    /* if it failed str2 will point to string, set tmp to -1 to loop */
	    if (str2 == string)
		tmp = -1;
	}
    }
    tgp->tracing = tmp;

    tmp = -1;
    while (tmp < 0 || tmp > 1000) {
	(void) printf("   send coalescing frequency in times per second [0-1000](%ld): ",
		      tgp->send_coal_ticks ? 
		      TG_TICKS_PER_SEC / tgp->send_coal_ticks : 0);
	getline(string);
	if (string[0] == '\n') {
	    if (tgp->send_coal_ticks)
		tmp = TG_TICKS_PER_SEC / tgp->send_coal_ticks;
	    else
		tmp = 0;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    if (tmp)
	tgp->send_coal_ticks = TG_TICKS_PER_SEC / tmp;
    else
	tgp->send_coal_ticks = 0;

#define LINK_NEGOTIATE 0x614c0000
#define NO_NEGOTIATE   0x414c0000
    tmp = -1;
    while (tmp != LINK_NEGOTIATE && tmp != NO_NEGOTIATE) {
	(void) printf("   link negotiation [0x%x or 0x%x](0x%lx): ", 
		      LINK_NEGOTIATE, NO_NEGOTIATE, tgp->link_negotiation);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->link_negotiation;
	    break;
	} else {
	    tmp = strtoul(string, &str2, 0);
	    /* if it failed str2 will point to string, set tmp to -1 to loop */
	    if (str2 == string)
		tmp = -1;
	}
    }
    tgp->link_negotiation = tmp;

#if 0
    tmp = -1;
    while (tmp < 0 || tmp > 10000000) {
	(void) printf("   replication count on transmit [0-10000000](%ld): ",
		      tgp->tx_replicate_count);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->tx_replicate_count;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    tgp->tx_replicate_count = tmp;

    tmp = -1;
    while (tmp == -1) {
	(void) printf("   replication pause time on transmit [anything](%ld): ",
		      tgp->tx_replicate_pause);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->tx_replicate_pause;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    tgp->tx_replicate_pause = tmp;
    
    tmp = -1;
    while (tmp < 1 || tmp > 16) {
	(void) printf("   number of frame to replicate [1-16](%ld): ",
		      tgp->tx_replicate_depth);
	getline(string);
	if (string[0] == '\n') {
	    tmp = tgp->tx_replicate_depth;
	    break;
	} else
	    sscanf(string, "%ld", &tmp);
    }
    tgp->tx_replicate_depth = tmp;
#endif /* 0 */
}

static int maxwritevals[8] = {0, 4, 16, 32, 64, 128, 256, 1024};
static int maxreadvals[8] = {0, 4, 16, 32, 64, 128, 256, 1024};

static void
TuneDma(int fd)
{
    bool ok;
    char string[80];
    int writeVal = 0, readVal = 0, curWriteVal, curReadVal;
    struct tg_reg writeData, readData;

    readData.addr = TG_PCI_STATE;
    if (ioctl(fd, ALT_READ_TG_REG, &readData) < 0) {
	perror("couldn't do ALT_READ_TG_REG");
	exit(1);
    }
    curWriteVal = maxwritevals[(readData.data & TG_PCI_STATE_DMA_WRITE_MASK) >>
			       TG_PCI_STATE_DMA_WRITE_SHIFT];
    curReadVal = maxreadvals[(readData.data & TG_PCI_STATE_DMA_READ_MASK) >>
			      TG_PCI_STATE_DMA_READ_SHIFT];

    /* ask what values we want */
    ok = FALSE;
    while (!ok) {
	(void) printf("Max write DMA value (0, 4, 16, 32, 64, 128, 256, 1024)(%d): ", 
		      curWriteVal);
	getline(string);
	switch(atoi(string)) {
	  case 0:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_DISA;
	    ok = TRUE;
	    break;

	  case 4:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_4;
	    ok = TRUE;
	    break;

	  case 16:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_16;
	    ok = TRUE;
	    break;

	  case 32:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_32;
	    ok = TRUE;
	    break;

	  case 64:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_64;
	    ok = TRUE;
	    break;

	  case 128:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_128;
	    ok = TRUE;
	    break;

	  case 256:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_256;
	    ok = TRUE;
	    break;

	  case 1024:
	    writeVal = TG_PCI_STATE_DMA_WRITE_MAX_1K;
	    ok = TRUE;
	    break;

	  default:
	    (void) printf("Invalid entry %d\n", atoi(string));
	    break;
	}
    }
    
    ok = FALSE;
    while (!ok) {
	(void) printf("Max read DMA value (0, 4, 16, 32, 64, 128, 256, 1024)(%d): ", 
		      curReadVal);
	getline(string);
	switch(atoi(string)) {
	  case 0:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_DISA;
	    ok = TRUE;
	    break;

	  case 4:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_4;
	    ok = TRUE;
	    break;

	  case 16:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_16;
	    ok = TRUE;
	    break;

	  case 32:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_32;
	    ok = TRUE;
	    break;

	  case 64:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_64;
	    ok = TRUE;
	    break;

	  case 128:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_128;
	    ok = TRUE;
	    break;

	  case 256:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_256;
	    ok = TRUE;
	    break;

	  case 1024:
	    readVal = TG_PCI_STATE_DMA_READ_MAX_1K;
	    ok = TRUE;
	    break;

	  default:
	    (void) printf("Invalid entry %d\n", atoi(string));
	    break;
	}
    }
    
    /* write the data out to the PCI STATE reg */
    writeData.addr = TG_PCI_STATE;
    writeData.data = writeVal | readVal;
    if (ioctl(fd, ALT_WRITE_TG_REG, &writeData) < 0) {
	perror("couldn't do ALT_WRITE_TG_REG");
	exit(1);
    }
}

static void
getline(char *s)
{
    while((*s++ = getchar()) != '\n');
    *s = '\0';
}
