/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996, 1997 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: mcast.c,v $
 * Revision 1.1.8.3  1998/06/08  23:57:00  ted
 * 	Excise AIX stuff from the source base
 * 	[1998/05/21  22:35:07  ted]
 *
 * 	checkpoint Solaris hybrid working
 * 	[1998/05/21  22:09:25  ted]
 *
 * Revision 1.1.8.2  1997/11/29  20:05:07  ted
 * 	Add include of strings.h for x86_solaris's ether_copy which is bcopy
 * 	[1997/11/29  20:04:56  ted]
 * 
 * Revision 1.1.8.1  1997/10/21  00:13:42  ted
 * 	Bring up to release 2.0 functionality
 * 	[1997/10/20  23:02:01  ted]
 * 
 * Revision 1.1.6.1  1997/10/16  17:32:29  ted
 * 	Generification, initial ODI driver, some bug fixes, preparation for use of MEM WRITE INVALIDATE
 * 	[1997/10/16  17:29:10  ted]
 * 
 * Revision 1.1.4.1  1997/10/06  01:18:18  ted
 * 	Add support for larger send ring size, send coal tick, and software MAC addr filtering
 * 	[1997/10/05  23:48:08  ted]
 * 
 * Revision 1.1.2.1  1997/10/05  23:34:21  skapur
 * 	Initial revision
 * 	[1997/10/05  23:34:09  skapur]
 * 
 * $EndLog$
 */

#ifndef __lint
static const char rcsid[] = "$Header: /projects/rcs/sw/ge/./nic/host/unix/utils/common/mcast.c,v 1.1.8.3 1998/06/08 23:57:00 ted Exp $";
#endif /* __lint */

/* XXX FOR STREAMS IMPLEMENATIONS ONLY XXX */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include <sys/errno.h>
#include <sys/stream.h>
#include <sys/ethernet.h>

typedef void cond_t;		/* for prototypes, in dki_lock.h, but KERNEL */
#include <sys/dditypes.h>	/* ddi types */
#include <sys/ksynch.h>		/* kconfvar_t */
#include <stropts.h>		/* must precede ddi.h (which defines min) */
#include <poll.h>
#include <sys/ddi.h>		/* getminor */
#include <sys/dlpi.h>		/* DL_UNATTACHED ... */
#include <sys/ioccom.h>

static void usage(char *);

/* Stuff for getopt()   */
extern char *optarg;
extern int optind, opterr;

#define PROG "mcast"
#define ALTDEV "/dev/alt"

static void getline(char *);
static char whiteSpace[] = " 	";
static char colon[] = ":";
static char databuf[64];
static char dataindbuf[1500];
static char *primitive2Str[0x36] = 
{"DL_INFO_REQ", "DL_BIND_REQ", "DL_UNBIND_REQ", "DL_INFO_ACK", "DL_BIND_ACK",
 "DL_ERROR_ACK", "DL_OK_ACK", "DL_UNITDATA_REQ", "DL_UNITDATA_IND",
 "DL_UDERROR_IND", "DL_UDQOS_REQ", "DL_ATTACH_REQ", "DL_DETACH_REQ",
 "DL_CONNECT_REQ", "DL_CONNECT_IND", "DL_CONNECT_RES", "DL_CONNECT_CON",
 "DL_TOKEN_REQ", "DL_TOKEN_ACK", "DL_DISCONNECT_REQ", "DL_DISCONNECT_IND",
 "DL_SUBS_UNBIND_REQ", "unknown message", "DL_RESET_REQ", "DL_RESET_IND",
 "DL_RESET_RES", "DL_RESET_CON", "DL_SUBS_BIND_REQ", "DL_SUBS_BIND_ACK",
 "DL_ENABMULTI_REQ", "DL_DISABMULTI_REQ", "DL_PROMISCON_REQ", 
 "DL_PROMISCOFF_REQ", "DL_DATA_ACK_REQ", "DL_DATA_ACK_IND", 
 "DL_DATA_ACK_STATUS_IND", "DL_REPLY_REQ", "DL_REPLY_IND", 
 "DL_REPLY_STATUS_IND", "DL_REPLY_UPDATE_REQ", "DL_REPLY_UPDATE_STATUS_IND", 
 "DL_XID_REQ", "DL_XID_IND", "DL_XID_RES", "DL_XID_CON", "DL_TEST_RE",
 "DL_TEST_IN", "DL_TEST_RE", "DL_TEST_CO", "DL_PHYS_ADDR_REQ", 
 "DL_PHYS_ADDR_ACK", "DL_SET_PHYS_ADDR_REQ", "DL_GET_STATISTICS_REQ"
 "DL_GET_STATISTICS_ACK"};

int
main(int argc, char **argv)
{
    int fd;
    int rc;
    struct strbuf ctlmsg;
    struct strbuf datamsg;
    dl_attach_req_t attreq;
    dl_bind_req_t bindreq;
    struct ouremreq {
	dl_enabmulti_req_t emreq;
	struct ether_addr addr;
    } locemreq;
    struct ourdmreq {
	dl_disabmulti_req_t dmreq;
	struct ether_addr addr;
    } locdmreq;
    struct ourudreq {
	dl_unitdata_req_t udreq;
	struct ether_addr addr;
	unsigned short sap;
    } locudreq;
    union DL_primitives dlpiReply;
    int flags;
    struct dlAddr {
	struct ether_addr macAddr;
	unsigned short sap;
    } dlAddr;
    struct ether_addr multiAddr;
    char command[80];
    char *token;
    int i, j, k;
    char *addrByte;
    char addressStr[80];
    struct pollfd ourfds[2];
    int pollrc;
    char device[80] = ALTDEV;
    int instance = 0;
    int c;
    int errs = 0;

    opterr = 0 ;  /* keep it quiet */

    while ((c = getopt(argc, argv, "d:")) != EOF) {
	switch (c) {
	case 'd': 
	    if (strlen(optarg) > 80)
		errs++;
	    else
		strcpy(device, optarg);
	    break;

	default: 
	    (void) printf("Got unknown command line argument %c\n", c);
	    errs++;
	    break;
	}
    }
    if (errs) {
	usage("usage");
	exit(1);
    }

    if (argc == optind+1) {
	/* get the instance number */
	instance = atoi(argv[optind]);
    }

    fd = open(device, O_RDWR);
    if (fd < 0) {
	perror("open failed");
	exit(1);
    }

    /* fill in the att request message */
    attreq.dl_primitive = DL_ATTACH_REQ;
    attreq.dl_ppa = instance;
    ctlmsg.buf = (char *)&attreq;
    ctlmsg.maxlen = sizeof(dl_attach_req_t);
    ctlmsg.len = sizeof(dl_attach_req_t);
    ctlmsg.buf = (char *)&attreq;
    rc = putmsg(fd, &ctlmsg, (struct strbuf *)0, 0);
    if (rc < 0) {
	perror("put of DLPI ATTACH request failed");
	exit(1);
    }

    /* look for the request response */
    memset(&dlpiReply, '\0', sizeof(union DL_primitives));
    ctlmsg.maxlen = sizeof(union DL_primitives);
    ctlmsg.len = sizeof(union DL_primitives);
    ctlmsg.buf = (char *)&dlpiReply;
    flags = 0;
    rc = getmsg(fd, &ctlmsg, (struct strbuf *)0, &flags);
    if (rc < 0) {
	perror("get of DLPI ATTACH reply failed");
	exit(1);
    }

    /* take a look at what came back */
    if (ctlmsg.len == -1 || dlpiReply.dl_primitive != DL_OK_ACK) {
	if (dlpiReply.dl_primitive == DL_ERROR_ACK) {
	    (void) printf("Got error response %lx/%lx to DL_ATTACH_REQ(%lx)\n", 
			  dlpiReply.error_ack.dl_errno, 
			  dlpiReply.error_ack.dl_unix_errno,
			  dlpiReply.error_ack.dl_error_primitive);
	} else {
	    (void) printf("Unexpected response to DL_ATTACH_REQ, %lx\n", 
			  dlpiReply.dl_primitive);
	}
	exit(1);
    }

    /* fill in the bind request message */
    bindreq.dl_primitive = DL_BIND_REQ;
    bindreq.dl_sap = 0x801;	/* some random number */
    bindreq.dl_max_conind = 0;
    bindreq.dl_service_mode = DL_CLDLS;
    bindreq.dl_conn_mgmt = 0;
    bindreq.dl_xidtest_flg = 0;
    ctlmsg.maxlen = sizeof(dl_bind_req_t);
    ctlmsg.len = sizeof(dl_bind_req_t);
    ctlmsg.buf = (char *)&bindreq;
    rc = putmsg(fd, &ctlmsg, (struct strbuf *)0, 0);
    if (rc < 0) {
	perror("put of DLPI ATTACH request failed");
	exit(1);
    }

    /* look for the request response */
    memset(&dlpiReply, '\0', sizeof(union DL_primitives));
    ctlmsg.maxlen = sizeof(union DL_primitives);
    ctlmsg.len = sizeof(union DL_primitives);
    ctlmsg.buf = (char *)&dlpiReply;
    flags = 0;
    rc = getmsg(fd, &ctlmsg, (struct strbuf *)0, &flags);
    if (rc < 0) {
	perror("get of DLPI BIND reply failed");
	exit(1);
    }

    /* take a look at what came back */
    if (ctlmsg.len == -1 || dlpiReply.dl_primitive != DL_BIND_ACK) {
	if (dlpiReply.dl_primitive == DL_ERROR_ACK) {
	    (void) printf("Got error response %lx/%lx to DL_BIND_REQ(%lx)\n", 
			  dlpiReply.error_ack.dl_errno, 
			  dlpiReply.error_ack.dl_unix_errno,
			  dlpiReply.error_ack.dl_error_primitive);
	} else {
	    (void) printf("Unexpected response to DL_BIND_REQ, %lx\n", 
			  dlpiReply.dl_primitive);
	}
	exit(1);
    }
    /* initialize the data area */
    for (i=0; i<64; i++) {
	databuf[i] = i;
    }
    memcpy((char *)&dlAddr, 
	   ((char *)&dlpiReply) + dlpiReply.bind_ack.dl_addr_offset,
	   dlpiReply.bind_ack.dl_addr_length);
    dlAddr.sap = dlpiReply.bind_ack.dl_sap;
    (void) printf("Our MAC address is %x:%x:%x:%x:%x:%x\n", 
		  (int)(dlAddr.macAddr.ether_addr_octet[0] & 0xff),
		  (int)(dlAddr.macAddr.ether_addr_octet[1] & 0xff),
		  (int)(dlAddr.macAddr.ether_addr_octet[2] & 0xff),
		  (int)(dlAddr.macAddr.ether_addr_octet[3] & 0xff),
		  (int)(dlAddr.macAddr.ether_addr_octet[4] & 0xff),
		  (int)(dlAddr.macAddr.ether_addr_octet[5] & 0xff));

    /* go into a interactive mode here either getting keyboard commands
     * or displaying incoming packets:
     *
     * three real commands
     *    s xx:xx:xx:xx:xx:xx - send packet to a multicast address
     *    a xx:xx:xx:xx:xx:xx - add multicast address xx:xx:xx:xx:xx:xx
     *    d xx:xx:xx:xx:xx:xx - delete multicast address xx:xx:xx:xx:xx:xx
     *    h/? - help
     *    q - quit
     */
    while (1) {
	(void) printf("Enter command:\n");

	/* look for either a command or a message */
	ourfds[0].fd = 0;
	ourfds[0].events = POLLIN;
	ourfds[0].revents = 0;
	ourfds[1].fd = fd;
	ourfds[1].events = POLLIN | POLLPRI;
	ourfds[1].revents = 0;
	pollrc = 0;
	while (pollrc == 0) {
	    pollrc = poll(ourfds, 2, INFTIM);
	}
	if (ourfds[1].revents) {
	    /* get a message from the stream via getmsg */
	    memset(&dlpiReply, '\0', sizeof(union DL_primitives));
	    ctlmsg.maxlen = sizeof(union DL_primitives);
	    ctlmsg.len = sizeof(union DL_primitives);
	    ctlmsg.buf = (char *)&dlpiReply;
	    datamsg.maxlen = 1500;
	    datamsg.len = 1500;
	    datamsg.buf = dataindbuf;
	    flags = 0;
	    rc = getmsg(fd, &ctlmsg, &datamsg, &flags);
	    if (rc < 0) {
		perror("get of DLPI BIND reply failed");
		exit(1);
	    }

	    /* print out the message type received */
	    (void) printf("received msg type %s, ctl len %d, data len %d\n", 
			  primitive2Str[dlpiReply.dl_primitive], ctlmsg.len,
			  datamsg.len);
	    if (dlpiReply.dl_primitive == DL_UNITDATA_IND) {
		(void) printf("Received data packet:\n");
		for (i=0; i < datamsg.len/32; i++) {
		    for (j=0; j < 8; j++) {
			for (k=0; k < 4; k++)
			    (void) printf("%2.2x", 
					(int)(dataindbuf[i*32+j*8+k] & 0xff));
			(void) printf(" ");
		    }
		    (void) printf("\n");
		}
	    }
	} else {
	    getline(command);
	    token = strtok(command, whiteSpace);
	    if (!token) {
		(void) printf("Invalid command %s\n", token);
		continue;
	    }
	    switch (*token) {
	    case 's':
		/* get the multicast address */
		token = strtok((char *)0, whiteSpace);

		/* fill in the unitdata request message */
		locudreq.udreq.dl_primitive = DL_UNITDATA_REQ;
		locudreq.udreq.dl_dest_addr_length = 8;
		locudreq.udreq.dl_dest_addr_offset = sizeof(dl_unitdata_req_t);
		locudreq.udreq.dl_priority.dl_min = 0;
		locudreq.udreq.dl_priority.dl_max = 0;

		/* parse the multicast address */
		strcpy(addressStr, token);
		addrByte = strtok(token, colon);
		for (i=0; i < 6; i++) {
		    if (!addrByte) {
			(void) printf("Invalid MAC address %s\n", addressStr);
			continue;
		    }
		    multiAddr.ether_addr_octet[i] = 
			strtol(addrByte, (char **)0, 16);
		    addrByte = strtok((char *)0, colon);
		}

		/* check for the group bit */
		if (!(multiAddr.ether_addr_octet[0] & 0x01)) {
		    (void) printf("MAC address must have group bit set\n");
		    continue;
		}

		(void) printf("sending packet to multicast address %x:%x:%x:%x:%x:%x ... ", 
			      (int)(multiAddr.ether_addr_octet[0] & 0xff),
			      (int)(multiAddr.ether_addr_octet[1] & 0xff),
			      (int)(multiAddr.ether_addr_octet[2] & 0xff),
			      (int)(multiAddr.ether_addr_octet[3] & 0xff),
			      (int)(multiAddr.ether_addr_octet[4] & 0xff),
			      (int)(multiAddr.ether_addr_octet[5] & 0xff));

		/* copy it into the message */
		ether_copy(&multiAddr, &locudreq.addr);
		locudreq.sap = dlAddr.sap;
		ctlmsg.maxlen = sizeof(struct ourudreq);
		ctlmsg.len = sizeof(struct ourudreq);
		ctlmsg.buf = (char *)&locudreq;
		datamsg.maxlen = 64;
		datamsg.len = 64;
		datamsg.buf = databuf;
		rc = putmsg(fd, &ctlmsg, &datamsg, 0);
		if (rc < 0) {
		    (void) printf("FAILED\n");
		    perror("put of DLPI UNITDATA request failed");
		    continue;
		}

		/* no response, typically */
		(void) printf("OK\n");
		break;

	    case 'a':
		/* get the multicast address */
		token = strtok((char *)0, whiteSpace);

		/* fill in the enabmulti request message */
		locemreq.emreq.dl_primitive = DL_ENABMULTI_REQ;
		locemreq.emreq.dl_addr_length = 6;
		locemreq.emreq.dl_addr_offset = sizeof(dl_enabmulti_req_t);

		/* parse the multicast address */
		strcpy(addressStr, token);
		addrByte = strtok(token, colon);
		for (i=0; i < 6; i++) {
		    if (!addrByte) {
			(void) printf("Invalid MAC address %s\n", addressStr);
			continue;
		    }
		    multiAddr.ether_addr_octet[i] = 
			strtol(addrByte, (char **)0, 16);
		    addrByte = strtok((char *)0, colon);
		}

		/* check for the group bit */
		if (!(multiAddr.ether_addr_octet[0] & 0x01)) {
		    (void) printf("MAC address must have group bit set\n");
		    continue;
		}

		(void) printf("adding multicast MAC address %x:%x:%x:%x:%x:%x ... ", 
			      (int)(multiAddr.ether_addr_octet[0] & 0xff),
			      (int)(multiAddr.ether_addr_octet[1] & 0xff),
			      (int)(multiAddr.ether_addr_octet[2] & 0xff),
			      (int)(multiAddr.ether_addr_octet[3] & 0xff),
			      (int)(multiAddr.ether_addr_octet[4] & 0xff),
			      (int)(multiAddr.ether_addr_octet[5] & 0xff));

		/* copy it into the message */
		ether_copy(&multiAddr, &locemreq.addr);
		ctlmsg.maxlen = sizeof(struct ouremreq);
		ctlmsg.len = sizeof(struct ouremreq);
		ctlmsg.buf = (char *)&locemreq;
		rc = putmsg(fd, &ctlmsg, (struct strbuf *)0, 0);
		if (rc < 0) {
		    (void) printf("FAILED\n");
		    perror("put of DLPI ENABMULTI request failed");
		    continue;
		}

		/* look for the request response */
		memset(&dlpiReply, '\0', sizeof(union DL_primitives));
		ctlmsg.maxlen = sizeof(union DL_primitives);
		ctlmsg.len = sizeof(union DL_primitives);
		ctlmsg.buf = (char *)&dlpiReply;
		flags = 0;
		rc = getmsg(fd, &ctlmsg, (struct strbuf *)0, &flags);
		if (rc < 0) {
		    (void) printf("FAILED\n");
		    perror("getmsg failed on DLPI ENABMULTI response");
		    continue;
		}

		/* take a look at what came back */
		if (ctlmsg.len == -1 || dlpiReply.dl_primitive != DL_OK_ACK) {
		    if (dlpiReply.dl_primitive == DL_ERROR_ACK) {
			(void) printf("FAILED\n");
			(void) printf("Got error response %lx/%lx to DL_ENABMULTI_REQ(%lx)\n", 
				      dlpiReply.error_ack.dl_errno, 
				      dlpiReply.error_ack.dl_unix_errno,
				      dlpiReply.error_ack.dl_error_primitive);
		    } else {
			(void) printf("FAILED\n");
			(void) printf("Unexpected response to DL_ENABMULTI_REQ, %lx\n", 
				      dlpiReply.dl_primitive);
		    }
		    continue;
		}
		(void) printf("OK\n");
		break;

	    case 'd':
		/* get the multicast address */
		token = strtok((char *)0, whiteSpace);

		/* fill in the disabmulti request message */
		locdmreq.dmreq.dl_primitive = DL_DISABMULTI_REQ;
		locdmreq.dmreq.dl_addr_length = 6;
		locdmreq.dmreq.dl_addr_offset = sizeof(dl_enabmulti_req_t);

		/* parse the multicast address */
		strcpy(addressStr, token);
		addrByte = strtok(token, colon);
		for (i=0; i < 6; i++) {
		    if (!addrByte) {
			(void) printf("Invalid MAC address %s\n", addressStr);
			continue;
		    }
		    multiAddr.ether_addr_octet[i] = 
			strtol(addrByte, (char **)0, 16);
		    addrByte = strtok((char *)0, colon);
		}

		/* check for the group bit */
		if (!(multiAddr.ether_addr_octet[0] & 0x01)) {
		    (void) printf("MAC address must have group bit set\n");
		    continue;
		}

		(void) printf("deleting multicast MAC address %x:%x:%x:%x:%x:%x ... ", 
			      (int)(multiAddr.ether_addr_octet[0] & 0xff),
			      (int)(multiAddr.ether_addr_octet[1] & 0xff),
			      (int)(multiAddr.ether_addr_octet[2] & 0xff),
			      (int)(multiAddr.ether_addr_octet[3] & 0xff),
			      (int)(multiAddr.ether_addr_octet[4] & 0xff),
			      (int)(multiAddr.ether_addr_octet[5] & 0xff));

		/* copy it into the message */
		ether_copy(&multiAddr, &locdmreq.addr);
		ctlmsg.maxlen = sizeof(struct ourdmreq);
		ctlmsg.len = sizeof(struct ourdmreq);
		ctlmsg.buf = (char *)&locdmreq;
		rc = putmsg(fd, &ctlmsg, (struct strbuf *)0, 0);
		if (rc < 0) {
		    perror("put of DLPI DISABMULTI request failed");
		    exit(1);
		}

		/* look for the request response */
		memset(&dlpiReply, '\0', sizeof(union DL_primitives));
		ctlmsg.maxlen = sizeof(union DL_primitives);
		ctlmsg.len = sizeof(union DL_primitives);
		ctlmsg.buf = (char *)&dlpiReply;
		flags = 0;
		rc = getmsg(fd, &ctlmsg, (struct strbuf *)0, &flags);
		if (rc < 0) {
		    (void) printf("FAILED\n");
		    perror("getmsg failed on DLPI DISABMULTI response");
		    continue;
		}

		/* take a look at what came back */
		if (ctlmsg.len == -1 || dlpiReply.dl_primitive != DL_OK_ACK) {
		    if (dlpiReply.dl_primitive == DL_ERROR_ACK) {
			(void) printf("FAILED\n");
			(void) printf("Got error response %lx/%lx to DL_DISABMULTI_REQ(%lx)\n", 
				      dlpiReply.error_ack.dl_errno, 
				      dlpiReply.error_ack.dl_unix_errno,
				      dlpiReply.error_ack.dl_error_primitive);
		    } else {
			(void) printf("FAILED\n");
			(void) printf("Unexpected response to DL_DISABMULTI_REQ, %lx\n", 
				      dlpiReply.dl_primitive);
		    }
		    continue;
		}
		(void) printf("OK\n");
		break;

	    case 'q':
		exit(0);

	    case 'h':
	    case '?':
		(void) printf("the following commands are supported:\n");
		(void) printf("    s xx:xx:xx:xx:xx:xx - send packet to a multicast address\n");
		(void) printf("    a xx:xx:xx:xx:xx:xx - add multicast address xx:xx:xx:xx:xx:xx\n");
		(void) printf("    d xx:xx:xx:xx:xx:xx - delete multicast address xx:xx:xx:xx:xx:xx\n");
		(void) printf("    h/? - help\n");
		(void) printf("    q - quit\n");
		break;

	    default:
		(void) printf("Invalid command %s\n", token);
		break;
	    }
	}
    }

    /* shouldn't ever get here */
    return(0);
}

static void
getline(char *s)
{
    while((*s++ = getchar()) != '\n');
    *s = '\0';
}

static void
usage(char *msg)
{
    (void) printf("%s : ", msg);
    (void) printf("%s [-d <device_name>] [<instance>]\n", PROG);
}
